var require = meteorInstall({"server":{"lib":{"constants.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/lib/constants.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// A collection of some global variables used in multiple places.                                                      //
SANDSTORM_ALTHOME = Meteor.settings && Meteor.settings.home;                                                           // 18
SANDSTORM_LOGDIR = (SANDSTORM_ALTHOME || "") + "/var/log";                                                             // 19
SANDSTORM_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandstorm";                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"accounts":{"email-token":{"token-server.js":["crypto","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/email-token/token-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var crypto;module.import("crypto",{"default":function(v){crypto=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
                                                                                                                       //
                                                                                                                       // 3
                                                                                                                       //
var V1_ROUNDS = 4096; // Selected to take ~5msec at creation time (2016) on a developer's laptop.                      // 5
var V1_KEYSIZE = 32; // 256 bits / 8 bits/byte = 32 bytes                                                              // 6
var V1_HASHFUNC = "sha512";                                                                                            // 7
// ^ hash function used with pbkdf2.  Chosen to be different from the function which maps the token                    //
// to the value stored in the database.  Note that the first thing that pbkdf2 does is                                 //
// HMAC(HASHFUNC, key, salt), and the first thing that HMAC does is either pad or hash the key to                      //
// make it the appropriate width.  The result is that knowing sha256(key) and the salt is possibly                     //
// sufficient to reconstruct the output of pbkdf2().                                                                   //
var V1_CIPHER = "AES-256-CTR"; // cipher used                                                                          // 13
                                                                                                                       //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                              // 15
                                                                                                                       //
var cleanupExpiredTokens = function cleanupExpiredTokens() {                                                           // 17
  Meteor.users.update({                                                                                                // 18
    "services.email.tokens.createdAt": {                                                                               // 19
      $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)                                                                  // 20
    }                                                                                                                  // 19
  }, {                                                                                                                 // 18
    $pull: {                                                                                                           // 23
      "services.email.tokens": {                                                                                       // 24
        createdAt: { $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS) }                                                 // 25
      }                                                                                                                // 24
    }                                                                                                                  // 23
  }, {                                                                                                                 // 22
    multi: true                                                                                                        // 29
  });                                                                                                                  // 28
};                                                                                                                     // 31
                                                                                                                       //
Meteor.startup(cleanupExpiredTokens);                                                                                  // 33
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                              //
SandstormDb.periodicCleanup(TOKEN_EXPIRATION_MS, cleanupExpiredTokens);                                                // 35
                                                                                                                       //
var hashToken = function hashToken(token) {                                                                            // 37
  return {                                                                                                             // 38
    digest: SHA256(token),                                                                                             // 39
    algorithm: "sha-256"                                                                                               // 40
  };                                                                                                                   // 38
};                                                                                                                     // 42
                                                                                                                       //
var checkToken = function checkToken(tokens, token) {                                                                  // 44
  // Looks for an object in `tokens` with `algorithm` and `digest` fields matching those in `token`.                   //
  // Returns the matching object, if one is found, or undefined if none match.                                         //
  var foundToken = undefined;                                                                                          // 47
  tokens.forEach(function (userToken) {                                                                                // 48
    if (userToken.algorithm === token.algorithm && userToken.digest === token.digest) {                                // 49
      foundToken = userToken;                                                                                          // 51
    }                                                                                                                  // 52
  });                                                                                                                  // 53
                                                                                                                       //
  return foundToken;                                                                                                   // 55
};                                                                                                                     // 56
                                                                                                                       //
var consumeToken = function consumeToken(user, token) {                                                                // 58
  var hashedToken = hashToken(token);                                                                                  // 59
  var foundToken = checkToken(user.services.email.tokens, hashedToken);                                                // 60
                                                                                                                       //
  if (foundToken !== undefined) {                                                                                      // 62
    Meteor.users.update({ _id: user._id }, { $pull: { "services.email.tokens": hashedToken } });                       // 63
  }                                                                                                                    // 64
                                                                                                                       //
  return foundToken;                                                                                                   // 66
};                                                                                                                     // 67
                                                                                                                       //
var makeBox = function makeBox(token, plaintext) {                                                                     // 69
  // Encrypt plaintext symmetrically with a key derived from token.  Returns an object with                            //
  // ciphertext and associated data needed to decrypt later.                                                           //
                                                                                                                       //
  // Produce a symmetric key.  Note that the token itself does not have sufficient entropy to                          //
  // be used as a key directly, so we need to use a KDF with a strong random salt.                                     //
  // In the fullness of time, it might be nice to move away from using a KDF (which blocks the whole                   //
  // node process) in favor of the token itself having enough entropy to serve as the key itself.                      //
  // This would require lengthening the token, which would make the manual-code-entry workflow                         //
  // worse, so I'm punting on that for now.                                                                            //
  var salt = Random.secret(16);                                                                                        // 79
  var key = crypto.pbkdf2Sync(token, salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                                        // 80
  var iv = crypto.randomBytes(16);                                                                                     // 81
  var cipher = crypto.createCipheriv(V1_CIPHER, key, iv);                                                              // 82
  var ciphertext = cipher.update(new Buffer(plaintext, "binary"));                                                     // 83
  return {                                                                                                             // 84
    version: 1,                                                                                                        // 85
    salt: salt,                                                                                                        // 86
    iv: iv.toString("base64"),                                                                                         // 87
    boxedValue: ciphertext.toString("base64")                                                                          // 88
  };                                                                                                                   // 84
};                                                                                                                     // 90
                                                                                                                       //
var tryUnbox = function tryUnbox(box, secret) {                                                                        // 92
  if (box) {                                                                                                           // 93
    if (box.version === 1) {                                                                                           // 94
      var key = crypto.pbkdf2Sync(secret, box.salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                               // 95
      var iv = new Buffer(box.iv, "base64");                                                                           // 96
      var cipher = crypto.createDecipheriv(V1_CIPHER, key, iv);                                                        // 97
      var cipherText = new Buffer(box.boxedValue, "base64");                                                           // 98
      var plaintext = cipher.update(cipherText);                                                                       // 99
      return plaintext.toString("binary");                                                                             // 100
    }                                                                                                                  // 101
  }                                                                                                                    // 102
                                                                                                                       //
  // If no box was provided, or it was of an unknown version, return no data.                                          //
  return;                                                                                                              // 105
};                                                                                                                     // 106
                                                                                                                       //
// Handler to login with a token.                                                                                      //
Accounts.registerLoginHandler("email", function (options) {                                                            // 109
  if (!options.email) {                                                                                                // 110
    return undefined; // don't handle                                                                                  // 111
  }                                                                                                                    // 112
                                                                                                                       //
  if (!Accounts.identityServices.email.isEnabled()) {                                                                  // 114
    throw new Meteor.Error(403, "Email identity service is disabled.");                                                // 115
  }                                                                                                                    // 116
                                                                                                                       //
  options = options.email;                                                                                             // 118
  check(options, {                                                                                                     // 119
    email: String,                                                                                                     // 120
    token: String                                                                                                      // 121
  });                                                                                                                  // 119
                                                                                                                       //
  var user = Meteor.users.findOne({                                                                                    // 124
    "services.email.email": options.email                                                                              // 125
  }, {                                                                                                                 // 124
    fields: {                                                                                                          // 127
      "services.email": 1                                                                                              // 128
    }                                                                                                                  // 127
  });                                                                                                                  // 126
                                                                                                                       //
  if (!user) {                                                                                                         // 132
    console.error("User not found:", options.email);                                                                   // 133
    return {                                                                                                           // 134
      error: new Meteor.Error(403, "User not found")                                                                   // 135
    };                                                                                                                 // 134
  }                                                                                                                    // 137
                                                                                                                       //
  if (!user.services.email.tokens) {                                                                                   // 139
    console.error("User has no token set:", options.email);                                                            // 140
    return {                                                                                                           // 141
      error: new Meteor.Error(403, "User has no token set")                                                            // 142
    };                                                                                                                 // 141
  }                                                                                                                    // 144
                                                                                                                       //
  var tokenString = options.token.trim();                                                                              // 146
  var maybeToken = consumeToken(user, tokenString);                                                                    // 147
  if (!maybeToken) {                                                                                                   // 148
    console.error("Token not found:", options.email);                                                                  // 149
    return {                                                                                                           // 150
      error: new Meteor.Error(403, "Invalid authentication code")                                                      // 151
    };                                                                                                                 // 150
  }                                                                                                                    // 153
                                                                                                                       //
  // Attempt to decrypt the resumePath, if provided.                                                                   //
  var resumePath = tryUnbox(maybeToken.secureBox, tokenString);                                                        // 156
                                                                                                                       //
  return {                                                                                                             // 158
    userId: user._id,                                                                                                  // 159
    options: {                                                                                                         // 160
      resumePath: resumePath                                                                                           // 161
    }                                                                                                                  // 160
  };                                                                                                                   // 158
});                                                                                                                    // 164
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 166
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 168
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 169
                                                                                                                       //
var makeTokenUrl = function makeTokenUrl(email, token, linkingIdentity) {                                              // 171
  if (linkingIdentity) {                                                                                               // 172
    return process.env.ROOT_URL + "/_emailLinkIdentity/" + encodeURIComponent(email) + "/" + encodeURIComponent(token) + "/" + Meteor.userId();
  } else {                                                                                                             // 175
    return process.env.ROOT_URL + "/_emailLogin/" + encodeURIComponent(email) + "/" + encodeURIComponent(token);       // 176
  }                                                                                                                    // 178
};                                                                                                                     // 179
                                                                                                                       //
///                                                                                                                    //
/// EMAIL VERIFICATION                                                                                                 //
///                                                                                                                    //
var sendTokenEmail = function sendTokenEmail(db, email, token, linkingIdentity) {                                      // 184
  var subject = void 0;                                                                                                // 185
  var text = void 0;                                                                                                   // 186
  if (!linkingIdentity) {                                                                                              // 187
    subject = "Log in to " + HOSTNAME;                                                                                 // 188
    text = "To confirm this email address on ";                                                                        // 189
  } else {                                                                                                             // 190
    subject = "Confirm this email address on " + HOSTNAME;                                                             // 191
    text = "To confirm this email address on ";                                                                        // 192
  }                                                                                                                    // 193
                                                                                                                       //
  text = text + HOSTNAME + ", click on the following link:\n\n" + makeTokenUrl(email, token, linkingIdentity) + "\n\n" + "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" + token;
                                                                                                                       //
  var options = {                                                                                                      // 200
    to: email,                                                                                                         // 201
    from: db.getServerTitle() + " <" + db.getReturnAddress() + ">",                                                    // 202
    subject: subject,                                                                                                  // 203
    text: text                                                                                                         // 204
  };                                                                                                                   // 200
                                                                                                                       //
  sendEmail(options);                                                                                                  // 207
};                                                                                                                     // 208
                                                                                                                       //
///                                                                                                                    //
/// CREATING USERS                                                                                                     //
///                                                                                                                    //
// returns the user id                                                                                                 //
var _createAndEmailTokenForUser = function _createAndEmailTokenForUser(db, email, linkingIdentity, resumePath) {       // 214
  check(email, String);                                                                                                // 215
  check(linkingIdentity, Boolean);                                                                                     // 216
  check(resumePath, String);                                                                                           // 217
                                                                                                                       //
  var atIndex = email.indexOf("@");                                                                                    // 219
  if (atIndex === -1) {                                                                                                // 220
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                                // 221
  }                                                                                                                    // 222
                                                                                                                       //
  var user = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });             // 224
  var userId = void 0;                                                                                                 // 226
                                                                                                                       //
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                                 //
  // Alternately, require using the link over copy/pasting the code, and crank up the entropy.                         //
  var token = Random.id(12);                                                                                           // 230
  var tokenObj = hashToken(token);                                                                                     // 231
  tokenObj.createdAt = new Date();                                                                                     // 232
  tokenObj.secureBox = makeBox(token, resumePath);                                                                     // 233
                                                                                                                       //
  if (user) {                                                                                                          // 235
    if (user.services.email.tokens && user.services.email.tokens.length > 2) {                                         // 236
      throw new Meteor.Error(409, "It looks like we sent a log in email to this address not long " + "ago. Please use the one that was already sent (check your spam folder if you can't find " + "it), or wait a while and try again");
    }                                                                                                                  // 240
                                                                                                                       //
    userId = user._id;                                                                                                 // 242
                                                                                                                       //
    Meteor.users.update({ _id: user._id }, { $push: { "services.email.tokens": tokenObj } });                          // 244
  } else {                                                                                                             // 245
    var options = {};                                                                                                  // 246
    user = {                                                                                                           // 247
      services: {                                                                                                      // 248
        email: {                                                                                                       // 249
          tokens: [tokenObj],                                                                                          // 250
          email: email                                                                                                 // 251
        }                                                                                                              // 249
      }                                                                                                                // 248
    };                                                                                                                 // 247
                                                                                                                       //
    userId = Accounts.insertUserDoc(options, user);                                                                    // 256
  }                                                                                                                    // 257
                                                                                                                       //
  sendTokenEmail(db, email, token, linkingIdentity);                                                                   // 259
                                                                                                                       //
  return userId;                                                                                                       // 261
};                                                                                                                     // 262
                                                                                                                       //
Meteor.methods({                                                                                                       // 264
  createAndEmailTokenForUser: function createAndEmailTokenForUser(email, linkingIdentity, resumePath) {                // 265
    // method for create user. Requests come from the client.                                                          //
    // This method will create a user if it doesn't exist, otherwise it will generate a token.                         //
    // It will always send an email to the user                                                                        //
                                                                                                                       //
    check(email, String);                                                                                              // 270
    check(linkingIdentity, Boolean);                                                                                   // 271
    check(resumePath, String);                                                                                         // 272
                                                                                                                       //
    if (!Accounts.identityServices.email.isEnabled()) {                                                                // 274
      throw new Meteor.Error(403, "Email identity service is disabled.");                                              // 275
    }                                                                                                                  // 276
    // Create user. result contains id and token.                                                                      //
    var user = _createAndEmailTokenForUser(this.connection.sandstormDb, email, linkingIdentity, resumePath);           // 278
  },                                                                                                                   // 279
                                                                                                                       //
  linkEmailIdentityToAccount: function linkEmailIdentityToAccount(email, token) {                                      // 281
    // Links the email identity with address `email` and login token `token` to the current account.                   //
    check(email, String);                                                                                              // 283
    check(token, String);                                                                                              // 284
    var account = Meteor.user();                                                                                       // 285
    if (!account || !account.loginIdentities) {                                                                        // 286
      throw new Meteor.Error(403, "Must be logged in to an account to link an email identity.");                       // 287
    }                                                                                                                  // 288
                                                                                                                       //
    var identity = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });       // 290
    if (!identity) {                                                                                                   // 292
      throw new Meteor.Error(403, "Invalid authentication code.");                                                     // 293
    }                                                                                                                  // 294
                                                                                                                       //
    var maybeToken = consumeToken(identity, token.trim());                                                             // 296
    if (!maybeToken) {                                                                                                 // 297
      throw new Meteor.Error(403, "Invalid authentication code.");                                                     // 298
    }                                                                                                                  // 299
                                                                                                                       //
    Accounts.linkIdentityToAccount(this.connection.sandstormDb, this.connection.sandstormBackend, identity._id, account._id);
                                                                                                                       //
    // Return the resume path, if we have one.                                                                         //
    var resumePath = tryUnbox(maybeToken.secureBox, token);                                                            // 305
    return resumePath;                                                                                                 // 306
  }                                                                                                                    // 307
});                                                                                                                    // 264
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"identity":{"identity-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/identity/identity-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var linkIdentityToAccountInternal = function linkIdentityToAccountInternal(db, backend, identityId, accountId) {       // 17
  // Links the identity to the account and grants it login access if possible. Makes the account                       //
  // durable if it is a demo account.                                                                                  //
                                                                                                                       //
  check(db, SandstormDb);                                                                                              // 21
  check(backend, SandstormBackend);                                                                                    // 22
  check(identityId, String);                                                                                           // 23
  check(accountId, String);                                                                                            // 24
                                                                                                                       //
  var accountUser = Meteor.users.findOne({ _id: accountId });                                                          // 26
  if (!accountUser) {                                                                                                  // 27
    throw new Meteor.Error(404, "No account found with ID " + accountId);                                              // 28
  }                                                                                                                    // 29
                                                                                                                       //
  if (accountUser.profile) {                                                                                           // 31
    throw new Meteor.Error(400, "Cannot link an identity to another identity.");                                       // 32
  }                                                                                                                    // 33
                                                                                                                       //
  if (!!_.findWhere(accountUser.loginIdentities, { id: identityId }) || !!_.findWhere(accountUser.nonloginIdentities, { id: identityId })) {
    throw new Meteor.Error("alreadyLinked", "Cannot link an identity that's alread linked to this account.");          // 37
  }                                                                                                                    // 39
                                                                                                                       //
  var identityUser = Meteor.users.findOne({ _id: identityId });                                                        // 41
                                                                                                                       //
  if (!identityUser) {                                                                                                 // 43
    throw new Meteor.Error(404, "No identity found with ID " + identityId);                                            // 44
  }                                                                                                                    // 45
                                                                                                                       //
  if (!identityUser.profile) {                                                                                         // 47
    throw new Meteor.Error(400, "Cannot link an account to another account");                                          // 48
  }                                                                                                                    // 49
                                                                                                                       //
  db.deleteUnusedAccount(backend, identityUser._id);                                                                   // 51
  if (Meteor.users.findOne({ "loginIdentities.id": identityUser._id })) {                                              // 52
    throw new Meteor.Error(403, "Cannot link an identity that can already log into another account");                  // 53
  }                                                                                                                    // 55
                                                                                                                       //
  var alreadyLinked = !!Meteor.users.findOne({ "nonloginIdentities.id": identityUser._id });                           // 57
                                                                                                                       //
  var pushModifier = alreadyLinked ? { nonloginIdentities: { id: identityUser._id } } : { loginIdentities: { id: identityUser._id } };
                                                                                                                       //
  var modifier = void 0;                                                                                               // 63
  if (accountUser.expires) {                                                                                           // 64
    if (alreadyLinked) {                                                                                               // 65
      throw new Meteor.Error(403, "Cannot create an account for an identity that's " + "already linked to another account.");
    }                                                                                                                  // 68
                                                                                                                       //
    modifier = {                                                                                                       // 70
      $push: pushModifier,                                                                                             // 71
      $unset: { expires: 1 },                                                                                          // 72
      $set: { upgradedFromDemo: Date.now() }                                                                           // 73
    };                                                                                                                 // 70
    if (Meteor.settings["public"].quotaEnabled) {                                                                      // 75
      // Demo users never got the referral notification. Send it now:                                                  //
      db.sendReferralProgramNotification(accountUser._id);                                                             // 77
    }                                                                                                                  // 78
  } else {                                                                                                             // 80
    modifier = { $push: pushModifier };                                                                                // 81
  }                                                                                                                    // 82
                                                                                                                       //
  // Make sure not to add the same identity twice.                                                                     //
  Meteor.users.update({ _id: accountUser._id,                                                                          // 85
    "nonloginIdentities.id": { $ne: identityUser._id },                                                                // 86
    "loginIdentities.id": { $ne: identityUser._id } }, modifier);                                                      // 87
                                                                                                                       //
  if (accountUser.expires) {                                                                                           // 90
    var demoIdentityId = SandstormDb.getUserIdentityIds(accountUser)[0];                                               // 91
    Meteor.users.update({ _id: demoIdentityId }, { $unset: { expires: 1 },                                             // 92
      $set: { upgradedFromDemo: Date.now() } });                                                                       // 94
                                                                                                                       //
    // Mark the demo identity as nonlogin. It'd be nicer if the identity started out as nonlogin,                      //
    // but to get that to work we would need to adjust the account creation and first login logic.                     //
    Meteor.users.update({ _id: accountUser._id,                                                                        // 98
      "loginIdentities.id": demoIdentityId,                                                                            // 99
      "nonloginIdentities.id": { $not: { $eq: demoIdentityId } } }, { $pull: { loginIdentities: { id: demoIdentityId } },
      $push: { nonloginIdentities: { id: demoIdentityId } } });                                                        // 102
  }                                                                                                                    // 104
};                                                                                                                     // 105
                                                                                                                       //
Meteor.methods({                                                                                                       // 107
  loginWithIdentity: function loginWithIdentity(accountUserId) {                                                       // 108
    // Logs into the account with ID `accountUserId`. Throws an exception if the current user is                       //
    // not an identity user listed in the account's `loginIdentities` field. This method is not                        //
    // intended to be called directly; client-side code should only invoke it through                                  //
    // `Meteor.loginWithIdentity()`, which additionally maintains the standard Meteor client-side                      //
    // login state.                                                                                                    //
                                                                                                                       //
    check(accountUserId, String);                                                                                      // 115
                                                                                                                       //
    var identityUser = Meteor.user();                                                                                  // 117
    if (!identityUser || !identityUser.profile) {                                                                      // 118
      throw new Meteor.Error(403, "Must be already logged in as an identity.");                                        // 119
    }                                                                                                                  // 120
                                                                                                                       //
    var accountUser = Meteor.users.findOne(accountUserId);                                                             // 122
    if (!accountUser) {                                                                                                // 123
      throw new Meteor.Error(404, "No such user found: " + accountUserId);                                             // 124
    }                                                                                                                  // 125
                                                                                                                       //
    var linkedIdentity = _.findWhere(accountUser.loginIdentities, { id: identityUser._id });                           // 127
                                                                                                                       //
    if (!linkedIdentity) {                                                                                             // 129
      throw new Meteor.Error(403, "Current identity is not a login identity for account " + accountUserId);            // 130
    }                                                                                                                  // 132
                                                                                                                       //
    return Accounts._loginMethod(this, "loginWithIdentity", [accountUserId], "identity", function () {                 // 134
      return { userId: accountUserId };                                                                                // 135
    });                                                                                                                // 135
  },                                                                                                                   // 136
                                                                                                                       //
  createAccountForIdentity: function createAccountForIdentity() {                                                      // 138
    // Creates a new account for the currently-logged-in identity.                                                     //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 141
    if (!(user && user.profile)) {                                                                                     // 142
      throw new Meteor.Error(403, "Must be logged in as an identity in order to create an account.");                  // 143
    }                                                                                                                  // 144
                                                                                                                       //
    if (Meteor.users.findOne({                                                                                         // 146
      $or: [{ "loginIdentities.id": user._id }, { "nonloginIdentities.id": user._id }]                                 // 147
    })) {                                                                                                              // 146
      throw new Meteor.Error(403, "Cannot create an account for an identity that's already " + "linked to another account.");
    }                                                                                                                  // 154
                                                                                                                       //
    var newUser = {                                                                                                    // 156
      loginIdentities: [{ id: user._id }],                                                                             // 157
      nonloginIdentities: []                                                                                           // 158
    };                                                                                                                 // 156
    if (user.services.dev) {                                                                                           // 160
      newUser.signupKey = "devAccounts";                                                                               // 161
      if (user.services.dev.isAdmin) {                                                                                 // 162
        newUser.isAdmin = true;                                                                                        // 163
      }                                                                                                                // 164
                                                                                                                       //
      if (user.services.dev.hasCompletedSignup) {                                                                      // 166
        newUser.hasCompletedSignup = true;                                                                             // 167
      }                                                                                                                // 168
    } else if (user.expires) {                                                                                         // 169
      // Demo user.                                                                                                    //
      newUser.expires = user.expires;                                                                                  // 171
      if (!!user.appDemoId) {                                                                                          // 172
        newUser.appDemoId = user.appDemoId;                                                                            // 173
      }                                                                                                                // 174
    }                                                                                                                  // 175
                                                                                                                       //
    var options = {};                                                                                                  // 177
                                                                                                                       //
    // This will throw an error if the identity has been added as a login identity to some                             //
    // other account while we were executing the body of this method.                                                  //
    return Accounts.insertUserDoc(options, newUser);                                                                   // 181
  },                                                                                                                   // 182
                                                                                                                       //
  linkIdentityToAccount: function linkIdentityToAccount(token) {                                                       // 184
    // Links the identity of the current user to the account that has `token` as a resume token.                       //
    // If the account is a demo account, makes the account durable and gives the identity login                        //
    // access to it.                                                                                                   //
                                                                                                                       //
    check(token, String);                                                                                              // 189
                                                                                                                       //
    if (!this.userId) {                                                                                                // 191
      throw new Meteor.Error(403, "Cannot link to account if not logged in.");                                         // 192
    }                                                                                                                  // 193
                                                                                                                       //
    var hashed = Accounts._hashLoginToken(token);                                                                      // 195
    var accountUser = Meteor.users.findOne({ "services.resume.loginTokens.hashedToken": hashed });                     // 196
                                                                                                                       //
    linkIdentityToAccountInternal(this.connection.sandstormDb, this.connection.sandstormBackend, this.userId, accountUser._id);
  },                                                                                                                   // 200
                                                                                                                       //
  unlinkIdentity: function unlinkIdentity(accountUserId, identityId) {                                                 // 202
    // Unlinks the identity with ID `identityId` from the account with ID `accountUserId`.                             //
                                                                                                                       //
    check(identityId, String);                                                                                         // 205
    check(accountUserId, String);                                                                                      // 206
                                                                                                                       //
    if (!this.userId) {                                                                                                // 208
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 209
    }                                                                                                                  // 210
                                                                                                                       //
    if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                       // 212
      throw new Meteor.Error(403, "Current user does not own identity " + identityId);                                 // 213
    }                                                                                                                  // 214
                                                                                                                       //
    var identityUser = Meteor.users.findOne({ _id: identityId });                                                      // 216
    Meteor.users.update({                                                                                              // 217
      _id: accountUserId                                                                                               // 218
    }, {                                                                                                               // 217
      $pull: {                                                                                                         // 220
        nonloginIdentities: { id: identityId },                                                                        // 221
        loginIdentities: { id: identityId }                                                                            // 222
      }                                                                                                                // 220
    });                                                                                                                // 219
  },                                                                                                                   // 225
                                                                                                                       //
  setIdentityAllowsLogin: function setIdentityAllowsLogin(identityId, allowLogin) {                                    // 227
    // Sets whether the current account allows the identity with ID `identityId` to log in.                            //
                                                                                                                       //
    check(identityId, String);                                                                                         // 230
    check(allowLogin, Boolean);                                                                                        // 231
    if (!this.userId) {                                                                                                // 232
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 233
    }                                                                                                                  // 234
                                                                                                                       //
    if (!this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                                       // 236
      throw new Meteor.Error(403, "Current user does not own identity " + identityId);                                 // 237
    }                                                                                                                  // 238
                                                                                                                       //
    if (allowLogin) {                                                                                                  // 240
      Meteor.users.update({ _id: this.userId,                                                                          // 241
        "nonloginIdentities.id": identityId,                                                                           // 242
        "loginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { nonloginIdentities: { id: identityId } },    // 243
        $push: { loginIdentities: { id: identityId } } });                                                             // 245
    } else {                                                                                                           // 246
      Meteor.users.update({ _id: this.userId,                                                                          // 247
        "loginIdentities.id": identityId,                                                                              // 248
        "nonloginIdentities.id": { $not: { $eq: identityId } } }, { $pull: { loginIdentities: { id: identityId } },    // 249
        $push: { nonloginIdentities: { id: identityId } } });                                                          // 251
    }                                                                                                                  // 252
  },                                                                                                                   // 253
                                                                                                                       //
  logoutIdentitiesOfCurrentAccount: function logoutIdentitiesOfCurrentAccount() {                                      // 255
    // Logs out all identities that are allowed to log in to the current account.                                      //
    var user = Meteor.user();                                                                                          // 257
    if (user && user.loginIdentities) {                                                                                // 258
      user.loginIdentities.forEach(function (identity) {                                                               // 259
        Meteor.users.update({ _id: identity.id }, { $set: { "services.resume.loginTokens": [] } });                    // 260
      });                                                                                                              // 261
    }                                                                                                                  // 262
  }                                                                                                                    // 263
});                                                                                                                    // 107
                                                                                                                       //
Accounts.linkIdentityToAccount = function (db, backend, identityId, accountId) {                                       // 266
  // Links the identity to the account. If the account is a demo account, makes it durable and                         //
  // gives the identity login access to it.                                                                            //
  check(db, SandstormDb);                                                                                              // 269
  check(backend, SandstormBackend);                                                                                    // 270
  check(identityId, String);                                                                                           // 271
  check(accountId, String);                                                                                            // 272
  linkIdentityToAccountInternal(db, backend, identityId, accountId);                                                   // 273
};                                                                                                                     // 274
                                                                                                                       //
Meteor.publish("accountsOfIdentity", function (identityId) {                                                           // 276
  check(identityId, String);                                                                                           // 277
  if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                              // 278
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             //
  var loginIdentities = {};                                                                                            // 281
                                                                                                                       //
  var _this = this;                                                                                                    // 283
  function addIdentitiesOfAccount(account) {                                                                           // 284
    account.loginIdentities.forEach(function (identity) {                                                              // 285
      if (!(identity.id in loginIdentities)) {                                                                         // 286
        var user = Meteor.users.findOne({ _id: identity.id });                                                         // 287
        if (user) {                                                                                                    // 288
          SandstormDb.fillInProfileDefaults(user);                                                                     // 289
          SandstormDb.fillInIntrinsicName(user);                                                                       // 290
          SandstormDb.fillInLoginId(user);                                                                             // 291
          var filteredUser = _.pick(user, "_id", "profile", "loginId");                                                // 292
          filteredUser.loginAccountId = account._id;                                                                   // 293
          filteredUser.sourceIdentityId = identityId;                                                                  // 294
          _this.added("loginIdentitiesOfLinkedAccounts", user._id, filteredUser);                                      // 295
        }                                                                                                              // 296
                                                                                                                       //
        loginIdentities[identity.id] = Meteor.users.find({ _id: identity.id }, { fields: { profile: 1 } }).observeChanges({
          changed: function changed(id, fields) {                                                                      // 300
            _this.changed("loginIdentitiesOfLinkedAccounts", id, fields);                                              // 301
          }                                                                                                            // 302
        });                                                                                                            // 299
      }                                                                                                                // 304
    });                                                                                                                // 305
  }                                                                                                                    // 306
                                                                                                                       //
  var cursor = Meteor.users.find({                                                                                     // 308
    $or: [{ "loginIdentities.id": identityId }, { "nonloginIdentities.id": identityId }]                               // 309
  });                                                                                                                  // 308
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 315
    added: function added(account) {                                                                                   // 316
      addIdentitiesOfAccount(account);                                                                                 // 317
    },                                                                                                                 // 318
                                                                                                                       //
    changed: function changed(newAccount, oldAccount) {                                                                // 320
      addIdentitiesOfAccount(newAccount);                                                                              // 321
    },                                                                                                                 // 322
                                                                                                                       //
    removed: function removed(account) {                                                                               // 324
      account.loginIdentities.forEach(function (identity) {                                                            // 325
        if (identity.id in loginIdentities) {                                                                          // 326
          _this.removed("loginIdentitiesOfLinkedAccounts", identity.id);                                               // 327
          loginIdentities[identity.id].stop();                                                                         // 328
          delete loginIdentities[identity.id];                                                                         // 329
        }                                                                                                              // 330
      });                                                                                                              // 331
    }                                                                                                                  // 332
  });                                                                                                                  // 315
  this.ready();                                                                                                        // 334
                                                                                                                       //
  this.onStop(function () {                                                                                            // 336
    handle.stop();                                                                                                     // 337
    Object.keys(loginIdentities).forEach(function (identityId) {                                                       // 338
      loginIdentities[identityId].stop();                                                                              // 339
      delete loginIdentities[identityId];                                                                              // 340
    });                                                                                                                // 341
  });                                                                                                                  // 342
});                                                                                                                    // 343
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"ldap":{"ldap-server.js":["babel-runtime/helpers/typeof","ldapjs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/ldap/ldap-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var ldapjs;module.import("ldapjs",{"default":function(v){ldapjs=v}});
var Future = Npm.require("fibers/future");                                                                             // 1
                                                                                                                       // 2
                                                                                                                       //
// At a minimum, set up LDAP_DEFAULTS.url and .dn according to                                                         //
// your needs. url should appear as 'ldap://your.url.here'                                                             //
// dn should appear in normal ldap format of comma separated attribute=value                                           //
// e.g. 'uid=someuser,cn=users,dc=somevalue'                                                                           //
LDAP_DEFAULTS = {                                                                                                      // 8
  url: false,                                                                                                          // 9
  port: "389",                                                                                                         // 10
  dn: false,                                                                                                           // 11
  searchDN: false,                                                                                                     // 12
  searchCredentials: false,                                                                                            // 13
  createNewUser: true,                                                                                                 // 14
  defaultDomain: false,                                                                                                // 15
  searchResultsProfileMap: false,                                                                                      // 16
  base: null,                                                                                                          // 17
  search: "(objectclass=*)",                                                                                           // 18
  ldapsCertificate: false                                                                                              // 19
};                                                                                                                     // 8
                                                                                                                       //
/**                                                                                                                    //
 @class LDAP                                                                                                           //
 @constructor                                                                                                          //
 */                                                                                                                    //
var LDAP = function LDAP() {                                                                                           // 26
  // Set options                                                                                                       //
  this.options = _.clone(LDAP_DEFAULTS);                                                                               // 28
};                                                                                                                     // 29
                                                                                                                       //
/**                                                                                                                    //
 * Attempt to bind (authenticate) ldap                                                                                 //
 * and perform a dn search if specified                                                                                //
 *                                                                                                                     //
 * @method ldapCheck                                                                                                   //
 *                                                                                                                     //
 * @param {Object} options  Object with username, ldapPass and overrides for LDAP_DEFAULTS object.                     //
 * Additionally the searchBeforeBind parameter can be specified, which is used to search for the DN                    //
 * if not provided.                                                                                                    //
 */                                                                                                                    //
LDAP.prototype.ldapCheck = function (db, options) {                                                                    // 41
                                                                                                                       //
  var _this = this;                                                                                                    // 43
                                                                                                                       //
  options = options || {};                                                                                             // 45
                                                                                                                       //
  if (options.hasOwnProperty("username") && options.hasOwnProperty("ldapPass")) {                                      // 47
    var _ret = function () {                                                                                           // 47
      _this.options.base = db.getLdapBase();                                                                           // 48
      _this.options.searchBeforeBind = {};                                                                             // 49
      _this.options.searchBeforeBind[db.getLdapSearchUsername()] = options.username;                                   // 50
      _this.options.filter = db.getLdapFilter() || "(objectclass=*)";                                                  // 51
      _this.options.searchBindDn = db.getLdapSearchBindDn();                                                           // 52
      _this.options.searchBindPassword = db.getLdapSearchBindPassword();                                               // 53
                                                                                                                       //
      var resolved = false;                                                                                            // 55
      var ldapAsyncFut = new Future();                                                                                 // 56
                                                                                                                       //
      // Create ldap client                                                                                            //
      var fullUrl = db.getLdapUrl();                                                                                   // 59
      var client = null;                                                                                               // 60
                                                                                                                       //
      var errorFunc = function errorFunc(err) {                                                                        // 62
        if (err) {                                                                                                     // 63
          if (resolved) return;                                                                                        // 64
          resolved = true;                                                                                             // 65
          ldapAsyncFut["return"]({                                                                                     // 66
            error: err                                                                                                 // 67
          });                                                                                                          // 66
        }                                                                                                              // 69
      };                                                                                                               // 70
                                                                                                                       //
      if (fullUrl.indexOf("ldaps://") === 0) {                                                                         // 72
        client = ldapjs.createClient({                                                                                 // 73
          url: fullUrl,                                                                                                // 74
          tlsOptions: {                                                                                                // 75
            ca: [_this.options.ldapsCertificate]                                                                       // 76
          }                                                                                                            // 75
        }, errorFunc);                                                                                                 // 73
      } else {                                                                                                         // 79
        client = ldapjs.createClient({                                                                                 // 80
          url: fullUrl                                                                                                 // 81
        }, errorFunc);                                                                                                 // 80
      }                                                                                                                // 83
                                                                                                                       //
      client.on("error", errorFunc);                                                                                   // 85
                                                                                                                       //
      // Slide @xyz.whatever from username if it was passed in                                                         //
      // and replace it with the domain specified in defaults                                                          //
      var emailSliceIndex = options.username.indexOf("@");                                                             // 89
      var username = void 0;                                                                                           // 90
      var domain = _this.options.defaultDomain;                                                                        // 91
                                                                                                                       //
      // If user appended email domain, strip it out                                                                   //
      // And use the defaults.defaultDomain if set                                                                     //
      if (emailSliceIndex !== -1) {                                                                                    // 95
        username = options.username.substring(0, emailSliceIndex);                                                     // 96
        domain = domain || options.username.substring(emailSliceIndex + 1, options.username.length);                   // 97
      } else {                                                                                                         // 98
        username = options.username;                                                                                   // 99
      }                                                                                                                // 100
                                                                                                                       //
      if (_this.options.searchBindDn) {                                                                                // 102
        var _ret2 = function () {                                                                                      // 102
          var ldapBindFut = new Future();                                                                              // 103
          client.bind(_this.options.searchBindDn, _this.options.searchBindPassword, function (err) {                   // 104
            if (err) {                                                                                                 // 106
              ldapBindFut["throw"](err);                                                                               // 107
            } else {                                                                                                   // 108
              ldapBindFut["return"]();                                                                                 // 109
            }                                                                                                          // 110
          });                                                                                                          // 111
                                                                                                                       //
          try {                                                                                                        // 114
            ldapBindFut.wait();                                                                                        // 115
          } catch (err) {                                                                                              // 116
            return {                                                                                                   // 117
              v: {                                                                                                     // 117
                v: { error: err }                                                                                      // 117
              }                                                                                                        // 117
            };                                                                                                         // 117
          }                                                                                                            // 118
        }();                                                                                                           // 102
                                                                                                                       //
        if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                // 102
      }                                                                                                                // 119
      // initialize result                                                                                             //
      var retObject = {                                                                                                // 121
        username: username,                                                                                            // 122
        email: domain ? username + "@" + domain : false,                                                               // 123
        emptySearch: true,                                                                                             // 124
        searchResults: {}                                                                                              // 125
      };                                                                                                               // 121
                                                                                                                       //
      var filter = _this.options.filter;                                                                               // 128
      Object.keys(_this.options.searchBeforeBind).forEach(function (searchKey) {                                       // 129
        filter = "&" + filter + "(" + searchKey + "=" + _this.options.searchBeforeBind[searchKey] + ")";               // 130
      });                                                                                                              // 131
                                                                                                                       //
      var searchOptions = {                                                                                            // 133
        scope: "sub",                                                                                                  // 134
        sizeLimit: 1,                                                                                                  // 135
        filter: filter                                                                                                 // 136
      };                                                                                                               // 133
                                                                                                                       //
      // perform LDAP search to determine DN                                                                           //
      client.search(_this.options.base, searchOptions, function (err, res) {                                           // 140
        if (err) {                                                                                                     // 141
          if (resolved) return;                                                                                        // 142
          resolved = true;                                                                                             // 143
          ldapAsyncFut["return"]({                                                                                     // 144
            error: err                                                                                                 // 145
          });                                                                                                          // 144
          return;                                                                                                      // 147
        }                                                                                                              // 148
                                                                                                                       //
        retObject.emptySearch = true;                                                                                  // 150
        res.on("searchEntry", function (entry) {                                                                       // 151
          retObject.dn = entry.objectName;                                                                             // 152
          retObject.username = retObject.dn;                                                                           // 153
          retObject.emptySearch = false;                                                                               // 154
                                                                                                                       //
          retObject.searchResults = _.omit(entry.object, "userPassword");                                              // 156
                                                                                                                       //
          // use the determined DN to bind                                                                             //
          client.bind(entry.objectName, options.ldapPass, function (err) {                                             // 159
            try {                                                                                                      // 160
              if (err) {                                                                                               // 161
                throw new Meteor.Error(err.code, err.message);                                                         // 162
              } else {                                                                                                 // 163
                resolved = true;                                                                                       // 164
                ldapAsyncFut["return"](retObject);                                                                     // 165
              }                                                                                                        // 166
            } catch (e) {                                                                                              // 167
              if (resolved) return;                                                                                    // 169
              resolved = true;                                                                                         // 170
              ldapAsyncFut["return"]({                                                                                 // 171
                error: e                                                                                               // 172
              });                                                                                                      // 171
            }                                                                                                          // 174
          });                                                                                                          // 175
        });                                                                                                            // 176
                                                                                                                       //
        res.on("error", errorFunc);                                                                                    // 178
                                                                                                                       //
        // If no dn is found, return as is.                                                                            //
        res.on("end", function (result) {                                                                              // 181
          if (retObject.dn === undefined) {                                                                            // 182
            resolved = true;                                                                                           // 183
            ldapAsyncFut["return"](retObject);                                                                         // 184
          }                                                                                                            // 185
        });                                                                                                            // 186
      });                                                                                                              // 187
                                                                                                                       //
      return {                                                                                                         // 189
        v: ldapAsyncFut.wait()                                                                                         // 189
      };                                                                                                               // 189
    }();                                                                                                               // 47
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                       // 47
  } else {                                                                                                             // 191
    throw new Meteor.Error(403, "Missing LDAP Auth Parameter");                                                        // 192
  }                                                                                                                    // 193
};                                                                                                                     // 195
                                                                                                                       //
// Register login handler with Meteor                                                                                  //
Accounts.registerLoginHandler("ldap", function (loginRequest) {                                                        // 198
  // If 'ldap' isn't set in loginRequest object,                                                                       //
  // then this isn't the proper handler (return undefined)                                                             //
  if (!loginRequest.ldap) {                                                                                            // 201
    return undefined;                                                                                                  // 202
  }                                                                                                                    // 203
                                                                                                                       //
  if (!Accounts.identityServices.ldap.isEnabled()) {                                                                   // 205
    throw new Meteor.Error(403, "LDAP service is disabled.");                                                          // 206
  }                                                                                                                    // 207
                                                                                                                       //
  check(loginRequest, {                                                                                                // 209
    ldap: true,                                                                                                        // 210
    username: String,                                                                                                  // 211
    ldapPass: String                                                                                                   // 212
  });                                                                                                                  // 209
                                                                                                                       //
  // Instantiate LDAP                                                                                                  //
  var ldapObj = new LDAP();                                                                                            // 216
                                                                                                                       //
  // Call ldapCheck and get response                                                                                   //
  var ldapResponse = ldapObj.ldapCheck(this.connection.sandstormDb, loginRequest);                                     // 219
                                                                                                                       //
  if (ldapResponse.error) {                                                                                            // 221
    return {                                                                                                           // 222
      userId: null,                                                                                                    // 223
      error: ldapResponse.error                                                                                        // 224
    };                                                                                                                 // 222
  } else if (ldapResponse.emptySearch) {                                                                               // 226
    return {                                                                                                           // 227
      userId: null,                                                                                                    // 228
      error: new Meteor.Error(403, "User not found in LDAP")                                                           // 229
    };                                                                                                                 // 227
  } else {                                                                                                             // 231
    // Set initial userId and token vals                                                                               //
    return Accounts.updateOrCreateUserFromExternalService("ldap", { id: ldapResponse.dn, username: loginRequest.username,
      rawAttrs: ldapResponse.searchResults }, {});                                                                     // 235
  }                                                                                                                    // 236
});                                                                                                                    // 238
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"saml":{"saml-server.js":["url","/imports/server/accounts/saml-utils.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/saml/saml-server.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Url;module.import("url",{"default":function(v){Url=v}});var SAML;module.import("/imports/server/accounts/saml-utils.js",{"SAML":function(v){SAML=v}});
                                                                                                                       // 2
                                                                                                                       //
var Fiber = Npm.require("fibers");                                                                                     // 4
                                                                                                                       //
if (!Accounts.saml) {                                                                                                  // 6
  Accounts.saml = {};                                                                                                  // 7
}                                                                                                                      // 8
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      //
// uses. Fortunately, they let us extract it.                                                                          //
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 12
                                                                                                                       //
RoutePolicy.declare("/_saml/", "network");                                                                             // 14
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 16
                                                                                                                       //
// TODO(soon): This may need to be a Mongo collection in order to work when the frontend is                            //
//   replicated (but currently Sandstorm for Work is not replicated).                                                  //
var _loginResultForCredentialToken = {};                                                                               // 20
                                                                                                                       //
var retrieveCredential = function retrieveCredential(credentialToken) {                                                // 22
  var result = _loginResultForCredentialToken[credentialToken];                                                        // 23
  delete _loginResultForCredentialToken[credentialToken];                                                              // 24
  return result;                                                                                                       // 25
};                                                                                                                     // 26
                                                                                                                       //
Accounts.registerLoginHandler(function (loginRequest) {                                                                // 28
  if (!loginRequest.saml || !loginRequest.credentialToken) {                                                           // 29
    return undefined;                                                                                                  // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (!Accounts.identityServices.saml.isEnabled()) {                                                                   // 33
    throw new Meteor.Error(403, "SAML service is disabled.");                                                          // 34
  }                                                                                                                    // 35
                                                                                                                       //
  var loginResult = retrieveCredential(loginRequest.credentialToken);                                                  // 37
  if (!loginResult) {                                                                                                  // 38
    throw new Meteor.Error(500, "SAML login did not complete.");                                                       // 39
  } else if (loginResult.profile && loginResult.profile.email) {                                                       // 40
    var user = _.pick(loginResult.profile, "displayName", "email");                                                    // 41
    user.id = loginResult.profile.nameID;                                                                              // 42
    return Accounts.updateOrCreateUserFromExternalService("saml", user, {});                                           // 43
  } else {                                                                                                             // 44
    throw new Meteor.Error(500, "SAML profile did not contain an email address");                                      // 45
  }                                                                                                                    // 46
});                                                                                                                    // 47
                                                                                                                       //
var samlUrlToObject = function samlUrlToObject(url) {                                                                  // 49
  // req.url will be "/_saml/<action>/<service name>/<credentialToken>"                                                //
  if (!url) return null;                                                                                               // 51
                                                                                                                       //
  var splitPath = url.split("/");                                                                                      // 54
                                                                                                                       //
  // Any non-saml request will continue down the default                                                               //
  // middlewares.                                                                                                      //
  if (splitPath[1] !== "_saml") return null;                                                                           // 58
                                                                                                                       //
  return {                                                                                                             // 61
    actionName: splitPath[2],                                                                                          // 62
    serviceName: splitPath[3],                                                                                         // 63
    credentialToken: splitPath[4]                                                                                      // 64
  };                                                                                                                   // 61
};                                                                                                                     // 66
                                                                                                                       //
var closePopup = function closePopup(res, err) {                                                                       // 68
  res.writeHead(200, { "Content-Type": "text/html" });                                                                 // 69
  var content = "<html><head><script>window.close()</script></head></html>";                                           // 70
  if (err) content = "<html><body><h2>Sorry, an error occured</h2><div>" + err + '</div><a onclick="window.close();">Close Window</a></body></html>';
  res.end(content, "utf-8");                                                                                           // 74
};                                                                                                                     // 75
                                                                                                                       //
var generateService = function generateService() {                                                                     // 77
  var entityId = SandstormDb.prototype.getSamlEntityId();                                                              // 78
  var service = {                                                                                                      // 79
    "provider": "default",                                                                                             // 80
    "entryPoint": SandstormDb.prototype.getSamlEntryPoint(),                                                           // 81
    // TODO(someday): find a better way to inject the DB                                                               //
    "issuer": entityId || HOSTNAME,                                                                                    // 83
    "cert": SandstormDb.prototype.getSamlPublicCert()                                                                  // 84
  };                                                                                                                   // 79
  return service;                                                                                                      // 86
};                                                                                                                     // 87
                                                                                                                       //
var middleware = function middleware(req, res, next) {                                                                 // 89
  // Make sure to catch any exceptions because otherwise we'd crash                                                    //
  // the runner                                                                                                        //
  try {                                                                                                                // 92
    var samlObject = samlUrlToObject(req.url);                                                                         // 93
    if (!samlObject || !samlObject.serviceName) {                                                                      // 94
      next();                                                                                                          // 95
      return;                                                                                                          // 96
    }                                                                                                                  // 97
                                                                                                                       //
    if (samlObject.actionName === "config") {                                                                          // 99
      var _saml = new SAML(generateService());                                                                         // 100
      res.writeHead(200, { "Content-Type": "text/xml" });                                                              // 101
      res.end(_saml.generateServiceProviderMetadata());                                                                // 102
      return;                                                                                                          // 103
    }                                                                                                                  // 104
                                                                                                                       //
    if (!Accounts.identityServices.saml.isEnabled()) {                                                                 // 106
      next();                                                                                                          // 107
      return;                                                                                                          // 108
    }                                                                                                                  // 109
                                                                                                                       //
    if (!samlObject.actionName) throw new Error("Missing SAML action");                                                // 111
                                                                                                                       //
    var service = generateService();                                                                                   // 114
                                                                                                                       //
    // Skip everything if there's no service set by the saml middleware                                                //
    if (!service || samlObject.serviceName !== service.provider) throw new Error("Unexpected SAML service " + samlObject.serviceName);
                                                                                                                       //
    if (samlObject.actionName === "authorize") {                                                                       // 120
      service.callbackUrl = Meteor.absoluteUrl("_saml/validate/" + service.provider);                                  // 121
      service.id = samlObject.credentialToken;                                                                         // 122
      var _saml2 = new SAML(service);                                                                                  // 123
      _saml2.getAuthorizeUrl(req, function (err, url) {                                                                // 124
        if (err) throw new Error("Unable to generate authorize url");                                                  // 125
        res.writeHead(302, { "Location": url });                                                                       // 127
        res.end();                                                                                                     // 128
      });                                                                                                              // 129
    } else if (samlObject.actionName === "validate") {                                                                 // 130
      var _saml3 = new SAML(service);                                                                                  // 131
      _saml3.validateResponse(req.body.SAMLResponse, function (err, profile, loggedOut) {                              // 132
        if (err) {                                                                                                     // 133
          console.error("Error validating SAML response", err.toString());                                             // 134
          throw new Error("Unable to validate response url");                                                          // 135
        }                                                                                                              // 136
                                                                                                                       //
        // Do NOT use samlObject.credentialToken; it isn't signed!                                                     //
        var credentialToken = profile.inResponseToId || profile.InResponseTo;                                          // 139
        if (!credentialToken) {                                                                                        // 140
          throw new Error("SAML response missing InResponseTo attribute. Sandstorm does not support " + "IdP-initiated authentication; authentication requests must start " + "from the user choosing SAML login in the Sandstorm UI.");
        }                                                                                                              // 145
                                                                                                                       //
        _loginResultForCredentialToken[credentialToken] = {                                                            // 147
          profile: profile                                                                                             // 148
        };                                                                                                             // 147
                                                                                                                       //
        closePopup(res);                                                                                               // 151
      });                                                                                                              // 152
    } else {                                                                                                           // 153
      throw new Error("Unexpected SAML action " + samlObject.actionName);                                              // 154
    }                                                                                                                  // 155
  } catch (err) {                                                                                                      // 156
    closePopup(res, err);                                                                                              // 157
  }                                                                                                                    // 158
};                                                                                                                     // 159
                                                                                                                       //
// Listen to incoming OAuth http requests                                                                              //
WebApp.connectHandlers.use(connect.urlencoded()).use(function (req, res, next) {                                       // 162
  // Need to create a Fiber since we're using synchronous http calls and nothing                                       //
  // else is wrapping this in a fiber automatically                                                                    //
  Fiber(function () {                                                                                                  // 165
    middleware(req, res, next);                                                                                        // 166
  }).run();                                                                                                            // 167
});                                                                                                                    // 168
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"accounts-ui-methods.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-methods.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file contains method definitions which are available on both client and server (on the                         //
// client for prediction purposes, on the server for actual execution).                                                //
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 20
  check(handle, String);                                                                                               // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  updateProfile: function updateProfile(identityId, profile) {                                                         // 26
    // TODO(cleanup): This check also appears in sandstorm-db/users.js.                                                //
    check(identityId, String);                                                                                         // 28
                                                                                                                       //
    check(profile, {                                                                                                   // 30
      name: String,                                                                                                    // 31
      handle: ValidHandle,                                                                                             // 32
      pronoun: Match.OneOf("male", "female", "neutral", "robot"),                                                      // 33
      unverifiedEmail: Match.Optional(String)                                                                          // 34
    });                                                                                                                // 30
                                                                                                                       //
    if (!this.userId) {                                                                                                // 37
      throw new Meteor.Error(403, "not logged in");                                                                    // 38
    }                                                                                                                  // 39
                                                                                                                       //
    var userToUpdate = Meteor.users.findOne({ _id: identityId });                                                      // 41
                                                                                                                       //
    if (!this.isSimulation && !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                 // 43
      throw new Meteor.Error(403, "identity is not linked to current user: " + identityId);                            // 45
    }                                                                                                                  // 46
                                                                                                                       //
    var newValues = {                                                                                                  // 48
      "profile.name": profile.name,                                                                                    // 49
      "profile.handle": profile.handle,                                                                                // 50
      "profile.pronoun": profile.pronoun                                                                               // 51
    };                                                                                                                 // 48
                                                                                                                       //
    Meteor.users.update({ _id: userToUpdate._id }, { $set: newValues });                                               // 54
                                                                                                                       //
    if (!Meteor.user().hasCompletedSignup) {                                                                           // 56
      Meteor.users.update({ _id: this.userId }, { $set: { hasCompletedSignup: true } });                               // 57
    }                                                                                                                  // 58
  },                                                                                                                   // 59
                                                                                                                       //
  testFirstSignup: function testFirstSignup(profile) {                                                                 // 61
    if (!this.userId) {                                                                                                // 62
      throw new Meteor.Error(403, "not logged in");                                                                    // 63
    }                                                                                                                  // 64
                                                                                                                       //
    Meteor.users.update(this.userId, { $unset: { hasCompletedSignup: "" } });                                          // 66
  },                                                                                                                   // 67
                                                                                                                       //
  uploadProfilePicture: function uploadProfilePicture(identityId) {                                                    // 69
    check(identityId, String);                                                                                         // 70
    if (!this.userId || !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {                       // 71
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 72
    }                                                                                                                  // 73
                                                                                                                       //
    return this.connection.sandstormDb.newAssetUpload({                                                                // 75
      profilePicture: { userId: this.userId, identityId: identityId }                                                  // 76
    });                                                                                                                // 75
  },                                                                                                                   // 78
                                                                                                                       //
  cancelUploadProfilePicture: function cancelUploadProfilePicture(id) {                                                // 80
    check(id, String);                                                                                                 // 81
    this.connection.sandstormDb.fulfillAssetUpload(id);                                                                // 82
  },                                                                                                                   // 83
                                                                                                                       //
  setPrimaryEmail: function setPrimaryEmail(email) {                                                                   // 85
    check(email, String);                                                                                              // 86
    if (!this.userId) {                                                                                                // 87
      throw new Meteor.Error(403, "Not logged in.");                                                                   // 88
    }                                                                                                                  // 89
                                                                                                                       //
    var emails = SandstormDb.getUserEmails(Meteor.user());                                                             // 91
    if (!_.findWhere(emails, { email: email, verified: true })) {                                                      // 92
      throw new Meteor.Error(403, "Not a verified email of the current user: " + email);                               // 93
    }                                                                                                                  // 94
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { primaryEmail: email } });                                      // 96
  }                                                                                                                    // 97
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"accounts-ui-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/accounts/accounts-ui-server.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Meteor permits users to modify their own profile by default, for some reason.                                       //
Meteor.users.deny({                                                                                                    // 18
  insert: function insert() {                                                                                          // 19
    return true;                                                                                                       // 19
  },                                                                                                                   // 19
                                                                                                                       //
  update: function update() {                                                                                          // 21
    return true;                                                                                                       // 21
  },                                                                                                                   // 21
                                                                                                                       //
  remove: function remove() {                                                                                          // 23
    return true;                                                                                                       // 23
  },                                                                                                                   // 23
                                                                                                                       //
  fetch: []                                                                                                            // 25
});                                                                                                                    // 18
                                                                                                                       //
Meteor.publish("getMyUsage", function () {                                                                             // 28
  var db = this.connection.sandstormDb;                                                                                // 29
  if (this.userId) {                                                                                                   // 30
    // TODO(someday): Make this reactive.                                                                              //
    var user = Meteor.users.findOne(this.userId);                                                                      // 32
    var usage = db.getMyUsage(user);                                                                                   // 33
    this.added("users", this.userId, {                                                                                 // 34
      pseudoUsage: usage                                                                                               // 35
    });                                                                                                                // 34
  }                                                                                                                    // 37
                                                                                                                       //
  this.ready();                                                                                                        // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"admin":{"admin-alert-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-alert-server.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var maintenanceMessageShape = {                                                                                        // 5
  text: String,                                                                                                        // 6
  time: Match.OneOf(Date, undefined, null),                                                                            // 7
  url: Match.Optional(String)                                                                                          // 8
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 11
  setMaintenanceMessage: function setMaintenanceMessage(params) {                                                      // 12
    checkAuth(undefined);                                                                                              // 13
    check(params, maintenanceMessageShape);                                                                            // 14
    var db = this.connection.sandstormDb;                                                                              // 15
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "adminAlertTime" }, { value: params.time });                                 // 17
    db.collections.settings.upsert({ _id: "adminAlertUrl" }, { value: params.url });                                   // 18
    db.collections.settings.upsert({ _id: "adminAlert" }, { value: params.text });                                     // 19
  }                                                                                                                    // 20
});                                                                                                                    // 11
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-user-invite.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/admin-user-invite.js                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.publish("allInviteTokens", function () {                                                                        // 1
  var db = this.connection.sandstormDb;                                                                                // 2
  if (!db.isAdminById(this.userId)) {                                                                                  // 3
    throw new Meteor.Error(403, "User must be admin to list invite tokens.");                                          // 4
  }                                                                                                                    // 5
                                                                                                                       //
  return db.collections.signupKeys.find({});                                                                           // 7
});                                                                                                                    // 8
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"network-capabilities-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/network-capabilities-server.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
Meteor.publish("adminGrains", function (grainIds) {                                                                    // 5
  // If the caller is an admin, publishes the Grains referred to by the provided list of grain IDs.                    //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 8
  check(grainIds, [String]);                                                                                           // 9
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 11
  return db.collections.grains.find({                                                                                  // 12
    _id: {                                                                                                             // 13
      $in: grainIds                                                                                                    // 14
    }                                                                                                                  // 13
  }, {                                                                                                                 // 12
    fields: {                                                                                                          // 17
      identityId: 1,                                                                                                   // 18
      title: 1,                                                                                                        // 19
      packageId: 1                                                                                                     // 20
    }                                                                                                                  // 17
  });                                                                                                                  // 16
});                                                                                                                    // 23
                                                                                                                       //
Meteor.publish("adminPackages", function (packageIds) {                                                                // 25
  // If the caller is an admin, publishes the Packages referred to by the provided list of package                     //
  // IDs.  Otherwise, does nothing.                                                                                    //
  if (!isAdminById(this.userId)) return [];                                                                            // 28
  check(packageIds, [String]);                                                                                         // 29
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 31
  return db.collections.packages.find({                                                                                // 32
    _id: {                                                                                                             // 33
      $in: packageIds                                                                                                  // 34
    }                                                                                                                  // 33
  }, {                                                                                                                 // 32
    fields: {                                                                                                          // 37
      manifest: 1                                                                                                      // 38
    }                                                                                                                  // 37
  });                                                                                                                  // 36
});                                                                                                                    // 41
                                                                                                                       //
Meteor.publish("adminIdentities", function (identityIds) {                                                             // 43
  // If the caller is an admin, publishes the identity Users listed by ID in identityIds.                              //
  // Otherwise, does nothing.                                                                                          //
  if (!isAdminById(this.userId)) return [];                                                                            // 46
  check(identityIds, [String]);                                                                                        // 47
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 49
  return db.collections.users.find({                                                                                   // 50
    _id: {                                                                                                             // 51
      $in: identityIds                                                                                                 // 52
    }                                                                                                                  // 51
  });                                                                                                                  // 50
});                                                                                                                    // 55
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"personalization-server.js":["meteor/meteor","meteor/check","/imports/server/auth.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/personalization-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var check;module.import("meteor/check",{"check":function(v){check=v}});var checkAuth;module.import("/imports/server/auth.js",{"checkAuth":function(v){checkAuth=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       //
var personalizationMessageShape = {                                                                                    // 5
  serverTitle: String,                                                                                                 // 6
  splashUrl: String,                                                                                                   // 7
  signupDialog: String,                                                                                                // 8
  termsOfServiceUrl: String,                                                                                           // 9
  privacyPolicyUrl: String,                                                                                            // 10
                                                                                                                       //
  whitelabelCustomLoginProviderName: String,                                                                           // 12
  whitelabelHideSendFeedback: Boolean,                                                                                 // 13
  whitelabelHideTroubleshooting: Boolean,                                                                              // 14
  whitelabelUseServerTitleForHomeText: Boolean                                                                         // 15
};                                                                                                                     // 5
                                                                                                                       //
Meteor.methods({                                                                                                       // 18
  setPersonalizationSettings: function setPersonalizationSettings(params) {                                            // 19
    checkAuth(undefined);                                                                                              // 20
    check(params, personalizationMessageShape);                                                                        // 21
    var db = this.connection.sandstormDb;                                                                              // 22
    // TODO(soon): make this a single write to a single settings object                                                //
    db.collections.settings.upsert({ _id: "serverTitle" }, { value: params.serverTitle });                             // 24
    db.collections.settings.upsert({ _id: "splashUrl" }, { value: params.splashUrl });                                 // 25
    db.collections.settings.upsert({ _id: "signupDialog" }, { value: params.signupDialog });                           // 26
    db.collections.settings.upsert({ _id: "termsUrl" }, { value: params.termsOfServiceUrl });                          // 27
    db.collections.settings.upsert({ _id: "privacyUrl" }, { value: params.privacyPolicyUrl });                         // 28
                                                                                                                       //
    db.collections.settings.upsert({ _id: "whitelabelCustomLoginProviderName" }, { value: params.whitelabelCustomLoginProviderName });
    db.collections.settings.upsert({ _id: "whitelabelHideSendFeedback" }, { value: params.whitelabelHideSendFeedback });
    db.collections.settings.upsert({ _id: "whitelabelHideTroubleshooting" }, { value: params.whitelabelHideTroubleshooting });
    db.collections.settings.upsert({ _id: "whitelabelUseServerTitleForHomeText" }, { value: params.whitelabelUseServerTitleForHomeText });
  },                                                                                                                   // 38
  getWhitelabelLogoUploadToken: function getWhitelabelLogoUploadToken() {                                              // 40
    checkAuth(undefined);                                                                                              // 41
    var db = this.connection.sandstormDb;                                                                              // 42
    return db.newAssetUpload({ loginLogo: {} });                                                                       // 43
  },                                                                                                                   // 44
  resetWhitelabelLogo: function resetWhitelabelLogo() {                                                                // 46
    checkAuth(undefined);                                                                                              // 47
    var db = this.connection.sandstormDb;                                                                              // 48
    var old = globalDb.collections.settings.findAndModify({                                                            // 49
      query: { _id: "whitelabelCustomLogoAssetId" },                                                                   // 50
      remove: true,                                                                                                    // 51
      fields: { value: 1 }                                                                                             // 52
    });                                                                                                                // 49
                                                                                                                       //
    if (old) {                                                                                                         // 55
      db.unrefStaticAsset(old.value);                                                                                  // 56
    }                                                                                                                  // 57
  }                                                                                                                    // 58
});                                                                                                                    // 18
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"system-status-server.js":["meteor/meteor","meteor/iron:router","meteor/random","crypto","fs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/system-status-server.js                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Router;module.import("meteor/iron:router",{"Router":function(v){Router=v}});var Random;module.import("meteor/random",{"Random":function(v){Random=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       //
var hashSessionId = function hashSessionId(sessionId) {                                                                // 7
  return Crypto.createHash("sha256").update(sessionId).digest("base64");                                               // 8
};                                                                                                                     // 9
                                                                                                                       //
// An in-memory map of random id -> timestamp, used to authorize requests to download the system                       //
// log.                                                                                                                //
var SYSTEM_LOG_DOWNLOAD_TOKENS = {};                                                                                   // 13
var SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION = 60000; // 60 seconds                                                 // 14
                                                                                                                       //
Meteor.methods({                                                                                                       // 16
  adminGetServerLogDownloadToken: function adminGetServerLogDownloadToken() {                                          // 17
    var db = this.connection.sandstormDb;                                                                              // 18
    if (!db.isAdminById(this.userId)) {                                                                                // 19
      throw new Meteor.Error(403, "User must be admin to download system log.");                                       // 20
    }                                                                                                                  // 21
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 23
    SYSTEM_LOG_DOWNLOAD_TOKENS[token] = Date.now();                                                                    // 24
    setTimeout(function () {                                                                                           // 25
      if (SYSTEM_LOG_DOWNLOAD_TOKENS[token]) {                                                                         // 26
        delete SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                                      // 27
      }                                                                                                                // 28
    }, SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION * 2);                                                               // 29
    return token;                                                                                                      // 30
  }                                                                                                                    // 31
});                                                                                                                    // 16
                                                                                                                       //
Router.map(function () {                                                                                               // 34
  this.route("adminDownloadServerLog", {                                                                               // 35
    where: "server",                                                                                                   // 36
    path: "/admin/status/server-log/:tokenId",                                                                         // 37
    action: function action() {                                                                                        // 38
      var token = this.params.tokenId;                                                                                 // 39
      var response = this.response;                                                                                    // 40
      var issueDate = SYSTEM_LOG_DOWNLOAD_TOKENS[token];                                                               // 41
      delete SYSTEM_LOG_DOWNLOAD_TOKENS[token]; // Clear the token from the in-memory map.                             // 42
      if (issueDate === undefined || issueDate + SYSTEM_LOG_DOWNLOAD_TOKEN_VALIDITY_DURATION < Date.now()) {           // 43
        // Require download to start within 60 seconds of the adminGetServerLogDownloadToken                           //
        // method being called.                                                                                        //
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 47
        return response.end("Invalid server log download token.");                                                     // 48
      }                                                                                                                // 49
                                                                                                                       //
      var logFilePath = SANDSTORM_LOGDIR + "/sandstorm.log";                                                           // 51
      var fd = Fs.openSync(logFilePath, "r");                                                                          // 52
      var stats = Fs.fstatSync(fd);                                                                                    // 53
      var initialSize = stats.size;                                                                                    // 54
      var readStream = Fs.createReadStream(undefined, {                                                                // 55
        fd: fd,                                                                                                        // 56
        start: 0,                                                                                                      // 57
        end: initialSize                                                                                               // 58
      });                                                                                                              // 55
                                                                                                                       //
      response.writeHead(200, {                                                                                        // 61
        "Content-Length": initialSize,                                                                                 // 62
        "Content-Type": "text/plain",                                                                                  // 63
        "content-Disposition": "attachment;filename=\"sandstorm.log\""                                                 // 64
      });                                                                                                              // 61
      readStream.pipe(response);                                                                                       // 66
    }                                                                                                                  // 67
  });                                                                                                                  // 35
});                                                                                                                    // 69
                                                                                                                       //
Meteor.publish("systemStatus", function () {                                                                           // 71
  // A pseudocollection containing the number of active grain sessions and unique                                      //
  // userIds associated with these sessions                                                                            //
  var db = this.connection.sandstormDb;                                                                                // 74
  if (!db.isAdminById(this.userId)) {                                                                                  // 75
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 76
  }                                                                                                                    // 77
                                                                                                                       //
  var _this = this;                                                                                                    // 79
  var userIdToSessionHashes = {}; // Maps userId => list of (sha256(sessionId))                                        // 80
  var grainIdToSessionHashes = {}; // Maps grainId => list of (sha256(sessionId))                                      // 81
                                                                                                                       //
  var userIdCount = 0;                                                                                                 // 83
  var grainIdCount = 0;                                                                                                // 84
                                                                                                                       //
  this.added("systemStatus", "globalStatus", {                                                                         // 86
    activeUsers: userIdCount,                                                                                          // 87
    activeGrains: grainIdCount                                                                                         // 88
  });                                                                                                                  // 86
                                                                                                                       //
  var query = db.collections.sessions.find();                                                                          // 91
  var handle = query.observe({                                                                                         // 92
    added: function added(session) {                                                                                   // 93
      var hashedSessionId = hashSessionId(session._id);                                                                // 94
      var changed = {};                                                                                                // 95
                                                                                                                       //
      // Update userId cache.                                                                                          //
      if (session.userId) {                                                                                            // 98
        if (userIdToSessionHashes[session.userId] === undefined) {                                                     // 99
          userIdToSessionHashes[session.userId] = [];                                                                  // 100
          userIdCount = userIdCount + 1;                                                                               // 101
          changed.activeUsers = userIdCount;                                                                           // 102
        }                                                                                                              // 103
                                                                                                                       //
        userIdToSessionHashes[session.userId] = _.union(userIdToSessionHashes[session.userId], [hashedSessionId]);     // 105
      }                                                                                                                // 107
                                                                                                                       //
      // Update grainId cache.                                                                                         //
      if (grainIdToSessionHashes[session.grainId] === undefined) {                                                     // 110
        grainIdToSessionHashes[session.grainId] = [];                                                                  // 111
        grainIdCount = grainIdCount + 1;                                                                               // 112
        changed.activeGrains = grainIdCount;                                                                           // 113
      }                                                                                                                // 114
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.union(grainIdToSessionHashes[session.grainId], [hashedSessionId]);   // 116
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 119
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 120
      }                                                                                                                // 121
    },                                                                                                                 // 122
    removed: function removed(session) {                                                                               // 124
      var hashedSessionId = hashSessionId(session._id);                                                                // 125
      var changed = {};                                                                                                // 126
                                                                                                                       //
      if (session.userId) {                                                                                            // 128
        userIdToSessionHashes[session.userId] = _.without(userIdToSessionHashes[session.userId], hashedSessionId);     // 129
                                                                                                                       //
        if (userIdToSessionHashes[session.userId].length === 0) {                                                      // 132
          delete userIdToSessionHashes[session.userId];                                                                // 133
          userIdCount = userIdCount - 1;                                                                               // 134
          changed.activeUsers = userIdCount;                                                                           // 135
        }                                                                                                              // 136
      }                                                                                                                // 137
                                                                                                                       //
      grainIdToSessionHashes[session.grainId] = _.without(grainIdToSessionHashes[session.grainId], hashedSessionId);   // 139
                                                                                                                       //
      if (grainIdToSessionHashes[session.grainId].length === 0) {                                                      // 142
        delete grainIdToSessionHashes[session.grainId];                                                                // 143
        grainIdCount = grainIdCount - 1;                                                                               // 144
        changed.activeGrains = grainIdCount;                                                                           // 145
      }                                                                                                                // 146
                                                                                                                       //
      if (!_.isEmpty(changed)) {                                                                                       // 148
        _this.changed("systemStatus", "globalStatus", changed);                                                        // 149
      }                                                                                                                // 150
    }                                                                                                                  // 151
  });                                                                                                                  // 92
                                                                                                                       //
  this.onStop(function () {                                                                                            // 154
    handle.stop();                                                                                                     // 155
  });                                                                                                                  // 156
  this.ready();                                                                                                        // 157
});                                                                                                                    // 158
                                                                                                                       //
Meteor.publish("adminDemoUsers", function () {                                                                         // 160
  // Publishes expiry information about demo accounts to admins, so demo users can be counted                          //
  // clientside and reactively updated.                                                                                //
  var db = this.connection.sandstormDb;                                                                                // 163
  if (!db.isAdminById(this.userId)) {                                                                                  // 164
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 165
  }                                                                                                                    // 166
                                                                                                                       //
  return db.collections.users.find({                                                                                   // 168
    expires: {                                                                                                         // 169
      $gt: new Date()                                                                                                  // 170
    },                                                                                                                 // 169
    loginIdentities: {                                                                                                 // 172
      $exists: true                                                                                                    // 173
    }                                                                                                                  // 172
  }, {                                                                                                                 // 168
    expires: 1,                                                                                                        // 176
    loginIdentities: 1                                                                                                 // 177
  });                                                                                                                  // 175
});                                                                                                                    // 179
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"drivers":{"external-ui-view.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/external-ui-view.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Promise = Npm.require("es6-promise").Promise;                                                                      // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var Url = Npm.require("url");                                                                                          // 20
var Http = Npm.require("http");                                                                                        // 21
var Https = Npm.require("https");                                                                                      // 22
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 23
                                                                                                                       //
WrappedUiView = function () {                                                                                          // 25
  function WrappedUiView(token, proxy) {                                                                               // 26
    _classCallCheck(this, WrappedUiView);                                                                              // 26
                                                                                                                       //
    // TODO(someday): handle the fact that these proxies will be garbage collected every 2 minutes,                    //
    // even if it's in use.                                                                                            //
    this.token = token;                                                                                                // 29
    this.proxy = proxy;                                                                                                // 30
  }                                                                                                                    // 31
                                                                                                                       //
  WrappedUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams, retryCount) {
    if (sessionType !== ApiSession.typeId) {                                                                           // 34
      throw new Error("SessionType must be ApiSession.");                                                              // 35
    }                                                                                                                  // 36
                                                                                                                       //
    retryCount = retryCount || 0;                                                                                      // 38
    var _this = this;                                                                                                  // 39
                                                                                                                       //
    return this.proxy.keepAlive().then(function () {                                                                   // 41
      // ignore the passed userInfo and instead use the one associated with this                                       //
      // token TODO(someday): Merge / intersect the two userInfo objects                                               //
      // (especially permissions) rather than only taking the token's user info.                                       //
      // This will allow the caller to request only a subset of the permissions                                        //
      // granted by the token, which is useful to protect against bugs.                                                //
      var session = _this.proxy.uiView.newSession(_this.proxy.userInfo, context, sessionType, sessionParams).session;  // 47
      return { session: session };                                                                                     // 49
    })["catch"](function (error) {                                                                                     // 50
      return _this.proxy.maybeRetryAfterError(error, retryCount).then(function () {                                    // 51
        return _this.newSession(userInfo, context, sessionType, sessionParams, retryCount + 1);                        // 52
      });                                                                                                              // 53
    });                                                                                                                // 54
  };                                                                                                                   // 55
                                                                                                                       //
  return WrappedUiView;                                                                                                // 25
}();                                                                                                                   // 25
                                                                                                                       //
getWrappedUiViewForToken = function getWrappedUiViewForToken(token) {                                                  // 58
  var proxyPromise = getProxyForApiToken(token);                                                                       // 59
                                                                                                                       //
  return proxyPromise.then(function (proxy) {                                                                          // 61
    return { view: new WrappedUiView(token, proxy) };                                                                  // 62
  });                                                                                                                  // 63
};                                                                                                                     // 64
                                                                                                                       //
ExternalUiView = function () {                                                                                         // 66
  function ExternalUiView(url, grainId, token) {                                                                       // 67
    _classCallCheck(this, ExternalUiView);                                                                             // 67
                                                                                                                       //
    this.url = url;                                                                                                    // 68
    this.grainId = grainId;                                                                                            // 69
    this.token = token;                                                                                                // 70
  }                                                                                                                    // 71
                                                                                                                       //
  ExternalUiView.prototype.newSession = function newSession(userInfo, context, sessionType, sessionParams) {           // 66
    if (sessionType !== ApiSession.typeId) {                                                                           // 74
      throw new Error("SessionType must be ApiSession.");                                                              // 75
    }                                                                                                                  // 76
                                                                                                                       //
    var options = {};                                                                                                  // 78
                                                                                                                       //
    if (this.token) {                                                                                                  // 80
      options.headers = {                                                                                              // 81
        authorization: "Bearer " + this.token                                                                          // 82
      };                                                                                                               // 81
    }                                                                                                                  // 84
                                                                                                                       //
    return { session: new Capnp.Capability(new ExternalWebSession(this.url, this.grainId, options), ApiSession) };     // 86
  };                                                                                                                   // 87
                                                                                                                       //
  return ExternalUiView;                                                                                               // 66
}();                                                                                                                   // 66
                                                                                                                       //
var responseCodes = {                                                                                                  // 90
  200: { type: "content", code: "ok" },                                                                                // 91
  201: { type: "content", code: "created" },                                                                           // 92
  202: { type: "content", code: "accepted" },                                                                          // 93
  204: { type: "noContent", shouldResetForm: false },                                                                  // 94
  205: { type: "noContent", shouldResetForm: true },                                                                   // 95
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 206: {type: 'noContent'},                                                                                         //
  // 300: {type: 'redirect'},                                                                                          //
  301: { type: "redirect", switchToGet: true, isPermanent: true },                                                     // 100
  302: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 101
  303: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 102
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 304: {type: 'redirect'},                                                                                          //
  // 305: {type: 'redirect'},                                                                                          //
  307: { type: "redirect", switchToGet: false, isPermanent: false },                                                   // 107
  308: { type: "redirect", switchToGet: false, isPermanent: true },                                                    // 108
  400: { type: "clientError", clientErrorCode: "badRequest", descriptionHtml: "Bad Request" },                         // 109
  403: { type: "clientError", clientErrorCode: "forbidden", descriptionHtml: "Forbidden" },                            // 110
  404: { type: "clientError", clientErrorCode: "notFound", descriptionHtml: "Not Found" },                             // 111
  405: { type: "clientError", clientErrorCode: "methodNotAllowed", descriptionHtml: "Method Not Allowed" },            // 112
  406: { type: "clientError", clientErrorCode: "notAcceptable", descriptionHtml: "Not Acceptable" },                   // 113
  409: { type: "clientError", clientErrorCode: "conflict", descriptionHtml: "Conflict" },                              // 114
  410: { type: "clientError", clientErrorCode: "gone", descriptionHtml: "Gone" },                                      // 115
  413: { type: "clientError", clientErrorCode: "requestEntityTooLarge", descriptionHtml: "Request Entity Too Large" },
  414: { type: "clientError", clientErrorCode: "requestUriTooLong", descriptionHtml: "Request-URI Too Long" },         // 117
  415: { type: "clientError", clientErrorCode: "unsupportedMediaType", descriptionHtml: "Unsupported Media Type" },    // 118
  418: { type: "clientError", clientErrorCode: "imATeapot", descriptionHtml: "I'm a teapot" },                         // 119
  500: { type: "serverError" },                                                                                        // 120
  501: { type: "serverError" },                                                                                        // 121
  502: { type: "serverError" },                                                                                        // 122
  503: { type: "serverError" },                                                                                        // 123
  504: { type: "serverError" },                                                                                        // 124
  505: { type: "serverError" }                                                                                         // 125
};                                                                                                                     // 90
                                                                                                                       //
ExternalWebSession = function () {                                                                                     // 128
  function ExternalWebSession(url, grainId, options) {                                                                 // 129
    _classCallCheck(this, ExternalWebSession);                                                                         // 129
                                                                                                                       //
    var parsedUrl = Url.parse(url);                                                                                    // 130
    this.host = parsedUrl.hostname;                                                                                    // 131
    this.port = parsedUrl.port;                                                                                        // 132
    this.protocol = parsedUrl.protocol;                                                                                // 133
    this.grainId = grainId;                                                                                            // 134
    this.options = options || {};                                                                                      // 135
  }                                                                                                                    // 136
                                                                                                                       //
  ExternalWebSession.prototype.get = function get(path, context) {                                                     // 128
    return this._requestHelper("GET", path, context);                                                                  // 139
  };                                                                                                                   // 140
                                                                                                                       //
  ExternalWebSession.prototype.post = function post(path, content, context) {                                          // 128
    return this._requestHelper("POST", path, context, content.content, content.mimeType);                              // 143
  };                                                                                                                   // 144
                                                                                                                       //
  ExternalWebSession.prototype.put = function put(path, content, context) {                                            // 128
    return this._requestHelper("PUT", path, context, content.content, content.mimeType);                               // 147
  };                                                                                                                   // 148
                                                                                                                       //
  ExternalWebSession.prototype["delete"] = function _delete(path, context) {                                           // 128
    return this._requestHelper("DELETE", path, context);                                                               // 151
  };                                                                                                                   // 152
                                                                                                                       //
  // TODO(someday): implement streaming and websockets for ExternalWebSession                                          //
  //postStreaming(path, mimeType, context) {                                                                           //
  //}                                                                                                                  //
                                                                                                                       //
  //putStreaming(path, mimeType, context) {                                                                            //
  //}                                                                                                                  //
                                                                                                                       //
  //openWebSocket(path, context, protocol, clientStream) {                                                             //
  //}                                                                                                                  //
                                                                                                                       //
  ExternalWebSession.prototype._requestHelper = function _requestHelper(method, path, context, content, contentType) {
    var _this = this;                                                                                                  // 165
    var session = _this;                                                                                               // 166
    return new Promise(function (resolve, reject) {                                                                    // 167
      var options = _.clone(session.options);                                                                          // 168
      options.headers = options.headers || {};                                                                         // 169
      options.path = path;                                                                                             // 170
      options.method = method;                                                                                         // 171
      if (contentType) {                                                                                               // 172
        options.headers["content-type"] = contentType;                                                                 // 173
      }                                                                                                                // 174
                                                                                                                       //
      // set accept header                                                                                             //
      if ("accept" in context) {                                                                                       // 177
        options.headers.accept = context.accept.map(function (acceptedType) {                                          // 178
          return acceptedType.mimeType + "; " + acceptedType.qValue;                                                   // 179
        }).join(", ");                                                                                                 // 180
      } else if (!("accept" in options.headers)) {                                                                     // 181
        options.headers.accept = "*/*";                                                                                // 182
      }                                                                                                                // 183
                                                                                                                       //
      // set cookies                                                                                                   //
      if (context.cookies && context.cookies.length > 0) {                                                             // 186
        options.headers.cookies = options.headers.cookies || "";                                                       // 187
        context.cookies.forEach(function (keyVal) {                                                                    // 188
          options.headers.cookies += keyVal.key + "=" + keyVal.val + ",";                                              // 189
        });                                                                                                            // 190
        options.headers.cookies = options.headers.cookies.slice(0, -1);                                                // 191
      }                                                                                                                // 192
                                                                                                                       //
      options.host = session.host;                                                                                     // 194
      options.port = session.port;                                                                                     // 195
                                                                                                                       //
      var requestMethod = Http.request;                                                                                // 197
      if (session.protocol === "https:") {                                                                             // 198
        requestMethod = Https.request;                                                                                 // 199
      }                                                                                                                // 200
                                                                                                                       //
      req = requestMethod(options, function (resp) {                                                                   // 202
        var buffers = [];                                                                                              // 203
        var statusInfo = responseCodes[resp.statusCode];                                                               // 204
                                                                                                                       //
        var rpcResponse = {};                                                                                          // 206
                                                                                                                       //
        switch (statusInfo.type) {                                                                                     // 208
          case "content":                                                                                              // 209
            resp.on("data", function (buf) {                                                                           // 210
              buffers.push(buf);                                                                                       // 211
            });                                                                                                        // 212
                                                                                                                       //
            resp.on("end", function () {                                                                               // 214
              var content = {};                                                                                        // 215
              rpcResponse.content = content;                                                                           // 216
                                                                                                                       //
              content.statusCode = statusInfo.code;                                                                    // 218
              if ("content-encoding" in resp.headers) content.encoding = resp.headers["content-encoding"];             // 219
              if ("content-language" in resp.headers) content.language = resp.headers["content-language"];             // 220
              if ("content-type" in resp.headers) content.language = resp.headers["content-type"];                     // 221
              if ("content-disposition" in resp.headers) {                                                             // 222
                var disposition = resp.headers["content-disposition"];                                                 // 223
                var parts = disposition.split(";");                                                                    // 224
                if (parts[0].toLowerCase().trim() === "attachment") {                                                  // 225
                  parts.forEach(function (part) {                                                                      // 226
                    var splitPart = part.split("=");                                                                   // 227
                    if (splitPart[0].toLowerCase().trim() === "filename") {                                            // 228
                      content.disposition = { download: splitPart[1].trim() };                                         // 229
                    }                                                                                                  // 230
                  });                                                                                                  // 231
                }                                                                                                      // 232
              }                                                                                                        // 233
                                                                                                                       //
              content.body = {};                                                                                       // 235
              content.body.bytes = Buffer.concat(buffers);                                                             // 236
                                                                                                                       //
              resolve(rpcResponse);                                                                                    // 238
            });                                                                                                        // 239
            break;                                                                                                     // 240
          case "noContent":                                                                                            // 241
            var noContent = {};                                                                                        // 242
            rpcResponse.noContent = noContent;                                                                         // 243
            noContent.setShouldResetForm = statusInfo.shouldResetForm;                                                 // 244
            resolve(rpcResponse);                                                                                      // 245
            break;                                                                                                     // 246
          case "redirect":                                                                                             // 247
            var redirect = {};                                                                                         // 248
            rpcResponse.redirect = redirect;                                                                           // 249
            redirect.isPermanent = statusInfo.isPermanent;                                                             // 250
            redirect.switchToGet = statusInfo.switchToGet;                                                             // 251
            if ("location" in resp.headers) redirect.location = resp.headers.location;                                 // 252
            resolve(rpcResponse);                                                                                      // 253
            break;                                                                                                     // 254
          case "clientError":                                                                                          // 255
            var clientError = {};                                                                                      // 256
            rpcResponse.clientError = clientError;                                                                     // 257
            clientError.statusCode = statusInfo.clientErrorCode;                                                       // 258
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 259
            resolve(rpcResponse);                                                                                      // 260
            break;                                                                                                     // 261
          case "serverError":                                                                                          // 262
            var serverError = {};                                                                                      // 263
            rpcResponse.serverError = serverError;                                                                     // 264
            clientError.descriptionHtml = statusInfo.descriptionHtml;                                                  // 265
            resolve(rpcResponse);                                                                                      // 266
            break;                                                                                                     // 267
          default:                                                                                                     // 268
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 269
            reject(err);                                                                                               // 270
            break;                                                                                                     // 271
        }                                                                                                              // 208
      });                                                                                                              // 273
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 275
        reject(e);                                                                                                     // 276
      });                                                                                                              // 277
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 279
        req.abort();                                                                                                   // 280
        err = new Error("Request timed out.");                                                                         // 281
        err.kjType = "overloaded";                                                                                     // 282
        reject(err);                                                                                                   // 283
      });                                                                                                              // 284
                                                                                                                       //
      if (content) {                                                                                                   // 286
        req.end(content);                                                                                              // 287
      } else {                                                                                                         // 288
        req.end();                                                                                                     // 289
      }                                                                                                                // 290
    });                                                                                                                // 291
  };                                                                                                                   // 292
                                                                                                                       //
  return ExternalWebSession;                                                                                           // 128
}();                                                                                                                   // 128
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"ip.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","bignum","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/ip.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Future = Npm.require("fibers/future");                                                                             // 19
var Net = Npm.require("net");                                                                                          // 20
var Dgram = Npm.require("dgram");                                                                                      // 21
var Promise = Npm.require("es6-promise").Promise;                                                                      // 22
var Capnp = Npm.require("capnp");                                                                                      // 23
                                                                                                                       //
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 25
                                                                                                                       //
ByteStreamConnection = function () {                                                                                   // 27
  function ByteStreamConnection(connection) {                                                                          // 28
    _classCallCheck(this, ByteStreamConnection);                                                                       // 28
                                                                                                                       //
    this.connection = connection;                                                                                      // 29
  }                                                                                                                    // 30
                                                                                                                       //
  ByteStreamConnection.prototype.done = function done() {                                                              // 27
    this.connection.end();                                                                                             // 33
  };                                                                                                                   // 34
                                                                                                                       //
  ByteStreamConnection.prototype.write = function write(data) {                                                        // 27
    this.connection.write(data);                                                                                       // 37
  };                                                                                                                   // 38
                                                                                                                       //
  // expectSize not implemented                                                                                        //
  // expectSize(size) { }                                                                                              //
                                                                                                                       //
                                                                                                                       //
  return ByteStreamConnection;                                                                                         // 27
}();                                                                                                                   // 27
                                                                                                                       //
var IpInterfaceImpl = function (_PersistentImpl) {                                                                     //
  _inherits(IpInterfaceImpl, _PersistentImpl);                                                                         //
                                                                                                                       //
  function IpInterfaceImpl(db, saveTemplate) {                                                                         // 45
    _classCallCheck(this, IpInterfaceImpl);                                                                            // 45
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                             // 45
  }                                                                                                                    // 47
                                                                                                                       //
  IpInterfaceImpl.prototype.listenTcp = function listenTcp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 50
      var resolved = false;                                                                                            // 51
      var server = Net.createServer(function (connection) {                                                            // 52
        var wrappedConnection = new ByteStreamConnection(connection);                                                  // 53
        var upstream = port.connect(wrappedConnection).upstream;                                                       // 54
                                                                                                                       //
        connection.on("data", function (data) {                                                                        // 56
          upstream.write(data);                                                                                        // 57
        });                                                                                                            // 58
                                                                                                                       //
        connection.on("close", function (hadError) {                                                                   // 60
          upstream.done();                                                                                             // 61
        });                                                                                                            // 62
                                                                                                                       //
        connection.on("error", function (err) {                                                                        // 64
          if (resolved) {                                                                                              // 65
            connection.write = errorWrite;                                                                             // 66
          } else {                                                                                                     // 67
            // upstream hasn't been resolved yet, so it's safe to reject                                               //
            reject(err);                                                                                               // 69
          }                                                                                                            // 70
        });                                                                                                            // 71
      });                                                                                                              // 72
                                                                                                                       //
      server.listen(portNum, function () {                                                                             // 74
        resolved = true;                                                                                               // 75
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 76
      });                                                                                                              // 77
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 79
        if (!resolved) {                                                                                               // 80
          reject(err);                                                                                                 // 81
        }                                                                                                              // 82
      });                                                                                                              // 83
    });                                                                                                                // 84
  };                                                                                                                   // 85
                                                                                                                       //
  IpInterfaceImpl.prototype.listenUdp = function listenUdp(portNum, port) {                                            //
    return new Promise(function (resolve, reject) {                                                                    // 88
      var portMap = {};                                                                                                // 89
      var resolved = false;                                                                                            // 90
      var server = Dgram.createSocket("udp4"); // TODO(someday): handle ipv6 sockets too                               // 91
      server.bind(portNum);                                                                                            // 92
                                                                                                                       //
      server.on("listening", function () {                                                                             // 94
        // Although UDP is connectionless, we don't resolve until here so that we can handle bind                      //
        // errors such as invalid host                                                                                 //
        resolved = true;                                                                                               // 97
        resolve({ handle: server }); // server has a close method which is all we want from a handle                   // 98
      });                                                                                                              // 99
                                                                                                                       //
      server.on("error", function (err) {                                                                              // 101
        // TODO(someday): do something about errors after the promise is resolved                                      //
        if (!resolved) {                                                                                               // 103
          reject(err);                                                                                                 // 104
        } else {                                                                                                       // 105
          console.error("error in listenUdp: " + err);                                                                 // 106
        }                                                                                                              // 107
      });                                                                                                              // 108
                                                                                                                       //
      var returnMap = {};                                                                                              // 110
      server.on("message", function (msg, rinfo) {                                                                     // 111
        var address = rinfo.address + "]:" + rinfo.port;                                                               // 112
        var returnPort = returnMap[address];                                                                           // 113
                                                                                                                       //
        if (!returnPort) {                                                                                             // 115
          returnMap[address] = returnPort = new BoundUdpPortImpl(server, rinfo.address, rinfo.port);                   // 116
        }                                                                                                              // 117
                                                                                                                       //
        port.send(msg, returnPort);                                                                                    // 119
      });                                                                                                              // 120
    });                                                                                                                // 121
  };                                                                                                                   // 122
                                                                                                                       //
  return IpInterfaceImpl;                                                                                              //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 123
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 127
  globalFrontendRefRegistry.register({                                                                                 // 128
    frontendRefField: "ipInterface",                                                                                   // 129
    typeId: IpRpc.IpInterface.typeId,                                                                                  // 130
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 132
      return new Capnp.Capability(new IpInterfaceImpl(db, saveTemplate), IpRpc.PersistentIpInterface);                 // 133
    },                                                                                                                 // 135
    validate: function validate(db, session, value) {                                                                  // 137
      check(value, true);                                                                                              // 138
                                                                                                                       //
      if (!session.userId) {                                                                                           // 140
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 141
      }                                                                                                                // 142
                                                                                                                       //
      return {                                                                                                         // 144
        descriptor: { tags: [{ id: IpRpc.IpInterface.typeId }] },                                                      // 145
        requirements: [{ userIsAdmin: session.userId }]                                                                // 146
      };                                                                                                               // 144
    },                                                                                                                 // 148
    query: function query(db, userId, value) {                                                                         // 150
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 151
        return [{                                                                                                      // 152
          _id: "frontendref-ipinterface",                                                                              // 154
          frontendRef: { ipInterface: true },                                                                          // 155
          cardTemplate: "ipInterfacePowerboxCard"                                                                      // 156
        }];                                                                                                            // 153
      } else {                                                                                                         // 159
        return [];                                                                                                     // 160
      }                                                                                                                // 161
    }                                                                                                                  // 162
  });                                                                                                                  // 128
});                                                                                                                    // 164
                                                                                                                       //
BoundUdpPortImpl = function () {                                                                                       // 166
  function BoundUdpPortImpl(server, address, port) {                                                                   // 167
    _classCallCheck(this, BoundUdpPortImpl);                                                                           // 167
                                                                                                                       //
    this.server = server;                                                                                              // 168
    this.address = address;                                                                                            // 169
    this.port = port;                                                                                                  // 170
  }                                                                                                                    // 171
                                                                                                                       //
  BoundUdpPortImpl.prototype.send = function send(message, returnPort) {                                               // 166
    // TODO(someday): this whole class is a hack to deal with the fact that we can't compare                           //
    // capabilities or build a map with them. What we should be doing is mapping all ports to                          //
    // their raw physical address/port, and using that here                                                            //
    this.server.send(message, 0, message.length, this.port, this.address);                                             // 177
  };                                                                                                                   // 178
                                                                                                                       //
  return BoundUdpPortImpl;                                                                                             // 166
}();                                                                                                                   // 166
                                                                                                                       //
var bits16 = Bignum(1).shiftLeft(16).sub(1);                                                                           // 181
var bits32 = Bignum(1).shiftLeft(32).sub(1);                                                                           // 182
                                                                                                                       //
var intToIpv4 = function intToIpv4(num) {                                                                              // 184
  var part1 = num & 255;                                                                                               // 185
  var part2 = num >> 8 & 255;                                                                                          // 186
  var part3 = num >> 16 & 255;                                                                                         // 187
  var part4 = num >> 24 & 255;                                                                                         // 188
                                                                                                                       //
  return part4 + "." + part3 + "." + part2 + "." + part1;                                                              // 190
};                                                                                                                     // 191
                                                                                                                       //
var addressToString = function addressToString(address) {                                                              // 193
  var ipv6num = Bignum(address.upper64).shiftLeft(64).add(Bignum(address.lower64));                                    // 194
                                                                                                                       //
  if (ipv6num.shiftRight(32).eq(bits16)) {                                                                             // 196
    // this is an ipv4 address, we should return it as such                                                            //
    var ipv4num = ipv6num.and(bits32).toNumber();                                                                      // 198
    return intToIpv4(ipv4num);                                                                                         // 199
  }                                                                                                                    // 200
                                                                                                                       //
  var hex = ipv6num.toString(16);                                                                                      // 202
  var numColons = 0;                                                                                                   // 203
  var out = "";                                                                                                        // 204
                                                                                                                       //
  for (var i = 0; i < hex.length; ++i) {                                                                               // 206
    // start with lower bits of address and build the output in reverse                                                //
    // this ensures that we can place a colon every 4 characters                                                       //
    out += hex[hex.length - 1 - i];                                                                                    // 209
    if ((i + 1) % 4 === 0) {                                                                                           // 210
      out += ":";                                                                                                      // 211
      ++numColons;                                                                                                     // 212
    }                                                                                                                  // 213
  }                                                                                                                    // 214
                                                                                                                       //
  // Double colon represents all bits being 0                                                                          //
  if (numColons < 7) {                                                                                                 // 217
    out += "::";                                                                                                       // 218
  }                                                                                                                    // 219
                                                                                                                       //
  return out.split("").reverse().join("");                                                                             // 221
};                                                                                                                     // 222
                                                                                                                       //
var addressType = function addressType(address) {                                                                      // 224
  var type = "udp4";                                                                                                   // 225
                                                                                                                       //
  // Check if it's an ipv6 address                                                                                     //
  // TODO(someday): make this less hacky and change address to explicitly pass this information                        //
  if (address.indexOf(":") != -1) {                                                                                    // 229
    type = "udp6";                                                                                                     // 230
  }                                                                                                                    // 231
                                                                                                                       //
  return type;                                                                                                         // 233
};                                                                                                                     // 234
                                                                                                                       //
var IpNetworkImpl = function (_PersistentImpl2) {                                                                      //
  _inherits(IpNetworkImpl, _PersistentImpl2);                                                                          //
                                                                                                                       //
  function IpNetworkImpl(db, saveTemplate) {                                                                           // 237
    _classCallCheck(this, IpNetworkImpl);                                                                              // 237
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 237
  }                                                                                                                    // 239
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHost = function getRemoteHost(address) {                                            //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 242
  };                                                                                                                   // 243
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHostByName = function getRemoteHostByName(address) {                                //
    return { host: new IpRemoteHostImpl(address) };                                                                    // 246
  };                                                                                                                   // 247
                                                                                                                       //
  return IpNetworkImpl;                                                                                                //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 248
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 252
  globalFrontendRefRegistry.register({                                                                                 // 253
    frontendRefField: "ipNetwork",                                                                                     // 254
    typeId: IpRpc.IpNetwork.typeId,                                                                                    // 255
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 257
      return new Capnp.Capability(new IpNetworkImpl(db, saveTemplate), IpRpc.PersistentIpNetwork);                     // 258
    },                                                                                                                 // 260
    validate: function validate(db, session, value) {                                                                  // 262
      check(value, true);                                                                                              // 263
                                                                                                                       //
      if (!session.userId) {                                                                                           // 265
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 266
      }                                                                                                                // 267
                                                                                                                       //
      return {                                                                                                         // 269
        descriptor: { tags: [{ id: IpRpc.IpNetwork.typeId }] },                                                        // 270
        requirements: [{ userIsAdmin: session.userId }]                                                                // 271
      };                                                                                                               // 269
    },                                                                                                                 // 273
    query: function query(db, userId, value) {                                                                         // 275
      if (userId && Meteor.users.findOne(userId).isAdmin) {                                                            // 276
        return [{                                                                                                      // 277
          _id: "frontendref-ipnetwork",                                                                                // 279
          frontendRef: { ipNetwork: true },                                                                            // 280
          cardTemplate: "ipNetworkPowerboxCard"                                                                        // 281
        }];                                                                                                            // 278
      } else {                                                                                                         // 284
        return [];                                                                                                     // 285
      }                                                                                                                // 286
    }                                                                                                                  // 287
  });                                                                                                                  // 253
});                                                                                                                    // 289
                                                                                                                       //
IpRemoteHostImpl = function () {                                                                                       // 291
  function IpRemoteHostImpl(address) {                                                                                 // 292
    _classCallCheck(this, IpRemoteHostImpl);                                                                           // 292
                                                                                                                       //
    if (address.upper64 || address.upper64 === 0) {                                                                    // 293
      // address is an ip.capnp:IpAddress, we need to convert it                                                       //
      this.address = addressToString(address);                                                                         // 295
    } else {                                                                                                           // 296
      this.address = address;                                                                                          // 297
    }                                                                                                                  // 298
  }                                                                                                                    // 299
                                                                                                                       //
  IpRemoteHostImpl.prototype.getTcpPort = function getTcpPort(portNum) {                                               // 291
    return { port: new TcpPortImpl(this.address, portNum) };                                                           // 302
  };                                                                                                                   // 303
                                                                                                                       //
  IpRemoteHostImpl.prototype.getUdpPort = function getUdpPort(portNum) {                                               // 291
    return { port: new UdpPortImpl(this.address, portNum) };                                                           // 306
  };                                                                                                                   // 307
                                                                                                                       //
  return IpRemoteHostImpl;                                                                                             // 291
}();                                                                                                                   // 291
                                                                                                                       //
TcpPortImpl = function () {                                                                                            // 310
  function TcpPortImpl(address, portNum) {                                                                             // 311
    _classCallCheck(this, TcpPortImpl);                                                                                // 311
                                                                                                                       //
    this.address = address;                                                                                            // 312
    this.port = portNum;                                                                                               // 313
  }                                                                                                                    // 314
                                                                                                                       //
  TcpPortImpl.prototype.connect = function connect(downstream) {                                                       // 310
    var _this = this;                                                                                                  // 317
    var resolved = false;                                                                                              // 318
    return new Promise(function (resolve, reject) {                                                                    // 319
      var client = Net.connect({ host: _this.address, port: _this.port }, function () {                                // 320
        resolved = true;                                                                                               // 321
        resolve({ upstream: new ByteStreamConnection(client) });                                                       // 322
      });                                                                                                              // 323
                                                                                                                       //
      client.on("data", function (data) {                                                                              // 325
        downstream.write(data);                                                                                        // 326
      });                                                                                                              // 327
                                                                                                                       //
      client.on("close", function (hadError) {                                                                         // 329
        downstream.done();                                                                                             // 330
      });                                                                                                              // 331
                                                                                                                       //
      client.on("error", function (err) {                                                                              // 333
        if (resolved) {                                                                                                // 334
          client.write = errorWrite;                                                                                   // 335
        } else {                                                                                                       // 336
          // upstream hasn't been resolved yet, so it's safe to reject                                                 //
          reject(err);                                                                                                 // 338
        }                                                                                                              // 339
      });                                                                                                              // 340
    });                                                                                                                // 341
  };                                                                                                                   // 342
                                                                                                                       //
  return TcpPortImpl;                                                                                                  // 310
}();                                                                                                                   // 310
                                                                                                                       //
var errorWrite = function errorWrite(data) {                                                                           // 345
  throw new Error("error occurred in connection");                                                                     // 346
};                                                                                                                     // 347
                                                                                                                       //
UdpPortImpl = function () {                                                                                            // 349
  function UdpPortImpl(address, portNum) {                                                                             // 350
    _classCallCheck(this, UdpPortImpl);                                                                                // 350
                                                                                                                       //
    this.address = address;                                                                                            // 351
    this.port = portNum;                                                                                               // 352
                                                                                                                       //
    var type = addressType(address);                                                                                   // 354
    this.socket = Dgram.createSocket(type);                                                                            // 355
                                                                                                                       //
    // TODO(someday): close socket after a certain time of inactivity?                                                 //
    // This may be pointless since grains are killed frequently when not in use anyways                                //
                                                                                                                       //
    // Temporary hack. We only expect clients to pass in a single return port, so we'll store it                       //
    // and only send replies here.                                                                                     //
    // This will be changed to be correct when equality comparisons are added to capabilities.                         //
    this.returnPort = null;                                                                                            // 363
                                                                                                                       //
    var _this = this;                                                                                                  // 365
    this.socket.on("message", function (msg, rinfo) {                                                                  // 366
      if (_this.returnPort) {                                                                                          // 367
        _this.returnPort.send(msg, _this);                                                                             // 368
      }                                                                                                                // 369
    });                                                                                                                // 370
  }                                                                                                                    // 371
                                                                                                                       //
  UdpPortImpl.prototype.send = function send(message, returnPort) {                                                    // 349
    this.returnPort = returnPort;                                                                                      // 374
    this.socket.send(message, 0, message.length, this.port, this.address);                                             // 375
                                                                                                                       //
    // TODO(someday): use callback to catch errors and do something with them                                          //
  };                                                                                                                   // 378
                                                                                                                       //
  return UdpPortImpl;                                                                                                  // 349
}();                                                                                                                   // 349
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"mail.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","/imports/server/persistent.js","simplesmtp","mailparser","mailcomposer","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/mail.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});var simplesmtp;module.import("simplesmtp",{"default":function(v){simplesmtp=v}});var MailParser;module.import("mailparser",{"MailParser":function(v){MailParser=v}});var MailComposer;module.import("mailcomposer",{"MailComposer":function(v){MailComposer=v}});var rawSend;module.import("/imports/server/email.js",{"rawSend":function(v){rawSend=v}});
                                                                                                                       //
                                                                                                                       //
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       //
                                                                                                                       // 22
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 24
var Future = Npm.require("fibers/future");                                                                             // 25
var Promise = Npm.require("es6-promise").Promise;                                                                      // 26
var Capnp = Npm.require("capnp");                                                                                      // 27
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 29
var EmailImpl = Capnp.importSystem("sandstorm/email-impl.capnp");                                                      // 30
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 31
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 32
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 33
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 35
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 37
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 38
                                                                                                                       //
var RECIPIENT_LIMIT = 20;                                                                                              // 40
                                                                                                                       //
var CLIENT_TIMEOUT = 15000; // 15s                                                                                     // 42
                                                                                                                       //
// Every day, reset all per-user sent counts to zero.                                                                  //
// TODO(cleanup): Consider a more granular approach. For example, each user could have a timer                         //
//   after which their count will reset. We'd only check the timer when that user is trying to                         //
//   send a new message. This avoids a global query.                                                                   //
if (!Meteor.settings.replicaNumber) {                                                                                  // 48
  // only first replica                                                                                                //
  SandstormDb.periodicCleanup(86400000, function () {                                                                  // 49
    Meteor.users.update({ dailySentMailCount: { $exists: true } }, { $unset: { dailySentMailCount: "" } }, { multi: true });
  });                                                                                                                  // 53
}                                                                                                                      // 54
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 56
  var server = simplesmtp.createSimpleServer({ SMTPBanner: "Sandstorm Mail Server" }, function (req) {                 // 57
    var mailparser = new MailParser();                                                                                 // 58
    req.pipe(mailparser);                                                                                              // 59
                                                                                                                       //
    mailparser.on("end", function (mail) {                                                                             // 61
      // Wrap in outer promise for easier error handling.                                                              //
      Promise.resolve().then(function () {                                                                             // 63
        // Extract the 'from' address.                                                                                 //
        var from = void 0;                                                                                             // 65
        if (mail.from && mail.from.length > 0) {                                                                       // 66
          // It's theoretically possible for the message to have multiple 'from' headers, but this                     //
          // never really happens in legitimate practice so we'll just take the first one.                             //
          from = mail.from[0];                                                                                         // 69
        } else {                                                                                                       // 70
          // The mail body is missing a 'From:' header. We'll use req.from instead. Note that                          //
          // req.from is actually the bounce address, which is sometimes *not* the original sender                     //
          // but rather some intermediate agent (e.g. a mailing list daemon). See:                                     //
          //   http://en.wikipedia.org/wiki/Bounce_address                                                             //
          // TODO(someday): Is this really right, or should we report a blank address instead?                         //
          from = { address: req.from, name: false };                                                                   // 76
        }                                                                                                              // 77
                                                                                                                       //
        var attachments = [];                                                                                          // 79
        if (mail.attachments) {                                                                                        // 80
          attachments = mail.attachments.map(function (attachment) {                                                   // 81
            var disposition = attachment.contentDisposition || "attachment";                                           // 82
            disposition += ';\n\tfilename="' + (attachment.fileName || attachment.generatedFileName) + '"';            // 83
            return {                                                                                                   // 84
              contentType: attachment.contentType,                                                                     // 85
              contentDisposition: disposition,                                                                         // 86
              contentId: attachment.contentId,                                                                         // 87
              content: attachment.content                                                                              // 88
            };                                                                                                         // 84
          });                                                                                                          // 90
        }                                                                                                              // 91
                                                                                                                       //
        if (mail.replyTo && mail.replyTo.length > 1) {                                                                 // 93
          console.error("More than one reply-to address address was received in an email.");                           // 94
        }                                                                                                              // 95
                                                                                                                       //
        var mailMessage = {                                                                                            // 97
          // Note that converting the date to nanoseconds actually goes outside the range of                           //
          // integers that Javascript can represent precisely. But this is OK because dates aren't                     //
          // precise anyway.                                                                                           //
          date: (mail.date || new Date()).getTime() * 1000000,                                                         // 101
          from: from,                                                                                                  // 102
          to: mail.to,                                                                                                 // 103
          cc: mail.cc || [],                                                                                           // 104
          bcc: mail.bcc || [],                                                                                         // 105
          replyTo: mail.replyTo && mail.replyTo[0] || {},                                                              // 106
          messageId: mail.headers["message-id"] || Meteor.uuid() + "@" + HOSTNAME,                                     // 107
          references: mail.references || [],                                                                           // 108
          inReplyTo: mail.inReplyTo || [],                                                                             // 109
          subject: mail.subject || "",                                                                                 // 110
          text: mail.text || null,                                                                                     // 111
          html: mail.html || null,                                                                                     // 112
          attachments: attachments                                                                                     // 113
        };                                                                                                             // 97
                                                                                                                       //
        // Get list of grain IDs.                                                                                      //
        var grainPublicIds = _.uniq(req.to.map(function (deliverTo) {                                                  // 117
          // simplesmtp already validates that the address contains an @.                                              //
          // To simplify things, we ignore the hostname part of the address and assume that the                        //
          // message would not have been sent here if it weren't intended for our host. Usually                        //
          // there will be an nginx frontend verifying hostnames anyway. Grain public IDs are                          //
          // globally unique anyway, so an e-mail meant for another server presumably won't match                      //
          // any ID at this one anyway.                                                                                //
          return deliverTo.slice(0, deliverTo.indexOf("@"));                                                           // 124
        }));                                                                                                           // 125
                                                                                                                       //
        // Deliver to each grain in parallel.                                                                          //
        return Promise.all(grainPublicIds.map(function (publicId) {                                                    // 128
          // Wrap in a function so that we can call it recursively to retry.                                           //
          var tryDeliver = function tryDeliver(retryCount) {                                                           // 130
            var grainId = void 0;                                                                                      // 131
            return inMeteor(function () {                                                                              // 132
              var grain = Grains.findOne({ publicId: publicId }, { fields: {} });                                      // 133
              if (grain) {                                                                                             // 134
                grainId = grain._id;                                                                                   // 135
                return globalBackend.continueGrain(grainId, retryCount > 0);                                           // 136
              } else {                                                                                                 // 137
                // TODO(someday): We really ought to rig things up so that the 'RCPT TO' SMTP command                  //
                //   fails in this case, but simplesmtp doesn't appear to support that.                                //
                throw new Error("No such grain: " + publicId);                                                         // 140
              }                                                                                                        // 141
            }).then(function (grainInfo) {                                                                             // 142
              var supervisor = grainInfo.supervisor;                                                                   // 143
              var uiView = supervisor.getMainView().view;                                                              // 144
                                                                                                                       //
              // Create an arbitrary struct to use as the session params. E-mail sessions actually                     //
              // require no params, but node-capnp won't let us pass null and we don't have an                         //
              // EmptyStruct type available, so we just use EmailAddress, but any struct type would                    //
              // work.                                                                                                 //
              // TODO(cleanup): Fix node-capnp to accept null.                                                         //
              var emptyParams = Capnp.serialize(EmailRpc.EmailAddress, {});                                            // 151
                                                                                                                       //
              // Create a new session of type HackEmailSession. This is a short-term hack until                        //
              // persistent capabilities and the Powerbox are implemented. We need to pass along a                     //
              // HackSessionContext because old versions of sandstorm-http-bridge always use                           //
              // the context of the most recent session; if an old RoundCube grain has a                               //
              // WebSession open, receives an email, and then tries to send an email, the request                      //
              // will go out on the SessionContext associated with the HackEmailSession that                           //
              // delivered the email.                                                                                  //
              var session = uiView.newSession({}, makeHackSessionContext(grainId), "0xc3b5ced7344b04a6", emptyParams).session.castAs(EmailSendPort);
              return session.send(mailMessage);                                                                        // 164
            })["catch"](function (err) {                                                                               // 165
              if (SandstormBackend.shouldRestartGrain(err, retryCount)) {                                              // 166
                return tryDeliver(retryCount + 1);                                                                     // 167
              } else {                                                                                                 // 168
                throw err;                                                                                             // 169
              }                                                                                                        // 170
            });                                                                                                        // 171
          };                                                                                                           // 172
                                                                                                                       //
          return tryDeliver(0);                                                                                        // 174
        }));                                                                                                           // 175
      }).then(function () {                                                                                            // 176
        req.accept();                                                                                                  // 177
      }, function (err) {                                                                                              // 178
        console.error("E-mail delivery failure:", err.stack);                                                          // 179
        req.reject(err.message);                                                                                       // 180
      });                                                                                                              // 181
    });                                                                                                                // 182
  });                                                                                                                  // 183
                                                                                                                       //
  if (global.SANDSTORM_SMTP_LISTEN_HANDLE) {                                                                           // 185
    server.listen(global.SANDSTORM_SMTP_LISTEN_HANDLE);                                                                // 186
  } else {                                                                                                             // 187
    // We must be running `run-dev.sh`.                                                                                //
    var BIND_IP = process.env.BIND_IP || "127.0.0.1";                                                                  // 189
    var SMTP_LISTEN_PORT = Meteor.settings["public"].smtpListenPort || 30025;                                          // 190
    server.listen(SMTP_LISTEN_PORT, BIND_IP);                                                                          // 191
  }                                                                                                                    // 192
});                                                                                                                    // 193
                                                                                                                       //
function formatAddress(field) {                                                                                        // 195
  if (!field) {                                                                                                        // 196
    return null;                                                                                                       // 197
  }                                                                                                                    // 198
                                                                                                                       //
  if (Array.isArray(field)) {                                                                                          // 200
    return field.map(formatAddress);                                                                                   // 201
  }                                                                                                                    // 202
                                                                                                                       //
  if (field.name) {                                                                                                    // 204
    return field.name + " <" + field.address + ">";                                                                    // 205
  }                                                                                                                    // 206
                                                                                                                       //
  return field.address;                                                                                                // 208
}                                                                                                                      // 209
                                                                                                                       //
hackSendEmail = function hackSendEmail(session, email) {                                                               // 211
  return inMeteor(function () {                                                                                        // 212
    var recipientCount = 0;                                                                                            // 213
    recipientCount += email.to ? email.to.length : 0;                                                                  // 214
    recipientCount += email.cc ? email.cc.length : 0;                                                                  // 215
    recipientCount += email.bcc ? email.bcc.length : 0;                                                                // 216
    if (recipientCount > RECIPIENT_LIMIT) {                                                                            // 217
      throw new Error("Sorry, Sandstorm currently only allows you to send an e-mail to " + RECIPIENT_LIMIT + " recipients at a time, for spam control. Consider setting up a mailing list. " + "Please feel free to contact us if this is a problem for you.");
    }                                                                                                                  // 222
                                                                                                                       //
    var grainAddress = session._getAddress();                                                                          // 224
    var userAddress = session._getUserAddress();                                                                       // 225
                                                                                                                       //
    // Overwrite the 'from' address with the grain's address.                                                          //
    if (!email.from) {                                                                                                 // 228
      email.from = {                                                                                                   // 229
        address: grainAddress                                                                                          // 230
      };                                                                                                               // 229
    }                                                                                                                  // 232
                                                                                                                       //
    if (email.from.address !== grainAddress && email.from.address !== userAddress.address) {                           // 234
      throw new Error("FROM header in outgoing emails need to equal either " + grainAddress + " or " + userAddress.address + ". Yours was: " + email.from.address);
    }                                                                                                                  // 238
                                                                                                                       //
    var mc = new MailComposer();                                                                                       // 240
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 242
      from: formatAddress(email.from),                                                                                 // 243
      to: formatAddress(email.to),                                                                                     // 244
      cc: formatAddress(email.cc),                                                                                     // 245
      bcc: formatAddress(email.bcc),                                                                                   // 246
      replyTo: formatAddress(email.replyTo),                                                                           // 247
      subject: email.subject,                                                                                          // 248
      text: email.text,                                                                                                // 249
      html: email.html                                                                                                 // 250
    });                                                                                                                // 242
                                                                                                                       //
    var envelope = mc.getEnvelope();                                                                                   // 253
    envelope.from = grainAddress;                                                                                      // 254
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 256
      envelope: envelope                                                                                               // 257
    });                                                                                                                // 256
                                                                                                                       //
    var headers = {};                                                                                                  // 260
    if (email.messageId) {                                                                                             // 261
      mc.addHeader("message-id", email.messageId);                                                                     // 262
    }                                                                                                                  // 263
                                                                                                                       //
    if (email.references) {                                                                                            // 265
      mc.addHeader("references", email.references);                                                                    // 266
    }                                                                                                                  // 267
                                                                                                                       //
    if (email.inReplyTo) {                                                                                             // 269
      mc.addHeader("in-reply-to", email.inReplyTo);                                                                    // 270
    }                                                                                                                  // 271
                                                                                                                       //
    if (email.date) {                                                                                                  // 273
      var date = new Date(email.date / 1000000);                                                                       // 274
      if (!isNaN(date.getTime())) {                                                                                    // 275
        // Check to make sure date is valid                                                                            //
        mc.addHeader("date", date.toUTCString());                                                                      // 276
      }                                                                                                                // 277
    }                                                                                                                  // 278
                                                                                                                       //
    if (email.attachments) {                                                                                           // 280
      email.attachments.forEach(function (attachment) {                                                                // 281
        mc.addAttachment({                                                                                             // 282
          cid: attachment.contentId,                                                                                   // 283
          contentType: attachment.contentType,                                                                         // 284
          contentDisposition: attachment.contentDisposition,                                                           // 285
          contents: attachment.content                                                                                 // 286
        });                                                                                                            // 282
      });                                                                                                              // 288
    }                                                                                                                  // 289
                                                                                                                       //
    var grain = Grains.findOne(session.grainId);                                                                       // 291
    if (!grain) throw new Error("Grain does not exist.");                                                              // 292
    globalDb.incrementDailySentMailCount(grain.userId);                                                                // 293
                                                                                                                       //
    rawSend(mc);                                                                                                       // 295
  }.bind(_this))["catch"](function (err) {                                                                             // 296
    console.error("Error sending e-mail:", err.stack);                                                                 // 297
    throw err;                                                                                                         // 298
  });                                                                                                                  // 299
};                                                                                                                     // 300
                                                                                                                       //
var EmailVerifierImpl = function (_PersistentImpl) {                                                                   //
  _inherits(EmailVerifierImpl, _PersistentImpl);                                                                       //
                                                                                                                       //
  function EmailVerifierImpl(db, saveTemplate, params) {                                                               // 303
    _classCallCheck(this, EmailVerifierImpl);                                                                          // 303
                                                                                                                       //
    var _this2 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 303
                                                                                                                       //
    _this2._id = params.id;                                                                                            // 305
    _this2._services = params.services;                                                                                // 306
    return _this2;                                                                                                     // 303
  }                                                                                                                    // 307
                                                                                                                       //
  EmailVerifierImpl.prototype.getId = function getId() {                                                               //
    return { id: new Buffer(this._id, "base64") };                                                                     // 310
  };                                                                                                                   // 311
                                                                                                                       //
  EmailVerifierImpl.prototype.verifyEmail = function verifyEmail(tabId, verification) {                                //
    var _this3 = this;                                                                                                 // 313
                                                                                                                       //
    return unwrapFrontendCap(verification, "verifiedEmail", function (verification) {                                  // 314
      if (verification.tabId !== tabId.toString("hex")) {                                                              // 315
        throw new Error("VerifiedEmail is from a different tab");                                                      // 316
      }                                                                                                                // 317
                                                                                                                       //
      if (_this3._services) {                                                                                          // 319
        // Since this verifier is restricted to specific services, only indicate a match if the                        //
        // VerifiedEmail was for the correct verifier ID. (If our _services is null, then we                           //
        // match all services, and therefore all VerifiedEmails.)                                                      //
        if (verification.verifierId !== _this3._id) {                                                                  // 323
          throw new Error("VerifierEmail is for a different EmailVerifier.");                                          // 324
        }                                                                                                              // 325
      }                                                                                                                // 326
                                                                                                                       //
      return verification.address;                                                                                     // 328
    });                                                                                                                // 329
  };                                                                                                                   // 330
                                                                                                                       //
  return EmailVerifierImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 331
                                                                                                                       //
var VerifiedEmailImpl = function (_PersistentImpl2) {                                                                  //
  _inherits(VerifiedEmailImpl, _PersistentImpl2);                                                                      //
                                                                                                                       //
  function VerifiedEmailImpl(db, saveTemplate) {                                                                       // 334
    _classCallCheck(this, VerifiedEmailImpl);                                                                          // 334
                                                                                                                       //
    return _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                            // 334
  }                                                                                                                    // 336
                                                                                                                       //
  return VerifiedEmailImpl;                                                                                            //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
function getVerifiedEmails(db, userId, verifierId) {                                                                   // 339
  // Get all of the email addresses verified as belonging to the given user using the given                            //
  // verifier.                                                                                                         //
                                                                                                                       //
  var services = null;                                                                                                 // 343
                                                                                                                       //
  if (verifierId) {                                                                                                    // 345
    var verifier = db.collections.apiTokens.findOne({ "frontendRef.emailVerifier.id": verifierId });                   // 346
    if (!verifier) return []; // invalid verifier                                                                      // 348
    var verifierInfo = verifier.frontendRef.emailVerifier;                                                             // 349
                                                                                                                       //
    if (verifierInfo.services) {                                                                                       // 351
      // Limit to the listed services.                                                                                 //
      services = {};                                                                                                   // 353
      verifierInfo.services.forEach(function (service) {                                                               // 354
        return services[service] = true;                                                                               // 354
      });                                                                                                              // 354
    }                                                                                                                  // 355
  }                                                                                                                    // 356
                                                                                                                       //
  var user = Meteor.users.findOne(userId);                                                                             // 358
  var emails = {}; // map address -> true, for uniquification                                                          // 359
  Meteor.users.find({ _id: { $in: SandstormDb.getUserIdentityIds(user) } }).forEach(function (identity) {              // 360
    if (!services || services[identity.profile.service]) {                                                             // 361
      SandstormDb.getVerifiedEmails(identity).forEach(function (email) {                                               // 362
        emails[email.email] = true;                                                                                    // 362
      });                                                                                                              // 362
    }                                                                                                                  // 363
  });                                                                                                                  // 364
                                                                                                                       //
  return Object.keys(emails);                                                                                          // 366
}                                                                                                                      // 367
                                                                                                                       //
// TODO(cleanup): Meteor.startup() needed because 00-startup.js runs *after* code in subdirectories                    //
//   (ugh).                                                                                                            //
Meteor.startup(function () {                                                                                           // 371
  globalFrontendRefRegistry.register({                                                                                 // 372
    frontendRefField: "emailVerifier",                                                                                 // 373
    typeId: EmailRpc.EmailVerifier.typeId,                                                                             // 374
                                                                                                                       //
    restore: function restore(db, saveTemplate, params) {                                                              // 376
      return new Capnp.Capability(new EmailVerifierImpl(db, saveTemplate, params), EmailImpl.PersistentEmailVerifier);
    },                                                                                                                 // 379
    validate: function validate(db, session, value) {                                                                  // 381
      check(value, { services: Match.Optional([String]) });                                                            // 382
                                                                                                                       //
      var services = value.services;                                                                                   // 384
      if (services) {                                                                                                  // 385
        services.forEach(function (service) {                                                                          // 386
          if (!Accounts.identityServices[service]) {                                                                   // 387
            throw new Error("No such identity service: " + service);                                                   // 388
          }                                                                                                            // 389
        });                                                                                                            // 390
      }                                                                                                                // 391
                                                                                                                       //
      value.id = Crypto.randomBytes(16).toString("base64");                                                            // 393
                                                                                                                       //
      return {                                                                                                         // 395
        descriptor: { tags: [{ id: EmailRpc.EmailVerifier.typeId }] },                                                 // 396
        requirements: []                                                                                               // 397
      };                                                                                                               // 395
    },                                                                                                                 // 399
    query: function query(db, userId, value) {                                                                         // 401
      var results = [];                                                                                                // 402
                                                                                                                       //
      results.push({                                                                                                   // 404
        _id: "emailverifier-all",                                                                                      // 405
        frontendRef: { emailVerifier: {} },                                                                            // 406
        cardTemplate: "emailVerifierPowerboxCard"                                                                      // 407
      });                                                                                                              // 404
                                                                                                                       //
      for (var name in Accounts.identityServices) {                                                                    // 410
        if (Accounts.identityServices[name].isEnabled()) {                                                             // 411
          results.push({                                                                                               // 412
            _id: "emailverifier-" + name,                                                                              // 413
            frontendRef: { emailVerifier: { services: [name] } },                                                      // 414
            cardTemplate: "emailVerifierPowerboxCard"                                                                  // 415
          });                                                                                                          // 412
        }                                                                                                              // 417
      };                                                                                                               // 418
                                                                                                                       //
      return results;                                                                                                  // 420
    }                                                                                                                  // 421
  });                                                                                                                  // 372
                                                                                                                       //
  globalFrontendRefRegistry.register({                                                                                 // 424
    frontendRefField: "verifiedEmail",                                                                                 // 425
    typeId: EmailRpc.VerifiedEmail.typeId,                                                                             // 426
                                                                                                                       //
    restore: function restore(db, saveTemplate) {                                                                      // 428
      return new Capnp.Capability(new VerifiedEmailImpl(db, saveTemplate), EmailImpl.PersistentVerifiedEmail);         // 429
    },                                                                                                                 // 431
    validate: function validate(db, session, value) {                                                                  // 433
      check(value, { verifierId: Match.Optional(String), address: String });                                           // 434
                                                                                                                       //
      if (!session.userId) {                                                                                           // 436
        throw new Meteor.Error(403, "Not logged in.");                                                                 // 437
      }                                                                                                                // 438
                                                                                                                       //
      // Verify that the address actually belongs to the user.                                                         //
                                                                                                                       //
      if (!_.contains(getVerifiedEmails(db, session.userId, value.verifierId), value.address)) {                       // 442
        throw new Meteor.Error(403, "User has no such verified address");                                              // 443
      }                                                                                                                // 444
                                                                                                                       //
      // Add the session's tabId.                                                                                      //
      value.tabId = session.tabId;                                                                                     // 447
                                                                                                                       //
      // Build the descriptor, which contains the verifier ID.                                                         //
      var tagValue = value.verifierId && Capnp.serialize(EmailRpc.VerifiedEmail.PowerboxTag, { verifierId: new Buffer(value.verifierId, "hex") });
                                                                                                                       //
      return {                                                                                                         // 454
        descriptor: { tags: [{ id: EmailRpc.VerifiedEmail.typeId, value: tagValue }] },                                // 455
        requirements: []                                                                                               // 456
      };                                                                                                               // 454
    },                                                                                                                 // 458
    query: function query(db, userId, value) {                                                                         // 460
      var verifierId = value && Capnp.parse(EmailRpc.VerifiedEmail.PowerboxTag, value).verifierId.toString("base64");  // 461
      return getVerifiedEmails(db, userId, verifierId).map(function (address) {                                        // 463
        return {                                                                                                       // 463
          _id: "email-" + address,                                                                                     // 464
          frontendRef: { verifiedEmail: { verifierId: verifierId, address: address } },                                // 465
          cardTemplate: "verifiedEmailPowerboxCard"                                                                    // 466
        };                                                                                                             // 463
      });                                                                                                              // 463
    }                                                                                                                  // 468
  });                                                                                                                  // 424
});                                                                                                                    // 470
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"00-startup.js":["/imports/db-deprecated.js","/imports/server/frontend-ref.js","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/00-startup.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.import("/imports/db-deprecated.js");var FrontendRefRegistry;module.import("/imports/server/frontend-ref.js",{"FrontendRefRegistry":function(v){FrontendRefRegistry=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       //
globalFrontendRefRegistry = new FrontendRefRegistry();                                                                 // 21
                                                                                                                       //
SandstormPowerbox.registerUiViewQueryHandler(globalFrontendRefRegistry);                                               // 23
                                                                                                                       //
if (global.BlackrockPayments && BlackrockPayments.registerPaymentsApi) {                                               // 25
  // TODO(cleanup): Meteor.startup() needed because unwrapFrontendCap is not defined yet when this                     //
  //   first runs. Move it into an import.                                                                             //
  Meteor.startup(function () {                                                                                         // 28
    BlackrockPayments.registerPaymentsApi(globalFrontendRefRegistry, PersistentImpl, unwrapFrontendCap);               // 29
  });                                                                                                                  // 31
}                                                                                                                      // 32
                                                                                                                       //
getWildcardOrigin = globalDb.getWildcardOrigin.bind(globalDb);                                                         // 34
                                                                                                                       //
Meteor.onConnection(function (connection) {                                                                            // 36
  // TODO(cleanup): This is the best way I've thought of so far to allow methods declared in                           //
  //   packages to actually use the DB, but it's pretty sad.                                                           //
  connection.sandstormDb = globalDb;                                                                                   // 39
  connection.frontendRefRegistry = globalFrontendRefRegistry;                                                          // 40
});                                                                                                                    // 41
SandstormDb.periodicCleanup(5 * 60 * 1000, SandstormPermissions.cleanupSelfDestructing(globalDb));                     // 42
SandstormDb.periodicCleanup(10 * 60 * 1000, SandstormPermissions.cleanupClientPowerboxTokens(globalDb));               // 43
SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                         // 45
  SandstormAutoupdateApps.updateAppIndex(globalDb);                                                                    // 46
});                                                                                                                    // 47
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 49
  globalDb.migrateToLatest();                                                                                          // 49
});                                                                                                                    // 49
LDAP_DEFAULTS.url = globalDb.getLdapUrl();                                                                             // 50
LDAP_DEFAULTS.base = globalDb.getLdapBase();                                                                           // 51
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"admin-server.js":["babel-runtime/helpers/objectWithoutProperties","meteor/meteor","fs","crypto","heapdump","/imports/server/auth.js","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _objectWithoutProperties;module.import("babel-runtime/helpers/objectWithoutProperties",{"default":function(v){_objectWithoutProperties=v}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Heapdump;module.import("heapdump",{"default":function(v){Heapdump=v}});var clearAdminToken,checkAuth,tokenIsValid,tokenIsSetupSession;module.import("/imports/server/auth.js",{"clearAdminToken":function(v){clearAdminToken=v},"checkAuth":function(v){checkAuth=v},"tokenIsValid":function(v){tokenIsValid=v},"tokenIsSetupSession":function(v){tokenIsSetupSession=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       //
var publicAdminSettings = ["google", "github", "ldap", "saml", "emailToken", "splashUrl", "signupDialog", "adminAlert", "adminAlertTime", "adminAlertUrl", "termsUrl", "privacyUrl", "appMarketUrl", "appIndexUrl", "appUpdatesEnabled", "serverTitle", "returnAddress", "ldapNameField", "organizationMembership", "organizationSettings", "whitelabelCustomLoginProviderName", "whitelabelCustomLogoAssetId", "whitelabelHideSendFeedback", "whitelabelHideTroubleshooting", "whitelabelUseServerTitleForHomeText"];
                                                                                                                       //
var FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS = ["customer", "expires", "features", "isElasticBilling", "isTrial", "issued", "userLimit"];
                                                                                                                       //
var PUBLIC_FEATURE_KEY_FIELDS = ["expires", "features"];                                                               // 41
                                                                                                                       //
var smtpConfigShape = {                                                                                                // 45
  hostname: String,                                                                                                    // 46
  port: Number,                                                                                                        // 47
  auth: {                                                                                                              // 48
    user: String,                                                                                                      // 49
    pass: String                                                                                                       // 50
  },                                                                                                                   // 48
  returnAddress: String                                                                                                // 52
};                                                                                                                     // 45
                                                                                                                       //
Meteor.methods({                                                                                                       // 55
  setAccountSetting: function setAccountSetting(token, serviceName, value) {                                           // 56
    checkAuth(token);                                                                                                  // 57
    check(serviceName, String);                                                                                        // 58
    check(value, Boolean);                                                                                             // 59
                                                                                                                       //
    // TODO(someday): currently this relies on the fact that an account is tied to a single                            //
    // identity, and thus has only that entry in "services". This will need to be looked at when                       //
    // multiple login methods/identities are allowed for a single account.                                             //
    if (!value && !tokenIsValid(token) && !tokenIsSetupSession(token) && serviceName in Meteor.user().services) {      // 64
      throw new Meteor.Error(403, "You can not disable the login service that your account uses.");                    // 65
    }                                                                                                                  // 67
                                                                                                                       //
    // Only check configurations for OAuth services.                                                                   //
    var oauthServices = ["google", "github"];                                                                          // 70
    if (value && oauthServices.indexOf(serviceName) != -1) {                                                           // 71
      var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                // 72
      var config = ServiceConfiguration.configurations.findOne({ service: serviceName });                              // 73
      if (!config) {                                                                                                   // 74
        throw new Meteor.Error(403, "You must configure the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 77
                                                                                                                       //
      if (!config.clientId || !config.secret) {                                                                        // 79
        throw new Meteor.Error(403, "You must provide a non-empty clientId and secret for the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
      }                                                                                                                // 82
    }                                                                                                                  // 83
                                                                                                                       //
    Settings.upsert({ _id: serviceName }, { $set: { value: value } });                                                 // 85
    if (value) {                                                                                                       // 86
      Settings.update({ _id: serviceName }, { $unset: { automaticallyReset: 1 } });                                    // 87
    }                                                                                                                  // 88
  },                                                                                                                   // 89
                                                                                                                       //
  setSmtpConfig: function setSmtpConfig(token, config) {                                                               // 91
    checkAuth(token);                                                                                                  // 92
    check(config, smtpConfigShape);                                                                                    // 93
                                                                                                                       //
    Settings.upsert({ _id: "smtpConfig" }, { $set: { value: config } });                                               // 95
  },                                                                                                                   // 96
                                                                                                                       //
  setSetting: function setSetting(token, name, value) {                                                                // 98
    checkAuth(token);                                                                                                  // 99
    check(name, String);                                                                                               // 100
    check(value, Match.OneOf(null, String, Date, Boolean));                                                            // 101
                                                                                                                       //
    Settings.upsert({ _id: name }, { $set: { value: value } });                                                        // 103
  },                                                                                                                   // 104
                                                                                                                       //
  submitFeatureKey: function submitFeatureKey(token, textBlock) {                                                      // 106
    checkAuth(token);                                                                                                  // 107
    check(textBlock, Match.OneOf(null, String));                                                                       // 108
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 110
                                                                                                                       //
    if (!textBlock) {                                                                                                  // 112
      // Delete the feature key.                                                                                       //
      db.collections.featureKey.remove("currentFeatureKey");                                                           // 114
      return;                                                                                                          // 115
    }                                                                                                                  // 116
                                                                                                                       //
    // textBlock is a base64'd string, possibly with newlines and comment lines starting with "-"                      //
    var featureKeyBase64 = _.chain(textBlock.split("\n")).filter(function (line) {                                     // 119
      return line.length > 0 && line[0] !== "-";                                                                       // 120
    }).value().join("");                                                                                               // 120
                                                                                                                       //
    var buf = new Buffer(featureKeyBase64, "base64");                                                                  // 124
    if (buf.length < 64) {                                                                                             // 125
      throw new Meteor.Error(401, "Invalid feature key");                                                              // 126
    }                                                                                                                  // 127
                                                                                                                       //
    // loadSignedFeatureKey is provided in feature-key.js                                                              //
    var featureKey = loadSignedFeatureKey(buf);                                                                        // 130
    if (!featureKey) {                                                                                                 // 131
      throw new Meteor.Error(401, "Invalid feature key");                                                              // 132
    }                                                                                                                  // 133
                                                                                                                       //
    // Persist the feature key in the database.                                                                        //
    db.collections.featureKey.upsert("currentFeatureKey", {                                                            // 136
      _id: "currentFeatureKey",                                                                                        // 139
      value: buf                                                                                                       // 140
    });                                                                                                                // 138
  },                                                                                                                   // 143
                                                                                                                       //
  saveOrganizationSettings: function saveOrganizationSettings(token, params) {                                         // 145
    checkAuth(token);                                                                                                  // 146
    check(params, {                                                                                                    // 147
      membership: {                                                                                                    // 148
        emailToken: {                                                                                                  // 149
          enabled: Boolean,                                                                                            // 150
          domain: String                                                                                               // 151
        },                                                                                                             // 149
        google: {                                                                                                      // 153
          enabled: Boolean,                                                                                            // 154
          domain: String                                                                                               // 155
        },                                                                                                             // 153
        ldap: {                                                                                                        // 157
          enabled: Boolean                                                                                             // 158
        },                                                                                                             // 157
        saml: {                                                                                                        // 160
          enabled: Boolean                                                                                             // 161
        }                                                                                                              // 160
      },                                                                                                               // 148
      settings: {                                                                                                      // 164
        disallowGuests: Boolean,                                                                                       // 165
        shareContacts: Boolean                                                                                         // 166
      }                                                                                                                // 164
    });                                                                                                                // 147
                                                                                                                       //
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationMembership" }, { value: params.membership });
    this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationSettings" }, { value: params.settings });
  },                                                                                                                   // 172
                                                                                                                       //
                                                                                                                       //
  adminConfigureLoginService: function adminConfigureLoginService(token, options) {                                    // 174
    checkAuth(token);                                                                                                  // 175
    check(options, Match.ObjectIncluding({ service: String }));                                                        // 176
                                                                                                                       //
    var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                  // 178
                                                                                                                       //
    ServiceConfiguration.configurations.upsert({ service: options.service }, options);                                 // 180
  },                                                                                                                   // 181
                                                                                                                       //
  clearResumeTokensForService: function clearResumeTokensForService(token, serviceName) {                              // 183
    checkAuth(token);                                                                                                  // 184
    check(serviceName, String);                                                                                        // 185
                                                                                                                       //
    var query = {};                                                                                                    // 187
    query["services." + serviceName] = { $exists: true };                                                              // 188
    Meteor.users.find(query).forEach(function (identity) {                                                             // 189
      if (identity.services.resume && identity.services.resume.loginTokens && identity.services.resume.loginTokens.length > 0) {
        Meteor.users.update({ _id: identity._id }, { $set: { "services.resume.loginTokens": [] } });                   // 192
      }                                                                                                                // 193
                                                                                                                       //
      Meteor.users.update({ "loginIdentities.id": identity._id }, { $set: { "services.resume.loginTokens": [] } });    // 195
    });                                                                                                                // 197
  },                                                                                                                   // 198
                                                                                                                       //
  adminUpdateUser: function adminUpdateUser(token, userInfo) {                                                         // 200
    checkAuth(token);                                                                                                  // 201
    check(userInfo, {                                                                                                  // 202
      userId: String,                                                                                                  // 203
      signupKey: Boolean,                                                                                              // 204
      isAdmin: Boolean                                                                                                 // 205
    });                                                                                                                // 202
                                                                                                                       //
    var userId = userInfo.userId;                                                                                      // 208
    if (userId === Meteor.userId() && !userInfo.isAdmin) {                                                             // 209
      throw new Meteor.Error(403, "User cannot remove admin permissions from itself.");                                // 210
    }                                                                                                                  // 211
                                                                                                                       //
    Meteor.users.update({ _id: userId }, { $set: _.omit(userInfo, ["_id", "userId"]) });                               // 213
  },                                                                                                                   // 214
                                                                                                                       //
  testSend: function testSend(token, smtpConfig, to) {                                                                 // 216
    checkAuth(token);                                                                                                  // 217
    check(smtpConfig, smtpConfigShape);                                                                                // 218
    check(to, String);                                                                                                 // 219
    var returnAddress = smtpConfig.returnAddress;                                                                      // 216
                                                                                                                       //
    var restConfig = _objectWithoutProperties(smtpConfig, ["returnAddress"]);                                          // 216
                                                                                                                       //
    try {                                                                                                              // 222
      sendEmail({                                                                                                      // 223
        to: to,                                                                                                        // 224
        from: globalDb.getServerTitle() + " <" + returnAddress + ">",                                                  // 225
        subject: "Testing your Sandstorm's SMTP setting",                                                              // 226
        text: "Success! Your outgoing SMTP is working.",                                                               // 227
        smtpConfig: restConfig                                                                                         // 228
      });                                                                                                              // 223
    } catch (e) {                                                                                                      // 230
      // Attempt to give more accurate error messages for a variety of known failure modes,                            //
      // and the actual exception data in the event a user hits a new failure mode.                                    //
      if (e.syscall === "getaddrinfo") {                                                                               // 233
        if (e.code === "EIO" || e.code === "ENOTFOUND") {                                                              // 234
          throw new Meteor.Error("getaddrinfo " + e.code, "Couldn't resolve \"" + smtpConfig.hostname + "\" - check for typos or broken DNS.");
        }                                                                                                              // 236
      } else if (e.syscall === "connect") {                                                                            // 237
        if (e.code === "ECONNREFUSED") {                                                                               // 238
          throw new Meteor.Error("connect ECONNREFUSED", "Server at " + smtpConfig.hostname + ":" + smtpConfig.port + " refused connection.  Check your settings, firewall rules, and that your mail server is up.");
        }                                                                                                              // 240
      } else if (e.name === "AuthError") {                                                                             // 241
        throw new Meteor.Error("auth error", "Authentication failed.  Check your credentials.  Message from " + smtpConfig.hostname + ": " + e.data);
      }                                                                                                                // 244
                                                                                                                       //
      throw new Meteor.Error("other-email-sending-error", "Error while trying to send test email: " + JSON.stringify(e));
    }                                                                                                                  // 247
  },                                                                                                                   // 248
                                                                                                                       //
  createSignupKey: function createSignupKey(token, note, quota) {                                                      // 250
    checkAuth(token);                                                                                                  // 251
    check(note, String);                                                                                               // 252
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 253
                                                                                                                       //
    var key = Random.id();                                                                                             // 255
    var content = { _id: key, used: false, note: note };                                                               // 256
    if (typeof quota === "number") content.quota = quota;                                                              // 257
    SignupKeys.insert(content);                                                                                        // 258
    return key;                                                                                                        // 259
  },                                                                                                                   // 260
                                                                                                                       //
  sendInvites: function sendInvites(token, origin, from, list, subject, message, quota) {                              // 262
    checkAuth(token);                                                                                                  // 263
    check([origin, from, list, subject, message], [String]);                                                           // 264
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 265
                                                                                                                       //
    if (!from.trim()) {                                                                                                // 267
      throw new Meteor.Error(403, "Must enter 'from' address.");                                                       // 268
    }                                                                                                                  // 269
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 271
      throw new Meteor.Error(403, "Must enter 'to' addresses.");                                                       // 272
    }                                                                                                                  // 273
                                                                                                                       //
    this.unblock();                                                                                                    // 275
                                                                                                                       //
    list = list.split("\n");                                                                                           // 277
    for (var i in list) {                                                                                              // 278
      var email = list[i].trim();                                                                                      // 279
                                                                                                                       //
      if (email) {                                                                                                     // 281
        var key = Random.id();                                                                                         // 282
                                                                                                                       //
        var content = {                                                                                                // 284
          _id: key,                                                                                                    // 285
          used: false,                                                                                                 // 286
          note: "E-mail invite to " + email,                                                                           // 287
          email: email,                                                                                                // 288
          definitelySent: false                                                                                        // 289
        };                                                                                                             // 284
        if (typeof quota === "number") content.quota = quota;                                                          // 291
        SignupKeys.insert(content);                                                                                    // 292
        sendEmail({                                                                                                    // 293
          to: email,                                                                                                   // 294
          from: from,                                                                                                  // 295
          envelopeFrom: globalDb.getReturnAddress(),                                                                   // 296
          subject: subject,                                                                                            // 297
          text: message.replace(/\$KEY/g, origin + "/signup/" + key)                                                   // 298
        });                                                                                                            // 293
        SignupKeys.update(key, { $set: { definitelySent: true } });                                                    // 300
      }                                                                                                                // 301
    }                                                                                                                  // 302
                                                                                                                       //
    return { sent: true };                                                                                             // 304
  },                                                                                                                   // 305
                                                                                                                       //
  adminToggleDisableCap: function adminToggleDisableCap(token, capId, value) {                                         // 307
    checkAuth(token);                                                                                                  // 308
    check(capId, String);                                                                                              // 309
    check(value, Boolean);                                                                                             // 310
                                                                                                                       //
    if (value) {                                                                                                       // 312
      ApiTokens.update({ _id: capId }, { $set: { revoked: true } });                                                   // 313
    } else {                                                                                                           // 314
      ApiTokens.update({ _id: capId }, { $set: { revoked: false } });                                                  // 315
    }                                                                                                                  // 316
  },                                                                                                                   // 317
                                                                                                                       //
  updateQuotas: function updateQuotas(token, list, quota) {                                                            // 319
    checkAuth(token);                                                                                                  // 320
    check(list, String);                                                                                               // 321
    check(quota, Match.OneOf(undefined, null, Number));                                                                // 322
                                                                                                                       //
    if (!list.trim()) {                                                                                                // 324
      throw new Meteor.Error(400, "Must enter addresses.");                                                            // 325
    }                                                                                                                  // 326
                                                                                                                       //
    var items = list.split("\n");                                                                                      // 328
    var invalid = [];                                                                                                  // 329
    for (var i in items) {                                                                                             // 330
      var modifier = typeof quota === "number" ? { $set: { quota: quota } } : { $unset: { quota: "" } };               // 331
      var n = SignupKeys.update({ email: items[i] }, modifier, { multi: true });                                       // 333
      n += Meteor.users.update({ signupEmail: items[i] }, modifier, { multi: true });                                  // 334
                                                                                                                       //
      if (n < 1) invalid.push(items[i]);                                                                               // 336
    }                                                                                                                  // 337
                                                                                                                       //
    if (invalid.length > 0) {                                                                                          // 339
      throw new Meteor.Error(404, "These addresses did not map to any user nor invite: " + invalid.join(", "));        // 340
    }                                                                                                                  // 342
  },                                                                                                                   // 343
                                                                                                                       //
  dismissAdminStatsNotifications: function dismissAdminStatsNotifications(token) {                                     // 345
    checkAuth(token);                                                                                                  // 346
    globalDb.collections.notifications.remove({ "admin.type": "reportStats" });                                        // 347
  },                                                                                                                   // 348
                                                                                                                       //
  signUpAsAdmin: function signUpAsAdmin(token) {                                                                       // 350
    check(token, String);                                                                                              // 351
    checkAuth(token);                                                                                                  // 352
    if (!this.userId) {                                                                                                // 353
      throw new Meteor.Error(403, "Must be logged in to sign up as admin.");                                           // 354
    }                                                                                                                  // 355
                                                                                                                       //
    if (!Meteor.user().loginIdentities) {                                                                              // 357
      throw new Meteor.Error(403, "Must be logged into an account to sign up as admin.");                              // 358
    }                                                                                                                  // 359
                                                                                                                       //
    Meteor.users.update({ _id: this.userId }, { $set: { isAdmin: true, signupKey: "admin" } });                        // 361
    clearAdminToken(token);                                                                                            // 362
  },                                                                                                                   // 363
                                                                                                                       //
  redeemSetupToken: function redeemSetupToken(token) {                                                                 // 365
    // Redeem an admin token into a setup session.                                                                     //
    check(token, String);                                                                                              // 367
    if (tokenIsValid(token)) {                                                                                         // 368
      var sessId = Random.secret();                                                                                    // 369
      var creationDate = new Date();                                                                                   // 370
      var hashedSessionId = Crypto.createHash("sha256").update(sessId).digest("base64");                               // 371
      this.connection.sandstormDb.collections.setupSession.upsert({                                                    // 372
        _id: "current-session"                                                                                         // 373
      }, {                                                                                                             // 372
        creationDate: creationDate,                                                                                    // 375
        hashedSessionId: hashedSessionId                                                                               // 376
      });                                                                                                              // 374
      // Then, invalidate the token, so one one else can use it.                                                       //
      clearAdminToken(token);                                                                                          // 379
      return sessId;                                                                                                   // 380
    } else {                                                                                                           // 381
      throw new Meteor.Error(401, "Invalid setup token");                                                              // 382
    }                                                                                                                  // 383
  },                                                                                                                   // 384
  heapdump: function heapdump() {                                                                                      // 386
    // Requests a heap dump. Intended for use by Sandstorm developers. Requires admin.                                 //
    //                                                                                                                 //
    // Call this from the JS console like:                                                                             //
    //   Meteor.call("heapdump");                                                                                      //
                                                                                                                       //
    checkAuth();                                                                                                       // 392
                                                                                                                       //
    // We use /var/log because it's a location in the container to which the front-end is allowed                      //
    // to write.                                                                                                       //
    var name = "/var/log/" + Date.now() + ".heapsnapshot";                                                             // 396
    Heapdump.writeSnapshot(name);                                                                                      // 397
    console.log("Wrote heapdump: /opt/sandstorm" + name);                                                              // 398
    return name;                                                                                                       // 399
  },                                                                                                                   // 400
                                                                                                                       //
                                                                                                                       //
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 402
    checkAuth();                                                                                                       // 403
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 404
                                                                                                                       //
    this.connection.sandstormDb.setPreinstalledApps(appAndPackageIds);                                                 // 406
  }                                                                                                                    // 407
});                                                                                                                    // 55
                                                                                                                       //
var authorizedAsAdmin = function authorizedAsAdmin(token, userId) {                                                    // 410
  return Match.test(token, Match.OneOf(undefined, null, String)) && (userId && isAdminById(userId) || tokenIsValid(token) || tokenIsSetupSession(token));
};                                                                                                                     // 413
                                                                                                                       //
Meteor.publish("admin", function (token) {                                                                             // 415
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 416
  return Settings.find();                                                                                              // 417
});                                                                                                                    // 418
                                                                                                                       //
Meteor.publish("adminServiceConfiguration", function (token) {                                                         // 420
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 421
  return Package["service-configuration"].ServiceConfiguration.configurations.find();                                  // 422
});                                                                                                                    // 423
                                                                                                                       //
Meteor.publish("publicAdminSettings", function () {                                                                    // 425
  return Settings.find({ _id: { $in: publicAdminSettings } });                                                         // 426
});                                                                                                                    // 427
                                                                                                                       //
Meteor.publish("adminToken", function (token) {                                                                        // 429
  check(token, String);                                                                                                // 430
  this.added("adminToken", "adminToken", { tokenIsValid: tokenIsValid(token) || tokenIsSetupSession(token) });         // 431
  this.ready();                                                                                                        // 432
});                                                                                                                    // 433
                                                                                                                       //
Meteor.publish("allUsers", function (token) {                                                                          // 435
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 436
  return Meteor.users.find();                                                                                          // 437
});                                                                                                                    // 438
                                                                                                                       //
Meteor.publish("adminUserDetails", function (userId) {                                                                 // 440
  var _this2 = this;                                                                                                   // 440
                                                                                                                       //
  if (!authorizedAsAdmin(undefined, this.userId)) return [];                                                           // 441
                                                                                                                       //
  // Reactive publish of any identities owned by the account with id userId,                                           //
  // as well as that user object itself.                                                                               //
  var identitySubs = {};                                                                                               // 445
  var accountId = userId;                                                                                              // 446
                                                                                                                       //
  var unrefIdentity = function unrefIdentity(identityId) {                                                             // 448
    if (!identitySubs[identityId]) {                                                                                   // 449
      // should never happen, but if somehow you attempt to unref an identity that we don't have a                     //
      // subscription to, then don't crash                                                                             //
      console.error("attempted to unref untracked identity id:", identityId);                                          // 452
      return;                                                                                                          // 453
    }                                                                                                                  // 454
                                                                                                                       //
    var observeHandle = identitySubs[identityId];                                                                      // 456
    delete identitySubs[identityId];                                                                                   // 457
    observeHandle.stop();                                                                                              // 458
    _this2.removed("users", identityId);                                                                               // 459
  };                                                                                                                   // 460
                                                                                                                       //
  var refIdentity = function refIdentity(identityId) {                                                                 // 462
    if (identitySubs[identityId]) {                                                                                    // 463
      // should never happen, but if somehow an account wound up with a duplicate identity ID,                         //
      // avoid leaking a subscription                                                                                  //
      console.error("duplicate identity id:", identityId);                                                             // 466
      return;                                                                                                          // 467
    }                                                                                                                  // 468
                                                                                                                       //
    var cursor = Meteor.users.find({ _id: identityId });                                                               // 470
    var observeHandle = cursor.observe({                                                                               // 471
      added: function added(doc) {                                                                                     // 472
        _this2.added("users", doc._id, doc);                                                                           // 473
      },                                                                                                               // 474
                                                                                                                       //
      changed: function changed(newDoc, oldDoc) {                                                                      // 476
        _this2.changed("users", newDoc._id, newDoc);                                                                   // 477
      },                                                                                                               // 478
                                                                                                                       //
      removed: function removed(oldDoc) {                                                                              // 480
        _this2.removed("users", oldDoc._id);                                                                           // 481
      }                                                                                                                // 482
    });                                                                                                                // 471
                                                                                                                       //
    identitySubs[identityId] = observeHandle;                                                                          // 485
  };                                                                                                                   // 486
                                                                                                                       //
  var accountCursor = Meteor.users.find({ _id: accountId });                                                           // 488
  var accountSubHandle = accountCursor.observe({                                                                       // 489
    added: function added(newDoc) {                                                                                    // 490
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 491
      newIdentities.forEach(function (identityId) {                                                                    // 492
        refIdentity(identityId);                                                                                       // 493
      });                                                                                                              // 494
                                                                                                                       //
      _this2.added("users", newDoc._id, newDoc);                                                                       // 496
    },                                                                                                                 // 497
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 499
      var newIdentities = SandstormDb.getUserIdentityIds(newDoc);                                                      // 500
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 501
                                                                                                                       //
      // Those in newDoc - oldDoc, ref.                                                                                //
      var identitiesAdded = _.difference(newIdentities, oldIdentities);                                                // 504
      identitiesAdded.forEach(function (identityId) {                                                                  // 505
        refIdentity(identityId);                                                                                       // 506
      });                                                                                                              // 507
                                                                                                                       //
      // Those in oldDoc - newDoc, unref.                                                                              //
      var identitiesRemoved = _.difference(oldIdentities, newIdentities);                                              // 510
      identitiesRemoved.forEach(function (identityId) {                                                                // 511
        unrefIdentity(identityId);                                                                                     // 512
      });                                                                                                              // 513
                                                                                                                       //
      _this2.changed("users", newDoc._id, newDoc);                                                                     // 515
    },                                                                                                                 // 516
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 518
      _this2.removed("users", oldDoc._id);                                                                             // 519
      var oldIdentities = SandstormDb.getUserIdentityIds(oldDoc);                                                      // 520
      oldIdentities.forEach(function (identityId) {                                                                    // 521
        unrefIdentity(identityId);                                                                                     // 522
      });                                                                                                              // 523
    }                                                                                                                  // 524
  });                                                                                                                  // 489
                                                                                                                       //
  this.onStop(function () {                                                                                            // 527
    accountSubHandle.stop();                                                                                           // 528
    // Also stop all the identity subscriptions.                                                                       //
    var subs = _.values(identitySubs);                                                                                 // 530
    subs.forEach(function (sub) {                                                                                      // 531
      sub.stop();                                                                                                      // 532
    });                                                                                                                // 533
  });                                                                                                                  // 534
                                                                                                                       //
  // Meteor's cursor.observe() will synchronously call all of the added() callbacks from the initial                   //
  // query, so by the time we get here we can report readiness.                                                        //
  this.ready();                                                                                                        // 538
});                                                                                                                    // 539
                                                                                                                       //
Meteor.publish("activityStats", function (token) {                                                                     // 541
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 542
  return ActivityStats.find();                                                                                         // 543
});                                                                                                                    // 544
                                                                                                                       //
Meteor.publish("statsTokens", function (token) {                                                                       // 546
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 547
  return StatsTokens.find();                                                                                           // 548
});                                                                                                                    // 549
                                                                                                                       //
Meteor.publish("allPackages", function (token) {                                                                       // 551
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 552
  return Packages.find({ manifest: { $exists: true } }, { fields: { appId: 1, "manifest.appVersion": 1,                // 553
      "manifest.actions": 1, "manifest.appTitle": 1, progress: 1, status: 1 } });                                      // 555
});                                                                                                                    // 556
                                                                                                                       //
Meteor.publish("realTimeStats", function (token) {                                                                     // 558
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 559
                                                                                                                       //
  // Last five minutes.                                                                                                //
  this.added("realTimeStats", "now", computeStats(new Date(Date.now() - 5 * 60 * 1000)));                              // 562
                                                                                                                       //
  // Since last sample.                                                                                                //
  var lastSample = ActivityStats.findOne({}, { sort: { timestamp: -1 } });                                             // 565
  var lastSampleTime = lastSample ? lastSample.timestamp : new Date(0);                                                // 566
  this.added("realTimeStats", "today", computeStats(lastSampleTime));                                                  // 567
                                                                                                                       //
  // TODO(someday): Update every few minutes?                                                                          //
                                                                                                                       //
  this.ready();                                                                                                        // 571
});                                                                                                                    // 572
                                                                                                                       //
Meteor.publish("adminLog", function (token) {                                                                          // 574
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 575
                                                                                                                       //
  var logfile = SANDSTORM_LOGDIR + "/sandstorm.log";                                                                   // 577
                                                                                                                       //
  var fd = Fs.openSync(logfile, "r");                                                                                  // 579
  var startSize = Fs.fstatSync(fd).size;                                                                               // 580
                                                                                                                       //
  // Start tailing at EOF - 8k.                                                                                        //
  var offset = Math.max(0, startSize - 8192);                                                                          // 583
                                                                                                                       //
  var _this = this;                                                                                                    // 585
  function doTail() {                                                                                                  // 586
    for (;;) {                                                                                                         // 587
      var buf = new Buffer(Math.max(1024, startSize - offset));                                                        // 588
      var n = Fs.readSync(fd, buf, 0, buf.length, offset);                                                             // 589
      if (n <= 0) break;                                                                                               // 590
      _this.added("adminLog", offset, { text: buf.toString("utf8", 0, n) });                                           // 591
      offset += n;                                                                                                     // 592
    }                                                                                                                  // 593
  }                                                                                                                    // 594
                                                                                                                       //
  // Watch the file for changes.                                                                                       //
  var watcher = Fs.watch(logfile, { persistent: false }, Meteor.bindEnvironment(doTail));                              // 597
                                                                                                                       //
  // When the subscription stops, stop watching the file.                                                              //
  this.onStop(function () {                                                                                            // 600
    watcher.close();                                                                                                   // 601
    Fs.closeSync(fd);                                                                                                  // 602
  });                                                                                                                  // 603
                                                                                                                       //
  // Read initial 8k tail data immediately.                                                                            //
  doTail();                                                                                                            // 606
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 609
});                                                                                                                    // 610
                                                                                                                       //
Meteor.publish("adminApiTokens", function (token) {                                                                    // 612
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 613
  return ApiTokens.find({                                                                                              // 614
    $or: [{ "frontendRef.ipNetwork": { $exists: true } }, { "frontendRef.ipInterface": { $exists: true } }]            // 615
  }, {                                                                                                                 // 614
    fields: {                                                                                                          // 620
      frontendRef: 1,                                                                                                  // 621
      created: 1,                                                                                                      // 622
      requirements: 1,                                                                                                 // 623
      revoked: 1,                                                                                                      // 624
      owner: 1                                                                                                         // 625
    }                                                                                                                  // 620
  });                                                                                                                  // 619
});                                                                                                                    // 628
                                                                                                                       //
Meteor.publish("featureKey", function (forAdmin, token) {                                                              // 630
  var _this3 = this;                                                                                                   // 630
                                                                                                                       //
  if (forAdmin && !authorizedAsAdmin(token, this.userId)) return [];                                                   // 631
                                                                                                                       //
  var fields = forAdmin ? FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS : PUBLIC_FEATURE_KEY_FIELDS;                          // 633
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 636
  var featureKeyQuery = db.collections.featureKey.find({ _id: "currentFeatureKey" });                                  // 637
  var observeHandle = featureKeyQuery.observe({                                                                        // 638
    added: function added(doc) {                                                                                       // 639
      // Load and verify the signed feature key.                                                                       //
      var buf = new Buffer(doc.value);                                                                                 // 641
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 642
                                                                                                                       //
      if (featureKey) {                                                                                                // 644
        var _ref;                                                                                                      // 644
                                                                                                                       //
        // If the signature is valid, publish the feature key information.                                             //
        var filteredFeatureKey = (_ref = _).pick.apply(_ref, [featureKey].concat(fields));                             // 646
        _this3.added("featureKey", doc._id, filteredFeatureKey);                                                       // 647
      }                                                                                                                // 648
    },                                                                                                                 // 649
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 651
      // Load and reverify the new signed feature key.                                                                 //
      var buf = new Buffer(newDoc.value);                                                                              // 653
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 654
                                                                                                                       //
      if (featureKey) {                                                                                                // 656
        var _ref2;                                                                                                     // 656
                                                                                                                       //
        // If the signature is valid, call this.changed() with the interesting fields.                                 //
        var filteredFeatureKey = (_ref2 = _).pick.apply(_ref2, [featureKey].concat(fields));                           // 658
        _this3.changed("featureKey", newDoc._id, filteredFeatureKey);                                                  // 659
      } else {                                                                                                         // 660
        // Otherwise, call this.removed(), since the new feature key is invalid.                                       //
        _this3.removed("featureKey", oldDoc._id);                                                                      // 662
      }                                                                                                                // 663
    },                                                                                                                 // 664
                                                                                                                       //
    removed: function removed(oldDoc) {                                                                                // 666
      _this3.removed("featureKey", oldDoc._id);                                                                        // 667
    }                                                                                                                  // 668
  });                                                                                                                  // 638
                                                                                                                       //
  this.onStop(function () {                                                                                            // 671
    observeHandle.stop();                                                                                              // 672
  });                                                                                                                  // 673
                                                                                                                       //
  this.ready();                                                                                                        // 675
});                                                                                                                    // 676
                                                                                                                       //
Meteor.publish("hasAdmin", function (token) {                                                                          // 678
  var _this4 = this;                                                                                                   // 678
                                                                                                                       //
  // Like hasUsers, but for admins, and with token auth required.                                                      //
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 680
                                                                                                                       //
  // Query if there are any admin users.                                                                               //
  var cursor = Meteor.users.find({ isAdmin: true });                                                                   // 683
  if (cursor.count() > 0) {                                                                                            // 684
    this.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                            // 685
  } else {                                                                                                             // 686
    (function () {                                                                                                     // 686
      var handle = cursor.observeChanges({                                                                             // 687
        added: function added(id) {                                                                                    // 688
          _this4.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                    // 689
          handle.stop();                                                                                               // 690
          handle = null;                                                                                               // 691
        }                                                                                                              // 692
      });                                                                                                              // 687
      _this4.onStop(function () {                                                                                      // 694
        if (handle) handle.stop();                                                                                     // 695
      });                                                                                                              // 696
    })();                                                                                                              // 686
  }                                                                                                                    // 697
                                                                                                                       //
  this.ready();                                                                                                        // 699
});                                                                                                                    // 700
                                                                                                                       //
Meteor.publish("appIndexAdmin", function (token) {                                                                     // 702
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 703
  return globalDb.collections.appIndex.find();                                                                         // 704
});                                                                                                                    // 705
                                                                                                                       //
function observeOauthService(name) {                                                                                   // 707
  Settings.find({ _id: name, value: true }).observe({                                                                  // 708
    added: function added() {                                                                                          // 709
      // Tell the oauth library it should accept login attempts from this service.                                     //
      Accounts.oauth.registerService(name);                                                                            // 711
    },                                                                                                                 // 712
                                                                                                                       //
    removed: function removed() {                                                                                      // 714
      // Tell the oauth library it should deny login attempts from this service.                                       //
      Accounts.oauth.unregisterService(name);                                                                          // 716
    }                                                                                                                  // 717
  });                                                                                                                  // 708
}                                                                                                                      // 719
                                                                                                                       //
observeOauthService("github");                                                                                         // 721
observeOauthService("google");                                                                                         // 722
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backup.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/backup.js                                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var ChildProcess = Npm.require("child_process");                                                                       // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Promise = Npm.require("es6-promise").Promise;                                                                      // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
                                                                                                                       //
var GrainInfo = Capnp.importSystem("sandstorm/grain.capnp").GrainInfo;                                                 // 22
                                                                                                                       //
var TOKEN_CLEANUP_MINUTES = 15;                                                                                        // 24
var TOKEN_CLEANUP_TIMER = TOKEN_CLEANUP_MINUTES * 60 * 1000;                                                           // 25
                                                                                                                       //
function cleanupToken(tokenId) {                                                                                       // 27
  check(tokenId, String);                                                                                              // 28
  FileTokens.remove({ _id: tokenId });                                                                                 // 29
  waitPromise(globalBackend.cap().deleteBackup(tokenId));                                                              // 30
}                                                                                                                      // 31
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 33
  // Cleanup tokens every TOKEN_CLEANUP_MINUTES                                                                        //
  SandstormDb.periodicCleanup(TOKEN_CLEANUP_TIMER, function () {                                                       // 35
    var queryDate = new Date(Date.now() - TOKEN_CLEANUP_TIMER);                                                        // 36
                                                                                                                       //
    FileTokens.find({ timestamp: { $lt: queryDate } }).forEach(function (token) {                                      // 38
      cleanupToken(token._id);                                                                                         // 39
    });                                                                                                                // 40
  });                                                                                                                  // 41
});                                                                                                                    // 42
                                                                                                                       //
Meteor.methods({                                                                                                       // 44
  backupGrain: function backupGrain(grainId) {                                                                         // 45
    check(grainId, String);                                                                                            // 46
    var grain = Grains.findOne(grainId);                                                                               // 47
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 48
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 49
    }                                                                                                                  // 50
                                                                                                                       //
    this.unblock();                                                                                                    // 52
                                                                                                                       //
    var token = {                                                                                                      // 54
      _id: Random.id(),                                                                                                // 55
      timestamp: new Date(),                                                                                           // 56
      name: grain.title                                                                                                // 57
    };                                                                                                                 // 54
                                                                                                                       //
    // TODO(soon): does the grain need to be offline?                                                                  //
                                                                                                                       //
    var grainInfo = _.pick(grain, "appId", "appVersion", "title");                                                     // 62
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 64
    waitPromise(globalBackend.cap().backupGrain(token._id, this.userId, grainId, grainInfo));                          // 65
                                                                                                                       //
    return token._id;                                                                                                  // 67
  },                                                                                                                   // 68
  newRestoreToken: function newRestoreToken() {                                                                        // 70
    if (!isSignedUpOrDemo()) {                                                                                         // 71
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can restore backups.");                          // 72
    }                                                                                                                  // 73
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 75
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 76
    }                                                                                                                  // 78
                                                                                                                       //
    var token = {                                                                                                      // 80
      _id: Random.id(),                                                                                                // 81
      timestamp: new Date()                                                                                            // 82
    };                                                                                                                 // 80
                                                                                                                       //
    FileTokens.insert(token);                                                                                          // 85
                                                                                                                       //
    return token._id;                                                                                                  // 87
  },                                                                                                                   // 88
  restoreGrain: function restoreGrain(tokenId, identityId) {                                                           // 90
    check(tokenId, String);                                                                                            // 91
    check(identityId, String);                                                                                         // 92
    var token = FileTokens.findOne(tokenId);                                                                           // 93
    if (!token || !isSignedUpOrDemo()) {                                                                               // 94
      throw new Meteor.Error(403, "Unauthorized", "Token was not found, or user cannot create grains");                // 95
    }                                                                                                                  // 97
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 99
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 100
    }                                                                                                                  // 102
                                                                                                                       //
    this.unblock();                                                                                                    // 104
                                                                                                                       //
    var grainId = Random.id(22);                                                                                       // 106
                                                                                                                       //
    try {                                                                                                              // 108
      var grainInfo = waitPromise(globalBackend.cap().restoreGrain(tokenId, this.userId, grainId)["catch"](function (err) {
        console.error("Unzip failure:", err.message);                                                                  // 111
        throw new Meteor.Error(500, "Invalid backup file.");                                                           // 112
      })).info;                                                                                                        // 113
      if (!grainInfo.appId) {                                                                                          // 114
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 115
        throw new Meteor.Error(500, "Metadata object for uploaded grain has no AppId");                                // 116
      }                                                                                                                // 117
                                                                                                                       //
      var action = UserActions.findOne({ appId: grainInfo.appId, userId: this.userId });                               // 119
                                                                                                                       //
      // Create variables we'll use for later Mongo query.                                                             //
      var packageId = void 0;                                                                                          // 122
      var appVersion = void 0;                                                                                         // 123
                                                                                                                       //
      // DevPackages are system-wide, so we do not check the user ID.                                                  //
      var devPackage = DevPackages.findOne({ appId: grainInfo.appId });                                                // 126
      if (devPackage) {                                                                                                // 127
        // If the dev app package exists, it should override the user action.                                          //
        packageId = devPackage.packageId;                                                                              // 129
        appVersion = devPackage.manifest.appVersion;                                                                   // 130
      } else if (action) {                                                                                             // 131
        // The app is installed, so we can continue restoring this                                                     //
        // grain.                                                                                                      //
        packageId = action.packageId;                                                                                  // 134
        appVersion = action.appVersion;                                                                                // 135
      } else {                                                                                                         // 136
        // If the package isn't installed at all, bail out.                                                            //
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 138
        throw new Meteor.Error(500, "App id for uploaded grain not installed", "App Id: " + grainInfo.appId);          // 139
      }                                                                                                                // 142
                                                                                                                       //
      if (appVersion < grainInfo.appVersion) {                                                                         // 144
        globalBackend.deleteGrain(grainId, this.userId);                                                               // 145
        throw new Meteor.Error(500, "App version for uploaded grain is newer than any " + "installed version. You need to upgrade your app first", "New version: " + grainInfo.appVersion + ", Old version: " + appVersion);
      }                                                                                                                // 151
                                                                                                                       //
      Grains.insert({                                                                                                  // 153
        _id: grainId,                                                                                                  // 154
        packageId: packageId,                                                                                          // 155
        appId: grainInfo.appId,                                                                                        // 156
        appVersion: appVersion,                                                                                        // 157
        userId: this.userId,                                                                                           // 158
        identityId: identityId,                                                                                        // 159
        title: grainInfo.title,                                                                                        // 160
        "private": true                                                                                                // 161
      });                                                                                                              // 153
    } finally {                                                                                                        // 163
      cleanupToken(tokenId);                                                                                           // 164
    }                                                                                                                  // 165
                                                                                                                       //
    return grainId;                                                                                                    // 167
  }                                                                                                                    // 168
});                                                                                                                    // 44
                                                                                                                       //
Router.map(function () {                                                                                               // 171
  this.route("downloadBackup", {                                                                                       // 172
    where: "server",                                                                                                   // 173
    path: "/downloadBackup/:tokenId",                                                                                  // 174
    action: function action() {                                                                                        // 175
      var token = FileTokens.findOne(this.params.tokenId);                                                             // 176
      var response = this.response;                                                                                    // 177
      if (!token) {                                                                                                    // 178
        response.writeHead(404, { "Content-Type": "text/plain" });                                                     // 179
        return response.end("File does not exist");                                                                    // 180
      }                                                                                                                // 181
                                                                                                                       //
      var started = false;                                                                                             // 183
      var filename = (token.name.replace(/["\n]/g, "") || "backup") + ".zip";                                          // 184
      var sawEnd = false;                                                                                              // 185
                                                                                                                       //
      var stream = {                                                                                                   // 187
        expectSize: function expectSize(size) {                                                                        // 188
          if (!started) {                                                                                              // 189
            started = true;                                                                                            // 190
            response.writeHead(200, {                                                                                  // 191
              "Content-Length": size,                                                                                  // 192
              "Content-Type": "application/zip",                                                                       // 193
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 194
            });                                                                                                        // 191
          }                                                                                                            // 196
        },                                                                                                             // 197
        write: function write(data) {                                                                                  // 199
          if (!started) {                                                                                              // 200
            started = true;                                                                                            // 201
            response.writeHead(200, {                                                                                  // 202
              "Content-Type": "application/zip",                                                                       // 203
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 204
            });                                                                                                        // 202
          }                                                                                                            // 206
                                                                                                                       //
          response.write(data);                                                                                        // 208
        },                                                                                                             // 209
        done: function done(data) {                                                                                    // 211
          if (!started) {                                                                                              // 212
            started = true;                                                                                            // 213
            response.writeHead(200, {                                                                                  // 214
              "Content-Length": 0,                                                                                     // 215
              "Content-Type": "application/zip",                                                                       // 216
              "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                        // 217
            });                                                                                                        // 214
          }                                                                                                            // 219
                                                                                                                       //
          sawEnd = true;                                                                                               // 221
          response.end();                                                                                              // 222
        }                                                                                                              // 223
      };                                                                                                               // 187
                                                                                                                       //
      waitPromise(globalBackend.cap().downloadBackup(this.params.tokenId, stream));                                    // 226
                                                                                                                       //
      if (!sawEnd) {                                                                                                   // 228
        console.error("backend failed to call done() when downloading backup");                                        // 229
        if (!started) {                                                                                                // 230
          throw new Meteor.Error(500, "backend failed to produce data");                                               // 231
        }                                                                                                              // 232
                                                                                                                       //
        response.end();                                                                                                // 234
      }                                                                                                                // 235
                                                                                                                       //
      cleanupToken(this.params.tokenId);                                                                               // 237
    }                                                                                                                  // 238
  });                                                                                                                  // 172
                                                                                                                       //
  this.route("uploadBackup", {                                                                                         // 241
    where: "server",                                                                                                   // 242
    path: "/uploadBackup/:token",                                                                                      // 243
    action: function action() {                                                                                        // 244
      var _this = this;                                                                                                // 244
                                                                                                                       //
      if (this.request.method === "POST") {                                                                            // 245
        var _ret = function () {                                                                                       // 245
          var token = FileTokens.findOne(_this.params.token);                                                          // 246
          if (!_this.params.token || !token) {                                                                         // 247
            _this.response.writeHead(403, {                                                                            // 248
              "Content-Type": "text/plain"                                                                             // 249
            });                                                                                                        // 248
            _this.response.write("Invalid upload token.");                                                             // 251
            _this.response.end();                                                                                      // 252
            return {                                                                                                   // 253
              v: void 0                                                                                                // 253
            };                                                                                                         // 253
          }                                                                                                            // 254
                                                                                                                       //
          var request = _this.request;                                                                                 // 256
          try {                                                                                                        // 257
            (function () {                                                                                             // 257
              var stream = globalBackend.cap().uploadBackup(_this.params.token).stream;                                // 258
                                                                                                                       //
              waitPromise(new Promise(function (resolve, reject) {                                                     // 260
                request.on("data", function (data) {                                                                   // 261
                  stream.write(data);                                                                                  // 262
                });                                                                                                    // 263
                request.on("end", function () {                                                                        // 264
                  resolve(stream.done());                                                                              // 265
                });                                                                                                    // 266
                request.on("error", function (err) {                                                                   // 267
                  stream.close();                                                                                      // 268
                });                                                                                                    // 269
              }));                                                                                                     // 270
                                                                                                                       //
              _this.response.writeHead(204);                                                                           // 272
              _this.response.end();                                                                                    // 273
            })();                                                                                                      // 257
          } catch (error) {                                                                                            // 274
            console.error(error.stack);                                                                                // 275
            _this.response.writeHead(500, {                                                                            // 276
              "Content-Type": "text/plain"                                                                             // 277
            });                                                                                                        // 276
            _this.response.write(error.stack);                                                                         // 279
            _this.response.end();                                                                                      // 280
          }                                                                                                            // 281
        }();                                                                                                           // 245
                                                                                                                       //
        if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                   // 245
      } else {                                                                                                         // 282
        this.response.writeHead(405, {                                                                                 // 283
          "Content-Type": "text/plain"                                                                                 // 284
        });                                                                                                            // 283
        this.response.write("You can only POST here.");                                                                // 286
        this.response.end();                                                                                           // 287
      }                                                                                                                // 288
    }                                                                                                                  // 289
  });                                                                                                                  // 241
});                                                                                                                    // 291
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"contacts-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/contacts-server.js                                                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.publish("contactProfiles", function (showAll) {                                                                 // 17
  var db = this.connection.sandstormDb;                                                                                // 18
  var _this = this;                                                                                                    // 19
  var userId = this.userId;                                                                                            // 20
                                                                                                                       //
  // We maintain a map from identity IDs to live query handles that track profile changes.                             //
  var contactIdentities = {};                                                                                          // 23
  var disallowGuests = db.getOrganizationDisallowGuests();                                                             // 24
                                                                                                                       //
  function addIdentityOfContact(identityId) {                                                                          // 26
    if (!(identityId in contactIdentities)) {                                                                          // 27
      var user = Meteor.users.findOne({ _id: identityId });                                                            // 28
                                                                                                                       //
      if (disallowGuests && !showAll) {                                                                                // 30
        if (!db.isIdentityInOrganization(user)) {                                                                      // 31
          return;                                                                                                      // 32
        }                                                                                                              // 33
      }                                                                                                                // 34
                                                                                                                       //
      if (user) {                                                                                                      // 36
        SandstormDb.fillInProfileDefaults(user);                                                                       // 37
        SandstormDb.fillInIntrinsicName(user);                                                                         // 38
        var filteredUser = _.pick(user, "_id", "profile");                                                             // 39
        _this.added("contactProfiles", user._id, filteredUser);                                                        // 40
      }                                                                                                                // 41
                                                                                                                       //
      contactIdentities[identityId] = Meteor.users.find({ _id: identityId }, { fields: { profile: 1 } }).observeChanges({
        changed: function changed(id, fields) {                                                                        // 45
          _this.changed("contactProfiles", id, fields);                                                                // 46
        }                                                                                                              // 47
      });                                                                                                              // 44
    }                                                                                                                  // 49
  }                                                                                                                    // 50
                                                                                                                       //
  var cursor = db.collections.contacts.find({ ownerId: userId });                                                      // 52
                                                                                                                       //
  var handle = cursor.observe({                                                                                        // 54
    added: function added(contact) {                                                                                   // 55
      addIdentityOfContact(contact.identityId);                                                                        // 56
    },                                                                                                                 // 57
                                                                                                                       //
    changed: function changed(contact) {                                                                               // 59
      addIdentityOfContact(contact.identityId);                                                                        // 60
    },                                                                                                                 // 61
                                                                                                                       //
    removed: function removed(contact) {                                                                               // 63
      _this.removed("contactProfiles", contact.identityId);                                                            // 64
      var contactIdentity = contactIdentities[contact.identityId];                                                     // 65
      if (contactIdentity) contactIdentities[contact.identityId].stop();                                               // 66
      delete contactIdentities[contact.identityId];                                                                    // 67
    }                                                                                                                  // 68
  });                                                                                                                  // 54
                                                                                                                       //
  var orgHandle = void 0;                                                                                              // 71
                                                                                                                       //
  if (db.getOrganizationShareContacts() && db.isUserInOrganization(db.collections.users.findOne({ _id: userId }))) {   // 73
    var orgCursor = db.collections.users.find({ profile: { $exists: 1 } });                                            // 75
    // TODO(perf): make a mongo query that can find all identities in an organization and add                          //
    // indices for it. Currently, we do some case insensitive matching which mongo can't                               //
    // handle well.                                                                                                    //
                                                                                                                       //
    orgHandle = orgCursor.observe({                                                                                    // 80
      added: function added(user) {                                                                                    // 81
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 82
          addIdentityOfContact(user._id);                                                                              // 83
        }                                                                                                              // 84
      },                                                                                                               // 85
                                                                                                                       //
      changed: function changed(user) {                                                                                // 87
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 88
          addIdentityOfContact(user._id);                                                                              // 89
        }                                                                                                              // 90
      },                                                                                                               // 91
                                                                                                                       //
      removed: function removed(user) {                                                                                // 93
        if (db.isIdentityInOrganization(user) && !db.userHasIdentity(userId, user._id)) {                              // 94
          _this.removed("contactProfiles", user._id);                                                                  // 95
          var contactIdentity = contactIdentities[contact.identityId];                                                 // 96
          if (contactIdentity) contactIdentities[contact.identityId].stop();                                           // 97
          delete contactIdentities[user._id];                                                                          // 98
        }                                                                                                              // 99
      }                                                                                                                // 100
    });                                                                                                                // 80
  }                                                                                                                    // 102
                                                                                                                       //
  this.ready();                                                                                                        // 104
                                                                                                                       //
  this.onStop(function () {                                                                                            // 106
    handle.stop();                                                                                                     // 107
    if (orgHandle) {                                                                                                   // 108
      orgHandle.stop();                                                                                                // 109
    }                                                                                                                  // 110
                                                                                                                       //
    Object.keys(contactIdentities).forEach(function (identityId) {                                                     // 112
      contactIdentities[identityId].stop();                                                                            // 113
      delete contactIdentities[identityId];                                                                            // 114
    });                                                                                                                // 115
  });                                                                                                                  // 116
});                                                                                                                    // 117
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"core.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/core.js                                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var PersistentImpl,hashSturdyRef,generateSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v},"hashSturdyRef":function(v){hashSturdyRef=v},"generateSturdyRef":function(v){generateSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var Crypto = Npm.require("crypto");                                                                                    // 18
var Url = Npm.require("url");                                                                                          // 19
                                                                                                                       // 20
                                                                                                                       //
var PersistentHandle = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentHandle;                              // 23
var SandstormCore = Capnp.importSystem("sandstorm/supervisor.capnp").SandstormCore;                                    // 24
var SandstormCoreFactory = Capnp.importSystem("sandstorm/backend.capnp").SandstormCoreFactory;                         // 25
var PersistentOngoingNotification = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentOngoingNotification;    // 26
var PersistentUiView = Capnp.importSystem("sandstorm/persistentuiview.capnp").PersistentUiView;                        // 27
var StaticAsset = Capnp.importSystem("sandstorm/grain.capnp").StaticAsset;                                             // 28
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 29
                                                                                                                       //
var SandstormCoreImpl = function () {                                                                                  //
  function SandstormCoreImpl(grainId) {                                                                                // 32
    _classCallCheck(this, SandstormCoreImpl);                                                                          // 32
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 33
  }                                                                                                                    // 34
                                                                                                                       //
  SandstormCoreImpl.prototype.restore = function restore(sturdyRef) {                                                  //
    var _this2 = this;                                                                                                 // 36
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 37
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 38
      var token = ApiTokens.findOne({                                                                                  // 39
        _id: hashedSturdyRef,                                                                                          // 40
        "owner.grain.grainId": _this2.grainId                                                                          // 41
      });                                                                                                              // 39
                                                                                                                       //
      if (!token) {                                                                                                    // 44
        throw new Error("no such token");                                                                              // 45
      }                                                                                                                // 46
                                                                                                                       //
      if (token.owner.grain.introducerIdentity) {                                                                      // 48
        throw new Error("Cannot restore grain-owned sturdyref that contains the obsolete " + "introducerIdentity field. Please request a new capability.");
      }                                                                                                                // 51
                                                                                                                       //
      return restoreInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this2.grainId }) }, [], token);     // 53
    });                                                                                                                // 56
  };                                                                                                                   // 57
                                                                                                                       //
  SandstormCoreImpl.prototype.drop = function drop(sturdyRef) {                                                        //
    var _this3 = this;                                                                                                 // 59
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 60
      return dropInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this3.grainId }) });                   // 61
    });                                                                                                                // 62
  };                                                                                                                   // 63
                                                                                                                       //
  SandstormCoreImpl.prototype.makeToken = function makeToken(ref, owner, requirements) {                               //
    var _this = this;                                                                                                  // 66
    return inMeteor(function () {                                                                                      // 67
      var sturdyRef = new Buffer(generateSturdyRef());                                                                 // 68
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 69
      ApiTokens.insert({                                                                                               // 70
        _id: hashedSturdyRef,                                                                                          // 71
        grainId: _this.grainId,                                                                                        // 72
        objectId: ref,                                                                                                 // 73
        owner: owner,                                                                                                  // 74
        created: new Date(),                                                                                           // 75
        requirements: requirements                                                                                     // 76
      });                                                                                                              // 70
                                                                                                                       //
      return {                                                                                                         // 79
        token: sturdyRef                                                                                               // 80
      };                                                                                                               // 79
    });                                                                                                                // 82
  };                                                                                                                   // 83
                                                                                                                       //
  SandstormCoreImpl.prototype.makeChildToken = function makeChildToken(parent, owner, requirements) {                  //
    return inMeteor(function () {                                                                                      // 86
      // Compute the save ApiToken template.                                                                           //
      return makeSaveTemplateForChild(parent.toString(), requirements);                                                // 88
    }).then(function (saveTemplate) {                                                                                  // 89
      // Create a dummy PersistentImpl and invoke its own save() method.                                               //
      return new PersistentImpl(globalDb, saveTemplate).save({ sealFor: owner });                                      // 91
    }).then(function (saveResult) {                                                                                    // 92
      // Transform to expected result structure.                                                                       //
      return { token: saveResult.sturdyRef };                                                                          // 94
    });                                                                                                                // 95
  };                                                                                                                   // 96
                                                                                                                       //
  SandstormCoreImpl.prototype.getOwnerNotificationTarget = function getOwnerNotificationTarget() {                     //
    var grainId = this.grainId;                                                                                        // 99
    return {                                                                                                           // 100
      owner: {                                                                                                         // 101
        addOngoing: function addOngoing(displayInfo, notification) {                                                   // 102
          return inMeteor(function () {                                                                                // 103
            var grain = Grains.findOne({ _id: grainId });                                                              // 104
            if (!grain) {                                                                                              // 105
              throw new Error("Grain not found.");                                                                     // 106
            }                                                                                                          // 107
                                                                                                                       //
            var castedNotification = notification.castAs(PersistentOngoingNotification);                               // 109
            var wakelockToken = waitPromise(castedNotification.save()).sturdyRef;                                      // 110
                                                                                                                       //
            // We have to close both the casted cap and the original. Perhaps this should be fixed in                  //
            // node-capnp?                                                                                             //
            castedNotification.close();                                                                                // 114
            notification.close();                                                                                      // 115
            var notificationId = Notifications.insert({                                                                // 116
              ongoing: wakelockToken,                                                                                  // 117
              grainId: grainId,                                                                                        // 118
              userId: grain.userId,                                                                                    // 119
              text: displayInfo.caption,                                                                               // 120
              timestamp: new Date(),                                                                                   // 121
              isUnread: true                                                                                           // 122
            });                                                                                                        // 116
                                                                                                                       //
            return {                                                                                                   // 125
              handle: globalFrontendRefRegistry.create(globalDb, { notificationHandle: notificationId })               // 126
            };                                                                                                         // 125
          });                                                                                                          // 129
        }                                                                                                              // 130
      }                                                                                                                // 101
    };                                                                                                                 // 100
  };                                                                                                                   // 133
                                                                                                                       //
  SandstormCoreImpl.prototype.backgroundActivity = function backgroundActivity(event) {                                //
    var _this4 = this;                                                                                                 // 135
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 136
      logActivity(_this4.grainId, null, event);                                                                        // 137
    });                                                                                                                // 138
  };                                                                                                                   // 139
                                                                                                                       //
  return SandstormCoreImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var makeSandstormCore = function makeSandstormCore(grainId) {                                                          // 142
  return new Capnp.Capability(new SandstormCoreImpl(grainId), SandstormCore);                                          // 143
};                                                                                                                     // 144
                                                                                                                       //
var NotificationHandle = function (_PersistentImpl) {                                                                  //
  _inherits(NotificationHandle, _PersistentImpl);                                                                      //
                                                                                                                       //
  // TODO(cleanup): Move to a different file.                                                                          //
                                                                                                                       //
  function NotificationHandle(db, saveTemplate, notificationId) {                                                      // 149
    _classCallCheck(this, NotificationHandle);                                                                         // 149
                                                                                                                       //
    var _this5 = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                       // 149
                                                                                                                       //
    _this5.notificationId = notificationId;                                                                            // 151
    return _this5;                                                                                                     // 149
  }                                                                                                                    // 152
                                                                                                                       //
  NotificationHandle.prototype.close = function close() {                                                              //
    var _this6 = this;                                                                                                 // 154
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 155
      if (!_this6.isSaved()) {                                                                                         // 156
        _dismissNotification(_this6.notificationId);                                                                   // 157
      }                                                                                                                // 158
    });                                                                                                                // 159
  };                                                                                                                   // 160
                                                                                                                       //
  return NotificationHandle;                                                                                           //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 163
                                                                                                                       //
var StaticAssetImpl = function () {                                                                                    //
  function StaticAssetImpl(assetId) {                                                                                  // 166
    _classCallCheck(this, StaticAssetImpl);                                                                            // 166
                                                                                                                       //
    check(assetId, String);                                                                                            // 167
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 168
    this._hostPath = makeWildcardHost("static") + "/" + assetId;                                                       // 169
  }                                                                                                                    // 170
                                                                                                                       //
  StaticAssetImpl.prototype.getUrl = function getUrl() {                                                               //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 173
  };                                                                                                                   // 174
                                                                                                                       //
  return StaticAssetImpl;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
var IdenticonStaticAssetImpl = function () {                                                                           //
  function IdenticonStaticAssetImpl(hash, size) {                                                                      // 178
    _classCallCheck(this, IdenticonStaticAssetImpl);                                                                   // 178
                                                                                                                       //
    check(hash, String);                                                                                               // 179
    check(size, Match.Integer);                                                                                        // 180
    this._protocol = PROTOCOL.slice(0, -1);                                                                            // 181
    this._hostPath = makeWildcardHost("static") + "/identicon/" + hash + "?s=" + size;                                 // 182
  }                                                                                                                    // 183
                                                                                                                       //
  IdenticonStaticAssetImpl.prototype.getUrl = function getUrl() {                                                      //
    return { protocol: this._protocol, hostPath: this._hostPath };                                                     // 186
  };                                                                                                                   // 187
                                                                                                                       //
  return IdenticonStaticAssetImpl;                                                                                     //
}();                                                                                                                   //
                                                                                                                       //
var PersistentUiViewImpl = function (_PersistentImpl2) {                                                               //
  _inherits(PersistentUiViewImpl, _PersistentImpl2);                                                                   //
                                                                                                                       //
  // TODO(cleanup): Move out of core.js.                                                                               //
                                                                                                                       //
  function PersistentUiViewImpl(db, saveTemplate, grainId) {                                                           // 193
    _classCallCheck(this, PersistentUiViewImpl);                                                                       // 193
                                                                                                                       //
    var _this7 = _possibleConstructorReturn(this, _PersistentImpl2.call(this, db, saveTemplate));                      // 193
                                                                                                                       //
    check(grainId, String);                                                                                            // 195
    _this7._db = db;                                                                                                   // 196
    _this7._grainId = grainId;                                                                                         // 197
    return _this7;                                                                                                     // 193
  }                                                                                                                    // 198
                                                                                                                       //
  PersistentUiViewImpl.prototype.getViewInfo = function getViewInfo() {                                                //
    var _this8 = this;                                                                                                 // 200
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 201
      var grain = _this8._db.getGrain(_this8._grainId);                                                                // 202
      if (!grain || grain.trashed) {                                                                                   // 203
        throw new Error("grain no longer exists");                                                                     // 204
      }                                                                                                                // 205
                                                                                                                       //
      var pkg = _this8._db.getPackage(grain.packageId) || DevPackages.findOne({ appId: grain.appId }) || {};           // 207
                                                                                                                       //
      var manifest = pkg.manifest || {};                                                                               // 211
                                                                                                                       //
      var viewInfo = grain.cachedViewInfo || {};                                                                       // 213
                                                                                                                       //
      if (!viewInfo.appTitle) {                                                                                        // 215
        viewInfo.appTitle = manifest.appTitle || {};                                                                   // 216
      }                                                                                                                // 217
                                                                                                                       //
      if (!viewInfo.grainIcon) {                                                                                       // 219
        var grainIcon = ((manifest.metadata || {}).icons || {}).grain;                                                 // 220
        if (grainIcon) {                                                                                               // 221
          viewInfo.grainIcon = new Capnp.Capability(new StaticAssetImpl(grainIcon.assetId), StaticAsset);              // 222
        } else {                                                                                                       // 224
          var hash = Identicon.hashAppIdForIdenticon(pkg.appId);                                                       // 225
          viewInfo.grainIcon = new Capnp.Capability(new IdenticonStaticAssetImpl(hash, 24), StaticAsset);              // 226
        }                                                                                                              // 228
      }                                                                                                                // 229
                                                                                                                       //
      return viewInfo;                                                                                                 // 231
    });                                                                                                                // 232
  };                                                                                                                   // 233
                                                                                                                       //
  // All other UiView methods are currently unimplemented, which, while not strictly correct,                          //
  // results in the same overall behavior, since users can't call restore() on a PersistentUiView,                     //
  // and grains can't call methods on UiViews because they lack the "is human" pseudopermission.                       //
                                                                                                                       //
                                                                                                                       //
  return PersistentUiViewImpl;                                                                                         //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
var makePersistentUiView = function makePersistentUiView(db, saveTemplate, grainId) {                                  // 240
  check(grainId, String);                                                                                              // 241
                                                                                                                       //
  // Verify that the grain exists and hasn't been trashed.                                                             //
  var grain = db.getGrain(grainId);                                                                                    // 244
  if (!grain || grain.trashed) {                                                                                       // 245
    throw new Meteor.Error(404, "grain not found");                                                                    // 246
  }                                                                                                                    // 247
                                                                                                                       //
  return new Capnp.Capability(new PersistentUiViewImpl(db, saveTemplate, grainId), PersistentUiView);                  // 249
};                                                                                                                     // 251
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 253
  frontendRefField: "notificationHandle",                                                                              // 254
                                                                                                                       //
  restore: function restore(db, saveTemplate, notificationId) {                                                        // 256
    return new Capnp.Capability(new NotificationHandle(db, saveTemplate, notificationId), PersistentHandle);           // 257
  }                                                                                                                    // 259
});                                                                                                                    // 253
                                                                                                                       //
function _dismissNotification(notificationId, callCancel) {                                                            // 262
  var notification = Notifications.findOne({ _id: notificationId });                                                   // 263
  if (notification) {                                                                                                  // 264
    Notifications.remove({ _id: notificationId });                                                                     // 265
    if (notification.ongoing) {                                                                                        // 266
      // For some reason, Mongo returns an object that looks buffer-like, but isn't a buffer.                          //
      // Only way to fix seems to be to copy it.                                                                       //
      var id = new Buffer(notification.ongoing);                                                                       // 269
                                                                                                                       //
      if (!callCancel) {                                                                                               // 271
        dropInternal(id, { frontend: null });                                                                          // 272
      } else {                                                                                                         // 273
        var notificationCap = restoreInternal(id, { frontend: null }, []).cap;                                         // 274
        var castedNotification = notificationCap.castAs(PersistentOngoingNotification);                                // 275
        dropInternal(id, { frontend: null });                                                                          // 276
        try {                                                                                                          // 277
          waitPromise(castedNotification.cancel());                                                                    // 278
          castedNotification.close();                                                                                  // 279
          notificationCap.close();                                                                                     // 280
        } catch (err) {                                                                                                // 281
          if (err.kjType !== "disconnected") {                                                                         // 282
            // ignore disconnected errors, since cancel may shutdown the grain before the supervisor                   //
            // responds.                                                                                               //
            throw err;                                                                                                 // 285
          }                                                                                                            // 286
        }                                                                                                              // 287
      }                                                                                                                // 288
    } else if (notification.appUpdates) {                                                                              // 289
      _.forEach(notification.appUpdates, function (app, appId) {                                                       // 290
        globalDb.deleteUnusedPackages(appId);                                                                          // 291
      });                                                                                                              // 292
    }                                                                                                                  // 293
  }                                                                                                                    // 294
}                                                                                                                      // 295
                                                                                                                       //
Meteor.methods({                                                                                                       // 297
  dismissNotification: function dismissNotification(notificationId) {                                                  // 298
    // This will remove notifications from the database and from view of the user.                                     //
    // For ongoing notifications, it will begin the process of cancelling and dropping them from                       //
    // the app.                                                                                                        //
                                                                                                                       //
    check(notificationId, String);                                                                                     // 303
                                                                                                                       //
    var notification = Notifications.findOne({ _id: notificationId });                                                 // 305
    if (!notification) {                                                                                               // 306
      throw new Meteor.Error(404, "Notification id not found.");                                                       // 307
    } else if (notification.userId !== Meteor.userId()) {                                                              // 308
      throw new Meteor.Error(403, "Notification does not belong to current user.");                                    // 309
    } else {                                                                                                           // 310
      _dismissNotification(notificationId, true);                                                                      // 311
    }                                                                                                                  // 312
  },                                                                                                                   // 313
  readAllNotifications: function readAllNotifications() {                                                              // 315
    // Marks all notifications as read for the current user.                                                           //
    if (!Meteor.userId()) {                                                                                            // 317
      throw new Meteor.Error(403, "User not logged in.");                                                              // 318
    }                                                                                                                  // 319
                                                                                                                       //
    Notifications.update({ userId: Meteor.userId() }, { $set: { isUnread: false } }, { multi: true });                 // 321
  },                                                                                                                   // 322
  acceptPowerboxOffer: function acceptPowerboxOffer(sessionId, sturdyRef, sessionToken) {                              // 324
    var db = this.connection.sandstormDb;                                                                              // 325
    check(sessionId, String);                                                                                          // 326
    check(sturdyRef, String);                                                                                          // 327
    check(sessionToken, Match.OneOf(String, null, undefined));                                                         // 328
                                                                                                                       //
    var sessionQuery = { _id: sessionId };                                                                             // 330
    if (sessionToken) {                                                                                                // 331
      sessionQuery.hashedToken = hashSturdyRef(sessionToken);                                                          // 332
    } else {                                                                                                           // 333
      sessionQuery.userId = this.userId;                                                                               // 334
    }                                                                                                                  // 335
                                                                                                                       //
    var session = db.collections.sessions.findOne(sessionQuery);                                                       // 337
    if (!session) {                                                                                                    // 338
      throw new Meteor.Error(404, "No matching session found.");                                                       // 339
    }                                                                                                                  // 340
                                                                                                                       //
    var tokenId = hashSturdyRef(sturdyRef);                                                                            // 342
    var apiToken = db.collections.apiTokens.findOne({                                                                  // 343
      _id: tokenId,                                                                                                    // 344
      "owner.clientPowerboxOffer.sessionId": sessionId                                                                 // 345
    });                                                                                                                // 343
                                                                                                                       //
    if (!apiToken) {                                                                                                   // 348
      throw new Meteor.Error(404, "No such token.");                                                                   // 349
    }                                                                                                                  // 350
                                                                                                                       //
    var newSturdyRef = void 0;                                                                                         // 352
    var hashedNewSturdyRef = void 0;                                                                                   // 353
    if (sessionToken && apiToken.parentToken) {                                                                        // 354
      // An anonymous user is being offered a child token. To avoid bloating the database,                             //
      // we deterministically derive the sturdyref from the session token and the hashed parent                        //
      // token.                                                                                                        //
      //                                                                                                               //
      // Note that an attacker with read access to the database might be able to derive                                //
      // `newSturdyRef` from `sessionToken` and gain access to the capability without ever having                      //
      // been explicitly offered it by the grain. Therefore, grains must assume that offering                          //
      // a capability to an anonymous user can possibly make that capability accessible to any                         //
      // other anonymous user who has connected through the same URL.                                                  //
                                                                                                                       //
      newSturdyRef = Crypto.createHash("sha256").update(sessionToken).update(apiToken.parentToken).digest("base64").slice(0, -1) // removing trailing "="
      .replace(/\+/g, "-").replace(/\//g, "_"); // make URL-safe                                                       // 365
                                                                                                                       //
      hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                                // 372
      if (db.collections.apiTokens.findOne({ _id: hashedNewSturdyRef })) {                                             // 373
        // We have already generated this token.                                                                       //
        db.removeApiTokens({ _id: tokenId });                                                                          // 375
        return newSturdyRef;                                                                                           // 376
      }                                                                                                                // 377
    } else {                                                                                                           // 378
      newSturdyRef = generateSturdyRef();                                                                              // 379
      hashedNewSturdyRef = hashSturdyRef(newSturdyRef);                                                                // 380
    }                                                                                                                  // 381
                                                                                                                       //
    apiToken._id = hashedNewSturdyRef;                                                                                 // 383
    apiToken.owner = { webkey: null };                                                                                 // 384
                                                                                                                       //
    db.collections.apiTokens.insert(apiToken);                                                                         // 386
    db.removeApiTokens({ _id: tokenId });                                                                              // 387
    return newSturdyRef;                                                                                               // 388
  }                                                                                                                    // 389
});                                                                                                                    // 297
                                                                                                                       //
var makeSaveTemplateForChild = function makeSaveTemplateForChild(parentToken, requirements, parentTokenInfo) {         // 393
  // Constructs (part of) an ApiToken record appropriate to be used when save()ing a capability                        //
  // that was originally created by restore()ing `parentToken`. This fills in everything that is                       //
  // appropriate to fill in based only on the parent. Some fields -- especially `owner`, `created`,                    //
  // and `_id` -- obviously cannot be filled in until `save()` is called.                                              //
  //                                                                                                                   //
  // `parentToken` is the raw SturdyRef of the parent.                                                                 //
  //                                                                                                                   //
  // `requirements` is a list of MembraneRequirements that should be added to any children.                            //
  //                                                                                                                   //
  // `parentTokenInfo` is the ApiToken record for `parentToken`. Provide this only if you have                         //
  // it handy; if omitted it will be looked up.                                                                        //
                                                                                                                       //
  parentTokenInfo = parentTokenInfo || ApiTokens.findOne(hashSturdyRef(parentToken));                                  // 406
  if (!parentTokenInfo) {                                                                                              // 407
    throw new Error("no such token");                                                                                  // 408
  }                                                                                                                    // 409
                                                                                                                       //
  var parentOwner = parentTokenInfo.owner || {};                                                                       // 411
                                                                                                                       //
  var saveTemplate = void 0;                                                                                           // 413
  if (parentOwner.clientPowerboxRequest || parentOwner.clientPowerboxOffer) {                                          // 414
    // Saving this token should make a copy of the restored token, rather than make a child                            //
    // token.                                                                                                          //
                                                                                                                       //
    saveTemplate = _.clone(parentTokenInfo);                                                                           // 418
                                                                                                                       //
    // Don't copy over fields that should be determined at save() time.                                                //
    delete saveTemplate._id;                                                                                           // 421
    delete saveTemplate.owner;                                                                                         // 422
    delete saveTemplate.created;                                                                                       // 423
  } else {                                                                                                             // 424
    if (parentTokenInfo.identityId) {                                                                                  // 425
      // A UiView token. Need to denormalize some fields from the parent.                                              //
      saveTemplate = _.pick(parentTokenInfo, "grainId", "identityId", "accountId");                                    // 427
                                                                                                                       //
      // By default, a save()d copy should have the same permissions, so set an allAccess role                         //
      // assignment.                                                                                                   //
      saveTemplate.roleAssignment = { allAccess: null };                                                               // 431
    } else {                                                                                                           // 432
      // A non-UiView child token.                                                                                     //
      saveTemplate = {};                                                                                               // 434
    }                                                                                                                  // 435
                                                                                                                       //
    // Saved token should be a child of the restored token.                                                            //
    saveTemplate.parentToken = parentTokenInfo._id;                                                                    // 438
  }                                                                                                                    // 439
                                                                                                                       //
  if (requirements) {                                                                                                  // 441
    // Append additional requirements requested by caller.                                                             //
    saveTemplate.requirements = (saveTemplate.requirements || []).concat(requirements);                                // 443
  }                                                                                                                    // 444
                                                                                                                       //
  return saveTemplate;                                                                                                 // 446
};                                                                                                                     // 447
                                                                                                                       //
restoreInternal = function (_restoreInternal) {                                                                        // 449
  function restoreInternal(_x, _x2, _x3, _x4, _x5) {                                                                   // 449
    return _restoreInternal.apply(this, arguments);                                                                    // 449
  }                                                                                                                    // 449
                                                                                                                       //
  restoreInternal.toString = function () {                                                                             // 449
    return _restoreInternal.toString();                                                                                // 449
  };                                                                                                                   // 449
                                                                                                                       //
  return restoreInternal;                                                                                              // 449
}(function (originalToken, ownerPattern, requirements, originalTokenInfo, currentTokenId) {                            // 449
  // Restores the token `originalToken`, which is a Buffer.                                                            //
  //                                                                                                                   //
  // `ownerPattern` is a match pattern (i.e. used with check()) that the token's owner must match.                     //
  // This is used to enforce than an entity can't use tokens owned by some other entity.                               //
  //                                                                                                                   //
  // `requirements` is a list of additional MembraneRequirements to add to the returned capability,                    //
  // beyond what's already stored in ApiTokens. This is often an empty list.                                           //
  //                                                                                                                   //
  // `originalTokenInfo` is optional. If specified, it should be the ApiToken record associated                        //
  // with `originalToken`. Provide this if you happen to have looked it up already.                                    //
  //                                                                                                                   //
  // `currentTokenId` is only provided when this function calls itself recursively. It is the                          //
  // _id (hashed token) of an ancestor of originalToken. The function recurses until it gets to                        //
  // the top-level token.                                                                                              //
                                                                                                                       //
  requirements = requirements || [];                                                                                   // 466
                                                                                                                       //
  if (!originalTokenInfo) {                                                                                            // 468
    originalTokenInfo = ApiTokens.findOne(hashSturdyRef(originalToken));                                               // 469
    if (!originalTokenInfo) {                                                                                          // 470
      throw new Meteor.Error(403, "No token found to restore");                                                        // 471
    }                                                                                                                  // 472
  }                                                                                                                    // 473
                                                                                                                       //
  var token = currentTokenId ? ApiTokens.findOne(currentTokenId) : originalTokenInfo;                                  // 475
  if (!token) {                                                                                                        // 477
    if (!originalTokenInfo) {                                                                                          // 478
      throw new Meteor.Error(403, "Couldn't restore token because parent token has been deleted");                     // 479
    }                                                                                                                  // 480
  }                                                                                                                    // 481
                                                                                                                       //
  if (token.revoked) {                                                                                                 // 483
    throw new Meteor.Error(403, "Token has been revoked");                                                             // 484
  }                                                                                                                    // 485
                                                                                                                       //
  // The ownerPattern should specify the appropriate user or grain involved, if appropriate.                           //
  check(token.owner, ownerPattern);                                                                                    // 488
                                                                                                                       //
  // Check requirements on the token.                                                                                  //
  checkRequirements(globalDb, token.requirements);                                                                     // 491
                                                                                                                       //
  // Check expiration.                                                                                                 //
  if (token.expires && token.expires.getTime() <= Date.now()) {                                                        // 494
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 495
  }                                                                                                                    // 496
                                                                                                                       //
  if (token.expiresIfUnused) {                                                                                         // 498
    if (token.expiresIfUnused.getTime() <= Date.now()) {                                                               // 499
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 500
    } else {                                                                                                           // 501
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(token._id, { $unset: { expiresIfUnused: "" } });                                                // 503
    }                                                                                                                  // 504
  }                                                                                                                    // 505
                                                                                                                       //
  // If this token has a parent, go ahead and recurse to it now.                                                       //
  if (token.parentToken) {                                                                                             // 508
    // A token which chains to some parent token.  Restore the parent token (possibly recursively),                    //
    // checking requirements on the way up.                                                                            //
    return restoreInternal(originalToken, Match.Any, requirements, originalTokenInfo, token.parentToken);              // 511
  }                                                                                                                    // 513
                                                                                                                       //
  // Check the passed-in `requirements`.                                                                               //
  checkRequirements(globalDb, requirements);                                                                           // 516
                                                                                                                       //
  if (token.objectId) {                                                                                                // 518
    // A token which represents a specific capability exported by a grain.                                             //
                                                                                                                       //
    // Fix Mongo converting Buffers to Uint8Arrays.                                                                    //
    if (token.objectId.appRef) {                                                                                       // 522
      token.objectId.appRef = new Buffer(token.objectId.appRef);                                                       // 523
    }                                                                                                                  // 524
                                                                                                                       //
    // Ensure the grain is running, then restore the capability.                                                       //
    return waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                   // 527
      // Note that in this case it is the supervisor's job to implement SystemPersistent, so we                        //
      // don't generate a saveTemplate here.                                                                           //
      return supervisor.restore(token.objectId, requirements, originalToken);                                          // 530
    }));                                                                                                               // 531
  } else {                                                                                                             // 532
    // Construct a template ApiToken for use if the restored capability is save()d later.                              //
    var saveTemplate = makeSaveTemplateForChild(originalToken, requirements, originalTokenInfo);                       // 534
                                                                                                                       //
    if (token.frontendRef) {                                                                                           // 536
      // A token which represents a capability implemented by a pseudo-driver.                                         //
                                                                                                                       //
      var cap = globalFrontendRefRegistry.restore(globalDb, saveTemplate, token.frontendRef);                          // 539
      return { cap: cap };                                                                                             // 540
    } else if (token.grainId) {                                                                                        // 541
      // It's a UiView.                                                                                                //
                                                                                                                       //
      // If a grain is attempting to restore a UiView, it gets a UiView which filters out all                          //
      // the method calls.  In the future, we may allow grains to restore UiViews that pass along the                  //
      // "is human" pseudopermission (say, to allow an app to proxy all requests to some grain and                     //
      // do some transformation), which will return a different capability.                                            //
      return { cap: makePersistentUiView(globalDb, saveTemplate, token.grainId) };                                     // 548
    } else {                                                                                                           // 549
      throw new Meteor.Error(500, "Unknown token type. ID: " + token._id);                                             // 550
    }                                                                                                                  // 551
  }                                                                                                                    // 552
});                                                                                                                    // 553
                                                                                                                       //
function dropInternal(sturdyRef, ownerPattern) {                                                                       // 555
  // Drops `sturdyRef`, checking first that its owner matches `ownerPattern`.                                          //
                                                                                                                       //
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 558
  var token = ApiTokens.findOne({ _id: hashedSturdyRef });                                                             // 559
  if (!token) {                                                                                                        // 560
    return;                                                                                                            // 561
  }                                                                                                                    // 562
                                                                                                                       //
  check(token.owner, ownerPattern);                                                                                    // 564
                                                                                                                       //
  if (token.frontendRef && token.frontendRef.notificationHandle) {                                                     // 566
    var notificationId = token.frontendRef.notificationHandle;                                                         // 567
    globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                                // 568
    var anyToken = ApiTokens.findOne({ "frontendRef.notificationHandle": notificationId });                            // 569
    if (!anyToken) {                                                                                                   // 570
      // No other tokens referencing this notification exist, so dismiss the notification                              //
      _dismissNotification(notificationId);                                                                            // 572
    }                                                                                                                  // 573
  } else if (token.objectId) {                                                                                         // 574
    waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                          // 575
      return supervisor.drop(token.objectId);                                                                          // 576
    }));                                                                                                               // 577
                                                                                                                       //
    globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                                // 579
  } else {                                                                                                             // 580
    globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                                // 581
  }                                                                                                                    // 582
}                                                                                                                      // 583
                                                                                                                       //
function SandstormCoreFactoryImpl() {}                                                                                 // 585
                                                                                                                       //
SandstormCoreFactoryImpl.prototype.getSandstormCore = function (grainId) {                                             // 588
  return { core: makeSandstormCore(grainId) };                                                                         // 589
};                                                                                                                     // 590
                                                                                                                       //
makeSandstormCoreFactory = function makeSandstormCoreFactory() {                                                       // 592
  return new Capnp.Capability(new SandstormCoreFactoryImpl(), SandstormCoreFactory);                                   // 593
};                                                                                                                     // 594
                                                                                                                       //
unwrapFrontendCap = function unwrapFrontendCap(cap, type, callback) {                                                  // 596
  // Expect that `cap` is a Cap'n Proto capability implemented by the frontend as a frontendRef                        //
  // with the given type (the name of one of the fields of frontendRef). Unwraps the capability                        //
  // and then calls callback() with the `frontendRef[type]` descriptor object as                                       //
  // the paramater. The callback runs in a Meteor fiber, but this function can be called from                          //
  // anywhere. The function returns a Promise for the result of the callback.                                          //
  //                                                                                                                   //
  // (The reason for the callback, rather than just returning a Promise for the descriptor, is                         //
  // so that you don't have to do your own inMeteor() dance.)                                                          //
                                                                                                                       //
  // For now, we save() the capability and then dig through ApiTokens to find where it leads.                          //
  // TODO(cleanup): In theory we should be using something like CapabilityServerSet, but it is                         //
  //   not available in Javascript yet and even if it were, it wouldn't work in the case where                         //
  //   there are multiple front-end replicas, since the capability could be on a different                             //
  //   replica.                                                                                                        //
                                                                                                                       //
  return cap.castAs(SystemPersistent).save({ frontend: null }).then(function (saveResult) {                            // 612
    return inMeteor(function () {                                                                                      // 613
      var tokenId = hashSturdyRef(saveResult.sturdyRef);                                                               // 614
      var tokenInfo = ApiTokens.findOne(tokenId);                                                                      // 615
                                                                                                                       //
      // Delete the token now since it's not needed.                                                                   //
      ApiTokens.remove(tokenId);                                                                                       // 618
                                                                                                                       //
      for (;;) {                                                                                                       // 620
        if (!tokenInfo) throw new Error("missing token?");                                                             // 621
        if (!tokenInfo.parentToken) break;                                                                             // 622
        tokenInfo = ApiTokens.findOne(tokenInfo.parentToken);                                                          // 623
      }                                                                                                                // 624
                                                                                                                       //
      if (!tokenInfo.frontendRef || !tokenInfo.frontendRef[type]) {                                                    // 626
        throw new Error("not a " + type + " capability");                                                              // 627
      }                                                                                                                // 628
                                                                                                                       //
      return callback(tokenInfo.frontendRef[type]);                                                                    // 630
    });                                                                                                                // 631
  });                                                                                                                  // 632
};                                                                                                                     // 633
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/demo-server.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var DEMO_EXPIRATION_MS = 60 * 60 * 1000;                                                                               // 19
var DEMO_GRACE_MS = 10 * 60 * 1000; // time between expiration and deletion                                            // 20
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 22
  // Enforce expiration times for demo accounts.                                                                       //
                                                                                                                       //
  if (attempt.user && attempt.user.expires) {                                                                          // 25
    (function () {                                                                                                     // 25
      var expireIn = attempt.user.expires.getTime() - Date.now() + DEMO_GRACE_MS;                                      // 26
      if (expireIn < 0) {                                                                                              // 27
        throw new Meteor.Error(403, "This demo account has expired.");                                                 // 28
      }                                                                                                                // 29
                                                                                                                       //
      if (!allowDemo) {                                                                                                // 31
        // An expiration time implies that this is a demo account, but those have been disabled.                       //
        // Perhaps the config was just changed.                                                                        //
        throw new Meteor.Error(403, "Demo accounts have been disabled.");                                              // 34
      }                                                                                                                // 35
                                                                                                                       //
      // Force connection close when account expires, so that the client reconnects and                                //
      // re-authenticates, which fails.                                                                                //
      var connection = attempt.connection;                                                                             // 39
      var handle = Meteor.setTimeout(function () {                                                                     // 40
        connection.close();                                                                                            // 40
      }, expireIn);                                                                                                    // 40
                                                                                                                       //
      connection.onClose(function () {                                                                                 // 42
        Meteor.clearTimeout(handle);                                                                                   // 42
      });                                                                                                              // 42
    })();                                                                                                              // 25
  }                                                                                                                    // 43
                                                                                                                       //
  return true;                                                                                                         // 45
});                                                                                                                    // 46
                                                                                                                       //
function cleanupExpiredUsers() {                                                                                       // 48
  // Delete expired demo accounts and all their grains.                                                                //
                                                                                                                       //
  var now = new Date(Date.now() - DEMO_GRACE_MS);                                                                      // 51
  Meteor.users.find({ expires: { $lt: now } }, { fields: { _id: 1, loginIdentities: 1, lastActive: 1, appDemoId: 1 } }).forEach(function (user) {
                                                                                                                       //
    globalDb.deleteGrains({ userId: user._id }, globalBackend, "demoGrain");                                           // 56
                                                                                                                       //
    console.log("delete user: " + user._id);                                                                           // 58
    // We intentionally do not do `ApiTokens.remove({accountId: user._id})`, because some such                         //
    // tokens might still play an active role in the sharing graph.                                                    //
    Contacts.remove({ ownerId: user._id });                                                                            // 61
    UserActions.remove({ userId: user._id });                                                                          // 62
    Notifications.remove({ userId: user._id });                                                                        // 63
    Meteor.users.remove(user._id);                                                                                     // 64
    waitPromise(globalBackend.cap().deleteUser(user._id));                                                             // 65
    if (user.loginIdentities && user.lastActive) {                                                                     // 66
      // When deleting a user, we can specify it as a "normal" user                                                    //
      // (type: user) or as a user who started out by using the app                                                    //
      // demo feature (type: appDemoUser).                                                                             //
      var deleteStatsType = "demoUser";                                                                                // 70
      var isAppDemoUser = !!user.appDemoId;                                                                            // 71
      if (isAppDemoUser) {                                                                                             // 72
        deleteStatsType = "appDemoUser";                                                                               // 73
      }                                                                                                                // 74
                                                                                                                       //
      // Intentionally record deleted users at time of deletion to avoid miscounting users that                        //
      // were demoing just before the day rolled over.                                                                 //
      DeleteStats.insert({ type: deleteStatsType, lastActive: new Date(), appId: user.appDemoId });                    // 78
    }                                                                                                                  // 79
  });                                                                                                                  // 80
}                                                                                                                      // 81
                                                                                                                       //
if (allowDemo) {                                                                                                       // 83
  Meteor.methods({                                                                                                     // 84
    createDemoUser: function createDemoUser(displayName, appDemoId) {                                                  // 85
      // This is a login method that creates a new temporary user                                                      //
      // every time it is used.                                                                                        //
      //                                                                                                               //
      // appDemoId is important for stats; see cleanupExpiredUsers().                                                  //
      check(displayName, String);                                                                                      // 90
      check(appDemoId, Match.OneOf(undefined, null, String));                                                          // 91
                                                                                                                       //
      // Create the new user.                                                                                          //
      var newUser = { expires: new Date(Date.now() + DEMO_EXPIRATION_MS) };                                            // 94
      if (appDemoId) {                                                                                                 // 95
        newUser.appDemoId = appDemoId;                                                                                 // 96
      }                                                                                                                // 97
                                                                                                                       //
      var userId = Accounts.insertUserDoc({ profile: { name: displayName } }, newUser);                                // 99
                                                                                                                       //
      // Log them in on this connection.                                                                               //
      return Accounts._loginMethod(this, "createDemoUser", arguments, "demo", function () {                            // 102
        return { userId: userId };                                                                                     // 103
      });                                                                                                              // 103
    },                                                                                                                 // 104
                                                                                                                       //
    testExpireDemo: function testExpireDemo() {                                                                        // 106
      if (!isDemoUser()) throw new Meteor.Error(403, "not a demo user");                                               // 107
                                                                                                                       //
      var newExpires = new Date(Date.now() + 15000);                                                                   // 109
      if (Meteor.user().expires.getTime() < newExpires.getTime()) {                                                    // 110
        throw new Meteor.Error(403, "can't exend demo");                                                               // 111
      }                                                                                                                // 112
                                                                                                                       //
      Meteor.users.update(this.userId, { $set: { expires: newExpires } });                                             // 114
    }                                                                                                                  // 115
  });                                                                                                                  // 84
                                                                                                                       //
  // If demo mode is enabled, we permit the client to subscribe to                                                     //
  // information about an app by appId. If this were available in                                                      //
  // non-demo mode, then anonymous users could effectively ask the                                                     //
  // server which apps are installed.                                                                                  //
  Meteor.publish("appInfo", function (appId) {                                                                         // 122
    // This publishes info about an app, including the latest                                                          //
    // version of it. Once you log in, it also publishes your                                                          //
    // list of UserActions.                                                                                            //
    check(appId, String);                                                                                              // 126
                                                                                                                       //
    var packageCursor = Packages.find({ appId: appId }, { sort: { "manifest.appVersion": -1 } });                      // 128
                                                                                                                       //
    var pkg = packageCursor.fetch()[0];                                                                                // 132
                                                                                                                       //
    // This allows us to avoid creating duplicate UserActions.                                                         //
    if (this.userId) {                                                                                                 // 135
      return [packageCursor, UserActions.find({ userId: this.userId, appId: appId })];                                 // 136
    }                                                                                                                  // 140
                                                                                                                       //
    return packageCursor;                                                                                              // 142
  });                                                                                                                  // 143
                                                                                                                       //
  SandstormDb.periodicCleanup(DEMO_EXPIRATION_MS, cleanupExpiredUsers);                                                // 145
} else {                                                                                                               // 146
  // Just run once, in case the config just changed from allowing demos to prohibiting them.                           //
  Meteor.setTimeout(cleanupExpiredUsers, DEMO_EXPIRATION_MS + DEMO_GRACE_MS);                                          // 148
}                                                                                                                      // 149
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"desktop-notifications-server.js":["meteor/meteor",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/desktop-notifications-server.js                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});// Sandstorm - Personal Cloud Sandbox       //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
SandstormDb.periodicCleanup(120000, function () {                                                                      // 19
  // Remove old desktop notfications regularly.                                                                        //
  // periodicCleanup doesn't like runs more frequent than once every two minutes                                       //
  var now = Date.now();                                                                                                // 22
  var then = new Date(now - 30000); // Clear tokens older than 30 seconds.                                             // 23
  globalDb.collections.desktopNotifications.find({                                                                     // 24
    creationDate: { $lt: then }                                                                                        // 25
  }).forEach(function (doc) {                                                                                          // 24
    globalDb.collections.desktopNotifications.remove({                                                                 // 27
      _id: doc._id                                                                                                     // 28
    });                                                                                                                // 27
  });                                                                                                                  // 30
});                                                                                                                    // 31
                                                                                                                       //
Meteor.publish("desktopNotifications", function () {                                                                   // 33
  var _this = this;                                                                                                    // 33
                                                                                                                       //
  var subscribeTime = new Date();                                                                                      // 34
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 36
    // No desktop notifications for anonymous users.                                                                   //
    return [];                                                                                                         // 38
  }                                                                                                                    // 39
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 41
  var callbacks = {                                                                                                    // 42
    added: function added(doc) {                                                                                       // 43
      _this.added("desktopNotifications", doc._id, doc);                                                               // 44
    },                                                                                                                 // 45
                                                                                                                       //
    changed: function changed(newDoc, oldDoc) {                                                                        // 47
      _this.changed("desktopNotifications", newDoc._id, newDoc);                                                       // 48
    },                                                                                                                 // 49
                                                                                                                       //
    removed: function removed(doc) {                                                                                   // 51
      _this.removed("desktopNotifications", doc._id);                                                                  // 52
    }                                                                                                                  // 53
  };                                                                                                                   // 42
                                                                                                                       //
  var sub = db.collections.desktopNotifications.find({                                                                 // 56
    userId: this.userId,                                                                                               // 57
    creationDate: { $gt: subscribeTime }                                                                               // 58
  }).observe(callbacks);                                                                                               // 56
                                                                                                                       //
  this.onStop(function () {                                                                                            // 61
    if (sub) {                                                                                                         // 62
      sub.stop();                                                                                                      // 63
    }                                                                                                                  // 64
  });                                                                                                                  // 65
                                                                                                                       //
  this.ready();                                                                                                        // 67
});                                                                                                                    // 68
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"dev-accounts-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/dev-accounts-server.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  createDevAccount: function createDevAccount(displayName, isAdmin, profile, unverifiedEmail) {                        // 20
    // This is a login method that creates or logs in a dev account with the given displayName                         //
                                                                                                                       //
    check(displayName, String);                                                                                        // 23
    check(isAdmin, Match.OneOf(undefined, null, Boolean));                                                             // 24
    check(profile, Match.OneOf(undefined, null, Object));                                                              // 25
    check(unverifiedEmail, Match.OneOf(undefined, null, String));                                                      // 26
                                                                                                                       //
    if (!this.connection.sandstormDb.allowDevAccounts()) {                                                             // 28
      throw new Meteor.Error(404, "Dev accounts are not enabled on this server");                                      // 29
    }                                                                                                                  // 30
                                                                                                                       //
    isAdmin = isAdmin || false;                                                                                        // 32
                                                                                                                       //
    profile = profile || {};                                                                                           // 34
    profile.name = profile.name || displayName;                                                                        // 35
    var hasCompletedSignup = !!unverifiedEmail && !!profile.pronoun && !!profile.handle;                               // 36
                                                                                                                       //
    var user = Meteor.users.findOne({ "services.dev.name": displayName });                                             // 38
    var userId = void 0;                                                                                               // 39
                                                                                                                       //
    if (user) {                                                                                                        // 41
      userId = user._id;                                                                                               // 42
    } else {                                                                                                           // 43
      userId = Accounts.insertUserDoc({                                                                                // 44
        profile: profile,                                                                                              // 45
        unverifiedEmail: unverifiedEmail                                                                               // 46
      }, {                                                                                                             // 44
        services: {                                                                                                    // 48
          dev: {                                                                                                       // 49
            name: displayName,                                                                                         // 50
            isAdmin: isAdmin,                                                                                          // 51
            hasCompletedSignup: hasCompletedSignup                                                                     // 52
          }                                                                                                            // 49
        }                                                                                                              // 48
      });                                                                                                              // 47
    }                                                                                                                  // 56
    // Log them in on this connection.                                                                                 //
    return Accounts._loginMethod(this, "createDevAccount", arguments, "dev", function () {                             // 58
      return { userId: userId };                                                                                       // 59
    });                                                                                                                // 59
  }                                                                                                                    // 60
});                                                                                                                    // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"feature-key.js":["bignum","ed25519",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/feature-key.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});var ed25519;module.import("ed25519",{"default":function(v){ed25519=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var FeatureKey = Capnp.importSystem("sandstorm/feature-key.capnp").FeatureKey;                                         // 20
                                                                                                                       //
// We don't currently have a way of reading the raw bytes of a capnp struct in Javascript the                          //
// way we do in C++. Awkwardly, what we end up with is four 64-bit ints that have been stringified                     //
// since JS can't actually deal with 64-bit ints. We have to laboriously reconstruct the underlying                    //
// bytes using Bignum. Don't forget that everything is little-endian, as DJBeesus intended.                            //
var bits0 = Bignum(FeatureKey.signingKey.key0);                                                                        // 26
var bits1 = Bignum(FeatureKey.signingKey.key1);                                                                        // 27
var bits2 = Bignum(FeatureKey.signingKey.key2);                                                                        // 28
var bits3 = Bignum(FeatureKey.signingKey.key3);                                                                        // 29
var signingKey = bits0.add(bits1.shiftLeft(64 * 1)).add(bits2.shiftLeft(64 * 2)).add(bits3.shiftLeft(64 * 3)).toBuffer({ endian: "little", size: 32 });
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 36
                                                                                                                       //
function verifyFeatureKeySignature(buf) {                                                                              // 39
  // buf is a Buffer containing an feature key with attached signature.                                                //
  // This function returns the signed data if the signature is valid,                                                  //
  // or undefined if the signature is invalid.                                                                         //
                                                                                                                       //
  // Per crypto_sign, the first 64 bytes are the ed25519 signature                                                     //
  // and the rest of the blob is the signed data.                                                                      //
  var signature = buf.slice(0, 64);                                                                                    // 46
  var signedData = buf.slice(64);                                                                                      // 47
                                                                                                                       //
  if (!ed25519.Verify(signedData, signature, signingKey)) {                                                            // 49
    console.error("feature key failed signature check", bits0, bits1, bits2, bits3);                                   // 50
    return undefined;                                                                                                  // 51
  } else {                                                                                                             // 52
    return signedData;                                                                                                 // 53
  }                                                                                                                    // 54
};                                                                                                                     // 55
                                                                                                                       //
// Export for use in db.js and server/admin.js                                                                         //
loadSignedFeatureKey = function loadSignedFeatureKey(buf) {                                                            // 58
  // Given a Buffer containing a signed feature key, verifies and parses the feature key.                              //
  // Returns the parsed FeatureKey if it was signed by a trusted key, or                                               //
  // undefined if the signature did not pass verification.                                                             //
  var verifiedFeatureKeyBlob = verifyFeatureKeySignature(buf);                                                         // 62
  if (verifiedFeatureKeyBlob) {                                                                                        // 63
    var featureKey = Capnp.parse(FeatureKey, verifiedFeatureKeyBlob, { packed: true });                                // 64
    if (featureKey.isForTesting && !isTesting) {                                                                       // 65
      // This key is for testing only, but the server is not running in testing mode. Note that                        //
      // enabling testing mode forfeits up all security.                                                               //
      return undefined;                                                                                                // 68
    }                                                                                                                  // 69
                                                                                                                       //
    return featureKey;                                                                                                 // 71
  } else {                                                                                                             // 72
    return undefined;                                                                                                  // 73
  }                                                                                                                    // 74
};                                                                                                                     // 75
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"grain-server.js":["babel-runtime/helpers/typeof","/imports/server/email.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/grain-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var sendEmail;module.import("/imports/server/email.js",{"send":function(v){sendEmail=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       // 18
                                                                                                                       //
var emailLinkWithInlineStyle = function emailLinkWithInlineStyle(url, text) {                                          // 20
  return "<a href='" + url + "' style='display:inline-block;text-decoration:none;" + "font-family:sans-serif;width:200px;min-height:30px;line-height:30px;" + "border-radius:4px;text-align:center;background:#762F87;color:white'>" + text + "</a>";
};                                                                                                                     // 25
                                                                                                                       //
Meteor.publish("grainTopBar", function (grainId) {                                                                     // 27
  check(grainId, String);                                                                                              // 28
                                                                                                                       //
  var result = [Grains.find({                                                                                          // 30
    _id: grainId,                                                                                                      // 32
    $or: [{ userId: this.userId }, { "private": { $ne: true } }]                                                       // 33
  }, {                                                                                                                 // 31
    fields: {                                                                                                          // 38
      title: 1,                                                                                                        // 39
      userId: 1,                                                                                                       // 40
      identityId: 1,                                                                                                   // 41
      "private": 1                                                                                                     // 42
    }                                                                                                                  // 38
  })];                                                                                                                 // 37
  if (this.userId) {                                                                                                   // 46
    var myIdentityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                 // 47
    result.push(ApiTokens.find({                                                                                       // 48
      grainId: grainId,                                                                                                // 49
      $or: [{ "owner.user.identityId": { $in: myIdentityIds } }, { identityId: { $in: myIdentityIds } }]               // 50
    }));                                                                                                               // 48
  }                                                                                                                    // 55
                                                                                                                       //
  return result;                                                                                                       // 57
});                                                                                                                    // 58
                                                                                                                       //
// We allow users to learn package information about a grain they own.                                                 //
// This is used for obtaining icon and app title information for grains                                                //
// you own, which is used in the sidebar. It is not a security/privacy                                                 //
// risk since it only exposes this information for grains the user owns.                                               //
Meteor.publish("packageByGrainId", function (grainId) {                                                                // 64
  check(grainId, String);                                                                                              // 65
  var publishThis = [];                                                                                                // 66
  // We need to publish the packageId so that client-side code can                                                     //
  // find the right package.                                                                                           //
  var thisGrainCursor = Grains.find({                                                                                  // 69
    _id: grainId,                                                                                                      // 70
    userId: this.userId                                                                                                // 71
  }, {                                                                                                                 // 69
    fields: { packageId: 1 }                                                                                           // 73
  });                                                                                                                  // 72
  publishThis.push(thisGrainCursor);                                                                                   // 75
                                                                                                                       //
  if (thisGrainCursor.count()) {                                                                                       // 77
    var thisGrain = thisGrainCursor.fetch()[0];                                                                        // 78
    var thisPackageCursor = Packages.find({ _id: thisGrain.packageId });                                               // 79
    publishThis.push(thisPackageCursor);                                                                               // 80
  }                                                                                                                    // 81
                                                                                                                       //
  return publishThis;                                                                                                  // 83
});                                                                                                                    // 84
                                                                                                                       //
Meteor.publish("tokenInfo", function (token) {                                                                         // 86
  // Allows the client side to map a raw token to its entry in ApiTokens, and the additional                           //
  // metadata that it will need to display the app icon and title.  We do not care about making                        //
  // the metadata reactive.                                                                                            //
  check(token, String);                                                                                                // 90
                                                                                                                       //
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 92
  var apiToken = ApiTokens.findOne({                                                                                   // 93
    _id: hashedToken                                                                                                   // 94
  }, {                                                                                                                 // 93
    fields: {                                                                                                          // 96
      grainId: 1,                                                                                                      // 97
      identityId: 1,                                                                                                   // 98
      owner: 1,                                                                                                        // 99
      revoked: 1                                                                                                       // 100
    }                                                                                                                  // 96
  });                                                                                                                  // 95
  if (!apiToken) {                                                                                                     // 103
    this.added("tokenInfo", token, { invalidToken: true });                                                            // 104
  } else if (apiToken.revoked) {                                                                                       // 105
    this.added("tokenInfo", token, { revoked: true });                                                                 // 106
  } else {                                                                                                             // 107
    var grainId = apiToken.grainId;                                                                                    // 108
    var grain = Grains.findOne({                                                                                       // 109
      _id: grainId                                                                                                     // 110
    }, {                                                                                                               // 109
      fields: {                                                                                                        // 112
        packageId: 1,                                                                                                  // 113
        appId: 1,                                                                                                      // 114
        userId: 1                                                                                                      // 115
      }                                                                                                                // 112
    });                                                                                                                // 111
    if (!grain) {                                                                                                      // 118
      this.added("tokenInfo", token, { invalidToken: true });                                                          // 119
    } else {                                                                                                           // 120
      if (apiToken.owner && apiToken.owner.user) {                                                                     // 121
        var identity = globalDb.getIdentity(apiToken.owner.user.identityId);                                           // 122
        var metadata = apiToken.owner.user.denormalizedGrainMetadata;                                                  // 123
        if (identity && metadata) {                                                                                    // 124
          SandstormDb.fillInLoginId(identity);                                                                         // 125
          this.added("tokenInfo", token, {                                                                             // 126
            identityOwner: _.pick(identity, "_id", "profile", "loginId"),                                              // 127
            grainId: grainId,                                                                                          // 128
            grainMetadata: metadata                                                                                    // 129
          });                                                                                                          // 126
        } else {                                                                                                       // 131
          this.added("tokenInfo", token, { invalidToken: true });                                                      // 132
        }                                                                                                              // 133
      } else if (!apiToken.owner || "webkey" in apiToken.owner) {                                                      // 134
        if (this.userId) {                                                                                             // 135
          var user = Meteor.users.findOne({ _id: this.userId });                                                       // 136
          var identityIds = SandstormDb.getUserIdentityIds(user);                                                      // 137
          var childToken = ApiTokens.findOne({                                                                         // 138
            "owner.user.identityId": { $in: identityIds },                                                             // 139
            parentToken: apiToken._id                                                                                  // 140
          });                                                                                                          // 138
          if (childToken || this.userId === grain.userId || identityIds.indexOf(apiToken.identityId) >= 0) {           // 142
            this.added("tokenInfo", token, { alreadyRedeemed: true, grainId: apiToken.grainId });                      // 144
            this.ready();                                                                                              // 145
            return;                                                                                                    // 146
          }                                                                                                            // 147
        }                                                                                                              // 148
                                                                                                                       //
        var pkg = Packages.findOne({ _id: grain.packageId }, { fields: { manifest: 1 } });                             // 150
        var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                            // 151
        var appIcon = undefined;                                                                                       // 152
        if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                             // 153
          var icons = pkg.manifest.metadata.icons;                                                                     // 154
          appIcon = icons.grain || icons.appGrid;                                                                      // 155
        }                                                                                                              // 156
                                                                                                                       //
        var denormalizedGrainMetadata = {                                                                              // 158
          appTitle: appTitle,                                                                                          // 159
          icon: appIcon,                                                                                               // 160
          appId: appIcon ? undefined : grain.appId                                                                     // 161
        };                                                                                                             // 158
        this.added("tokenInfo", token, {                                                                               // 163
          webkey: true,                                                                                                // 164
          grainId: grainId,                                                                                            // 165
          grainMetadata: denormalizedGrainMetadata                                                                     // 166
        });                                                                                                            // 163
      } else {                                                                                                         // 168
        this.added("tokenInfo", token, { invalidToken: true });                                                        // 169
      }                                                                                                                // 170
    }                                                                                                                  // 171
  }                                                                                                                    // 172
                                                                                                                       //
  this.ready();                                                                                                        // 174
  return;                                                                                                              // 175
});                                                                                                                    // 176
                                                                                                                       //
Meteor.publish("requestingAccess", function (grainId) {                                                                // 178
  check(grainId, String);                                                                                              // 179
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 181
    throw new Meteor.Error(403, "Must be logged in to request access.");                                               // 182
  }                                                                                                                    // 183
                                                                                                                       //
  var grain = globalDb.getGrain(grainId);                                                                              // 185
  if (!grain) {                                                                                                        // 186
    throw new Meteor.Error(404, "Grain not found.");                                                                   // 187
  }                                                                                                                    // 188
                                                                                                                       //
  if (grain.userId === this.userId) {                                                                                  // 190
    this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: grain.identityId });              // 191
  }                                                                                                                    // 193
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: this.userId }));                        // 195
  var ownerIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));                  // 196
                                                                                                                       //
  var _this = this;                                                                                                    // 199
  var query = ApiTokens.find({                                                                                         // 200
    grainId: grainId,                                                                                                  // 201
    identityId: { $in: ownerIdentityIds },                                                                             // 202
    parentToken: { $exists: false },                                                                                   // 203
    "owner.user.identityId": { $in: identityIds },                                                                     // 204
    revoked: { $ne: true }                                                                                             // 205
  });                                                                                                                  // 200
  var handle = query.observe({                                                                                         // 207
    added: function added(apiToken) {                                                                                  // 208
      _this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: apiToken.owner.user.identityId });
    }                                                                                                                  // 211
  });                                                                                                                  // 207
                                                                                                                       //
  this.onStop(function () {                                                                                            // 214
    return handle.stop();                                                                                              // 214
  });                                                                                                                  // 214
});                                                                                                                    // 215
                                                                                                                       //
Meteor.publish("grainSize", function (grainId) {                                                                       // 217
  // Publish pseudo-collection containing the size of the grain opened in the given session.                           //
  check(grainId, String);                                                                                              // 219
                                                                                                                       //
  var grain = Grains.findOne(grainId);                                                                                 // 221
  if (!grain || grain.userId !== this.userId) {                                                                        // 222
    return [];                                                                                                         // 223
  }                                                                                                                    // 224
                                                                                                                       //
  var supervisor = globalBackend.cap().getGrain(this.userId, grainId).supervisor;                                      // 226
                                                                                                                       //
  var _this = this;                                                                                                    // 228
  var stopped = false;                                                                                                 // 229
  var promise = getGrainSize(supervisor);                                                                              // 230
                                                                                                                       //
  function getNext(oldSize) {                                                                                          // 232
    promise = getGrainSize(supervisor, oldSize);                                                                       // 233
    promise.then(function (size) {                                                                                     // 234
      if (!stopped) {                                                                                                  // 235
        if (size !== oldSize) {                                                                                        // 236
          // sometimes there are false alarms                                                                          //
          _this.changed("grainSizes", grainId, { size: size });                                                        // 237
        }                                                                                                              // 238
                                                                                                                       //
        getNext(size);                                                                                                 // 240
      }                                                                                                                // 241
    }, function (err) {                                                                                                // 242
                                                                                                                       //
      if (!stopped) {                                                                                                  // 244
        if (err.kjType === "disconnected") {                                                                           // 245
          _this.stop();                                                                                                // 246
        } else {                                                                                                       // 247
          _this.error(err);                                                                                            // 248
        }                                                                                                              // 249
      }                                                                                                                // 250
    });                                                                                                                // 251
  }                                                                                                                    // 252
                                                                                                                       //
  promise.then(function (size) {                                                                                       // 254
    if (!stopped) {                                                                                                    // 255
      _this.added("grainSizes", grainId, { size: size });                                                              // 256
      _this.ready();                                                                                                   // 257
      getNext(size);                                                                                                   // 258
    }                                                                                                                  // 259
  }, function (err) {                                                                                                  // 260
                                                                                                                       //
    if (!stopped) {                                                                                                    // 262
      if (err.kjType === "disconnected") {                                                                             // 263
        _this.stop();                                                                                                  // 264
      } else {                                                                                                         // 265
        _this.error(err);                                                                                              // 266
      }                                                                                                                // 267
    }                                                                                                                  // 268
  });                                                                                                                  // 269
                                                                                                                       //
  _this.onStop(function () {                                                                                           // 271
    stopped = true;                                                                                                    // 272
    promise.cancel();                                                                                                  // 273
  });                                                                                                                  // 274
});                                                                                                                    // 275
                                                                                                                       //
var GRAIN_DELETION_MS = 1000 * 60 * 60 * 24 * 30; // thirty days                                                       // 277
SandstormDb.periodicCleanup(86400000, function () {                                                                    // 278
  var trashExpiration = new Date(Date.now() - GRAIN_DELETION_MS);                                                      // 279
  globalDb.removeApiTokens({ trashed: { $lt: trashExpiration } });                                                     // 280
  globalDb.deleteGrains({ trashed: { $lt: trashExpiration } }, globalBackend, "grain");                                // 281
});                                                                                                                    // 282
                                                                                                                       //
Meteor.methods({                                                                                                       // 284
  moveGrainsToTrash: function moveGrainsToTrash(grainIds) {                                                            // 285
    check(grainIds, [String]);                                                                                         // 286
                                                                                                                       //
    if (this.userId) {                                                                                                 // 288
      Grains.update({ userId: { $eq: this.userId },                                                                    // 289
        _id: { $in: grainIds },                                                                                        // 290
        trashed: { $exists: false } }, { $set: { trashed: new Date() } }, { multi: true });                            // 291
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 295
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 297
        "owner.user.identityId": { $in: identityIds },                                                                 // 298
        trashed: { $exists: false } }, { $set: { "trashed": new Date() } }, { multi: true });                          // 299
    }                                                                                                                  // 302
  },                                                                                                                   // 303
                                                                                                                       //
  moveGrainsOutOfTrash: function moveGrainsOutOfTrash(grainIds) {                                                      // 305
    check(grainIds, [String]);                                                                                         // 306
                                                                                                                       //
    if (this.userId) {                                                                                                 // 308
      Grains.update({ userId: { $eq: this.userId },                                                                    // 309
        _id: { $in: grainIds },                                                                                        // 310
        trashed: { $exists: true } }, { $unset: { trashed: 1 } }, { multi: true });                                    // 311
                                                                                                                       //
      var identityIds = SandstormDb.getUserIdentityIds(Meteor.user());                                                 // 315
                                                                                                                       //
      ApiTokens.update({ grainId: { $in: grainIds },                                                                   // 317
        "owner.user.identityId": { $in: identityIds },                                                                 // 318
        "trashed": { $exists: true } }, { $unset: { "trashed": 1 } }, { multi: true });                                // 319
    }                                                                                                                  // 322
  },                                                                                                                   // 323
                                                                                                                       //
  deleteGrain: function deleteGrain(grainId) {                                                                         // 325
    check(grainId, String);                                                                                            // 326
                                                                                                                       //
    if (this.userId) {                                                                                                 // 328
      var query = {                                                                                                    // 329
        _id: grainId,                                                                                                  // 330
        userId: this.userId,                                                                                           // 331
        trashed: { $exists: true }                                                                                     // 332
      };                                                                                                               // 329
      var numDeleted = globalDb.deleteGrains(query, globalBackend, isDemoUser() ? "demoGrain" : "grain");              // 334
                                                                                                                       //
      // Usually we don't automatically remove user-owned tokens that have become invalid,                             //
      // because if we did their owner might become confused as to why they have mysteriously                          //
      // disappeared. In this particular case, however, for tokens held by the grain owner,                            //
      // there should be no confusion. Indeed, it would be more confusing *not* to remove these                        //
      // tokens, because then the grain could still show up in the trash bin as a "shared with me"                     //
      // grain after the owner clicks "delete permanently".                                                            //
      //                                                                                                               //
      // Note that these tokens may be visible to other accounts if there are identities shared                        //
      // between the accounts; by only removing 'trashed' tokens, we minimize confusion in that                        //
      // case too.                                                                                                     //
      if (numDeleted > 0) {                                                                                            // 347
        globalDb.removeApiTokens({                                                                                     // 348
          grainId: grainId,                                                                                            // 349
          "owner.user.identityId": { $in: SandstormDb.getUserIdentityIds(Meteor.user()) },                             // 350
          "trashed": { $exists: true }                                                                                 // 351
        });                                                                                                            // 348
      }                                                                                                                // 353
    }                                                                                                                  // 354
  },                                                                                                                   // 355
                                                                                                                       //
  forgetGrain: function forgetGrain(grainId, identityId) {                                                             // 357
    check(grainId, String);                                                                                            // 358
    check(identityId, String);                                                                                         // 359
                                                                                                                       //
    if (!this.userId) {                                                                                                // 361
      throw new Meteor.Error(403, "Must be logged in to forget a grain.");                                             // 362
    }                                                                                                                  // 363
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 365
      throw new Meteor.Error(403, "Current user does not have the identity " + identityId);                            // 366
    }                                                                                                                  // 367
                                                                                                                       //
    globalDb.removeApiTokens({ grainId: grainId,                                                                       // 369
      "owner.user.identityId": identityId,                                                                             // 370
      "trashed": { $exists: true }                                                                                     // 371
    });                                                                                                                // 369
  },                                                                                                                   // 373
                                                                                                                       //
  updateGrainPreferredIdentity: function updateGrainPreferredIdentity(grainId, identityId) {                           // 375
    check(grainId, String);                                                                                            // 376
    check(identityId, String);                                                                                         // 377
    if (!this.userId) {                                                                                                // 378
      throw new Meteor.Error(403, "Must be logged in.");                                                               // 379
    }                                                                                                                  // 380
                                                                                                                       //
    var grain = globalDb.getGrain(grainId) || {};                                                                      // 382
    if (!grain.userId === this.userId) {                                                                               // 383
      throw new Meteor.Error(403, "Grain not owned by current user.");                                                 // 384
    }                                                                                                                  // 385
                                                                                                                       //
    Grains.update({ _id: grainId }, { $set: { identityId: identityId } });                                             // 387
  },                                                                                                                   // 388
                                                                                                                       //
  updateGrainTitle: function updateGrainTitle(grainId, newTitle, identityId) {                                         // 390
    check(grainId, String);                                                                                            // 391
    check(newTitle, String);                                                                                           // 392
    check(identityId, String);                                                                                         // 393
    if (this.userId) {                                                                                                 // 394
      var grain = Grains.findOne(grainId);                                                                             // 395
      if (grain) {                                                                                                     // 396
        if (grain.userId === this.userId) {                                                                            // 397
          Grains.update({ _id: grainId, userId: this.userId }, { $set: { title: newTitle } });                         // 398
                                                                                                                       //
          // Denormalize new title out to all sharing tokens.                                                          //
          ApiTokens.update({ grainId: grainId, "owner.user": { $exists: true } }, { $set: { "owner.user.upstreamTitle": newTitle } }, { multi: true });
        } else {                                                                                                       // 404
          if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                    // 405
            throw new Meteor.Error(403, "Current user does not have identity " + identityId);                          // 406
          }                                                                                                            // 407
                                                                                                                       //
          var token = ApiTokens.findOne({                                                                              // 409
            grainId: grainId,                                                                                          // 410
            objectId: { $exists: false },                                                                              // 411
            "owner.user.identityId": identityId                                                                        // 412
          }, {                                                                                                         // 409
            sort: { created: 1 } });                                                                                   // 414
          // The oldest token is our source of truth for the name.                                                     //
          if (token && token.owner.user.title !== newTitle) {                                                          // 416
            if (token.owner.user.upstreamTitle === newTitle) {                                                         // 417
              // User renamed grain to match upstream title. Act like they never renamed it at                         //
              // all.                                                                                                  //
              ApiTokens.update({                                                                                       // 420
                grainId: grainId,                                                                                      // 421
                "owner.user.identityId": identityId                                                                    // 422
              }, {                                                                                                     // 420
                $set: { "owner.user.title": newTitle },                                                                // 424
                $unset: { "owner.user.upstreamTitle": 1, "owner.user.renamed": 1 }                                     // 425
              }, {                                                                                                     // 423
                multi: true                                                                                            // 427
              });                                                                                                      // 426
            } else {                                                                                                   // 429
              var modification = {                                                                                     // 430
                "owner.user.title": newTitle,                                                                          // 431
                "owner.user.renamed": true                                                                             // 432
              };                                                                                                       // 430
                                                                                                                       //
              if (!token.owner.user.upstreamTitle) {                                                                   // 435
                // If `upstreamTitle` isn't present then it is equal to the old title.                                 //
                modification["owner.user.upstreamTitle"] = token.owner.user.title;                                     // 437
              }                                                                                                        // 438
                                                                                                                       //
              ApiTokens.update({ grainId: grainId, "owner.user.identityId": identityId }, { $set: modification }, { multi: true });
            }                                                                                                          // 443
          }                                                                                                            // 444
        }                                                                                                              // 445
      }                                                                                                                // 446
    }                                                                                                                  // 447
  },                                                                                                                   // 448
                                                                                                                       //
  privatizeGrain: function privatizeGrain(grainId) {                                                                   // 450
    check(grainId, String);                                                                                            // 451
    if (this.userId) {                                                                                                 // 452
      Grains.update({ _id: grainId, userId: this.userId }, { $set: { "private": true } });                             // 453
    }                                                                                                                  // 454
  },                                                                                                                   // 455
                                                                                                                       //
  inviteUsersToGrain: function inviteUsersToGrain(origin, identityId, grainId, title, roleAssignment, contacts, message) {
    var _this2 = this;                                                                                                 // 458
                                                                                                                       //
    if (!this.isSimulation) {                                                                                          // 459
      var _ret = function () {                                                                                         // 459
        check(origin, String);                                                                                         // 460
        check(identityId, String);                                                                                     // 461
        check(grainId, String);                                                                                        // 462
        check(title, String);                                                                                          // 463
        check(roleAssignment, roleAssignmentPattern);                                                                  // 464
        check(contacts, [{                                                                                             // 465
          _id: String,                                                                                                 // 467
          isDefault: Match.Optional(Boolean),                                                                          // 468
          profile: Match.ObjectIncluding({                                                                             // 469
            service: String,                                                                                           // 470
            name: String,                                                                                              // 471
            intrinsicName: String                                                                                      // 472
          })                                                                                                           // 469
        }]);                                                                                                           // 466
        check(message, { text: String, html: String });                                                                // 476
        if (!_this2.userId) {                                                                                          // 477
          throw new Meteor.Error(403, "Must be logged in to share by email.");                                         // 478
        }                                                                                                              // 479
                                                                                                                       //
        if (!globalDb.userHasIdentity(_this2.userId, identityId)) {                                                    // 481
          throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                           // 482
        }                                                                                                              // 483
                                                                                                                       //
        if (contacts.length === 0) {                                                                                   // 485
          throw new Meteor.Error(400, "No contacts were provided.");                                                   // 486
        }                                                                                                              // 487
                                                                                                                       //
        if (globalDb.isDemoUser()) {                                                                                   // 489
          throw new Meteor.Error(403, "Demo users are not allowed to share by email.");                                // 490
        }                                                                                                              // 491
                                                                                                                       //
        var accountId = _this2.userId;                                                                                 // 493
        var outerResult = { successes: [], failures: [] };                                                             // 494
        var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                          // 495
        var replyTo = globalDb.getPrimaryEmail(accountId, identityId);                                                 // 496
        contacts.forEach(function (contact) {                                                                          // 497
          if (contact.isDefault && contact.profile.service === "email") {                                              // 498
            var emailAddress = contact.profile.intrinsicName;                                                          // 499
            var result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "email invitation for " + emailAddress, roleAssignment, { webkey: { forSharing: true } });
            var url = origin + "/shared/" + result.token;                                                              // 504
            var html = message.html + "<br><br>" + emailLinkWithInlineStyle(url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: If you forward this email to other people, they will be able to access " + "the share as well. To prevent this, remove the button before forwarding.</div>";
            try {                                                                                                      // 510
              globalDb.incrementDailySentMailCount(accountId);                                                         // 511
              sendEmail({                                                                                              // 512
                to: emailAddress,                                                                                      // 513
                from: fromEmail,                                                                                       // 514
                replyTo: replyTo,                                                                                      // 515
                subject: title + " - Invitation to collaborate",                                                       // 516
                text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + url + "\n\nNote: If you forward this email to other people, they will be able to " + "access the share as well. To prevent this, remove the link before forwarding.",
                html: html                                                                                             // 520
              });                                                                                                      // 512
            } catch (e) {                                                                                              // 522
              outerResult.failures.push({ contact: contact, error: e.toString() });                                    // 523
            }                                                                                                          // 524
          } else {                                                                                                     // 525
            var _result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "direct invitation to " + contact.profile.intrinsicName, roleAssignment, { user: { identityId: contact._id, title: title } });
            var _url = origin + "/shared/" + _result.token;                                                            // 530
            try {                                                                                                      // 531
              var identity = Meteor.users.findOne({ _id: contact._id });                                               // 532
              var email = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                     // 533
              if (email) {                                                                                             // 535
                var intrinsicName = contact.profile.intrinsicName;                                                     // 536
                var loginNote = void 0;                                                                                // 537
                if (contact.profile.service === "google") {                                                            // 538
                  loginNote = "Google account with address " + email.email;                                            // 539
                } else if (contact.profile.service === "github") {                                                     // 540
                  loginNote = "Github account with username " + intrinsicName;                                         // 541
                } else if (contact.profile.service === "email") {                                                      // 542
                  loginNote = "email address " + intrinsicName;                                                        // 543
                } else if (contact.profile.service === "ldap") {                                                       // 544
                  loginNote = "LDAP username " + intrinsicName;                                                        // 545
                } else if (contact.profile.service === "saml") {                                                       // 546
                  loginNote = "SAML ID " + intrinsicName;                                                              // 547
                } else {                                                                                               // 548
                  throw new Meteor.Error(500, "Unknown service to email share link.");                                 // 549
                }                                                                                                      // 550
                                                                                                                       //
                var _html = message.html + "<br><br>" + emailLinkWithInlineStyle(_url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: You will need to log in with your " + loginNote + " to access this grain.";
                globalDb.incrementDailySentMailCount(accountId);                                                       // 557
                sendEmail({                                                                                            // 558
                  to: email.email,                                                                                     // 559
                  from: fromEmail,                                                                                     // 560
                  replyTo: replyTo,                                                                                    // 561
                  subject: title + " - Invitation to collaborate",                                                     // 562
                  text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + _url + "\n\nNote: You will need to log in with your " + loginNote + " to access this grain.",
                  html: _html                                                                                          // 566
                });                                                                                                    // 558
              } else {                                                                                                 // 568
                outerResult.failures.push({ contact: contact, warning: "User does not have a " + "verified email, so notification of this share was not sent to them. Please " + "manually share " + _url + " with them." });
              }                                                                                                        // 572
            } catch (e) {                                                                                              // 573
              outerResult.failures.push({ contact: contact, error: e.toString(),                                       // 574
                warning: "Share succeeded, but there was an error emailing the user. Please " + "manually share " + _url + " with them." });
            }                                                                                                          // 577
          }                                                                                                            // 578
        });                                                                                                            // 579
                                                                                                                       //
        return {                                                                                                       // 581
          v: outerResult                                                                                               // 581
        };                                                                                                             // 581
      }();                                                                                                             // 459
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 459
    }                                                                                                                  // 582
  },                                                                                                                   // 583
                                                                                                                       //
  requestAccess: function requestAccess(origin, grainId, identityId) {                                                 // 585
    check(origin, String);                                                                                             // 586
    check(grainId, String);                                                                                            // 587
    check(identityId, String);                                                                                         // 588
    if (!this.isSimulation) {                                                                                          // 589
      if (!this.userId) {                                                                                              // 590
        throw new Meteor.Error(403, "Must be logged in to request access.");                                           // 591
      }                                                                                                                // 592
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 594
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 595
      }                                                                                                                // 596
                                                                                                                       //
      var grain = Grains.findOne(grainId);                                                                             // 598
      if (!grain) {                                                                                                    // 599
        throw new Meteor.Error(404, "No such grain");                                                                  // 600
      }                                                                                                                // 601
                                                                                                                       //
      var grainOwner = globalDb.getUser(grain.userId);                                                                 // 603
      var email = _.findWhere(SandstormDb.getUserEmails(grainOwner), { primary: true });                               // 604
      if (!email) {                                                                                                    // 605
        throw new Meteor.Error("no email", "Grain owner has no email address.");                                       // 606
      }                                                                                                                // 607
                                                                                                                       //
      var emailAddress = email.email;                                                                                  // 609
                                                                                                                       //
      var identity = globalDb.getIdentity(identityId);                                                                 // 611
      globalDb.addContact(grainOwner._id, identityId);                                                                 // 612
                                                                                                                       //
      var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                            // 614
      var replyTo = globalDb.getPrimaryEmail(Meteor.userId(), identityId);                                             // 615
                                                                                                                       //
      // TODO(soon): In the HTML version, we should display an identity card.                                          //
      var identityNote = "";                                                                                           // 618
      if (identity.profile.service === "google") {                                                                     // 619
        identityNote = " (" + identity.privateIntrinsicName + ")";                                                     // 620
      } else if (identity.profile.service === "github") {                                                              // 621
        identityNote = " (" + identity.profile.intrinsicName + " on GitHub)";                                          // 622
      } else if (identity.profile.service === "email") {                                                               // 623
        identityNote = " (" + identity.profile.intrinsicName + ")";                                                    // 624
      } else if (identity.profile.service === "ldap") {                                                                // 625
        identityNote = " (" + identity.profile.intrinsicName + " on LDAP)";                                            // 626
      } else if (identity.profile.service === "saml") {                                                                // 627
        identityNote = " (" + identity.profile.intrinsicName + " on SAML)";                                            // 628
      }                                                                                                                // 629
                                                                                                                       //
      var message = identity.profile.name + identityNote + " is requesting access to your grain: " + grain.title + ".";
                                                                                                                       //
      var url = origin + "/share/" + grainId + "/" + identityId;                                                       // 634
                                                                                                                       //
      var html = message + "<br><br>" + emailLinkWithInlineStyle(url, "Open Sharing Menu");                            // 636
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 639
      var ACCESS_REQUEST_LIMIT = 10;                                                                                   // 640
      var resetCount = true;                                                                                           // 641
      if (user.accessRequests) {                                                                                       // 642
        if (user.accessRequests.resetOn < new Date()) {                                                                // 643
          Meteor.users.update({ _id: user._id }, { $unset: { accessRequests: 1 } });                                   // 644
        } else if (user.accessRequests.count >= ACCESS_REQUEST_LIMIT) {                                                // 645
          throw new Meteor.Error(403, "For spam control reasons, you are not allowed to make " + "more than " + ACCESS_REQUEST_LIMIT + " access requests per day.");
        } else {                                                                                                       // 649
          resetCount = false;                                                                                          // 650
        }                                                                                                              // 651
      }                                                                                                                // 652
                                                                                                                       //
      var modifier = { $inc: { "accessRequests.count": 1 } };                                                          // 654
      if (resetCount) {                                                                                                // 655
        var tomorrow = new Date(Date.now() + 86400000);                                                                // 656
        modifier.$set = { "accessRequests.resetOn": tomorrow };                                                        // 657
      }                                                                                                                // 658
                                                                                                                       //
      Meteor.users.update({ _id: user._id }, modifier);                                                                // 660
                                                                                                                       //
      sendEmail({                                                                                                      // 662
        to: emailAddress,                                                                                              // 663
        from: fromEmail,                                                                                               // 664
        replyTo: replyTo,                                                                                              // 665
        subject: grain.title + " - Request for access",                                                                // 666
        text: message + "\n\nFollow this link to share access:\n\n" + url,                                             // 667
        html: html                                                                                                     // 668
      });                                                                                                              // 662
    }                                                                                                                  // 670
  }                                                                                                                    // 671
});                                                                                                                    // 284
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"hack-session.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/hack-session.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var hashSturdyRef,checkRequirements;module.import("/imports/server/persistent.js",{"hashSturdyRef":function(v){hashSturdyRef=v},"checkRequirements":function(v){checkRequirements=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Http = Npm.require("http");                                                                                        // 18
var Https = Npm.require("https");                                                                                      // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Net = Npm.require("net");                                                                                          // 21
var Dgram = Npm.require("dgram");                                                                                      // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Capnp = Npm.require("capnp");                                                                                      // 24
                                                                                                                       // 25
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 27
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 28
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 29
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 30
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 31
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 32
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                               // 33
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 35
                                                                                                                       //
ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                            // 37
HOSTNAME = ROOT_URL.hostname;                                                                                          // 38
                                                                                                                       //
SessionContextImpl = function () {                                                                                     // 40
  function SessionContextImpl(grainId, sessionId, identityId, tabId) {                                                 // 41
    _classCallCheck(this, SessionContextImpl);                                                                         // 41
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 42
    this.sessionId = sessionId;                                                                                        // 43
    this.identityId = identityId;                                                                                      // 44
    this.tabId = tabId;                                                                                                // 45
  }                                                                                                                    // 46
                                                                                                                       //
  SessionContextImpl.prototype.claimRequest = function claimRequest(sturdyRef, requiredPermissions) {                  // 40
    var _this2 = this;                                                                                                 // 48
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 49
      var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                  // 50
                                                                                                                       //
      var token = ApiTokens.findOne({                                                                                  // 52
        _id: hashedSturdyRef,                                                                                          // 53
        "owner.clientPowerboxRequest.grainId": _this2.grainId,                                                         // 54
        "owner.clientPowerboxRequest.sessionId": _this2.sessionId                                                      // 55
      });                                                                                                              // 52
                                                                                                                       //
      if (!token) {                                                                                                    // 58
        throw new Error("no such token");                                                                              // 59
      }                                                                                                                // 60
                                                                                                                       //
      // Honor `requiredPermissions`.                                                                                  //
      var requirements = [];                                                                                           // 63
      if (token.owner.clientPowerboxRequest.introducerIdentity) {                                                      // 64
        requirements.push({                                                                                            // 65
          permissionsHeld: {                                                                                           // 66
            permissions: requiredPermissions || [],                                                                    // 67
            identityId: token.owner.clientPowerboxRequest.introducerIdentity,                                          // 68
            grainId: _this2.grainId                                                                                    // 69
          }                                                                                                            // 66
        });                                                                                                            // 65
      }                                                                                                                // 72
                                                                                                                       //
      return restoreInternal(new Buffer(sturdyRef), { clientPowerboxRequest: Match.ObjectIncluding({ grainId: _this2.grainId }) }, requirements, token);
    });                                                                                                                // 78
  };                                                                                                                   // 79
                                                                                                                       //
  SessionContextImpl.prototype.offer = function offer(cap, requiredPermissions, descriptor, displayInfo) {             // 40
    var _this3 = this;                                                                                                 // 81
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 82
                                                                                                                       //
      var session = Sessions.findOne({ _id: _this3.sessionId });                                                       // 84
                                                                                                                       //
      if (!session.identityId && !session.hashedToken) {                                                               // 86
        throw new Error("Session has neither an identityId nor a hashedToken.");                                       // 87
      }                                                                                                                // 88
                                                                                                                       //
      var castedCap = cap.castAs(SystemPersistent);                                                                    // 90
      var apiTokenOwner = { clientPowerboxOffer: { sessionId: _this3.sessionId } };                                    // 91
      var isUiView = descriptor && descriptor.tags && descriptor.tags.length === 1 && descriptor.tags[0] && descriptor.tags[0].id && descriptor.tags[0].id === Grain.UiView.typeId;
      if (isUiView) {                                                                                                  // 95
        var tagValue = {};                                                                                             // 96
        if (descriptor.tags[0].value) {                                                                                // 97
          tagValue = Capnp.parse(Grain.UiView.PowerboxTag, descriptor.tags[0].value);                                  // 98
        }                                                                                                              // 99
                                                                                                                       //
        if (!tagValue.title) {                                                                                         // 101
          // TODO(someday): We should arguably throw here, but the collections app currently                           //
          //   fails to provide a title.                                                                               //
          tagValue.title = "offer()ed grain had no title";                                                             // 104
        }                                                                                                              // 105
                                                                                                                       //
        if (session.identityId) {                                                                                      // 107
          apiTokenOwner = {                                                                                            // 108
            user: {                                                                                                    // 109
              identityId: _this3.identityId,                                                                           // 110
              title: tagValue.title                                                                                    // 111
            }                                                                                                          // 109
          };                                                                                                           // 108
        }                                                                                                              // 114
      }                                                                                                                // 115
                                                                                                                       //
      // TODO(soon): This will eventually use SystemPersistent.addRequirements when membranes                          //
      // are fully implemented for supervisors.                                                                        //
      var permissionsHeld = {                                                                                          // 119
        grainId: _this3.grainId,                                                                                       // 120
        permissions: requiredPermissions                                                                               // 121
      };                                                                                                               // 119
                                                                                                                       //
      if (session.identityId) {                                                                                        // 124
        permissionsHeld.identityId = session.identityId;                                                               // 125
      } else if (session.hashedToken) {                                                                                // 126
        permissionsHeld.tokenId = session.hashedToken;                                                                 // 127
      } else {                                                                                                         // 128
        throw new Error("Cannot offer to anonymous session that does not have a token.");                              // 129
      }                                                                                                                // 130
                                                                                                                       //
      var requirement = { permissionsHeld: permissionsHeld };                                                          // 132
                                                                                                                       //
      checkRequirements(globalDb, [requirement]);                                                                      // 134
                                                                                                                       //
      var save = castedCap.save(apiTokenOwner);                                                                        // 136
      var sturdyRef = waitPromise(save).sturdyRef;                                                                     // 137
      ApiTokens.update({ _id: hashSturdyRef(sturdyRef) }, { $push: { requirements: requirement } });                   // 138
                                                                                                                       //
      var powerboxView = void 0;                                                                                       // 140
      if (isUiView) {                                                                                                  // 141
        if (session.identityId) {                                                                                      // 142
          // Deduplicate.                                                                                              //
          var tokenId = hashSturdyRef(sturdyRef.toString());                                                           // 144
          var newApiToken = ApiTokens.findOne({ _id: tokenId });                                                       // 145
          var dupeQuery = _.pick(newApiToken, "grainId", "roleAssignment", "requirements", "parentToken", "identityId", "accountId");
          dupeQuery._id = { $ne: newApiToken._id };                                                                    // 148
          dupeQuery["owner.user.identityId"] = _this3.identityId;                                                      // 149
          dupeQuery.trashed = { $exists: false };                                                                      // 150
          dupeQuery.revoked = { $exists: false };                                                                      // 151
                                                                                                                       //
          var dupeToken = ApiTokens.findOne(dupeQuery);                                                                // 153
          if (dupeToken) {                                                                                             // 154
            globalDb.removeApiTokens({ _id: tokenId });                                                                // 155
            tokenId = dupeToken._id;                                                                                   // 156
          }                                                                                                            // 157
                                                                                                                       //
          powerboxView = { offer: { uiView: { tokenId: tokenId } } };                                                  // 159
        } else {                                                                                                       // 160
          powerboxView = { offer: { uiView: { token: sturdyRef.toString() } } };                                       // 161
        }                                                                                                              // 162
      } else {                                                                                                         // 163
        powerboxView = {                                                                                               // 164
          offer: {                                                                                                     // 165
            token: sturdyRef.toString()                                                                                // 166
          }                                                                                                            // 165
        };                                                                                                             // 164
      }                                                                                                                // 169
                                                                                                                       //
      Sessions.update({ _id: _this3.sessionId }, {                                                                     // 171
        $set: {                                                                                                        // 173
          powerboxView: powerboxView                                                                                   // 174
        }                                                                                                              // 173
      });                                                                                                              // 172
    });                                                                                                                // 178
  };                                                                                                                   // 179
                                                                                                                       //
  SessionContextImpl.prototype.activity = function activity(event) {                                                   // 40
    var _this4 = this;                                                                                                 // 181
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 182
      logActivity(_this4.grainId, _this4.identityId, event);                                                           // 183
    });                                                                                                                // 184
  };                                                                                                                   // 185
                                                                                                                       //
  return SessionContextImpl;                                                                                           // 40
}();                                                                                                                   // 40
                                                                                                                       //
Meteor.methods({                                                                                                       // 188
  finishPowerboxRequest: function finishPowerboxRequest(sessionId, webkeyUrl, saveLabel, identityId, grainId) {        // 189
    check(sessionId, String);                                                                                          // 190
    check(webkeyUrl, String);                                                                                          // 191
    check(saveLabel, Match.OneOf(undefined, null, String));                                                            // 192
    check(identityId, String);                                                                                         // 193
    check(grainId, String);                                                                                            // 194
                                                                                                                       //
    var userId = Meteor.userId();                                                                                      // 196
    if (!userId || !globalDb.userHasIdentity(userId, identityId)) {                                                    // 197
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 198
    }                                                                                                                  // 199
                                                                                                                       //
    var parsedWebkey = Url.parse(webkeyUrl.trim());                                                                    // 201
    var hostId = matchWildcardHost(parsedWebkey.host);                                                                 // 202
    if (!hostId || !globalDb.isApiHostId(hostId)) {                                                                    // 203
      throw new Meteor.Error(500, "Hostname does not match this server. External webkeys are not " + "supported (yet)");
    }                                                                                                                  // 206
                                                                                                                       //
    var token = parsedWebkey.hash;                                                                                     // 208
    if (!token) {                                                                                                      // 209
      throw new Meteor.Error(400, "Invalid webkey. You must pass in the full webkey, " + "including domain name and hash fragment");
    }                                                                                                                  // 212
                                                                                                                       //
    token = token.slice(1);                                                                                            // 214
    if (globalDb.isTokenSpecificHostId(hostId) && hostId !== globalDb.apiHostIdForToken(token)) {                      // 215
      // Note: This case is not security-sensitive. The client could easily compute the correct                        //
      //   host ID for this token. But since they've passed one that doesn't match, we assume                          //
      //   something is wrong and stop here.                                                                           //
      throw new Meteor.Error(400, "Invalid webkey: token doesn't match hostname.");                                    // 219
    }                                                                                                                  // 220
                                                                                                                       //
    var cap = restoreInternal(new Buffer(token), Match.Optional({ webkey: Match.Optional(Match.Any) }), []).cap;       // 222
    var castedCap = cap.castAs(SystemPersistent);                                                                      // 224
    var owner = {                                                                                                      // 225
      clientPowerboxRequest: {                                                                                         // 226
        grainId: grainId,                                                                                              // 227
        introducerIdentity: identityId,                                                                                // 228
        sessionId: sessionId                                                                                           // 229
      }                                                                                                                // 226
    };                                                                                                                 // 225
    if (saveLabel) {                                                                                                   // 232
      grainOwner.saveLabel = {                                                                                         // 233
        defaultText: saveLabel                                                                                         // 234
      };                                                                                                               // 233
    }                                                                                                                  // 236
                                                                                                                       //
    var save = castedCap.save(owner);                                                                                  // 238
    var sturdyRef = waitPromise(save).sturdyRef;                                                                       // 239
    return sturdyRef.toString();                                                                                       // 240
  },                                                                                                                   // 241
  finishPowerboxOffer: function finishPowerboxOffer(sessionId) {                                                       // 243
    check(sessionId, String);                                                                                          // 244
                                                                                                                       //
    Sessions.update({ _id: sessionId }, { $unset: { powerboxView: null } });                                           // 246
  },                                                                                                                   // 247
  getViewInfoForApiToken: function getViewInfoForApiToken(apiTokenId) {                                                // 249
    check(apiTokenId, String);                                                                                         // 250
    var token = globalDb.collections.apiTokens.findOne(apiTokenId);                                                    // 251
    if (!token) {                                                                                                      // 252
      throw new Meteor.Error(400, "No such token.");                                                                   // 253
    }                                                                                                                  // 254
                                                                                                                       //
    var grain = globalDb.collections.grains.findOne(token.grainId);                                                    // 256
    if (!grain) {                                                                                                      // 257
      throw new Meteor.Error(500, "No grain found for token.");                                                        // 258
    }                                                                                                                  // 259
                                                                                                                       //
    return grain.cachedViewInfo;                                                                                       // 261
  }                                                                                                                    // 262
});                                                                                                                    // 188
                                                                                                                       //
HackSessionContextImpl = function (_SessionContextImpl) {                                                              // 265
  _inherits(HackSessionContextImpl, _SessionContextImpl);                                                              // 265
                                                                                                                       //
  function HackSessionContextImpl(grainId, sessionId, identityId, tabId) {                                             // 266
    _classCallCheck(this, HackSessionContextImpl);                                                                     // 266
                                                                                                                       //
    return _possibleConstructorReturn(this, _SessionContextImpl.call(this, grainId, sessionId, identityId, tabId));    // 266
  }                                                                                                                    // 268
                                                                                                                       //
  HackSessionContextImpl.prototype._getPublicId = function _getPublicId() {                                            // 265
    // Get the grain's public ID, assigning a new one if it doesn't yet have one.                                      //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    while (!this.publicId) {                                                                                           // 275
      // We haven't looked up the public ID yet.                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { publicId: 1 } });                                           // 277
      if (!grain) throw new Error("Grain does not exist.");                                                            // 278
                                                                                                                       //
      if (grain.publicId) {                                                                                            // 280
        this.publicId = grain.publicId;                                                                                // 281
      } else {                                                                                                         // 282
        // The grain doesn't have a public ID yet. Generate one.                                                       //
        var candidate = generateRandomHostname(20);                                                                    // 284
                                                                                                                       //
        if (Grains.findOne({ publicId: candidate })) {                                                                 // 286
          // This should never ever happen.                                                                            //
          console.error("CRITICAL PROBLEM: Public ID collision. " + "CSPRNG is bad or has insufficient entropy.");     // 288
          continue;                                                                                                    // 290
        }                                                                                                              // 291
                                                                                                                       //
        // Carefully perform an update that becomes a no-op if anyone else has assigned a public ID                    //
        // simultaneously.                                                                                             //
        if (Grains.update({ _id: this.grainId, publicId: { $exists: false } }, { $set: { publicId: candidate } }) > 0) {
          // We won the race.                                                                                          //
          this.publicId = candidate;                                                                                   // 298
        }                                                                                                              // 299
      }                                                                                                                // 300
    }                                                                                                                  // 301
                                                                                                                       //
    return this.publicId;                                                                                              // 303
  };                                                                                                                   // 304
                                                                                                                       //
  HackSessionContextImpl.prototype._getAddress = function _getAddress() {                                              // 265
    // Get the grain's outgoing e-mail address.                                                                        //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    return this._getPublicId() + "@" + HOSTNAME;                                                                       // 311
  };                                                                                                                   // 312
                                                                                                                       //
  HackSessionContextImpl.prototype._getUserAddress = function _getUserAddress() {                                      // 265
    // Get the user's e-mail address.                                                                                  //
    //                                                                                                                 //
    // Must be called in a Meteor context.                                                                             //
                                                                                                                       //
    var grain = Grains.findOne(this.grainId, { fields: { identityId: 1 } });                                           // 319
                                                                                                                       //
    var identity = globalDb.getIdentity(grain.identityId);                                                             // 321
                                                                                                                       //
    var primaryEmail = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                        // 323
    var email = primaryEmail && primaryEmail.email || identity.unverifiedEmail;                                        // 324
                                                                                                                       //
    var result = {};                                                                                                   // 326
    if (email) {                                                                                                       // 327
      result.address = email;                                                                                          // 328
    }                                                                                                                  // 329
                                                                                                                       //
    if (identity.profile.name) {                                                                                       // 331
      result.name = identity.profile.name;                                                                             // 332
    }                                                                                                                  // 333
                                                                                                                       //
    return result;                                                                                                     // 335
  };                                                                                                                   // 336
                                                                                                                       //
  HackSessionContextImpl.prototype.send = function send(email) {                                                       // 265
    return hackSendEmail(this, email);                                                                                 // 339
  };                                                                                                                   // 340
                                                                                                                       //
  HackSessionContextImpl.prototype.getPublicId = function getPublicId() {                                              // 265
    return inMeteor(function () {                                                                                      // 343
      var result = {};                                                                                                 // 344
                                                                                                                       //
      result.publicId = this._getPublicId();                                                                           // 346
      result.hostname = HOSTNAME;                                                                                      // 347
      result.autoUrl = ROOT_URL.protocol + "//" + makeWildcardHost(result.publicId);                                   // 348
                                                                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { userId: 1 } });                                             // 350
      result.isDemoUser = Meteor.users.findOne(grain.userId).expires ? true : false;                                   // 351
                                                                                                                       //
      return result;                                                                                                   // 353
    }.bind(this));                                                                                                     // 354
  };                                                                                                                   // 355
                                                                                                                       //
  HackSessionContextImpl.prototype.httpGet = function httpGet(url) {                                                   // 265
    var _this = this;                                                                                                  // 358
    var session = _this;                                                                                               // 359
                                                                                                                       //
    return new Promise(function (resolve, reject) {                                                                    // 361
      var requestMethod = Http.request;                                                                                // 362
      if (url.indexOf("https://") === 0) {                                                                             // 363
        requestMethod = Https.request;                                                                                 // 364
      } else if (url.indexOf("http://") !== 0) {                                                                       // 365
        err = new Error("Protocol not recognized.");                                                                   // 366
        err.nature = "precondition";                                                                                   // 367
        reject(err);                                                                                                   // 368
      }                                                                                                                // 369
                                                                                                                       //
      req = requestMethod(url, function (resp) {                                                                       // 371
        var buffers = [];                                                                                              // 372
        var err = void 0;                                                                                              // 373
                                                                                                                       //
        switch (Math.floor(resp.statusCode / 100)) {                                                                   // 375
          case 2:                                                                                                      // 376
            // 2xx response -- OK.                                                                                     //
            resp.on("data", function (buf) {                                                                           // 377
              buffers.push(buf);                                                                                       // 378
            });                                                                                                        // 379
                                                                                                                       //
            resp.on("end", function () {                                                                               // 381
              resolve({                                                                                                // 382
                content: Buffer.concat(buffers),                                                                       // 383
                mimeType: resp.headers["content-type"] || null                                                         // 384
              });                                                                                                      // 382
            });                                                                                                        // 386
            break;                                                                                                     // 387
          case 3:                                                                                                      // 388
            // 3xx response -- redirect.                                                                               //
            resolve(session.httpGet(resp.headers.location));                                                           // 389
            break;                                                                                                     // 390
          case 4:                                                                                                      // 391
            // 4xx response -- client error.                                                                           //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 392
            err.nature = "precondition";                                                                               // 393
            reject(err);                                                                                               // 394
            break;                                                                                                     // 395
          case 5:                                                                                                      // 396
            // 5xx response -- internal server error.                                                                  //
            err = new Error("Status code " + resp.statusCode + " received in response.");                              // 397
            err.nature = "localBug";                                                                                   // 398
            reject(err);                                                                                               // 399
            break;                                                                                                     // 400
          default:                                                                                                     // 401
            // ???                                                                                                     //
            err = new Error("Invalid status code " + resp.statusCode + " received in response.");                      // 402
            err.nature = "localBug";                                                                                   // 403
            reject(err);                                                                                               // 404
            break;                                                                                                     // 405
        }                                                                                                              // 375
      });                                                                                                              // 407
                                                                                                                       //
      req.on("error", function (e) {                                                                                   // 409
        e.nature = "networkFailure";                                                                                   // 410
        reject(e);                                                                                                     // 411
      });                                                                                                              // 412
                                                                                                                       //
      req.setTimeout(15000, function () {                                                                              // 414
        req.abort();                                                                                                   // 415
        err = new Error("Request timed out.");                                                                         // 416
        err.nature = "localBug";                                                                                       // 417
        err.durability = "overloaded";                                                                                 // 418
        reject(err);                                                                                                   // 419
      });                                                                                                              // 420
                                                                                                                       //
      req.end();                                                                                                       // 422
    });                                                                                                                // 423
  };                                                                                                                   // 424
                                                                                                                       //
  HackSessionContextImpl.prototype.getUserAddress = function getUserAddress() {                                        // 265
    return inMeteor(function () {                                                                                      // 427
      return this._getUserAddress();                                                                                   // 428
    }.bind(this));                                                                                                     // 429
  };                                                                                                                   // 430
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteGenerateApiToken = function obsoleteGenerateApiToken(petname, userInfo, expires) {
    throw new Error("generateApiToken() has been removed. Use offer templates instead.");                              // 433
  };                                                                                                                   // 434
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteListApiTokens = function obsoleteListApiTokens() {                          // 265
    throw new Error("listApiTokens() has been removed. Use offer templates instead.");                                 // 437
  };                                                                                                                   // 438
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteRevokeApiToken = function obsoleteRevokeApiToken(tokenId) {                 // 265
    throw new Error("revokeApiToken() has been removed. Use offer templates instead.");                                // 441
  };                                                                                                                   // 442
                                                                                                                       //
  HackSessionContextImpl.prototype.getUiViewForEndpoint = function getUiViewForEndpoint(url) {                         // 265
    var parsedUrl = Url.parse(url);                                                                                    // 445
                                                                                                                       //
    if (parsedUrl.hash) {                                                                                              // 447
      // Assume that anything with a fragment is a webkey                                                              //
      if (parsedUrl.pathname) {                                                                                        // 448
        throw new Error("Webkey urls cannot contain a path.");                                                         // 449
      }                                                                                                                // 450
                                                                                                                       //
      var token = parsedUrl.hash.slice(1); // Get rid of # which is always the first character                         // 452
      var hostId = matchWildcardHost(parsedUrl.host);                                                                  // 453
      if (hostId && globalDb.isApiHostId(hostId)) {                                                                    // 454
        // Connecting to a local capability.                                                                           //
        return getWrappedUiViewForToken(token);                                                                        // 456
      } else {                                                                                                         // 457
        // Connecting to a remote server with a bearer token.                                                          //
        // TODO(someday): Negotiate server-to-server Cap'n Proto connection.                                           //
        return { view: new ExternalUiView(url, this.grainId, token) };                                                 // 460
      }                                                                                                                // 461
    } else {                                                                                                           // 462
      return { view: new ExternalUiView(url, this.grainId) };                                                          // 463
    }                                                                                                                  // 464
  };                                                                                                                   // 465
                                                                                                                       //
  return HackSessionContextImpl;                                                                                       // 265
}(SessionContextImpl);                                                                                                 // 265
                                                                                                                       //
makeHackSessionContext = function makeHackSessionContext(grainId, sessionId, identityId, tabId) {                      // 468
  return new Capnp.Capability(new HackSessionContextImpl(grainId, sessionId, identityId, tabId), HackSessionContext);  // 469
};                                                                                                                     // 471
                                                                                                                       //
var HOSTNAME_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";                                                           // 473
                                                                                                                       //
generateRandomHostname = function generateRandomHostname(length) {                                                     // 475
  // Generate a random unique name suitable for use in a hostname.                                                     //
                                                                                                                       //
  var digits = [];                                                                                                     // 478
  for (var i = 0; i < length; i++) {                                                                                   // 479
    digits[i] = Random.choice(HOSTNAME_CHARS);                                                                         // 480
  }                                                                                                                    // 481
                                                                                                                       //
  return digits.join("");                                                                                              // 483
};                                                                                                                     // 484
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"identity.js":["babel-runtime/helpers/classCallCheck","babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","/imports/server/persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/identity.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var _possibleConstructorReturn;module.import("babel-runtime/helpers/possibleConstructorReturn",{"default":function(v){_possibleConstructorReturn=v}});var _inherits;module.import("babel-runtime/helpers/inherits",{"default":function(v){_inherits=v}});var PersistentImpl;module.import("/imports/server/persistent.js",{"PersistentImpl":function(v){PersistentImpl=v}});
                                                                                                                       //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var IdentityRpc = Capnp.importSystem("sandstorm/identity-impl.capnp");                                                 // 18
                                                                                                                       // 19
                                                                                                                       //
var IdentityImpl = function (_PersistentImpl) {                                                                        //
  _inherits(IdentityImpl, _PersistentImpl);                                                                            //
                                                                                                                       //
  function IdentityImpl(db, saveTemplate, identityId) {                                                                // 22
    _classCallCheck(this, IdentityImpl);                                                                               // 22
                                                                                                                       //
    var _this = _possibleConstructorReturn(this, _PersistentImpl.call(this, db, saveTemplate));                        // 22
                                                                                                                       //
    _this.identityId = identityId;                                                                                     // 24
    return _this;                                                                                                      // 22
  }                                                                                                                    // 25
                                                                                                                       //
  return IdentityImpl;                                                                                                 //
}(PersistentImpl);                                                                                                     //
                                                                                                                       //
;                                                                                                                      // 26
                                                                                                                       //
makeIdentity = function makeIdentity(identityId, requriements) {                                                       // 28
  var saveTemplate = { frontendRef: { identity: identityId } };                                                        // 29
  return new Capnp.Capability(new IdentityImpl(globalDb, saveTemplate, identityId), IdentityRpc.PersistentIdentity);   // 30
};                                                                                                                     // 32
                                                                                                                       //
globalFrontendRefRegistry.register({                                                                                   // 34
  frontendRefField: "identity",                                                                                        // 35
                                                                                                                       //
  restore: function restore(db, saveTemplate, identityId) {                                                            // 37
    return new Capnp.Capability(new IdentityImpl(db, saveTemplate, identityId), IdentityRpc.PersistentIdentity);       // 38
  }                                                                                                                    // 40
});                                                                                                                    // 34
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"install-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/install-server.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var localizedTextPattern = {                                                                                           // 19
  defaultText: String,                                                                                                 // 20
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 21
};                                                                                                                     // 19
                                                                                                                       //
var uploadTokens = {};                                                                                                 // 24
                                                                                                                       //
// Not all users are allowed to upload apps. We need to manually implement authorization                               //
// because Meteor.userId() is not available in server-side routes.                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 29
  cancelDownload: function (_cancelDownload) {                                                                         // 30
    function cancelDownload(_x) {                                                                                      // 30
      return _cancelDownload.apply(this, arguments);                                                                   // 30
    }                                                                                                                  // 30
                                                                                                                       //
    cancelDownload.toString = function () {                                                                            // 30
      return _cancelDownload.toString();                                                                               // 30
    };                                                                                                                 // 30
                                                                                                                       //
    return cancelDownload;                                                                                             // 30
  }(function (packageId) {                                                                                             // 30
    check(packageId, String);                                                                                          // 31
                                                                                                                       //
    // TODO(security):  Only let user cancel download if they initiated it.                                            //
    cancelDownload(packageId);                                                                                         // 34
  }),                                                                                                                  // 35
                                                                                                                       //
  newUploadToken: function newUploadToken() {                                                                          // 37
    if (!isSignedUp()) {                                                                                               // 38
      throw new Meteor.Error(403, "Unauthorized", "Only invited users can upload apps.");                              // 39
    }                                                                                                                  // 40
                                                                                                                       //
    if (globalDb.isUninvitedFreeUser()) {                                                                              // 42
      throw new Meteor.Error(403, "Unauthorized", "Only paid users can upload apps.");                                 // 43
    }                                                                                                                  // 44
                                                                                                                       //
    var token = Random.id(22);                                                                                         // 46
    uploadTokens[token] = setTimeout(function () {                                                                     // 47
      delete uploadTokens[token];                                                                                      // 48
    }, 20 * 60 * 1000);                                                                                                // 49
                                                                                                                       //
    return token;                                                                                                      // 51
  },                                                                                                                   // 52
                                                                                                                       //
  upgradeGrains: function upgradeGrains(appId, version, packageId) {                                                   // 54
    this.connection.sandstormDb.upgradeGrains(appId, version, packageId, globalBackend);                               // 55
  },                                                                                                                   // 56
                                                                                                                       //
  ensureInstalled: function ensureInstalled(packageId, url, isRetry) {                                                 // 58
    check(packageId, String);                                                                                          // 59
    check(url, Match.OneOf(String, undefined, null));                                                                  // 60
    check(isRetry, Boolean);                                                                                           // 61
                                                                                                                       //
    if (!packageId.match(/^[a-zA-Z0-9]*$/)) {                                                                          // 63
      throw new Meteor.Error(400, "The package ID contains illegal characters.");                                      // 64
    }                                                                                                                  // 65
                                                                                                                       //
    if (!this.userId) {                                                                                                // 67
      if (allowDemo && isSafeDemoAppUrl(url)) {                                                                        // 68
        // continue on                                                                                                 //
      } else {                                                                                                         // 70
          // jscs:ignore disallowEmptyBlocks                                                                           //
          throw new Meteor.Error(403, "You must be logged in to install packages.");                                   // 71
        }                                                                                                              // 72
    } else if (!isSignedUp() && !isDemoUser()) {                                                                       // 73
      throw new Meteor.Error(403, "This Sandstorm server requires you to get an invite before installing apps.");      // 74
    } else if (isUserOverQuota(Meteor.user())) {                                                                       // 76
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 77
    }                                                                                                                  // 79
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 81
                                                                                                                       //
    if (!pkg || pkg.status !== "ready") {                                                                              // 83
      if (!this.userId || isDemoUser() || globalDb.isUninvitedFreeUser()) {                                            // 84
        if (!isSafeDemoAppUrl(url)) {                                                                                  // 85
          // TODO(someday): Billing prompt on client side.                                                             //
          throw new Meteor.Error(403, "Sorry, demo and free users cannot upload custom apps; " + "they may only install apps from apps.sandstorm.io.");
        }                                                                                                              // 89
      }                                                                                                                // 90
    }                                                                                                                  // 91
                                                                                                                       //
    if (!pkg || isRetry) {                                                                                             // 93
      globalDb.startInstall(packageId, url, isRetry);                                                                  // 94
    }                                                                                                                  // 95
  }                                                                                                                    // 96
});                                                                                                                    // 29
                                                                                                                       //
Meteor.publish("packageInfo", function (packageId) {                                                                   // 99
  check(packageId, String);                                                                                            // 100
  var db = this.connection.sandstormDb;                                                                                // 101
  var pkgCursor = db.collections.packages.find(packageId);                                                             // 102
  var pkg = pkgCursor.fetch()[0];                                                                                      // 103
  if (pkg && this.userId) {                                                                                            // 104
    return [pkgCursor, db.collections.userActions.find({ userId: this.userId, appId: pkg.appId }), db.collections.grains.find({ userId: this.userId, appId: pkg.appId })];
  } else {                                                                                                             // 110
    return pkgCursor;                                                                                                  // 111
  }                                                                                                                    // 112
});                                                                                                                    // 113
                                                                                                                       //
Router.map(function () {                                                                                               // 115
  this.route("upload", {                                                                                               // 116
    where: "server",                                                                                                   // 117
    path: "/upload/:token",                                                                                            // 118
                                                                                                                       //
    action: function action() {                                                                                        // 120
      if (!this.params.token || !uploadTokens[this.params.token]) {                                                    // 121
        this.response.writeHead(403, {                                                                                 // 122
          "Content-Type": "text/plain"                                                                                 // 123
        });                                                                                                            // 122
        this.response.write("Invalid upload token.");                                                                  // 125
        this.response.end();                                                                                           // 126
      } else if (this.request.method === "POST") {                                                                     // 127
        try {                                                                                                          // 128
          var packageId = promiseToFuture(doClientUpload(this.request)).wait();                                        // 129
          this.response.writeHead(200, {                                                                               // 130
            "Content-Length": packageId.length,                                                                        // 131
            "Content-Type": "text/plain"                                                                               // 132
          });                                                                                                          // 130
          this.response.write(packageId);                                                                              // 134
          this.response.end();                                                                                         // 135
          clearTimeout(uploadTokens[this.params.token]);                                                               // 136
          delete uploadTokens[this.params.token];                                                                      // 137
        } catch (error) {                                                                                              // 138
          console.error(error.stack);                                                                                  // 139
          this.response.writeHead(500, {                                                                               // 140
            "Content-Type": "text/plain"                                                                               // 141
          });                                                                                                          // 140
          this.response.write("Unpacking SPK failed; is it valid?");                                                   // 143
          this.response.end();                                                                                         // 144
        };                                                                                                             // 145
      } else {                                                                                                         // 146
        this.response.writeHead(405, {                                                                                 // 147
          "Content-Type": "text/plain"                                                                                 // 148
        });                                                                                                            // 147
        this.response.write("You can only POST here.");                                                                // 150
        this.response.end();                                                                                           // 151
      }                                                                                                                // 152
    }                                                                                                                  // 153
  });                                                                                                                  // 116
});                                                                                                                    // 155
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"installer.js":["babel-runtime/helpers/classCallCheck","fs","path","crypto","child_process","http","https","url","request",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/installer.js                                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});var Path;module.import("path",{"default":function(v){Path=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var ChildProcess;module.import("child_process",{"default":function(v){ChildProcess=v}});var Http;module.import("http",{"default":function(v){Http=v}});var Https;module.import("https",{"default":function(v){Https=v}});var Url;module.import("url",{"default":function(v){Url=v}});var Request;module.import("request",{"default":function(v){Request=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       // 18
                                                                                                                       // 19
                                                                                                                       // 20
                                                                                                                       // 21
                                                                                                                       // 22
                                                                                                                       // 23
var Promise = Npm.require("es6-promise").Promise;                                                                      // 24
                                                                                                                       // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
                                                                                                                       //
var Manifest = Capnp.importSystem("sandstorm/package.capnp").Manifest;                                                 // 28
                                                                                                                       //
var installers = void 0; // set to {} on main replica                                                                  // 30
// To protect against race conditions, we require that each row in the Packages                                        //
// collection have at most one writer at a time, as tracked by this `installers`                                       //
// map. Each key is a package ID and each value is either an AppInstaller object                                       //
// or the string 'uninstalling', indicating that some fiber is working on                                              //
// uninstalling the package.                                                                                           //
                                                                                                                       //
var verifyIsMainReplica = function verifyIsMainReplica() {                                                             // 37
  if (Meteor.settings.replicaNumber) {                                                                                 // 38
    throw new Error("This can only be called on the main front-end replica.");                                         // 39
  }                                                                                                                    // 40
};                                                                                                                     // 41
                                                                                                                       //
var deletePackageInternal = function deletePackageInternal(pkg) {                                                      // 43
  verifyIsMainReplica();                                                                                               // 44
                                                                                                                       //
  var packageId = pkg._id;                                                                                             // 46
                                                                                                                       //
  if (packageId in installers) {                                                                                       // 48
    return;                                                                                                            // 49
  }                                                                                                                    // 50
                                                                                                                       //
  installers[packageId] = "uninstalling";                                                                              // 52
                                                                                                                       //
  try {                                                                                                                // 54
    var action = UserActions.findOne({ packageId: packageId });                                                        // 55
    var grain = Grains.findOne({ packageId: packageId });                                                              // 56
    var notificationQuery = {};                                                                                        // 57
    notificationQuery["appUpdates." + pkg.appId] = { $exists: true };                                                  // 58
    if (!grain && !action && !(pkg.isAutoUpdated && Notifications.findOne(notificationQuery)) && !globalDb.getAppIdForPreinstalledPackage(packageId)) {
      Packages.update({                                                                                                // 61
        _id: packageId                                                                                                 // 62
      }, {                                                                                                             // 61
        $set: { status: "delete" },                                                                                    // 64
        $unset: { shouldCleanup: "" }                                                                                  // 65
      });                                                                                                              // 63
      waitPromise(globalBackend.cap().deletePackage(packageId));                                                       // 67
      Packages.remove(packageId);                                                                                      // 68
                                                                                                                       //
      // Clean up assets (icon, etc).                                                                                  //
      getAllManifestAssets(pkg.manifest).forEach(function (assetId) {                                                  // 71
        globalDb.unrefStaticAsset(assetId);                                                                            // 72
      });                                                                                                              // 73
    } else {                                                                                                           // 74
      Packages.update({ _id: packageId }, { $unset: { shouldCleanup: "" } });                                          // 75
    }                                                                                                                  // 76
                                                                                                                       //
    delete installers[packageId];                                                                                      // 78
  } catch (error) {                                                                                                    // 79
    delete installers[packageId];                                                                                      // 80
    throw error;                                                                                                       // 81
  }                                                                                                                    // 82
};                                                                                                                     // 83
                                                                                                                       //
var startInstallInternal = function startInstallInternal(pkg) {                                                        // 85
  verifyIsMainReplica();                                                                                               // 86
                                                                                                                       //
  if (pkg._id in installers) {                                                                                         // 88
    return;                                                                                                            // 89
  }                                                                                                                    // 90
                                                                                                                       //
  var installer = new AppInstaller(pkg._id, pkg.url, pkg.appId, pkg.isAutoUpdated);                                    // 92
  installers[pkg._id] = installer;                                                                                     // 93
  installer.start();                                                                                                   // 94
};                                                                                                                     // 95
                                                                                                                       //
cancelDownload = function cancelDownload(packageId) {                                                                  // 97
  Packages.remove({ _id: packageId, status: "download" });                                                             // 98
};                                                                                                                     // 99
                                                                                                                       //
var cancelDownloadInternal = function cancelDownloadInternal(pkg) {                                                    // 101
  verifyIsMainReplica();                                                                                               // 102
                                                                                                                       //
  var installer = installers[pkg._id];                                                                                 // 104
                                                                                                                       //
  // Don't do anything unless a download is in progress.                                                               //
  if (installer && installer.downloadRequest) {                                                                        // 107
    // OK, effect cancellation by faking an error.                                                                     //
    installer.wrapCallback(function () {                                                                               // 109
      throw new Error("Canceled");                                                                                     // 110
    })();                                                                                                              // 111
  }                                                                                                                    // 112
};                                                                                                                     // 113
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 115
  installers = {};                                                                                                     // 116
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 118
    // Restart any deletions that were killed while in-progress.                                                       //
    Packages.find({ status: "delete" }).forEach(deletePackageInternal);                                                // 120
                                                                                                                       //
    // Watch for new installation requests and fulfill them.                                                           //
    Packages.find({ status: { $in: ["download", "verify", "unpack", "analyze"] } }).observe({                          // 123
      added: startInstallInternal,                                                                                     // 124
      removed: cancelDownloadInternal                                                                                  // 125
    });                                                                                                                // 123
                                                                                                                       //
    // Watch for new cleanup requests and fulfill them.                                                                //
    Packages.find({ status: "ready", shouldCleanup: true }).observe({                                                  // 129
      added: deletePackageInternal                                                                                     // 130
    });                                                                                                                // 129
  });                                                                                                                  // 132
}                                                                                                                      // 133
                                                                                                                       //
doClientUpload = function doClientUpload(stream) {                                                                     // 135
  return new Promise(function (resolve, reject) {                                                                      // 136
    var id = Random.id();                                                                                              // 137
                                                                                                                       //
    var backendStream = globalBackend.cap().installPackage().stream;                                                   // 139
    var hasher = Crypto.createHash("sha256");                                                                          // 140
                                                                                                                       //
    stream.on("data", function (chunk) {                                                                               // 142
      try {                                                                                                            // 143
        hasher.update(chunk);                                                                                          // 144
        backendStream.write(chunk);                                                                                    // 145
      } catch (err) {                                                                                                  // 146
        reject(err);                                                                                                   // 147
      }                                                                                                                // 148
    });                                                                                                                // 149
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 151
      try {                                                                                                            // 152
        (function () {                                                                                                 // 152
          backendStream.done();                                                                                        // 153
          var packageId = hasher.digest("hex").slice(0, 32);                                                           // 154
          resolve(backendStream.saveAs(packageId).then(function () {                                                   // 155
            return packageId;                                                                                          // 156
          }));                                                                                                         // 157
          backendStream.close();                                                                                       // 158
        })();                                                                                                          // 152
      } catch (err) {                                                                                                  // 159
        reject(err);                                                                                                   // 160
      }                                                                                                                // 161
    });                                                                                                                // 162
                                                                                                                       //
    stream.on("error", function (err) {                                                                                // 164
      // TODO(soon):  This event does't seem to fire if the user leaves the page mid-upload.                           //
      try {                                                                                                            // 166
        backendStream.close();                                                                                         // 167
        reject(err);                                                                                                   // 168
      } catch (err2) {                                                                                                 // 169
        reject(err2);                                                                                                  // 170
      }                                                                                                                // 171
    });                                                                                                                // 172
  });                                                                                                                  // 173
};                                                                                                                     // 174
                                                                                                                       //
AppInstaller = function () {                                                                                           // 176
  function AppInstaller(packageId, url, appId, isAutoUpdated) {                                                        // 177
    _classCallCheck(this, AppInstaller);                                                                               // 177
                                                                                                                       //
    verifyIsMainReplica();                                                                                             // 178
                                                                                                                       //
    this.packageId = packageId;                                                                                        // 180
    this.url = url;                                                                                                    // 181
    this.failed = false;                                                                                               // 182
    this.appId = appId;                                                                                                // 183
    this.isAutoUpdated = isAutoUpdated;                                                                                // 184
                                                                                                                       //
    // Serializes database writes.                                                                                     //
    this.writeChain = Promise.resolve();                                                                               // 187
  }                                                                                                                    // 188
                                                                                                                       //
  AppInstaller.prototype.updateProgress = function updateProgress(status, progress, error, manifest) {                 // 176
    // TODO(security):  On error, we should actually delete the package from the database and only                     //
    //   display the error to whomever was watching at the time.  Otherwise it's easy to confuse                       //
    //   people by 'pre-failing' packages.  (Actually, perhaps if a user tries to download an                          //
    //   already-downloading package but specifies a different URL, we really should initiate an                       //
    //   entirely separate download...  but cancel it if the first download succeeds.)                                 //
                                                                                                                       //
    this.status = status;                                                                                              // 197
    this.progress = progress || -1;                                                                                    // 198
    this.error = error;                                                                                                // 199
    this.manifest = manifest || null;                                                                                  // 200
                                                                                                                       //
    var _this = this;                                                                                                  // 202
                                                                                                                       //
    // The callback passed to inMeteor() runs in a new fiber. We need to make sure database writes                     //
    // occur in exactly the order in which we generate them, so we use a promise chain to serialize                    //
    // them.                                                                                                           //
    this.writeChain = this.writeChain.then(function () {                                                               // 207
      return inMeteor(function () {                                                                                    // 208
        if (manifest) extractManifestAssets(manifest);                                                                 // 209
                                                                                                                       //
        Packages.update(_this.packageId, {                                                                             // 211
          $set: {                                                                                                      // 212
            status: _this.status,                                                                                      // 213
            progress: _this.progress,                                                                                  // 214
            error: _this.error ? _this.error.message : null,                                                           // 215
            manifest: _this.manifest,                                                                                  // 216
            appId: _this.appId,                                                                                        // 217
            authorPgpKeyFingerprint: _this.authorPgpKeyFingerprint                                                     // 218
          }                                                                                                            // 212
        });                                                                                                            // 211
                                                                                                                       //
        if (_this.authorPgpKeyFingerprint) {                                                                           // 222
          globalDb.updateKeybaseProfileAsync(_this.authorPgpKeyFingerprint);                                           // 223
        }                                                                                                              // 224
      })["catch"](function (err) {                                                                                     // 225
        console.error(err.stack);                                                                                      // 226
      });                                                                                                              // 227
    });                                                                                                                // 228
  };                                                                                                                   // 229
                                                                                                                       //
  AppInstaller.prototype.wrapCallback = function wrapCallback(method) {                                                // 176
    // Note that the function below must not be an arrow function, since arrow functions do not have                   //
    // access to the context's arguments array.                                                                        //
    var _this = this;                                                                                                  // 234
    return function () {                                                                                               // 235
      if (_this.failed) return;                                                                                        // 236
      try {                                                                                                            // 237
        return method.apply(_this, _.toArray(arguments));                                                              // 238
      } catch (err) {                                                                                                  // 239
        _this.failed = true;                                                                                           // 240
        _this.cleanup();                                                                                               // 241
        _this.updateProgress("failed", 0, err);                                                                        // 242
        _this.writeChain = _this.writeChain.then(function () {                                                         // 243
          delete installers[_this.packageId];                                                                          // 244
        });                                                                                                            // 245
        console.error("Failed to install app:", err.stack);                                                            // 246
      }                                                                                                                // 247
    };                                                                                                                 // 248
  };                                                                                                                   // 249
                                                                                                                       //
  AppInstaller.prototype.cleanup = function cleanup() {                                                                // 176
    if (this.uploadStream) {                                                                                           // 252
      try {                                                                                                            // 253
        this.uploadStream.close();                                                                                     // 254
      } catch (err) {}                                                                                                 // 255
                                                                                                                       //
      delete this.uploadStream;                                                                                        // 257
    }                                                                                                                  // 258
                                                                                                                       //
    if (this.downloadRequest) {                                                                                        // 260
      try {                                                                                                            // 261
        this.downloadRequest.abort();                                                                                  // 262
      } catch (err) {}                                                                                                 // 263
                                                                                                                       //
      delete this.downloadRequest;                                                                                     // 265
    }                                                                                                                  // 266
  };                                                                                                                   // 267
                                                                                                                       //
  AppInstaller.prototype.start = function start() {                                                                    // 176
    var _this2 = this;                                                                                                 // 269
                                                                                                                       //
    return this.wrapCallback(function () {                                                                             // 270
      _this2.cleanup();                                                                                                // 271
                                                                                                                       //
      globalBackend.cap().tryGetPackage(_this2.packageId).then(_this2.wrapCallback(function (info) {                   // 273
        if (info.appId) {                                                                                              // 274
          _this2.appId = info.appId;                                                                                   // 275
          _this2.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                               // 276
          _this2.done(info.manifest);                                                                                  // 277
        } else {                                                                                                       // 278
          _this2.doDownload();                                                                                         // 279
        }                                                                                                              // 280
      }), _this2.wrapCallback(function (err) {                                                                         // 281
        throw err;                                                                                                     // 282
      }));                                                                                                             // 283
    })();                                                                                                              // 284
  };                                                                                                                   // 285
                                                                                                                       //
  AppInstaller.prototype.doDownload = function doDownload() {                                                          // 176
    if (!this.url) {                                                                                                   // 288
      throw new Error("Unknown package ID, and no URL was provided.");                                                 // 289
    }                                                                                                                  // 290
                                                                                                                       //
    console.log("Downloading app:", this.url);                                                                         // 292
    this.updateProgress("download");                                                                                   // 293
                                                                                                                       //
    this.uploadStream = globalBackend.cap().installPackage().stream;                                                   // 295
    return this.doDownloadTo(this.uploadStream);                                                                       // 296
  };                                                                                                                   // 297
                                                                                                                       //
  AppInstaller.prototype.doDownloadTo = function doDownloadTo(out) {                                                   // 176
    var _this3 = this;                                                                                                 // 299
                                                                                                                       //
    var url = Url.parse(this.url);                                                                                     // 300
    var options = {                                                                                                    // 301
      hostname: url.hostname,                                                                                          // 302
      port: url.port,                                                                                                  // 303
      path: url.path                                                                                                   // 304
    };                                                                                                                 // 301
                                                                                                                       //
    var protocol = void 0;                                                                                             // 307
    if (url.protocol === "http:" || url.protocol === "https:") {                                                       // 308
      protocol = Request.defaults({                                                                                    // 309
        maxRedirects: 20,                                                                                              // 310
        // Since we will verify the download against a hash anyway, we don't need to verify the                        //
        // server's certificate. In fact, the only reason we support HTTPS at all here is because                      //
        // some servers refuse to serve over HTTP (which is, in general, a good thing). Skipping the                   //
        // certificate check here is helpful in that it means we don't have to worry about having a                    //
        // reasonable list of trusted CAs available to Sandstorm.                                                      //
        strictSSL: false                                                                                               // 316
      });                                                                                                              // 309
    } else {                                                                                                           // 318
      throw new Error("Protocol not supported: " + url.protocol);                                                      // 319
    }                                                                                                                  // 320
                                                                                                                       //
    // TODO(security):  It could arguably be a security problem that it's possible to probe the                        //
    //   server's local network (behind any firewalls) by presenting URLs here.                                        //
    var bytesExpected = undefined;                                                                                     // 324
    var bytesReceived = 0;                                                                                             // 325
    var hasher = Crypto.createHash("sha256");                                                                          // 326
    var done = false;                                                                                                  // 327
    var updateDownloadProgress = _.throttle(this.wrapCallback(function () {                                            // 328
      if (!done) {                                                                                                     // 329
        if (bytesExpected) {                                                                                           // 330
          _this3.updateProgress("download", bytesReceived / bytesExpected);                                            // 331
        } else {                                                                                                       // 332
          _this3.updateProgress("download", bytesReceived);                                                            // 333
        }                                                                                                              // 334
      }                                                                                                                // 335
    }), 500);                                                                                                          // 336
                                                                                                                       //
    var request = protocol.get(this.url);                                                                              // 338
                                                                                                                       //
    request.on("response", this.wrapCallback(function (response) {                                                     // 340
      if ("content-length" in response.headers) {                                                                      // 341
        bytesExpected = parseInt(response.headers["content-length"]);                                                  // 342
      }                                                                                                                // 343
    }));                                                                                                               // 344
                                                                                                                       //
    request.on("data", this.wrapCallback(function (chunk) {                                                            // 346
      hasher.update(chunk);                                                                                            // 347
      out.write(chunk);                                                                                                // 348
      bytesReceived += chunk.length;                                                                                   // 349
      updateDownloadProgress();                                                                                        // 350
    }));                                                                                                               // 351
                                                                                                                       //
    request.on("end", this.wrapCallback(function () {                                                                  // 353
      out.done();                                                                                                      // 354
                                                                                                                       //
      if (hasher.digest("hex").slice(0, 32) !== _this3.packageId) {                                                    // 356
        throw new Error("Package hash did not match.");                                                                // 357
      }                                                                                                                // 358
                                                                                                                       //
      done = true;                                                                                                     // 360
      delete _this3.downloadRequest;                                                                                   // 361
                                                                                                                       //
      _this3.updateProgress("unpack");                                                                                 // 363
      out.saveAs(_this3.packageId).then(_this3.wrapCallback(function (info) {                                          // 364
        _this3.appId = info.appId;                                                                                     // 365
        _this3.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                                 // 366
        _this3.done(info.manifest);                                                                                    // 367
      }), _this3.wrapCallback(function (err) {                                                                         // 368
        throw err;                                                                                                     // 369
      }));                                                                                                             // 370
    }));                                                                                                               // 371
                                                                                                                       //
    request.on("error", this.wrapCallback(function (err) {                                                             // 373
      throw err;                                                                                                       // 373
    }));                                                                                                               // 373
                                                                                                                       //
    this.downloadRequest = request;                                                                                    // 375
  };                                                                                                                   // 376
                                                                                                                       //
  AppInstaller.prototype.done = function done(manifest) {                                                              // 176
    console.log("App ready:", this.packageId);                                                                         // 379
    this.updateProgress("ready", 1, undefined, manifest);                                                              // 380
    var _this = this;                                                                                                  // 381
    _this.writeChain = _this.writeChain.then(function () {                                                             // 382
      return inMeteor(function () {                                                                                    // 383
        if (_this.isAutoUpdated) {                                                                                     // 384
          globalDb.sendAppUpdateNotifications(_this.appId, _this.packageId, manifest.appTitle && manifest.appTitle.defaultText, manifest.appVersion, manifest.appMarketingVersion && manifest.appMarketingVersion.defaultText);
        }                                                                                                              // 388
                                                                                                                       //
        if (globalDb.getPackageIdForPreinstalledApp(_this.appId) && globalDb.collections.appIndex.findOne({            // 390
          _id: _this.appId,                                                                                            // 392
          packageId: _this.packageId                                                                                   // 393
        })) {                                                                                                          // 391
          // Only mark app as preinstall ready if its appId is in the preinstalledApps setting                         //
          // and if it's the latest package version in the appIndex. The updateAppIndex function                       //
          // will always trigger updates of preinstalled apps, even if a concurrent download of                        //
          // an older package is going on.                                                                             //
          globalDb.setPreinstallAppAsReady(_this.appId, _this.packageId);                                              // 399
        }                                                                                                              // 400
      });                                                                                                              // 401
    }).then(function () {                                                                                              // 402
      delete installers[_this.packageId];                                                                              // 403
    });                                                                                                                // 404
  };                                                                                                                   // 405
                                                                                                                       //
  return AppInstaller;                                                                                                 // 176
}();                                                                                                                   // 176
                                                                                                                       //
extractManifestAssets = function extractManifestAssets(manifest) {                                                     // 408
  var metadata = manifest.metadata;                                                                                    // 409
  if (!metadata) return;                                                                                               // 410
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 412
  if (icons) {                                                                                                         // 413
    var handleIcon = function handleIcon(icon) {                                                                       // 414
      if (icon.svg) {                                                                                                  // 415
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/svg+xml" }, icon.svg);                               // 416
        icon.format = "svg";                                                                                           // 417
        delete icon.svg;                                                                                               // 418
        return true;                                                                                                   // 419
      } else if (icon.png) {                                                                                           // 420
        // Use the 1x version for 'normal' DPI, unless 1x isn't provided, in which case use 2x.                        //
        var normalDpi = icon.png.dpi1x || icon.png.dpi2x;                                                              // 422
        if (!normalDpi) return false;                                                                                  // 423
        icon.format = "png";                                                                                           // 424
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/png" }, normalDpi);                                  // 425
                                                                                                                       //
        if (icon.png.dpi1x && icon.png.dpi2x) {                                                                        // 427
          // Icon specifies both resolutions, so also record a 2x DPI option.                                          //
          icon.assetId2xDpi = globalDb.addStaticAsset({ mimeType: "image/png" }, icon.png.dpi2x);                      // 429
        }                                                                                                              // 430
                                                                                                                       //
        delete icon.png;                                                                                               // 432
        return true;                                                                                                   // 433
      } else {                                                                                                         // 434
        // Unknown icon. Filter it.                                                                                    //
        return false;                                                                                                  // 436
      }                                                                                                                // 437
    };                                                                                                                 // 438
                                                                                                                       //
    if (icons.appGrid && !handleIcon(icons.appGrid)) delete icons.appGrid;                                             // 440
    if (icons.grain && !handleIcon(icons.grain)) delete icons.grain;                                                   // 441
                                                                                                                       //
    // We don't need the market icons.                                                                                 //
    if (icons.market) delete icons.market;                                                                             // 444
    if (icons.marketBig) delete icons.marketBig;                                                                       // 445
  }                                                                                                                    // 446
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 448
    if (text.defaultText) {                                                                                            // 449
      text.defaultTextAssetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, text.defaultText);                 // 450
      delete text.defaultText;                                                                                         // 451
    }                                                                                                                  // 452
                                                                                                                       //
    if (text.localizations) {                                                                                          // 454
      text.localizations.forEach(function (localization) {                                                             // 455
        if (localization.text) {                                                                                       // 456
          localization.assetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, localization.text);               // 457
          delete localization.text;                                                                                    // 459
        }                                                                                                              // 460
      });                                                                                                              // 461
    }                                                                                                                  // 462
  };                                                                                                                   // 463
                                                                                                                       //
  var license = metadata.license;                                                                                      // 465
  if (license) {                                                                                                       // 466
    if (license.proprietary) license.proprietary = handleLocalizedText(license.proprietary);                           // 467
    if (license.publicDomain) license.publicDomain = handleLocalizedText(license.proprietary);                         // 468
    if (license.notices) license.notices = handleLocalizedText(license.notices);                                       // 469
  }                                                                                                                    // 470
                                                                                                                       //
  var author = metadata.author;                                                                                        // 472
  if (author) {                                                                                                        // 473
    // We remove the PGP signature since it was already verified down to a key ID in the back-end.                     //
    if (author.pgpSignature) delete author.pgpSignature;                                                               // 475
  }                                                                                                                    // 476
                                                                                                                       //
  // Don't need the keyring either.                                                                                    //
  if (metadata.pgpKeyring) delete metadata.pgpKeyring;                                                                 // 479
                                                                                                                       //
  // Perhaps used by the 'about' page?                                                                                 //
  if (metadata.description) metadata.description = handleLocalizedText(metadata.description);                          // 482
                                                                                                                       //
  // Screenshots are for app marketing; we don't use them post-install.                                                //
  if (metadata.screenshots) delete metadata.screenshots;                                                               // 485
                                                                                                                       //
  // We might allow the user to view the changelog.                                                                    //
  if (metadata.changeLog) metadata.changeLog = handleLocalizedText(metadata.changeLog);                                // 488
};                                                                                                                     // 489
                                                                                                                       //
getAllManifestAssets = function getAllManifestAssets(manifest) {                                                       // 491
  // Returns a list of all asset IDs in the given manifest.                                                            //
                                                                                                                       //
  var metadata = manifest.metadata;                                                                                    // 494
  if (!metadata) return [];                                                                                            // 495
                                                                                                                       //
  var result = [];                                                                                                     // 497
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 499
  if (icons) {                                                                                                         // 500
    var handleIcon = function handleIcon(icon) {                                                                       // 501
      if (icon.assetId) {                                                                                              // 502
        result.push(icon.assetId);                                                                                     // 503
      }                                                                                                                // 504
    };                                                                                                                 // 505
                                                                                                                       //
    if (icons.appGrid) handleIcon(icons.appGrid);                                                                      // 507
    if (icons.grain) handleIcon(icons.grain);                                                                          // 508
  }                                                                                                                    // 509
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 511
    if (text.defaultTextAssetId) {                                                                                     // 512
      result.push(defaultTextAssetId);                                                                                 // 513
    }                                                                                                                  // 514
                                                                                                                       //
    if (text.localizations) {                                                                                          // 516
      text.localizations.forEach(function (localization) {                                                             // 517
        if (localization.assetId) {                                                                                    // 518
          result.push(localization.assetId);                                                                           // 519
        }                                                                                                              // 520
      });                                                                                                              // 521
    }                                                                                                                  // 522
  };                                                                                                                   // 523
                                                                                                                       //
  var license = metadata.license;                                                                                      // 525
  if (license) {                                                                                                       // 526
    if (license.proprietary) handleLocalizedText(license.proprietary);                                                 // 527
    if (license.publicDomain) handleLocalizedText(license.publicDomain);                                               // 528
    if (license.notices) handleLocalizedText(license.notices);                                                         // 529
  }                                                                                                                    // 530
                                                                                                                       //
  if (metadata.description) handleLocalizedText(metadata.description);                                                 // 532
  if (metadata.changeLog) handleLocalizedText(metadata.changeLog);                                                     // 533
                                                                                                                       //
  return result;                                                                                                       // 535
};                                                                                                                     // 536
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"notifications-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/notifications-server.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var SupervisorCapnp = Capnp.importSystem("sandstorm/supervisor.capnp");                                                // 18
var SystemPersistent = SupervisorCapnp.SystemPersistent;                                                               // 19
                                                                                                                       //
logActivity = function logActivity(grainId, identityId, event) {                                                       // 21
  check(grainId, String);                                                                                              // 22
  check(identityId, String);                                                                                           // 23
  // `event` is always an ActivityEvent parsed from Cap'n Proto buf that's too complicated to check                    //
  // here.                                                                                                             //
                                                                                                                       //
  // TODO(perf): A cached copy of the grain from when the session opened would be fine to use                          //
  //   here, rather than looking it up every time.                                                                     //
  grain = Grains.findOne(grainId);                                                                                     // 29
  if (!grain) {                                                                                                        // 30
    // Shouldn't be possible since activity events come from the grain.                                                //
    throw new Error("no such grain");                                                                                  // 32
  }                                                                                                                    // 33
                                                                                                                       //
  // Look up the event typedef.                                                                                        //
  var eventType = ((grain.cachedViewInfo || {}).eventTypes || [])[event.type];                                         // 36
  if (!eventType) {                                                                                                    // 37
    throw new Error("No such event type in app's ViewInfo: " + event.type);                                            // 38
  }                                                                                                                    // 39
                                                                                                                       //
  if (!eventType.suppressUnread) {                                                                                     // 41
    // Clear the "seenAllActivity" bit for all users except the acting user.                                           //
    // TODO(perf): Consider throttling? Or should that be the app's responsibility?                                    //
    if (identityId != grain.identityId) {                                                                              // 44
      Grains.update(grainId, { $unset: { ownerSeenAllActivity: true } });                                              // 45
    }                                                                                                                  // 46
                                                                                                                       //
    // Also clear on ApiTokens.                                                                                        //
    ApiTokens.update({                                                                                                 // 49
      "grainId": grainId,                                                                                              // 50
      "owner.user.seenAllActivity": true,                                                                              // 51
      "owner.user.identityId": { $ne: identityId }                                                                     // 52
    }, { $unset: { "owner.user.seenAllActivity": true } }, { multi: true });                                           // 49
  }                                                                                                                    // 54
                                                                                                                       //
  // Apply auto-subscriptions.                                                                                         //
  if (eventType.autoSubscribeToGrain) {                                                                                // 57
    globalDb.subscribeToActivity(identityId, grainId);                                                                 // 58
  }                                                                                                                    // 59
                                                                                                                       //
  if (event.thread && eventType.autoSubscribeToThread) {                                                               // 61
    globalDb.subscribeToActivity(identityId, grainId, event.thread.path || "");                                        // 62
  }                                                                                                                    // 63
                                                                                                                       //
  // Figure out whom we need to notify.                                                                                //
  var notifyMap = {};                                                                                                  // 66
  var addRecipient = function addRecipient(recipient) {                                                                // 67
    // Mutes take priority over subscriptions.                                                                         //
    if (recipient.mute) {                                                                                              // 69
      notifyMap[identityId] = false;                                                                                   // 70
    } else {                                                                                                           // 71
      if (!(recipient.identityId in notifyMap)) {                                                                      // 72
        notifyMap[recipient.identityId] = true;                                                                        // 73
      }                                                                                                                // 74
    }                                                                                                                  // 75
  };                                                                                                                   // 76
                                                                                                                       //
  // Don't notify self.                                                                                                //
  addRecipient({ identityId: identityId, mute: true });                                                                // 79
                                                                                                                       //
  // Notify subscribers, if desired.                                                                                   //
  if (eventType.notifySubscribers) {                                                                                   // 82
    // The grain owner is implicitly subscribed.                                                                       //
    addRecipient({ identityId: grain.identityId });                                                                    // 84
                                                                                                                       //
    // Add everyone subscribed to the grain.                                                                           //
    globalDb.getActivitySubscriptions(grainId).forEach(addRecipient);                                                  // 87
                                                                                                                       //
    if (event.thread) {                                                                                                // 89
      // Add everyone subscribed to the thread.                                                                        //
      globalDb.getActivitySubscriptions(grainId, event.thread.path || "").forEach(addRecipient);                       // 91
    }                                                                                                                  // 92
  }                                                                                                                    // 93
                                                                                                                       //
  // Add everyone who is mentioned.                                                                                    //
  if (event.users && event.users.length > 0) {                                                                         // 96
    (function () {                                                                                                     // 96
      var promises = [];                                                                                               // 97
      event.users.forEach(function (user) {                                                                            // 98
        if (user.identity && (user.mentioned || user.subscribed)) {                                                    // 99
          promises.push(unwrapFrontendCap(user.identity, "identity", function (targetId) {                             // 100
            addRecipient({ identityId: targetId });                                                                    // 101
          }));                                                                                                         // 102
        }                                                                                                              // 103
      });                                                                                                              // 104
      waitPromise(Promise.all(promises).then(function (junk) {                                                         // 105
        return undefined;                                                                                              // 105
      }));                                                                                                             // 105
    })();                                                                                                              // 96
  }                                                                                                                    // 106
                                                                                                                       //
  // Make a list of everyone to notify.                                                                                //
  var notify = [];                                                                                                     // 109
  for (var _identityId in notifyMap) {                                                                                 // 110
    if (notifyMap[_identityId]) {                                                                                      // 111
      notify.push(_identityId);                                                                                        // 112
    }                                                                                                                  // 113
  }                                                                                                                    // 114
                                                                                                                       //
  if (notify.length > 0) {                                                                                             // 116
    (function () {                                                                                                     // 116
      var notification = {                                                                                             // 117
        grainId: grainId,                                                                                              // 118
        path: event.path || ""                                                                                         // 119
      };                                                                                                               // 117
                                                                                                                       //
      // Fields we'll update even if the notification already exists.                                                  //
      var update = {                                                                                                   // 123
        isUnread: true,                                                                                                // 124
        timestamp: new Date()                                                                                          // 125
      };                                                                                                               // 123
                                                                                                                       //
      if (event.thread) {                                                                                              // 128
        notification.threadPath = event.thread.path || "";                                                             // 129
      }                                                                                                                // 130
                                                                                                                       //
      if (identityId) {                                                                                                // 132
        notification.initiatingIdentity = identityId;                                                                  // 133
      }                                                                                                                // 134
                                                                                                                       //
      notification.eventType = event.type;                                                                             // 136
      update.text = eventType.verbPhrase;                                                                              // 137
                                                                                                                       //
      notify.forEach(function (targetId) {                                                                             // 139
        // Notify all accounts connected with this identity.                                                           //
        Meteor.users.find({ $or: [{ "loginIdentities.id": targetId }, { "nonloginIdentities.id": targetId }] }).forEach(function (account) {
          Notifications.upsert(_.extend({ userId: account._id }, notification), {                                      // 145
            $set: update,                                                                                              // 146
            $inc: { count: 1 }                                                                                         // 147
          });                                                                                                          // 145
        });                                                                                                            // 149
      });                                                                                                              // 150
    })();                                                                                                              // 116
  }                                                                                                                    // 151
};                                                                                                                     // 152
                                                                                                                       //
Meteor.methods({                                                                                                       // 154
  testNotifications: function testNotifications() {                                                                    // 155
    // Deliver a test notification of each non-grain-initiated type to the user.                                       //
    if (!this.userId) return;                                                                                          // 157
                                                                                                                       //
    Notifications.insert({                                                                                             // 159
      admin: {                                                                                                         // 160
        action: "/admin/stats",                                                                                        // 161
        type: "reportStats"                                                                                            // 162
      },                                                                                                               // 160
      userId: this.userId,                                                                                             // 164
      text: { defaultText: "You can help Sandstorm by sending us some anonymous " + "usage stats. Click here for more info." },
      timestamp: new Date(),                                                                                           // 167
      isUnread: true                                                                                                   // 168
    });                                                                                                                // 159
                                                                                                                       //
    Notifications.insert({                                                                                             // 171
      userId: this.userId,                                                                                             // 172
      referral: true,                                                                                                  // 173
      timestamp: new Date(),                                                                                           // 174
      isUnread: true                                                                                                   // 175
    });                                                                                                                // 171
                                                                                                                       //
    if (global.BlackrockPayments) {                                                                                    // 178
      Notifications.insert({                                                                                           // 179
        userId: this.userId,                                                                                           // 180
        mailingListBonus: true,                                                                                        // 181
        timestamp: new Date(),                                                                                         // 182
        isUnread: true                                                                                                 // 183
      });                                                                                                              // 179
    }                                                                                                                  // 185
  }                                                                                                                    // 186
});                                                                                                                    // 154
                                                                                                                       //
Meteor.publish("notifications", function () {                                                                          // 189
  return Notifications.find({ userId: this.userId });                                                                  // 190
});                                                                                                                    // 191
                                                                                                                       //
Meteor.publish("notificationGrains", function (notificationIds) {                                                      // 193
  // Since publishes can't be reactive, we leave it to the client to subscribe to both                                 //
  // "notifications" and "notificationGrains" reactively.                                                              //
  check(notificationIds, [String]);                                                                                    // 196
  var notifications = Notifications.find({                                                                             // 197
    _id: { $in: notificationIds },                                                                                     // 198
    userId: this.userId                                                                                                // 199
  }, {                                                                                                                 // 197
    fields: { grainId: 1, initiatingIdentity: 1 }                                                                      // 201
  });                                                                                                                  // 200
                                                                                                                       //
  var grainIds = notifications.map(function (row) {                                                                    // 204
    return row.grainId;                                                                                                // 205
  }).filter(function (x) {                                                                                             // 206
    return x;                                                                                                          // 206
  });                                                                                                                  // 206
                                                                                                                       //
  var identities = notifications.map(function (row) {                                                                  // 208
    return row.initiatingIdentity;                                                                                     // 209
  }).filter(function (x) {                                                                                             // 210
    return x;                                                                                                          // 210
  });                                                                                                                  // 210
                                                                                                                       //
  return [Grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } }), Meteor.users.find({ _id: { $in: identities } }, { fields: { profile: 1 } })];
});                                                                                                                    // 216
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"pre-meteor.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/pre-meteor.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file implements logic that we place in front of our main Meteor application,                                   //
// including routing of requests to proxies and handling of static web publishing.                                     //
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 20
var Fs = Npm.require("fs");                                                                                            // 21
var Dns = Npm.require("dns");                                                                                          // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Future = Npm.require("fibers/future");                                                                             // 24
var Http = Npm.require("http");                                                                                        // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 27
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 29
var DDP_HOSTNAME = process.env.DDP_DEFAULT_CONNECTION_URL && Url.parse(process.env.DDP_DEFAULT_CONNECTION_URL).hostname;
var CACHE_TTL_SECONDS = 30; // 30 seconds.  Cache-Control expects units of seconds, not millis.                        // 32
var DNS_CACHE_TTL = CACHE_TTL_SECONDS * 1000; // DNS cache is in millis.                                               // 33
                                                                                                                       //
var webPublishingHandlers = {};                                                                                        // 35
// Maps grain public IDs to Connect handlers.                                                                          //
// TODO(perf): Garbage-collect this map?                                                                               //
                                                                                                                       //
var dnsCache = {};                                                                                                     // 39
// Unfortunately, node's DNS library doesn't cache results, so we do our own caching.                                  //
// Unfortunately, node's DNS library also dosen't give us TTLs. So, we'll cache for                                    //
// DNS_CACHE_TTL (a relatively small value) and rely on the upstream DNS server to implement                           //
// better caching.                                                                                                     //
                                                                                                                       //
function isSandstormShell(hostname) {                                                                                  // 45
  // Is this hostname mapped to the Sandstorm shell?                                                                   //
                                                                                                                       //
  return hostname === HOSTNAME || DDP_HOSTNAME && hostname === DDP_HOSTNAME;                                           // 48
}                                                                                                                      // 49
                                                                                                                       //
// We need to use connect. Let's make sure we're using the same version as Meteor's WebApp module                      //
// uses. Fortunately, they let us extract it.                                                                          //
var connect = WebAppInternals.NpmModules.connect.module;                                                               // 53
                                                                                                                       //
var mime = connect["static"].mime;                                                                                     // 55
                                                                                                                       //
function wwwHandlerForGrain(grainId) {                                                                                 // 57
  return function (request, response) {                                                                                // 58
    var path = request.url;                                                                                            // 59
                                                                                                                       //
    // If a directory, open "index.html".                                                                              //
    if (path.slice(-1) === "/") {                                                                                      // 62
      path = path + "index.html";                                                                                      // 63
    }                                                                                                                  // 64
                                                                                                                       //
    // Strip leading "/".                                                                                              //
    if (path[0] === "/") path = path.slice(1);                                                                         // 67
                                                                                                                       //
    // Strip query.                                                                                                    //
    path = path.split("?")[0];                                                                                         // 70
                                                                                                                       //
    var type = mime.lookup(path);                                                                                      // 72
    var charset = mime.charsets.lookup(type);                                                                          // 73
    if (charset) {                                                                                                     // 74
      type = type + "; charset=" + charset;                                                                            // 75
    } else if (type === "application/json") {                                                                          // 76
      // HACK: Apparently the MIME module does not assume UTF-8 for JSON. :(                                           //
      type = type + "; charset=utf-8";                                                                                 // 78
    }                                                                                                                  // 79
                                                                                                                       //
    // TODO(perf): Automatically gzip text content? Use Express's "compress" middleware for this?                      //
    //   Note that nginx will also auto-compress things...                                                             //
                                                                                                                       //
    response.setHeader("Content-Type", type);                                                                          // 84
    response.setHeader("Cache-Control", "public, max-age=" + CACHE_TTL_SECONDS);                                       // 85
                                                                                                                       //
    if (path === "apps/index.json" || path.match(/apps\/[a-z0-9]{52}[.]json/) || path === "experimental/index.json" || path.match(/experimental\/[a-z0-9]{52}[.]json/)) {
      // TODO(cleanup): Extra special terrible hack: The app index needs to serve these JSON files                     //
      //   cross-origin. We could almost just make all web sites allow cross-origin since generally                    //
      //   web publishing is meant to publish public content. There is one case where this is                          //
      //   problematic, though: sites behind a firewall. Those sites could potentially be read                         //
      //   by outside sites if CORS is enabled on them. Some day we should make it so apps can                         //
      //   explicitly opt-in to allowing cross-origin queries but that day is not today.                               //
      response.setHeader("Access-Control-Allow-Origin", "*");                                                          // 97
    }                                                                                                                  // 98
                                                                                                                       //
    var stream = new ResponseStream(response, 200, "OK");                                                              // 100
                                                                                                                       //
    // We hold our own capability to the stream becaues we don't want ResponseStream's close()                         //
    // logic to happen if the response has no data.                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): This is pretty ugly.                                                                             //
    var streamCap = new Capnp.Capability(stream, ByteStream);                                                          // 106
                                                                                                                       //
    globalBackend.useGrain(grainId, function (supervisor) {                                                            // 108
      return supervisor.getWwwFileHack(path, streamCap).then(function (result) {                                       // 109
        // jscs:disable disallowQuotedKeysInObjects                                                                    //
        var status = result.status;                                                                                    // 111
        if (status === "file") {                                                                                       // 112
          // Nothing to do.                                                                                            //
        } else if (status === "directory") {                                                                           // 114
            stream.sendingDirectResponse();                                                                            // 115
            response.writeHead(303, {                                                                                  // 116
              "Content-Type": "text/plain",                                                                            // 117
              "Location": "/" + path + "/",                                                                            // 118
              "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                  // 119
            });                                                                                                        // 116
            response.end("redirect: /" + path + "/");                                                                  // 121
          } else if (status === "notFound") {                                                                          // 122
            stream.sendingDirectResponse();                                                                            // 123
            response.writeHead(404, {                                                                                  // 124
              "Content-Type": "text/plain"                                                                             // 125
            });                                                                                                        // 124
            response.end("404 not found: /" + path);                                                                   // 127
          } else {                                                                                                     // 128
            console.error("didn't understand result of getWwwFileHack:", status);                                      // 129
            stream.sendingDirectResponse();                                                                            // 130
            response.writeHead(500, {                                                                                  // 131
              "Content-Type": "text/plain"                                                                             // 132
            });                                                                                                        // 131
            response.end("Internal server error");                                                                     // 134
          }                                                                                                            // 135
                                                                                                                       //
        streamCap.close();                                                                                             // 137
      });                                                                                                              // 138
    })["catch"](function (err) {                                                                                       // 139
      console.error(err.stack);                                                                                        // 140
      streamCap.close();                                                                                               // 141
    });                                                                                                                // 142
  };                                                                                                                   // 143
}                                                                                                                      // 144
                                                                                                                       //
function writeErrorResponse(res, err) {                                                                                // 146
  var status = 500;                                                                                                    // 147
  if (err instanceof Meteor.Error && typeof err.error === "number" && err.error >= 400 && err.error < 600) {           // 148
    status = err.error;                                                                                                // 150
  } else if (err.httpErrorCode) {                                                                                      // 151
    status = err.httpErrorCode;                                                                                        // 152
  }                                                                                                                    // 153
                                                                                                                       //
  // Log errors that are our fault, but not errors that are the client's fault.                                        //
  if (status >= 500) console.error(err.stack);                                                                         // 156
                                                                                                                       //
  res.writeHead(status, { "Content-Type": err.htmlMessage ? "text/html" : "text/plain" });                             // 158
  res.end(err.htmlMessage || err.message);                                                                             // 159
}                                                                                                                      // 160
                                                                                                                       //
var PNG_MAGIC = new Buffer([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A]);                                          // 162
var JPEG_MAGIC = new Buffer([0xFF, 0xD8, 0xFF]);                                                                       // 163
                                                                                                                       //
function checkMagic(buf, magic) {                                                                                      // 165
  if (buf.length < magic.length) return false;                                                                         // 166
                                                                                                                       //
  for (var i = 0; i < magic.length; i++) {                                                                             // 168
    if (buf[i] != magic[i]) return false;                                                                              // 169
  }                                                                                                                    // 170
                                                                                                                       //
  return true;                                                                                                         // 172
}                                                                                                                      // 173
                                                                                                                       //
function serveSelfTest(req, res) {                                                                                     // 175
  try {                                                                                                                // 176
    if (req.method === "GET" && req.url === "/") {                                                                     // 177
      var content = new Buffer("Self-test OK.");                                                                       // 179
                                                                                                                       //
      // Convert the ROOT_URL to something that is a valid origin.                                                     //
      var rootUrlAsOrigin = process.env.ROOT_URL;                                                                      // 182
      if (rootUrlAsOrigin.slice(-1) === "/") {                                                                         // 183
        rootUrlAsOrigin = rootUrlAsOrigin.slice(0, -1);                                                                // 184
      }                                                                                                                // 185
                                                                                                                       //
      res.writeHead(200, {                                                                                             // 187
        "Content-Type": "text/plain",                                                                                  // 188
        "Content-Length": content.length,                                                                              // 189
        "Access-Control-Allow-Origin": rootUrlAsOrigin                                                                 // 190
      });                                                                                                              // 187
      res.end(content);                                                                                                // 192
    } else {                                                                                                           // 193
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 194
      res.end("Bad request to self-test subdomain.");                                                                  // 195
      return;                                                                                                          // 196
    }                                                                                                                  // 197
  } catch (err) {                                                                                                      // 198
    console.log("WARNING: An error occurred while serving self-test; proceeding anyway:", err);                        // 199
  }                                                                                                                    // 200
}                                                                                                                      // 201
                                                                                                                       //
function serveStaticAsset(req, res, hostId) {                                                                          // 203
  inMeteor(function () {                                                                                               // 204
    if (req.method === "GET") {                                                                                        // 205
      var assetCspHeader = "default-src 'none'; style-src 'unsafe-inline'; sandbox";                                   // 206
      if (req.headers["if-none-match"] === "permanent") {                                                              // 207
        // Cache never invalidates since we use a new URL for every resource.                                          //
        res.writeHead(304, {                                                                                           // 209
          "Cache-Control": "public, max-age=31536000",                                                                 // 210
          "ETag": "permanent",                                                                                         // 211
                                                                                                                       //
          // To be safe, send these again, although it shouldn't be necessary.                                         //
          "Content-Security-Policy": assetCspHeader,                                                                   // 214
          "Access-Control-Allow-Origin": "*",                                                                          // 215
          "X-Content-Type-Options": "nosniff"                                                                          // 216
        });                                                                                                            // 209
        res.end();                                                                                                     // 218
        return;                                                                                                        // 219
      }                                                                                                                // 220
                                                                                                                       //
      var url = Url.parse(req.url, true);                                                                              // 222
      var pathname = url.pathname.slice(1);                                                                            // 223
      var asset = void 0;                                                                                              // 224
      if (pathname.startsWith("identicon/")) {                                                                         // 225
        var size = parseInt((url.query || {}).s);                                                                      // 226
        asset = new Identicon(pathname.slice("identicon/".length), size).asAsset();                                    // 227
      } else if (pathname.indexOf("/") == -1) {                                                                        // 228
        asset = globalDb.getStaticAsset(pathname);                                                                     // 229
      }                                                                                                                // 230
                                                                                                                       //
      if (asset) {                                                                                                     // 232
        var headers = {                                                                                                // 233
          "Content-Type": asset.mimeType,                                                                              // 234
          "Content-Length": asset.content.length,                                                                      // 235
                                                                                                                       //
          // Assets can be cached forever because each one has a unique ID.                                            //
          "Cache-Control": "public, max-age=31536000",                                                                 // 238
                                                                                                                       //
          // Since different resources get different URLs, we can use a static etag.                                   //
          "ETag": "permanent",                                                                                         // 241
                                                                                                                       //
          // Set strict Content-Security-Policy to prevent static assets from executing any script                     //
          // or doing basically anything when browsed to directly. The static assets host is not                       //
          // intended to serve HTML. Mostly, it serves images and javascript -- note that setting                      //
          // the CSP header on Javascript files does not prevent other hosts from voluntarily                          //
          // specifying these scripts in <script> tags.                                                                //
          "Content-Security-Policy": assetCspHeader,                                                                   // 248
                                                                                                                       //
          // Allow any host to fetch these assets. This is safe since requests to this host are                        //
          // totally side-effect-free and the asset ID acts as a capability to prevent loading                         //
          // assets you're not supposed to know about.                                                                 //
          "Access-Control-Allow-Origin": "*",                                                                          // 253
                                                                                                                       //
          // Extra protection against content type trickery.                                                           //
          "X-Content-Type-Options": "nosniff"                                                                          // 256
        };                                                                                                             // 233
                                                                                                                       //
        if (asset.encoding) {                                                                                          // 259
          headers["Content-Encoding"] = asset.encoding;                                                                // 260
        }                                                                                                              // 261
                                                                                                                       //
        res.writeHead(200, headers);                                                                                   // 263
        res.end(asset.content);                                                                                        // 264
      } else {                                                                                                         // 265
        res.writeHead(404, { "Content-Type": "text/plain" });                                                          // 266
        res.end("not found");                                                                                          // 267
      }                                                                                                                // 268
    } else if (req.method === "POST") {                                                                                // 269
      var _ret = function () {                                                                                         // 269
        res.setHeader("Access-Control-Allow-Origin", "*");                                                             // 270
                                                                                                                       //
        var url = Url.parse(req.url);                                                                                  // 272
        var purpose = globalDb.fulfillAssetUpload(url.pathname.slice(1));                                              // 273
                                                                                                                       //
        // Sanity check the purpose of this upload token.                                                              //
        if (!purpose) {                                                                                                // 276
          res.writeHead(404, { "Content-Type": "text/plain" });                                                        // 277
          res.end("Upload token not found or expired.");                                                               // 278
          return {                                                                                                     // 279
            v: void 0                                                                                                  // 279
          };                                                                                                           // 279
        } else if (purpose.profilePicture) {                                                                           // 280
          var userId = purpose.profilePicture.userId;                                                                  // 281
          var identityId = purpose.profilePicture.identityId;                                                          // 282
          check(userId, String);                                                                                       // 283
          check(identityId, String);                                                                                   // 284
        } else if (purpose.loginLogo) {                                                                                // 285
          // no additional fields for loginLogo                                                                        //
        } else {                                                                                                       // 287
            res.writeHead(500, { "Content-Type": "text/plain" });                                                      // 288
            res.end("Found invalid purpose for upload");                                                               // 289
            return {                                                                                                   // 290
              v: void 0                                                                                                // 290
            };                                                                                                         // 290
          }                                                                                                            // 291
                                                                                                                       //
        var buffers = [];                                                                                              // 293
        var totalSize = 0;                                                                                             // 294
        var done = new Future();                                                                                       // 295
        req.on("data", function (buf) {                                                                                // 296
          totalSize += buf.length;                                                                                     // 297
          if (totalSize <= 64 * 1024) {                                                                                // 298
            buffers.push(buf);                                                                                         // 299
          }                                                                                                            // 300
        });                                                                                                            // 301
        req.on("end", done["return"].bind(done));                                                                      // 302
        req.on("error", done["throw"].bind(done));                                                                     // 303
        done.wait();                                                                                                   // 304
                                                                                                                       //
        if (totalSize > 64 * 1024) {                                                                                   // 306
          // TODO(soon): Resize the image ourselves.                                                                   //
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 308
          res.end("Picture too large; please use an image under 64 KiB.");                                             // 309
          return {                                                                                                     // 310
            v: void 0                                                                                                  // 310
          };                                                                                                           // 310
        }                                                                                                              // 311
                                                                                                                       //
        var content = Buffer.concat(buffers);                                                                          // 313
        var type = void 0;                                                                                             // 314
        if (checkMagic(content, PNG_MAGIC)) {                                                                          // 315
          type = "image/png";                                                                                          // 316
        } else if (checkMagic(content, JPEG_MAGIC)) {                                                                  // 317
          type = "image/jpeg";                                                                                         // 318
        } else {                                                                                                       // 319
          res.writeHead(400, { "Content-Type": "text/plain" });                                                        // 320
          res.end("Image must be PNG or JPEG.");                                                                       // 321
          return {                                                                                                     // 322
            v: void 0                                                                                                  // 322
          };                                                                                                           // 322
        }                                                                                                              // 323
                                                                                                                       //
        var assetId = globalDb.addStaticAsset({ mimeType: type }, content);                                            // 325
                                                                                                                       //
        if (purpose.profilePicture) {                                                                                  // 327
          var _identityId = purpose.profilePicture.identityId;                                                         // 328
          var old = Meteor.users.findAndModify({                                                                       // 329
            query: { _id: _identityId },                                                                               // 330
            update: { $set: { "profile.picture": assetId } },                                                          // 331
            fields: { "profile.picture": 1 }                                                                           // 332
          });                                                                                                          // 329
                                                                                                                       //
          if (old && old.profile && old.profile.picture) {                                                             // 335
            globalDb.unrefStaticAsset(old.profile.picture);                                                            // 336
          }                                                                                                            // 337
        } else if (purpose.loginLogo) {                                                                                // 338
          var _old = globalDb.collections.settings.findAndModify({                                                     // 339
            query: { _id: "whitelabelCustomLogoAssetId" },                                                             // 340
            update: {                                                                                                  // 341
              $setOnInsert: { _id: "whitelabelCustomLogoAssetId" },                                                    // 342
              $set: { value: assetId }                                                                                 // 343
            },                                                                                                         // 341
            upsert: true,                                                                                              // 345
            fields: { value: 1 }                                                                                       // 346
          });                                                                                                          // 339
                                                                                                                       //
          if (_old && _old.value) {                                                                                    // 349
            globalDb.unrefStaticAsset(_old.value);                                                                     // 350
          }                                                                                                            // 351
        }                                                                                                              // 352
                                                                                                                       //
        res.writeHead(204, {});                                                                                        // 354
        res.end();                                                                                                     // 355
      }();                                                                                                             // 269
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 269
    } else if (req.method === "OPTIONS") {                                                                             // 356
      var requestedHeaders = req.headers["access-control-request-headers"];                                            // 357
      if (requestedHeaders) {                                                                                          // 358
        res.setHeader("Access-Control-Allow-Headers", requestedHeaders);                                               // 359
      }                                                                                                                // 360
                                                                                                                       //
      res.writeHead(204, {                                                                                             // 362
        "Access-Control-Allow-Origin": "*",                                                                            // 363
        "Access-Control-Allow-Methods": "GET, HEAD, POST, OPTIONS",                                                    // 364
        "Access-Control-Max-Age": "3600"                                                                               // 365
      });                                                                                                              // 362
      res.end();                                                                                                       // 367
    } else {                                                                                                           // 368
      res.writeHead(405, "Method Not Allowed", {                                                                       // 369
        "Allow": "GET, POST, OPTIONS",                                                                                 // 370
        "Content-Type": "text/plain"                                                                                   // 371
      });                                                                                                              // 369
      res.end("405 Method Not Allowed: " + req.method);                                                                // 373
    }                                                                                                                  // 374
  })["catch"](function (err) {                                                                                         // 375
    writeErrorResponse(res, err);                                                                                      // 376
  });                                                                                                                  // 377
}                                                                                                                      // 378
                                                                                                                       //
var canonicalizeShellOrWildcardUrl = function canonicalizeShellOrWildcardUrl(hostname, url) {                          // 380
  // Start with ROOT_URL, apply host & path from inbound URL, then                                                     //
  // redirect.                                                                                                         //
  var targetUrl = Url.parse(process.env.ROOT_URL);                                                                     // 383
                                                                                                                       //
  // Retain the protocol & port from ROOT_URL but use the inbound                                                      //
  // hostname.                                                                                                         //
  targetUrl.host = hostname + ":" + targetUrl.port;                                                                    // 387
                                                                                                                       //
  // The following allows to avoid decoding + re-encoding query                                                        //
  // string parameters, if provided.                                                                                   //
  targetUrl = Url.resolve(Url.format(targetUrl), url);                                                                 // 391
  return targetUrl;                                                                                                    // 392
};                                                                                                                     // 393
                                                                                                                       //
var handleNonMeteorRequest = function handleNonMeteorRequest(req, res, next, redirectIfInWildcard) {                   // 395
  // if redirectIfInWildcard is true, and if the host is part of the wildcard host, then we will                       //
  // prefer to redirect to the canonical url for that request.  If false, we will respond to the                       //
  // request directly.                                                                                                 //
                                                                                                                       //
  var hostname = req.headers.host.split(":")[0];                                                                       // 400
                                                                                                                       //
  var publicIdPromise = void 0;                                                                                        // 402
  // See if the request was for a host in the wildcard.                                                                //
  var id = matchWildcardHost(req.headers.host);                                                                        // 404
  if (id) {                                                                                                            // 405
    // Match!                                                                                                          //
    if (redirectIfInWildcard) {                                                                                        // 407
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 408
      res.end();                                                                                                       // 409
      return;                                                                                                          // 410
    }                                                                                                                  // 411
                                                                                                                       //
    if (id === "static") {                                                                                             // 413
      // Static assets domain.                                                                                         //
      serveStaticAsset(req, res);                                                                                      // 415
      return;                                                                                                          // 416
    }                                                                                                                  // 417
                                                                                                                       //
    if (id.match(/^selftest-/)) {                                                                                      // 419
      // Self test domain pattern. Starts w/ hyphen to avoid ambiguity with grain session/static                       //
      // publishing wildcard hosts.                                                                                    //
      serveSelfTest(req, res);                                                                                         // 422
      return;                                                                                                          // 423
    }                                                                                                                  // 424
                                                                                                                       //
    // Try to route the request to a session.                                                                          //
    publicIdPromise = tryProxyRequest(id, req, res).then(function (handled) {                                          // 427
      if (handled) {                                                                                                   // 428
        return null;                                                                                                   // 429
      } else {                                                                                                         // 430
        return id;                                                                                                     // 431
      }                                                                                                                // 432
    });                                                                                                                // 433
  } else {                                                                                                             // 434
    // Not a wildcard host. Perhaps it is a custom host.                                                               //
    publicIdPromise = lookupPublicIdFromDns(hostname);                                                                 // 436
  }                                                                                                                    // 437
                                                                                                                       //
  publicIdPromise.then(function (publicId) {                                                                           // 439
    if (publicId) {                                                                                                    // 440
      return Promise.resolve(undefined).then(function () {                                                             // 441
        var handler = webPublishingHandlers[publicId];                                                                 // 442
        if (handler) {                                                                                                 // 443
          return handler;                                                                                              // 444
        } else {                                                                                                       // 445
          // We don't have a handler for this publicId, so look it up in the grain DB.                                 //
          return inMeteor(function () {                                                                                // 447
            var grain = Grains.findOne({ publicId: publicId }, { fields: { _id: 1 } });                                // 448
            if (!grain) {                                                                                              // 449
              throw new Meteor.Error(404, "No such grain for public ID: " + publicId);                                 // 450
            }                                                                                                          // 451
                                                                                                                       //
            var grainId = grain._id;                                                                                   // 453
            return webPublishingHandlers[publicId] = wwwHandlerForGrain(grainId);                                      // 454
          });                                                                                                          // 455
        }                                                                                                              // 456
      }).then(function (handler) {                                                                                     // 457
        handler(req, res);                                                                                             // 458
      });                                                                                                              // 459
    } else {                                                                                                           // 460
      // Already handled by tryProxyRequest above, no further action needed.                                           //
      return Promise.resolve(undefined);                                                                               // 462
    }                                                                                                                  // 463
  })["catch"](function (err) {                                                                                         // 464
    writeErrorResponse(res, err);                                                                                      // 465
  });                                                                                                                  // 466
};                                                                                                                     // 467
                                                                                                                       //
// This function serves responses on Sandstorm's main HTTP/HTTPS                                                       //
// port.                                                                                                               //
var handleNonMeteorRequestDirectly = function handleNonMeteorRequestDirectly(req, res, next) {                         // 471
  handleNonMeteorRequest(req, res, next, false);                                                                       // 472
};                                                                                                                     // 473
                                                                                                                       //
// "Alternate ports" are ports other than the main HTTP or HTTPS port.                                                 //
// They are handled as follows:                                                                                        //
//                                                                                                                     //
// * Requests to the shell & grains, we redirect to the main port.                                                     //
// * For requests to static publishing on hosts within the wildcard, we redirect to the main port.                     //
// * For static publishing glued in via DNS TXT record, we serve the request as-is.                                    //
//                                                                                                                     //
// Alternate ports are bound to FD #5 and higher.                                                                      //
var getNumberOfAlternatePorts = function getNumberOfAlternatePorts() {                                                 // 483
  var numPorts = process.env.PORT.split(",").length;                                                                   // 484
  var numAlternatePorts = numPorts - 1;                                                                                // 485
  return numAlternatePorts;                                                                                            // 486
};                                                                                                                     // 487
                                                                                                                       //
var handleNonMainPortRequest = function handleNonMainPortRequest(req, res, next) {                                     // 489
  try {                                                                                                                // 490
    if (!req.headers.host) {                                                                                           // 491
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 492
      res.end("Missing Host header");                                                                                  // 493
      return;                                                                                                          // 494
    }                                                                                                                  // 495
                                                                                                                       //
    // If this request is intended for the shell, redirect to the canonical shell URL.                                 //
    var hostname = req.headers.host.split(":")[0];                                                                     // 498
    if (isSandstormShell(hostname)) {                                                                                  // 499
      res.writeHead(302, { "Location": canonicalizeShellOrWildcardUrl(hostname, req.url) });                           // 500
      res.end();                                                                                                       // 501
      return;                                                                                                          // 502
    }                                                                                                                  // 503
                                                                                                                       //
    handleNonMeteorRequest(req, res, next, true);                                                                      // 505
  } catch (e) {                                                                                                        // 506
    // This should never be reached, because all the request handlers should be catching                               //
    // exceptions, but you can never be too careful in a top-level request handler.                                    //
    console.err("Unhandled exception in request handler:", e.stack);                                                   // 509
    res.writeHead(500, { "Content-Type": "text/plain" });                                                              // 510
    res.end("Unhandled exception: " + e.stack);                                                                        // 511
  }                                                                                                                    // 512
};                                                                                                                     // 513
                                                                                                                       //
var listenOnAlternatePorts = function listenOnAlternatePorts() {                                                       // 515
  for (var i = 0; i < getNumberOfAlternatePorts(); i++) {                                                              // 516
    // Call createServerForSandstorm() to skip our monkey patching.                                                    //
    var alternatePortServer = Http.createServerForSandstorm(handleNonMainPortRequest);                                 // 518
    alternatePortServer.listen({ fd: i + 5 });                                                                         // 519
  }                                                                                                                    // 520
};                                                                                                                     // 521
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 523
  var meteorRequestListeners = WebApp.httpServer.listeners("request");                                                 // 524
                                                                                                                       //
  // Construct the middleware chain for requests to non-DDP, non-shell hosts.                                          //
  var nonMeteorRequestHandler = connect();                                                                             // 527
  // BlackrockPayments is only defined in the Blackrock build of Sandstorm.                                            //
  if (global.BlackrockPayments) {                                                                                      // 529
    // Have to check with global, because it could be undefined.                                                       //
    nonMeteorRequestHandler.use(BlackrockPayments.makeConnectHandler(globalDb));                                       // 530
  }                                                                                                                    // 531
                                                                                                                       //
  nonMeteorRequestHandler.use(handleNonMeteorRequestDirectly);                                                         // 533
                                                                                                                       //
  WebApp.httpServer.removeAllListeners("request");                                                                     // 535
  WebApp.httpServer.on("request", function (req, res) {                                                                // 536
    try {                                                                                                              // 537
      if (!req.headers.host) {                                                                                         // 538
        res.writeHead(400, { "Content-Type": "text/plain" });                                                          // 539
        res.end("Missing Host header");                                                                                // 540
        return;                                                                                                        // 541
      }                                                                                                                // 542
                                                                                                                       //
      var hostname = req.headers.host.split(":")[0];                                                                   // 544
      if (isSandstormShell(hostname)) {                                                                                // 545
        // If destined for the DDP host or the main host, pass on to Meteor                                            //
        for (var i = 0; i < meteorRequestListeners.length; i++) {                                                      // 547
          meteorRequestListeners[i](req, res);                                                                         // 548
        }                                                                                                              // 549
      } else {                                                                                                         // 550
        // Otherwise, dispatch to our own middleware proxy chain.                                                      //
        nonMeteorRequestHandler(req, res);                                                                             // 552
        // Adjust timeouts on proxied requests to allow apps to long-poll if needed.                                   //
        WebApp._timeoutAdjustmentRequestCallback(req, res);                                                            // 554
      }                                                                                                                // 555
    } catch (e) {                                                                                                      // 556
      // This should never be reached, because all the request handlers should be catching                             //
      // exceptions, but you can never be too careful in a top-level request handler.                                  //
      console.err("Unhandled exception in request handler:", e.stack);                                                 // 559
      res.writeHead(500, { "Content-Type": "text/plain" });                                                            // 560
      res.end("Unhandled exception: " + e.stack);                                                                      // 561
    }                                                                                                                  // 562
  });                                                                                                                  // 563
                                                                                                                       //
  var meteorUpgradeListeners = WebApp.httpServer.listeners("upgrade");                                                 // 565
  WebApp.httpServer.removeAllListeners("upgrade");                                                                     // 566
                                                                                                                       //
  WebApp.httpServer.on("upgrade", function (req, socket, head) {                                                       // 568
    Promise.resolve(undefined).then(function () {                                                                      // 569
      if (!req.headers.host) {                                                                                         // 570
        throw new Meteor.Error(400, "Missing Host header");                                                            // 571
      } else if (isSandstormShell(req.headers.host.split(":")[0])) {                                                   // 572
        // Go on to Meteor.                                                                                            //
        for (var ii = 0; ii < meteorUpgradeListeners.length; ++ii) {                                                   // 574
          meteorUpgradeListeners[ii](req, socket, head);                                                               // 575
        }                                                                                                              // 576
                                                                                                                       //
        return true;                                                                                                   // 578
      } else {                                                                                                         // 579
        var id = matchWildcardHost(req.headers.host);                                                                  // 580
        if (id) {                                                                                                      // 581
          return tryProxyUpgrade(id, req, socket, head);                                                               // 582
        } else {                                                                                                       // 583
          return false;                                                                                                // 584
        }                                                                                                              // 585
      }                                                                                                                // 586
    }).then(function (handled) {                                                                                       // 587
      if (!handled) socket.destroy();                                                                                  // 588
    })["catch"](function (err) {                                                                                       // 589
      console.error("WebSocket event handler failed:", err.stack);                                                     // 590
      socket.destroy();                                                                                                // 591
    });                                                                                                                // 592
  });                                                                                                                  // 593
                                                                                                                       //
  listenOnAlternatePorts();                                                                                            // 595
});                                                                                                                    // 596
                                                                                                                       //
var errorTxtMapping = {};                                                                                              // 598
errorTxtMapping[Dns.NOTFOUND] = "<p>" + "If you were trying to configure static publishing for a blog or website, powered " + "by a Sandstorm app hosted at this server, you either have not added DNS TXT records " + "correctly, or the DNS cache has not updated yet (may take a while, like 5 minutes to one " + "hour).</p>";
errorTxtMapping[Dns.NODATA] = errorTxtMapping[Dns.NOTFOUND];                                                           // 604
errorTxtMapping[Dns.TIMEOUT] = "<p>" + "The DNS query has timed out, which may be a sign of poorly configured DNS on the server.</p>";
errorTxtMapping[Dns.CONNREFUSED] = "<p>" + "The DNS server refused the connection, which means either your DNS server is down/unreachable, " + "or the server has misconfigured their DNS.</p>";
                                                                                                                       //
function lookupPublicIdFromDns(hostname) {                                                                             // 611
  // Given a hostname, determine its public ID.                                                                        //
  // We look for a TXT record indicating the public ID. Unfortunately, according to spec, a single                     //
  // hostname cannot have both a CNAME and a TXT record, because a TXT lookup on a CNAME'd host                        //
  // should actually be redirected to the CNAME, just like an A lookup would be. In practice lots                      //
  // of DNS software actually allows TXT records on CNAMEs, and it seems to work, but some software                    //
  // does not allow it and it's explicitly disallowed by the spec. Therefore, we instead look for                      //
  // the TXT record on a subdomain.                                                                                    //
  //                                                                                                                   //
  // I also considered having the CNAME itself point to <publicId>.<hostname>, where                                   //
  // *.<hostname> is in turn a CNAME for the Sandstorm server. This approach seemed elegant at                         //
  // first, but has a number of problems, the biggest being that it breaks the ability to place a                      //
  // CDN like CloudFlare in front of the site.                                                                         //
                                                                                                                       //
  var cache = dnsCache[hostname];                                                                                      // 625
  if (cache && Date.now() < cache.expiration) {                                                                        // 626
    return Promise.resolve(cache.value);                                                                               // 627
  }                                                                                                                    // 628
                                                                                                                       //
  return new Promise(function (resolve, reject) {                                                                      // 630
    Dns.resolveTxt("sandstorm-www." + hostname, function (err, records) {                                              // 631
      if (err) {                                                                                                       // 632
        var errorMsg = errorTxtMapping[err.code] || "";                                                                // 633
        var error = new Error('Error looking up DNS TXT records for host "' + hostname + '": ' + err.message);         // 634
        error.htmlMessage = '<style type="text/css">h2, h3, p { max-width: 600px; }</style>' + "<h2>Sandstorm static publishing needs further configuration (or wrong URL)</h2>" + errorMsg + "<p>To visit this Sandstorm server's main interface, go to: <a href='" + process.env.ROOT_URL + "'>" + process.env.ROOT_URL + "</a></p>" + "<h3>DNS details</h3>" + '<p>Error looking up DNS TXT records for host "' + hostname + '": ' + err.message + "</p>" + "<p>If you have the <tt>dig</tt> tool, you can run this command to learn more:</p>" + "<p><tt>dig TXT sandstorm-www." + hostname + "</tt></p>" + "<h3>Changing the server URL, or troubleshooting OAuth login</h3>" + "<p>If you are the server admin and want to use this address as the main interface, " + "edit /opt/sandstorm/sandstorm.conf, modify the BASE_URL setting, and restart " + "Sandstorm.</p>" + "<p>If you got here after trying to log in via OAuth (e.g. through GitHub or Google), " + "the problem is probably that the OAuth callback URL was set wrong. You need to " + "update it through the respective login provider's management console. The " + "easiest way to do that is to run <tt>sudo sandstorm admin-token</tt>, then " + "reconfigure the OAuth provider.</p>";
        error.httpErrorCode = _.contains(["ENOTFOUND", "ENODATA"], err.code) ? 404 : 500;                              // 655
        reject(error);                                                                                                 // 656
      } else if (records.length !== 1) {                                                                               // 657
        reject(new Error('Host "sandstorm-www.' + hostname + '" must have exactly one TXT record.'));                  // 658
      } else {                                                                                                         // 659
        var result = records[0];                                                                                       // 660
        dnsCache[hostname] = { value: result, expiration: Date.now() + DNS_CACHE_TTL };                                // 661
        resolve(result);                                                                                               // 662
      }                                                                                                                // 663
    });                                                                                                                // 664
  });                                                                                                                  // 665
}                                                                                                                      // 666
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"proxy.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck","bignum",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/proxy.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var Bignum;module.import("bignum",{"default":function(v){Bignum=v}});
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
var Crypto = Npm.require("crypto");                                                                                    // 18
var ChildProcess = Npm.require("child_process");                                                                       // 19
var Fs = Npm.require("fs");                                                                                            // 20
var Path = Npm.require("path");                                                                                        // 21
var Future = Npm.require("fibers/future");                                                                             // 22
var Http = Npm.require("http");                                                                                        // 23
var Url = Npm.require("url");                                                                                          // 24
var Promise = Npm.require("es6-promise").Promise;                                                                      // 25
var Capnp = Npm.require("capnp");                                                                                      // 26
var Net = Npm.require("net");                                                                                          // 27
                                                                                                                       //
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 29
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 30
var WebSession = Capnp.importSystem("sandstorm/web-session.capnp").WebSession;                                         // 31
var HackSession = Capnp.importSystem("sandstorm/hack-session.capnp");                                                  // 32
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 33
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 34
                                                                                                                       //
var storeReferralProgramInfoApiTokenCreated = function storeReferralProgramInfoApiTokenCreated(db, accountId, identityId, apiTokenAccountId) {
  // From the Referral program's perspective, if Bob's Account has no referredByComplete, then we                      //
  // update Bob's Identity to say it's referredBy Alice's Account (which is apiTokenAccountId).                        //
  check(accountId, String);                                                                                            // 39
  check(identityId, String);                                                                                           // 40
  check(apiTokenAccountId, String);                                                                                    // 41
                                                                                                                       //
  // Bail out early if quota enforcement is disabled.                                                                  //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 44
    return;                                                                                                            // 45
  }                                                                                                                    // 46
                                                                                                                       //
  var aliceAccountId = apiTokenAccountId;                                                                              // 48
  var bobAccountId = accountId;                                                                                        // 49
  var bobIdentityId = identityId;                                                                                      // 50
                                                                                                                       //
  if (Meteor.users.find({                                                                                              // 52
    _id: bobAccountId,                                                                                                 // 53
    referredByComplete: { $exists: true }                                                                              // 54
  }).count() > 0) {                                                                                                    // 52
    return;                                                                                                            // 56
  }                                                                                                                    // 57
                                                                                                                       //
  // Only actually update Bob's Identity ID if there is no referredBy.                                                 //
  Meteor.users.update({ _id: bobIdentityId, referredBy: { $exists: false } }, { $set: { referredBy: aliceAccountId } });
};                                                                                                                     // 63
                                                                                                                       //
function referralProgramLogSharingTokenUse(db, bobAccountId) {                                                         // 65
  // Hooray! The sharing token is valid! Someone (let's call them Charlie) is going to get a UiView                    //
  // to this grain!  This means that the user who created this apiToken knows how to use the 'share                    //
  // access' interface. Let's call them Bob.                                                                           //
  //                                                                                                                   //
  // If Bob's Account.referredByComplete is not yet set, then look at Bob's Identities and take the                    //
  // first referredBy we find -- let's call that Alice.                                                                //
  //                                                                                                                   //
  // We copy Alice's account ID to Bob's Account.referredByComplete, and then update Alice's                           //
  // referredIdentityIds to point at Bob's Identity, and then remove the referredBy from Bob's                         //
  // Identity since it has become redundant.                                                                           //
  //                                                                                                                   //
  // Implementation note: this does mean that Alice can get referral credit for Bob by sharing a                       //
  // link with Bob, even if Bob already had an account.                                                                //
                                                                                                                       //
  // Bail out early if quota support is not enabled.                                                                   //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 81
    return;                                                                                                            // 82
  }                                                                                                                    // 83
                                                                                                                       //
  // Bail out if Bob has a referredByComplete.                                                                         //
  if (Meteor.users.find({ _id: bobAccountId, referredByComplete: { $exists: true } }).count() > 0) {                   // 86
    return;                                                                                                            // 87
  }                                                                                                                    // 88
                                                                                                                       //
  // Look for a referredBy on any of Bob's identities.                                                                 //
  var bobIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: bobAccountId }));                    // 91
  var bobIdentityWithReferredBy = Meteor.users.findOne({                                                               // 92
    _id: { $in: bobIdentityIds },                                                                                      // 93
    referredBy: { $exists: true }                                                                                      // 94
  });                                                                                                                  // 92
                                                                                                                       //
  if (!bobIdentityWithReferredBy) {                                                                                    // 97
    return;                                                                                                            // 98
  }                                                                                                                    // 99
                                                                                                                       //
  var aliceAccountId = bobIdentityWithReferredBy.referredBy;                                                           // 101
                                                                                                                       //
  // Store Bob's Account.referralCompletedBy.                                                                          //
  var now = new Date();                                                                                                // 104
  Meteor.users.update({                                                                                                // 105
    _id: bobAccountId,                                                                                                 // 106
    referredByComplete: { $exists: false }                                                                             // 107
  }, {                                                                                                                 // 105
    $set: {                                                                                                            // 109
      referredByComplete: bobIdentityWithReferredBy.referredBy,                                                        // 110
      referredCompleteDate: now                                                                                        // 111
    }                                                                                                                  // 109
  });                                                                                                                  // 108
                                                                                                                       //
  // Update Alice's Account.referredIdentityIds.                                                                       //
  Meteor.users.update({ _id: aliceAccountId }, {                                                                       // 116
    $push: { referredIdentityIds: bobIdentityWithReferredBy._id }                                                      // 117
  });                                                                                                                  // 116
                                                                                                                       //
  // Remove now-redundant Bob identity referredBy.                                                                     //
  Meteor.users.update({ _id: bobIdentityWithReferredBy._id }, {                                                        // 121
    $unset: { referredBy: true }                                                                                       // 122
  });                                                                                                                  // 121
}                                                                                                                      // 124
                                                                                                                       //
var HeaderWhitelist = function () {                                                                                    //
  function HeaderWhitelist(list) {                                                                                     // 127
    var _this2 = this;                                                                                                 // 127
                                                                                                                       //
    _classCallCheck(this, HeaderWhitelist);                                                                            // 127
                                                                                                                       //
    this._headers = {};                                                                                                // 128
    this._prefixes = [];                                                                                               // 129
                                                                                                                       //
    list.forEach(function (pattern) {                                                                                  // 131
      if (pattern.endsWith("*")) {                                                                                     // 132
        _this2._prefixes.push(pattern.slice(0, -1));                                                                   // 133
      } else {                                                                                                         // 134
        _this2._headers[pattern] = true;                                                                               // 135
      }                                                                                                                // 136
    });                                                                                                                // 137
  }                                                                                                                    // 138
                                                                                                                       //
  HeaderWhitelist.prototype.matches = function matches(header) {                                                       //
    header = header.toLowerCase();                                                                                     // 141
    if (this._headers[header]) return true;                                                                            // 142
                                                                                                                       //
    for (var i in this._prefixes) {                                                                                    // 144
      if (header.startsWith(this._prefixes[i])) {                                                                      // 145
        return true;                                                                                                   // 146
      }                                                                                                                // 147
    };                                                                                                                 // 148
                                                                                                                       //
    return false;                                                                                                      // 150
  };                                                                                                                   // 151
                                                                                                                       //
  return HeaderWhitelist;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
var REQUEST_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Context.headerWhitelist);                                // 154
var RESPONSE_HEADER_WHITELIST = new HeaderWhitelist(WebSession.Response.headerWhitelist);                              // 155
                                                                                                                       //
// User-agent strings that should be allowed to use http basic authentication.                                         //
// These are regex matches, so ensure they are escaped properly with double                                            //
// backslashes. For security reasons, we MUST NOT whitelist any user-agents                                            //
// that may render html and execute embedded scripts.                                                                  //
BASIC_AUTH_USER_AGENTS = ["git\\/", "GitHub-Hookshot\\/", "mirall\\/", "Mozilla\\/5\\.0 \\([^\\\\]*\\) mirall\\/", "Mozilla\\/5\\.0 \\(iOS\\) ownCloud-iOS\\/", "Mozilla\\/5\\.0 \\(Android\\) ownCloud-android\\/", "litmus\\/"];
BASIC_AUTH_USER_AGENTS_REGEX = new RegExp("^(" + BASIC_AUTH_USER_AGENTS.join("|") + ")", "");                          // 170
                                                                                                                       //
var SESSION_PROXY_TIMEOUT = 60000;                                                                                     // 172
                                                                                                                       //
var sandstormCoreFactory = makeSandstormCoreFactory();                                                                 // 174
var backendAddress = "unix:" + (SANDSTORM_ALTHOME || "") + Backend.socketPath;                                         // 175
var sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 176
var sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 177
                                                                                                                       //
// TODO(cleanup): This initilization belongs with the rest of our package initialization in                            //
//   db-deprecated.js. We can't put it there now because we need to contruct sandstormCoreFactory first.               //
globalBackend = new SandstormBackend(globalDb, sandstormBackend);                                                      // 181
Meteor.onConnection(function (connection) {                                                                            // 182
  connection.sandstormBackend = globalBackend;                                                                         // 183
});                                                                                                                    // 184
                                                                                                                       //
// We've observed a problem in production where occasionally the front-end stops talking to the                        //
// back-end. It happens very rarely -- like once a month -- and we've been unable to reproduce it                      //
// in testing, making it very hard to debug. The problem appears both on Sandstorm and Blackrock.                      //
// Restarting the node process (and only the node process) always fixes the problem.                                   //
//                                                                                                                     //
// Here, I've added some code that attempts to detect the problem by doing a health check                              //
// periodically and then remaking the connection if it seems broken. We'll see if this helps!                          //
var backendHealthy = true;                                                                                             // 193
var disconnectCount = 0;                                                                                               // 194
Meteor.setInterval(function () {                                                                                       // 195
  if (!backendHealthy) {                                                                                               // 196
    if (disconnectCount++ > 2) process.abort();                                                                        // 197
    console.error("error: Backend hasn't responded in 30 seconds! Reconnecting.");                                     // 198
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(true);                                        // 199
    sandstormBackendConnection.close();                                                                                // 200
    sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 201
    sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 202
    globalBackend._backendCap = sandstormBackend;                                                                      // 203
  }                                                                                                                    // 204
                                                                                                                       //
  var debugLog = !backendHealthy;                                                                                      // 206
  backendHealthy = false;                                                                                              // 207
  var promise = sandstormBackend.ping().then(function () {                                                             // 208
    backendHealthy = true;                                                                                             // 209
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(false);                                       // 210
  }, function (err) {                                                                                                  // 211
    console.error("error: Backend ping threw error!", err.stack);                                                      // 212
    // The connection will be remade on the next interval. Note that we do NOT normally observe                        //
    // exceptions being thrown for this problem; we see the connection simply stop responding.                         //
    // So we don't expect this branch to execute in any case.                                                          //
  });                                                                                                                  // 216
                                                                                                                       //
  if (debugLog) {                                                                                                      // 218
    console.log("capnp.js: outer promise:", promise);                                                                  // 219
  }                                                                                                                    // 220
}, 30000);                                                                                                             // 221
                                                                                                                       //
// =======================================================================================                             //
// Meteor context <-> Async Node.js context adapters                                                                   //
// TODO(cleanup):  Move to a different file.                                                                           //
                                                                                                                       //
var inMeteorInternal = Meteor.bindEnvironment(function (callback) {                                                    // 227
  callback();                                                                                                          // 228
});                                                                                                                    // 229
                                                                                                                       //
inMeteor = function inMeteor(callback) {                                                                               // 231
  // Calls the callback in a Meteor context.  Returns a Promise for its result.                                        //
  return new Promise(function (resolve, reject) {                                                                      // 233
    inMeteorInternal(function () {                                                                                     // 234
      try {                                                                                                            // 235
        resolve(callback());                                                                                           // 236
      } catch (err) {                                                                                                  // 237
        reject(err);                                                                                                   // 238
      }                                                                                                                // 239
    });                                                                                                                // 240
  });                                                                                                                  // 241
};                                                                                                                     // 242
                                                                                                                       //
promiseToFuture = function promiseToFuture(promise) {                                                                  // 244
  var result = new Future();                                                                                           // 245
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                           // 246
  return result;                                                                                                       // 247
};                                                                                                                     // 248
                                                                                                                       //
waitPromise = function waitPromise(promise) {                                                                          // 250
  return promiseToFuture(promise).wait();                                                                              // 251
};                                                                                                                     // 252
                                                                                                                       //
// =======================================================================================                             //
// API for creating / starting grains from Meteor methods.                                                             //
                                                                                                                       //
var proxiesByHostId = {};                                                                                              // 257
                                                                                                                       //
Meteor.methods({                                                                                                       // 259
  newGrain: function newGrain(packageId, command, title, identityId) {                                                 // 260
    // Create and start a new grain.                                                                                   //
                                                                                                                       //
    check(packageId, String);                                                                                          // 263
    check(command, Object); // Manifest.Command from package.capnp.                                                    // 264
    check(title, String);                                                                                              // 265
    check(identityId, String);                                                                                         // 266
                                                                                                                       //
    if (!this.userId) {                                                                                                // 268
      throw new Meteor.Error(403, "Unauthorized", "Must be logged in to create grains.");                              // 269
    }                                                                                                                  // 270
                                                                                                                       //
    if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                          // 272
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 273
    }                                                                                                                  // 274
                                                                                                                       //
    if (!isSignedUpOrDemo()) {                                                                                         // 276
      throw new Meteor.Error(403, "Unauthorized", "Only invited users or demo users can create grains.");              // 277
    }                                                                                                                  // 279
                                                                                                                       //
    if (isUserOverQuota(Meteor.user())) {                                                                              // 281
      throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");           // 282
    }                                                                                                                  // 284
                                                                                                                       //
    var pkg = Packages.findOne(packageId);                                                                             // 286
    var isDev = false;                                                                                                 // 287
    if (!pkg) {                                                                                                        // 288
      // Maybe they wanted a dev package.  Check there too.                                                            //
      pkg = DevPackages.findOne(packageId);                                                                            // 290
      isDev = true;                                                                                                    // 291
    }                                                                                                                  // 292
                                                                                                                       //
    if (!pkg) {                                                                                                        // 294
      throw new Meteor.Error(404, "Not Found", "No such package is installed.");                                       // 295
    }                                                                                                                  // 296
                                                                                                                       //
    var appId = pkg.appId;                                                                                             // 298
    var manifest = pkg.manifest;                                                                                       // 299
    var grainId = Random.id(22); // 128 bits of entropy                                                                // 300
    Grains.insert({                                                                                                    // 301
      _id: grainId,                                                                                                    // 302
      packageId: packageId,                                                                                            // 303
      appId: appId,                                                                                                    // 304
      appVersion: manifest.appVersion,                                                                                 // 305
      userId: this.userId,                                                                                             // 306
      identityId: identityId,                                                                                          // 307
      title: title,                                                                                                    // 308
      "private": true                                                                                                  // 309
    });                                                                                                                // 301
                                                                                                                       //
    globalBackend.startGrainInternal(packageId, grainId, this.userId, command, true, isDev);                           // 312
    globalBackend.updateLastActive(grainId, this.userId, identityId);                                                  // 313
    return grainId;                                                                                                    // 314
  },                                                                                                                   // 315
  openSession: function openSession(grainId, identityId, cachedSalt) {                                                 // 317
    // Open a new UI session on an existing grain.  Starts the grain if it is not already                              //
    // running.                                                                                                        //
                                                                                                                       //
    check(grainId, String);                                                                                            // 321
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 322
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 323
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 325
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 326
    }                                                                                                                  // 327
                                                                                                                       //
    var grain = Grains.findOne({ _id: grainId });                                                                      // 329
    if (!grain) {                                                                                                      // 330
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + grainId);                                          // 331
    } else if (grain.trashed) {                                                                                        // 332
      throw new Meteor.Error("grain-is-in-trash", "Grain is in trash", "Grain ID: " + grainId);                        // 333
    }                                                                                                                  // 334
                                                                                                                       //
    var db = this.connection.sandstormDb;                                                                              // 336
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 337
    if (!SandstormPermissions.mayOpenGrain(db, { grain: { _id: grainId, identityId: identityId } })) {                 // 338
      throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                       // 340
    }                                                                                                                  // 341
                                                                                                                       //
    var opened = globalBackend.openSessionInternal(grainId, this.userId, identityId, null, null, cachedSalt);          // 343
    var result = opened.methodResult;                                                                                  // 345
    var proxy = new Proxy(grainId, this.userId, result.sessionId, result.hostId, result.tabId, identityId, false, opened.supervisor);
    proxiesByHostId[result.hostId] = proxy;                                                                            // 348
    return result;                                                                                                     // 349
  },                                                                                                                   // 350
  openSessionFromApiToken: function openSessionFromApiToken(params, identityId, cachedSalt) {                          // 352
    // Given an API token, either opens a new WebSession to the underlying grain or returns a                          //
    // path to which the client should redirect in order to open such a session.                                       //
                                                                                                                       //
    check(params, {                                                                                                    // 356
      token: String,                                                                                                   // 357
      incognito: Boolean                                                                                               // 358
    });                                                                                                                // 356
    check(identityId, Match.OneOf(undefined, null, String));                                                           // 360
    check(cachedSalt, Match.OneOf(undefined, null, String));                                                           // 361
                                                                                                                       //
    if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                             // 363
      throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                            // 364
    }                                                                                                                  // 365
                                                                                                                       //
    if (!identityId && globalDb.getOrganizationDisallowGuests()) {                                                     // 367
      throw new Meteor.Error("guestDisallowed", "This Sandstorm server does not allow " + "guests or anonymous users");
    }                                                                                                                  // 370
                                                                                                                       //
    var token = params.token;                                                                                          // 372
    var incognito = params.incognito;                                                                                  // 373
    var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                      // 374
    var apiToken = ApiTokens.findOne(hashedToken);                                                                     // 375
    validateWebkey(apiToken);                                                                                          // 376
    var grain = Grains.findOne({ _id: apiToken.grainId });                                                             // 377
    if (!grain) {                                                                                                      // 378
      throw new Meteor.Error(404, "Grain not found", "Grain ID: " + apiToken.grainId);                                 // 379
    }                                                                                                                  // 380
                                                                                                                       //
    if (apiToken.accountId) {                                                                                          // 382
      referralProgramLogSharingTokenUse(globalDb, apiToken.accountId);                                                 // 383
    }                                                                                                                  // 384
                                                                                                                       //
    var title = void 0;                                                                                                // 386
    if (grain.userId === apiToken.accountId) {                                                                         // 387
      title = grain.title;                                                                                             // 388
    } else {                                                                                                           // 389
      var sharerToken = apiToken.identityId && ApiTokens.findOne({                                                     // 390
        grainId: apiToken.grainId,                                                                                     // 392
        "owner.user.identityId": apiToken.identityId                                                                   // 393
      }, {                                                                                                             // 391
        sort: {                                                                                                        // 395
          lastUsed: -1                                                                                                 // 396
        }                                                                                                              // 395
      });                                                                                                              // 394
      if (sharerToken) {                                                                                               // 399
        title = sharerToken.owner.user.title;                                                                          // 400
      } else {                                                                                                         // 401
        title = "shared grain";                                                                                        // 402
      }                                                                                                                // 403
    }                                                                                                                  // 404
                                                                                                                       //
    if (this.userId && !incognito) {                                                                                   // 406
      if (identityId != apiToken.identityId && identityId != grain.identityId && !ApiTokens.findOne({ "owner.user.identityId": identityId, parentToken: hashedToken })) {
        var owner = { user: { identityId: identityId, title: title } };                                                // 409
                                                                                                                       //
        // Create a new API token for the identity redeeming this token.                                               //
        var result = SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: token }, apiToken.grainId, apiToken.petname || "redeemed webkey", { allAccess: null }, owner);
        globalDb.addContact(apiToken.accountId, identityId);                                                           // 416
                                                                                                                       //
        // If the parent API token is forSharing and it has an accountId, then the logged-in user (call                //
        // them Bob) is about to access a grain owned by someone (call them Alice) and save a reference                //
        // to it as a new ApiToken. (For share-by-link, this occurs when viewing the grain. For                        //
        // share-by-identity, this happens immediately.)                                                               //
        if (result.parentApiToken) {                                                                                   // 422
          var parentApiToken = result.parentApiToken;                                                                  // 423
          if (parentApiToken.forSharing && parentApiToken.accountId) {                                                 // 424
            storeReferralProgramInfoApiTokenCreated(globalDb, this.userId, owner.user.identityId, parentApiToken.accountId);
          }                                                                                                            // 427
        }                                                                                                              // 428
      }                                                                                                                // 429
                                                                                                                       //
      return { redirectToGrain: apiToken.grainId };                                                                    // 431
    } else {                                                                                                           // 432
      if (!SandstormPermissions.mayOpenGrain(globalDb, { token: apiToken })) {                                         // 433
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 434
      }                                                                                                                // 436
                                                                                                                       //
      var opened = globalBackend.openSessionInternal(apiToken.grainId, null, null, title, apiToken, cachedSalt);       // 438
                                                                                                                       //
      var _result = opened.methodResult;                                                                               // 441
      var proxy = new Proxy(apiToken.grainId, grain.userId, _result.sessionId, _result.hostId, _result.tabId, identityId, false, opened.supervisor);
      proxy.apiToken = apiToken;                                                                                       // 445
      proxiesByHostId[_result.hostId] = proxy;                                                                         // 446
      return _result;                                                                                                  // 447
    }                                                                                                                  // 448
  },                                                                                                                   // 449
  keepSessionAlive: function keepSessionAlive(sessionId) {                                                             // 451
    // TODO(security):  Prevent draining someone else's quota by holding open several grains shared                    //
    //   by them.                                                                                                      //
    check(sessionId, String);                                                                                          // 454
                                                                                                                       //
    var session = Sessions.findAndModify({                                                                             // 456
      query: { _id: sessionId },                                                                                       // 457
      update: { $set: { timestamp: new Date().getTime() } },                                                           // 458
      fields: { grainId: 1, identityId: 1, hostId: 1 }                                                                 // 459
    });                                                                                                                // 456
                                                                                                                       //
    if (session) {                                                                                                     // 462
      // Session still present in database, so send keep-alive to backend.                                             //
      try {                                                                                                            // 464
        var grainId = session.grainId;                                                                                 // 465
        var hostId = session.hostId;                                                                                   // 466
        var supervisor = proxiesByHostId[hostId] && proxiesByHostId[hostId].supervisor;                                // 467
        if (!supervisor) {                                                                                             // 468
          supervisor = globalBackend.continueGrain(grainId).supervisor;                                                // 469
        }                                                                                                              // 470
                                                                                                                       //
        waitPromise(supervisor.keepAlive());                                                                           // 472
        globalBackend.updateLastActive(grainId, this.userId, session.identityId);                                      // 473
      } catch (err) {                                                                                                  // 474
        // Ignore disconnects, which imply that the grain shut down already. It'll start back up on                    //
        // the next request, so whatever.                                                                              //
        if (err.kjType !== "disconnected") {                                                                           // 477
          throw err;                                                                                                   // 478
        }                                                                                                              // 479
      }                                                                                                                // 480
                                                                                                                       //
      return true;                                                                                                     // 482
    } else {                                                                                                           // 483
      return false;                                                                                                    // 484
    }                                                                                                                  // 485
  },                                                                                                                   // 486
  shutdownGrain: function shutdownGrain(grainId) {                                                                     // 488
    check(grainId, String);                                                                                            // 489
    var grain = Grains.findOne(grainId);                                                                               // 490
    if (!grain || !this.userId || grain.userId !== this.userId) {                                                      // 491
      throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                              // 492
    }                                                                                                                  // 493
                                                                                                                       //
    waitPromise(globalBackend.shutdownGrain(grainId, grain.userId, true));                                             // 495
  }                                                                                                                    // 496
});                                                                                                                    // 259
                                                                                                                       //
var validateWebkey = function validateWebkey(apiToken, refreshedExpiration) {                                          // 499
  // Validates that `apiToken` is a valid UiView webkey, throwing an exception if it is not. If                        //
  // `refreshedExpiration` is set and if the token has an `expiresIfUnused` field, then the                            //
  // `expiresIfUnused` field is reset to `refreshedExpiration`.                                                        //
                                                                                                                       //
  if (!apiToken) {                                                                                                     // 504
    throw new Meteor.Error(403, "Invalid authorization token");                                                        // 505
  }                                                                                                                    // 506
                                                                                                                       //
  if (apiToken.revoked) {                                                                                              // 508
    throw new Meteor.Error(403, "Authorization token has been revoked");                                               // 509
  }                                                                                                                    // 510
                                                                                                                       //
  if (apiToken.owner && !("webkey" in apiToken.owner)) {                                                               // 512
    throw new Meteor.Error(403, "Unauthorized to open non-webkey token.");                                             // 513
  }                                                                                                                    // 514
                                                                                                                       //
  if (apiToken.expires && apiToken.expires.getTime() <= Date.now()) {                                                  // 516
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 517
  }                                                                                                                    // 518
                                                                                                                       //
  if (apiToken.expiresIfUnused) {                                                                                      // 520
    if (apiToken.expiresIfUnused.getTime() <= Date.now()) {                                                            // 521
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 522
    } else if (refreshedExpiration) {                                                                                  // 523
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: refreshedExpiration } });                              // 524
    } else {                                                                                                           // 525
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: null } });                                             // 527
    }                                                                                                                  // 528
  }                                                                                                                    // 529
                                                                                                                       //
  if (apiToken.objectId || apiToken.frontendRef) {                                                                     // 531
    throw new Meteor.Error(403, "ApiToken refers to a non-webview Capability.");                                       // 532
  }                                                                                                                    // 533
};                                                                                                                     // 534
                                                                                                                       //
// Used by shared/grain.js (which sounds like a broken dependency, since this code is only available                   //
// on the server)                                                                                                      //
getGrainSize = function getGrainSize(supervisor, oldSize) {                                                            // 538
  var promise = void 0;                                                                                                // 539
  if (oldSize === undefined) {                                                                                         // 540
    promise = supervisor.getGrainSize();                                                                               // 541
  } else {                                                                                                             // 542
    promise = supervisor.getGrainSizeWhenDifferent(oldSize);                                                           // 543
  }                                                                                                                    // 544
                                                                                                                       //
  var promise2 = promise.then(function (result) {                                                                      // 546
    return parseInt(result.size);                                                                                      // 546
  });                                                                                                                  // 546
  promise2.cancel = function () {                                                                                      // 547
    promise.cancel();                                                                                                  // 547
  };                                                                                                                   // 547
                                                                                                                       //
  return promise2;                                                                                                     // 549
};                                                                                                                     // 550
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 552
  var shutdownApp = function shutdownApp(appId) {                                                                      // 553
    Grains.find({ appId: appId }).forEach(function (grain) {                                                           // 554
      waitPromise(globalBackend.shutdownGrain(grain._id, grain.userId));                                               // 555
    });                                                                                                                // 556
  };                                                                                                                   // 557
                                                                                                                       //
  DevPackages.find().observe({                                                                                         // 559
    removed: function removed(devPackage) {                                                                            // 560
      shutdownApp(devPackage.appId);                                                                                   // 560
    },                                                                                                                 // 560
    changed: function changed(newDevPackage, oldDevPackage) {                                                          // 562
      shutdownApp(oldDevPackage.appId);                                                                                // 563
      if (oldDevPackage.appId !== newDevPackage.appId) {                                                               // 564
        shutdownApp(newDevPackage.appId);                                                                              // 565
      }                                                                                                                // 566
    },                                                                                                                 // 567
    added: function added(devPackage) {                                                                                // 569
      shutdownApp(devPackage.appId);                                                                                   // 569
    }                                                                                                                  // 569
  });                                                                                                                  // 559
                                                                                                                       //
  Sessions.find().observe({                                                                                            // 572
    removed: function removed(session) {                                                                               // 573
      var proxy = proxiesByHostId[session.hostId];                                                                     // 574
      delete proxiesByHostId[session.hostId];                                                                          // 575
      if (proxy) {                                                                                                     // 576
        proxy.close();                                                                                                 // 577
      }                                                                                                                // 578
    }                                                                                                                  // 579
  });                                                                                                                  // 572
});                                                                                                                    // 581
                                                                                                                       //
// Kill off sessions idle for >~3 minutes.                                                                             //
var TIMEOUT_MS = 180000;                                                                                               // 584
var gcSessions = function gcSessions() {                                                                               // 585
  var now = new Date().getTime();                                                                                      // 586
  Sessions.remove({ timestamp: { $lt: now - TIMEOUT_MS } });                                                           // 587
};                                                                                                                     // 588
                                                                                                                       //
SandstormDb.periodicCleanup(TIMEOUT_MS, gcSessions);                                                                   // 590
                                                                                                                       //
var getProxyForHostId = function getProxyForHostId(hostId, isAlreadyOpened) {                                          // 592
  // Get the Proxy corresponding to the given grain session host, possibly (re)creating it if it                       //
  // doesn't already exist. The first request on the session host will always create a new proxy.                      //
  // Later requests may create a proxy if they go to a different front-end replica or if the                           //
  // front-end was restarted.                                                                                          //
  check(hostId, String);                                                                                               // 597
                                                                                                                       //
  return Promise.resolve(undefined).then(function () {                                                                 // 599
    var proxy = proxiesByHostId[hostId];                                                                               // 600
    if (proxy) {                                                                                                       // 601
      return proxy;                                                                                                    // 602
    } else {                                                                                                           // 603
      // Set table entry to null for now so that we can detect if it is concurrently deleted.                          //
      proxiesByHostId[hostId] = null;                                                                                  // 605
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 607
        var session = Sessions.findOne({ hostId: hostId });                                                            // 608
        if (!session) {                                                                                                // 609
          if (isAlreadyOpened) {                                                                                       // 610
            var _ret = function () {                                                                                   // 610
              var observer = void 0;                                                                                   // 611
              return {                                                                                                 // 612
                v: new Promise(function (resolve, reject) {                                                            // 612
                  var task = Meteor.setTimeout(function () {                                                           // 613
                    reject(new Meteor.Error(504, "Requested session that no longer exists, and " + "timed out waiting for client to restore it. This can happen if you have " + "opened an app's content in a new window and then closed it in the " + "UI. If you see this error *inside* the Sandstorm UI, please report a " + "bug and describe the circumstances of the error."));
                  }, SESSION_PROXY_TIMEOUT);                                                                           // 619
                  observer = Sessions.find({ hostId: hostId }).observe({                                               // 620
                    added: function added() {                                                                          // 621
                      Meteor.clearTimeout(task);                                                                       // 622
                      resolve(getProxyForHostId(hostId, false));                                                       // 623
                    }                                                                                                  // 624
                  });                                                                                                  // 620
                }).then(function (v) {                                                                                 // 626
                  observer.stop();                                                                                     // 627
                  return v;                                                                                            // 628
                }, function (e) {                                                                                      // 629
                  observer.stop();                                                                                     // 630
                  throw e;                                                                                             // 631
                })                                                                                                     // 632
              };                                                                                                       // 612
            }();                                                                                                       // 610
                                                                                                                       //
            if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;               // 610
          } else {                                                                                                     // 633
            // Does not appear to be a valid session host.                                                             //
            return undefined;                                                                                          // 635
          }                                                                                                            // 636
        }                                                                                                              // 637
                                                                                                                       //
        var apiToken = void 0;                                                                                         // 639
        if (session.hashedToken) {                                                                                     // 640
          apiToken = ApiTokens.findOne({ _id: session.hashedToken });                                                  // 641
          // We don't have to fully validate the API token here because if it changed the session                      //
          // would have been deleted.                                                                                  //
          if (!apiToken) {                                                                                             // 644
            throw new Meteor.Error(410, "ApiToken has been deleted");                                                  // 645
          }                                                                                                            // 646
        }                                                                                                              // 647
                                                                                                                       //
        var grain = Grains.findOne(session.grainId);                                                                   // 649
        if (!grain) {                                                                                                  // 650
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 652
        }                                                                                                              // 653
                                                                                                                       //
        // Note that we don't need to call mayOpenGrain() because the existence of a session                           //
        // implies this check was already performed.                                                                   //
                                                                                                                       //
        var proxy = new Proxy(grain._id, grain.userId, session._id, hostId, session.tabId, session.identityId, false);
        if (apiToken) proxy.apiToken = apiToken;                                                                       // 660
                                                                                                                       //
        // Only add the proxy to the table if it was not concurrently deleted (which could happen                      //
        // e.g. if the user's access was revoked).                                                                     //
        if (hostId in proxiesByHostId) {                                                                               // 664
          proxiesByHostId[hostId] = proxy;                                                                             // 665
        } else {                                                                                                       // 666
          throw new Meteor.Error(403, "Session was concurrently closed.");                                             // 667
        }                                                                                                              // 668
                                                                                                                       //
        return proxy;                                                                                                  // 670
      });                                                                                                              // 671
    }                                                                                                                  // 672
  });                                                                                                                  // 673
};                                                                                                                     // 674
                                                                                                                       //
// =======================================================================================                             //
// API tokens                                                                                                          //
                                                                                                                       //
var ApiSessionProxies = function () {                                                                                  //
  // Class that caches proxies for requests that come in through HTTP API endpoints. Such                              //
  // requests are not associated with any entry in the `Sessions` collection, so we need                               //
  // some other means of detecting unused proxies and closing them. This class works by keeping                        //
  // the proxies in two buckets. When a proxy is used, it is put in the new bucket. Periodically,                      //
  // the old bucket is emptied and the contents of new bucket are moved to the old bucket.                             //
  //                                                                                                                   //
  // Each bucket is a two-level map, keyed by hashes of the tokens and their `ApiSession.Params`                       //
  // structs.                                                                                                          //
                                                                                                                       //
  function ApiSessionProxies(intervalMillis) {                                                                         // 689
    var _this3 = this;                                                                                                 // 689
                                                                                                                       //
    _classCallCheck(this, ApiSessionProxies);                                                                          // 689
                                                                                                                       //
    check(intervalMillis, Number);                                                                                     // 690
    this.newBucket = {};                                                                                               // 691
    this.oldBucket = {};                                                                                               // 692
    this.interval = Meteor.setInterval(function () {                                                                   // 693
      for (var oldHashedToken in _this3.oldBucket) {                                                                   // 694
        for (var oldHashedParams in _this3.oldBucket[oldHashedToken]) {                                                // 695
          var newProxy = _this3.newBucket[oldHashedToken] && _this3.newBucket[oldHashedToken][oldHashedParams];        // 696
          var oldProxy = _this3.oldBucket[oldHashedToken][oldHashedParams];                                            // 698
          if (oldProxy && !newProxy) {                                                                                 // 699
            if (Object.keys(oldProxy.websockets).length > 0) {                                                         // 700
              // A client has an open websocket. Keep the proxy around.                                                //
              _this3.put(oldHashedToken, oldHashedParams, oldProxy);                                                   // 702
            } else {                                                                                                   // 703
              // We can close this proxy and forget about it.                                                          //
              oldProxy.close();                                                                                        // 705
            }                                                                                                          // 706
          }                                                                                                            // 707
        }                                                                                                              // 708
      }                                                                                                                // 709
                                                                                                                       //
      _this3.oldBucket = _this3.newBucket;                                                                             // 711
      _this3.newBucket = {};                                                                                           // 712
    }, intervalMillis);                                                                                                // 713
  }                                                                                                                    // 714
                                                                                                                       //
  ApiSessionProxies.prototype.get = function get(hashedToken, hashedParams) {                                          //
    if (this.newBucket[hashedToken] && this.newBucket[hashedToken][hashedParams]) {                                    // 717
      return this.newBucket[hashedToken][hashedParams];                                                                // 718
    } else if (this.oldBucket[hashedToken] && this.oldBucket[hashedToken][hashedParams]) {                             // 719
      var proxy = this.oldBucket[hashedToken][hashedParams];                                                           // 720
      delete this.oldBucket[hashedToken][hashedParams];                                                                // 721
      this.put(hashedToken, hashedParams, proxy);                                                                      // 722
      return proxy;                                                                                                    // 723
    } else {                                                                                                           // 724
      return null;                                                                                                     // 725
    }                                                                                                                  // 726
  };                                                                                                                   // 727
                                                                                                                       //
  ApiSessionProxies.prototype.put = function put(hashedToken, hashedParams, proxy) {                                   //
    if (!this.newBucket[hashedToken]) {                                                                                // 730
      this.newBucket[hashedToken] = {};                                                                                // 731
    }                                                                                                                  // 732
                                                                                                                       //
    this.newBucket[hashedToken][hashedParams] = proxy;                                                                 // 734
  };                                                                                                                   // 735
                                                                                                                       //
  ApiSessionProxies.prototype.removeProxiesOfToken = function removeProxiesOfToken(hashedToken) {                      //
    if (hashedToken in this.oldBucket) {                                                                               // 738
      for (var hashedParams in this.oldBucket[hashedToken]) {                                                          // 739
        this.oldBucket[hashedToken][hashedParams].close();                                                             // 740
      }                                                                                                                // 741
                                                                                                                       //
      delete this.oldBucket[hashedToken];                                                                              // 743
    }                                                                                                                  // 744
                                                                                                                       //
    if (hashedToken in this.newBucket) {                                                                               // 746
      for (var _hashedParams in this.newBucket[hashedToken]) {                                                         // 747
        this.newBucket[hashedToken][_hashedParams].close();                                                            // 748
      }                                                                                                                // 749
                                                                                                                       //
      delete this.newBucket[hashedToken];                                                                              // 751
    }                                                                                                                  // 752
  };                                                                                                                   // 753
                                                                                                                       //
  return ApiSessionProxies;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var apiSessionProxies = new ApiSessionProxies(3 * 60 * 1000);                                                          // 756
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 758
  Grains.find().observe({                                                                                              // 759
    changed: function changed(newGrain, oldGrain) {                                                                    // 760
      if (oldGrain["private"] != newGrain["private"]) {                                                                // 761
        Sessions.remove({ grainId: oldGrain._id, identityId: { $ne: oldGrain.identityId } });                          // 762
        ApiTokens.find({ grainId: oldGrain._id }).forEach(function (apiToken) {                                        // 763
          apiSessionProxies.removeProxiesOfToken(apiToken._id);                                                        // 764
        });                                                                                                            // 765
      }                                                                                                                // 766
    }                                                                                                                  // 767
  });                                                                                                                  // 759
});                                                                                                                    // 769
                                                                                                                       //
function getApiSessionParams(request) {                                                                                // 771
  var params = {};                                                                                                     // 772
  if ("x-sandstorm-passthrough" in request.headers) {                                                                  // 773
    var optIns = request.headers["x-sandstorm-passthrough"].split(",").map(function (s) {                              // 774
      return s.trim();                                                                                                 // 776
    });                                                                                                                // 776
    // The only currently supported passthrough value is 'address', but others could be useful in                      //
    // the future.                                                                                                     //
                                                                                                                       //
    if (optIns.indexOf("address") !== -1) {                                                                            // 780
      // Sadly, we can't use request.socket.remoteFamily because it's not available in the                             //
      // (rather-old) version of node that comes in the Meteor bundle we're using. Hence this                          //
      // hackery.                                                                                                      //
      var addressToPass = request.socket.remoteAddress;                                                                // 784
      if (isRfc1918OrLocal(addressToPass) && "x-real-ip" in request.headers) {                                         // 785
        // Allow overriding the socket's remote address with X-Real-IP header if the request comes                     //
        // from either localhost or an RFC1918 address. These are not useful for geolocation anyway.                   //
        addressToPass = request.headers["x-real-ip"];                                                                  // 788
      }                                                                                                                // 789
                                                                                                                       //
      if (Net.isIPv4(addressToPass)) {                                                                                 // 791
        // Map IPv4 addresses in IPv6.                                                                                 //
        // This conveniently comes out to a 48-bit number, which is precisely representable in a                       //
        // double (which has 53 mantissa bits). Thus we can avoid using Bignum/strings, which we                       //
        // might otherwise need to precisely represent 64-bit fields.                                                  //
        var v4Int = 0xFFFF00000000 + addressToPass.split(".").map(function (x) {                                       // 796
          return parseInt(x, 10);                                                                                      // 797
        }).reduce(function (a, b) {                                                                                    // 797
          return 256 * a + b;                                                                                          // 798
        });                                                                                                            // 798
        params.remoteAddress = {                                                                                       // 799
          lower64: v4Int,                                                                                              // 800
          upper64: 0                                                                                                   // 801
        };                                                                                                             // 799
      } else if (Net.isIPv6(addressToPass)) {                                                                          // 803
        // TODO(test): Unit test this                                                                                  //
        // Parse a valid v6 address.                                                                                   //
        // Split into groups, then insert an appropriate number of 0's if :: was used.                                 //
        var groups = addressToPass.split(":");                                                                         // 807
                                                                                                                       //
        // Strip extra empty group in the case of a leading or trailing '::'.                                          //
        if (groups[0] === "") {                                                                                        // 810
          groups.shift();                                                                                              // 811
        }                                                                                                              // 812
                                                                                                                       //
        if (groups[groups.length - 1] === "") {                                                                        // 814
          groups.pop();                                                                                                // 815
        }                                                                                                              // 816
                                                                                                                       //
        var lastGroup = groups[groups.length - 1];                                                                     // 818
        // Handle IPv4-mapped IPv6 addresses.  These end in a dotted-quad IPv4 address, which we                       //
        // should expand into two groups of 4-character hex strings, like the rest of the address.                     //
        if (Net.isIPv4(lastGroup)) {                                                                                   // 821
          groups.pop();                                                                                                // 822
          var quad = lastGroup.split(".").map(function (x) {                                                           // 823
            return parseInt(x, 10);                                                                                    // 823
          });                                                                                                          // 823
          groups.push((quad[0] * 256 + quad[1]).toString(16));                                                         // 824
          groups.push((quad[2] * 256 + quad[3]).toString(16));                                                         // 825
        }                                                                                                              // 826
                                                                                                                       //
        var groupsToAdd = 8 - groups.length;                                                                           // 828
        var emptyGroupIndex = groups.indexOf("");                                                                      // 829
        var cleanGroups = void 0;                                                                                      // 830
        if (emptyGroupIndex !== -1) {                                                                                  // 831
          var head = groups.slice(0, emptyGroupIndex);                                                                 // 832
          // groupsToAdd + 1 because we sliced out the empty element                                                   //
          var mid = Array(groupsToAdd + 1);                                                                            // 834
          for (var i = 0; i < groupsToAdd + 1; i++) {                                                                  // 835
            mid[i] = "0";                                                                                              // 836
          }                                                                                                            // 837
                                                                                                                       //
          var tail = groups.slice(emptyGroupIndex + 1, groups.length);                                                 // 839
          cleanGroups = [].concat(head, mid, tail);                                                                    // 840
        } else {                                                                                                       // 841
          cleanGroups = groups;                                                                                        // 842
        }                                                                                                              // 843
                                                                                                                       //
        var ints = cleanGroups.map(function (x) {                                                                      // 845
          return parseInt(x, 16);                                                                                      // 845
        });                                                                                                            // 845
        // We use strings because we'd lose data from loss of precision casting the 64-bit uints                       //
        // into 53-bit-mantissa doubles.                                                                               //
        params.remoteAddress = {                                                                                       // 848
          upper64: quadToIntString(ints.slice(0, 4)),                                                                  // 849
          lower64: quadToIntString(ints.slice(4, 8))                                                                   // 850
        };                                                                                                             // 848
      }                                                                                                                // 852
    }                                                                                                                  // 853
  }                                                                                                                    // 854
                                                                                                                       //
  return Capnp.serialize(ApiSession.Params, params);                                                                   // 856
}                                                                                                                      // 857
                                                                                                                       //
// Used by server/drivers/external-ui/view.js                                                                          //
getProxyForApiToken = function getProxyForApiToken(token, request) {                                                   // 860
  check(token, String);                                                                                                // 861
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 862
  var tabId = Crypto.createHash("sha256").update("tab:").update(hashedToken).digest("hex").slice(0, 32);               // 863
  var serializedParams = getApiSessionParams(request);                                                                 // 865
  var hashedParams = Crypto.createHash("sha256").update(serializedParams).digest("base64");                            // 866
  return Promise.resolve(undefined).then(function () {                                                                 // 867
    var proxy = apiSessionProxies.get(hashedToken, hashedParams);                                                      // 868
    if (proxy) {                                                                                                       // 869
      if (proxy.expires && proxy.expires.getTime() <= Date.now()) {                                                    // 870
        throw new Meteor.Error(403, "Authorization token expired");                                                    // 871
      }                                                                                                                // 872
                                                                                                                       //
      return proxy;                                                                                                    // 874
    } else {                                                                                                           // 875
      return inMeteor(function () {                                                                                    // 876
        var tokenInfo = ApiTokens.findOne(hashedToken);                                                                // 877
        validateWebkey(tokenInfo);                                                                                     // 878
                                                                                                                       //
        var grain = Grains.findOne(tokenInfo.grainId);                                                                 // 880
        if (!grain) {                                                                                                  // 881
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 883
        }                                                                                                              // 884
                                                                                                                       //
        var proxy = void 0;                                                                                            // 886
        if (tokenInfo.userInfo) {                                                                                      // 887
          throw new Error("API tokens created with arbitrary userInfo no longer supported");                           // 888
        } else {                                                                                                       // 889
          var identityId = null;                                                                                       // 890
          if (tokenInfo.identityId && !tokenInfo.forSharing) {                                                         // 891
            identityId = tokenInfo.identityId;                                                                         // 892
          }                                                                                                            // 893
                                                                                                                       //
          proxy = new Proxy(tokenInfo.grainId, grain.userId, null, null, tabId, identityId, true);                     // 895
          proxy.apiToken = tokenInfo;                                                                                  // 896
          proxy.apiSessionParams = serializedParams;                                                                   // 897
        }                                                                                                              // 898
                                                                                                                       //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: tokenInfo })) {                                      // 900
          // Note that only public grains may be opened without a user ID.                                             //
          throw new Meteor.Error(403, "Unauthorized.");                                                                // 902
        }                                                                                                              // 903
                                                                                                                       //
        if (tokenInfo.expires) {                                                                                       // 905
          proxy.expires = tokenInfo.expires;                                                                           // 906
        }                                                                                                              // 907
                                                                                                                       //
        apiSessionProxies.put(hashedToken, hashedParams, proxy);                                                       // 909
                                                                                                                       //
        return proxy;                                                                                                  // 911
      });                                                                                                              // 912
    }                                                                                                                  // 913
  });                                                                                                                  // 914
};                                                                                                                     // 915
                                                                                                                       //
var apiUseBasicAuth = function apiUseBasicAuth(req, hostId) {                                                          // 917
  // If the request was to a token-specific host *and* the request has no Origin header (meaning                       //
  // it is not an XHR from a web site), then we permit the use of HTTP basic auth. The reason we                       //
  // prohibit XHRs is because we want to discourage people from using basic auth in a browser,                         //
  // because the browser will cache the credentials, which exposes the hostname to XSRF attack                         //
  // (which is mostly, but not completely, mitigated by the unguessable hostname). The reason we                       //
  // want to allow basic auth at all is because a lot of existing client apps support only basic                       //
  // auth. New clients and web-based clients should use `Authorization: bearer <token>` instead.                       //
  if (globalDb.isTokenSpecificHostId(hostId) && !req.headers.origin) {                                                 // 925
    return true;                                                                                                       // 926
  }                                                                                                                    // 927
                                                                                                                       //
  // Historically, all API tokens were served from the same host rather than have token-specific                       //
  // hosts. In this model, basic auth in browsers was far more dangerous since the hostname was                        //
  // not a secret -- in fact, even benign attempts to use two APIs on the same server from the same                    //
  // browser could interfere if using basic auth. Hence, basic auth was prohibited except when                         //
  // coming from certain whitelisted clients known not to be browsers, e.g. Mirall, the ownCloud                       //
  // client app.                                                                                                       //
  //                                                                                                                   //
  // Since many clients in the wild have already been configured to use the shared API host, we                        //
  // must continue to support them, so this logic remains.                                                             //
  var agent = req.headers["user-agent"];                                                                               // 938
  return agent.match(BASIC_AUTH_USER_AGENTS_REGEX);                                                                    // 939
};                                                                                                                     // 940
                                                                                                                       //
var apiTokenForRequest = function apiTokenForRequest(req, hostId) {                                                    // 942
  // Extract the API token from the request.                                                                           //
                                                                                                                       //
  var auth = req.headers.authorization;                                                                                // 945
  var token = void 0;                                                                                                  // 946
  if (auth && auth.slice(0, 7).toLowerCase() === "bearer ") {                                                          // 947
    token = auth.slice(7).trim();                                                                                      // 948
  } else if (auth && auth.slice(0, 6).toLowerCase() === "basic " && apiUseBasicAuth(req, hostId)) {                    // 949
    token = new Buffer(auth.slice(6).trim(), "base64").toString().split(":")[1];                                       // 951
  } else if (hostId !== "api" && req.url.startsWith("/.sandstorm-token/")) {                                           // 952
    // Disallow clients that use the old "api" hostId from using tokens in the path.                                   //
    // Allowing them would be a security problem in browsers that ignore CSP.                                          //
    var parts = req.url.slice(1).split("/"); // remove leading / and split                                             // 955
    if (parts.length < 2) {                                                                                            // 956
      token = undefined;                                                                                               // 957
    } else {                                                                                                           // 958
      token = parts[1];                                                                                                // 959
      req.url = "/" + parts.slice(2).join("/");                                                                        // 960
      // remove .sandstorm-api-token/$TOKEN from path                                                                  //
    }                                                                                                                  // 962
  } else {                                                                                                             // 963
      token = undefined;                                                                                               // 964
    }                                                                                                                  // 965
                                                                                                                       //
  if (token && hostId !== "api") {                                                                                     // 967
    // Verify that the token matches the specific host.                                                                //
    if (hostId !== globalDb.apiHostIdForToken(token)) {                                                                // 969
      token = undefined;                                                                                               // 970
    }                                                                                                                  // 971
  }                                                                                                                    // 972
                                                                                                                       //
  return token;                                                                                                        // 974
};                                                                                                                     // 975
                                                                                                                       //
// =======================================================================================                             //
// Routing to proxies.                                                                                                 //
//                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyUpgrade = function tryProxyUpgrade(hostId, req, socket, head) {                                                // 982
  // Attempt to handle a WebSocket upgrade by dispatching it to a grain. Returns a promise that                        //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  if (globalDb.isApiHostId(hostId)) {                                                                                  // 988
    var token = apiTokenForRequest(req, hostId);                                                                       // 989
    if (token) {                                                                                                       // 990
      return getProxyForApiToken(token, req).then(function (proxy) {                                                   // 991
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 994
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 996
        return true;                                                                                                   // 997
      });                                                                                                              // 998
    } else {                                                                                                           // 999
      return Promise.resolve(false);                                                                                   // 1000
    }                                                                                                                  // 1001
  } else {                                                                                                             // 1002
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1003
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1004
      if (proxy) {                                                                                                     // 1005
        // Cross-origin requests are not allowed on UI session hosts.                                                  //
        var origin = req.headers.origin;                                                                               // 1007
        if (origin !== PROTOCOL + "//" + req.headers.host) {                                                           // 1008
          throw new Meteor.Error(403, "Detected illegal cross-origin WebSocket from: " + origin);                      // 1009
        }                                                                                                              // 1010
                                                                                                                       //
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 1014
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 1016
        return true;                                                                                                   // 1017
      } else {                                                                                                         // 1018
        return false;                                                                                                  // 1019
      }                                                                                                                // 1020
    });                                                                                                                // 1021
  }                                                                                                                    // 1022
};                                                                                                                     // 1023
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyRequest = function tryProxyRequest(hostId, req, res) {                                                         // 1026
  // Attempt to handle an HTTP request by dispatching it to a grain. Returns a promise that                            //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  var hostIdHash = globalDb.isApiHostId(hostId);                                                                       // 1032
  if (hostIdHash) {                                                                                                    // 1033
    var _ret2 = function () {                                                                                          // 1033
      // This is a request for the API host.                                                                           //
                                                                                                                       //
      res.setHeader("Access-Control-Allow-Origin", "*");                                                               // 1036
                                                                                                                       //
      if (req.method === "OPTIONS") {                                                                                  // 1038
        // Reply to CORS preflight request.                                                                            //
                                                                                                                       //
        // All we want to do is permit APIs to be accessed from arbitrary origins. Since clients                       //
        // must send a valid Authorization header, and since cookies are not used for                                  //
        // authorization, this is perfectly safe. In a sane world, we would only need to send back                     //
        // 'Access-Control-Allow-Origin: *' and be done with it.                                                       //
        //                                                                                                             //
        // However, CORS demands that we explicitly whitelist individual methods and headers for                       //
        // use cross-origin, as if this is somehow useful for implementing any practical security                      //
        // policy (it isn't). To make matters worse, we are REQUIRED to enumerate each one                             //
        // individually. We cannot just write '*' for these lists. WTF, CORS?                                          //
        //                                                                                                             //
        // Luckily, the request tells us exactly what method and headers are being requested, so we                    //
        // only need to copy those over, rather than create an exhaustive list. But this is still                      //
        // overly complicated.                                                                                         //
                                                                                                                       //
        var accessControlHeaders = {                                                                                   // 1055
          "Access-Control-Allow-Methods": "GET, HEAD, POST, PUT, PATCH, DELETE",                                       // 1056
          "Access-Control-Max-Age": "3600"                                                                             // 1057
        };                                                                                                             // 1055
                                                                                                                       //
        // Copy all requested headers to the allowed headers list.                                                     //
        var requestedHeaders = req.headers["access-control-request-headers"];                                          // 1061
        if (requestedHeaders) {                                                                                        // 1062
          accessControlHeaders["Access-Control-Allow-Headers"] = requestedHeaders;                                     // 1063
        }                                                                                                              // 1064
                                                                                                                       //
        // Add the requested method to the allowed methods list, if it's not there already.                            //
        var requestedMethod = req.headers["access-control-request-method"];                                            // 1067
        if (requestedMethod && !_.contains(["GET", "HEAD", "POST", "PUT", "PATCH", "DELETE"], requestedMethod)) {      // 1068
          accessControlHeaders["Access-Control-Allow-Methods"] += ", " + requestedMethod;                              // 1070
        }                                                                                                              // 1071
                                                                                                                       //
        for (header in accessControlHeaders) {                                                                         // 1073
          res.setHeader(header, accessControlHeaders[header]);                                                         // 1074
        }                                                                                                              // 1075
      }                                                                                                                // 1076
                                                                                                                       //
      var errorHandler = function errorHandler(err) {                                                                  // 1078
        if (err instanceof Meteor.Error) {                                                                             // 1079
          console.log("error: " + err);                                                                                // 1080
          res.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                                      // 1081
        } else {                                                                                                       // 1082
          res.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                               // 1083
        }                                                                                                              // 1084
                                                                                                                       //
        res.end(err.stack);                                                                                            // 1086
      };                                                                                                               // 1087
                                                                                                                       //
      var token = apiTokenForRequest(req, hostId);                                                                     // 1089
      if (token && req.headers["x-sandstorm-token-keepalive"]) {                                                       // 1090
        inMeteor(function () {                                                                                         // 1091
          var keepaliveDuration = parseInt(req.headers["x-sandstorm-token-keepalive"]);                                // 1092
          check(keepaliveDuration, Match.Integer);                                                                     // 1093
          var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                // 1094
          validateWebkey(ApiTokens.findOne(hashedToken), new Date(Date.now() + keepaliveDuration));                    // 1095
        }).then(function () {                                                                                          // 1096
          res.writeHead(200, {});                                                                                      // 1097
          res.end();                                                                                                   // 1098
        }, errorHandler);                                                                                              // 1099
      } else if (token) {                                                                                              // 1100
        getProxyForApiToken(token, req).then(function (proxy) {                                                        // 1101
          proxy.requestHandler(req, res);                                                                              // 1102
        }, errorHandler);                                                                                              // 1103
      } else {                                                                                                         // 1104
        // No token. Look up static API host info.                                                                     //
        inMeteor(function () {                                                                                         // 1106
          var apiHost = globalDb.collections.apiHosts.findOne(hostIdHash);                                             // 1107
                                                                                                                       //
          if (req.method === "OPTIONS") {                                                                              // 1109
            // OPTIONS request with no authorization token.                                                            //
                                                                                                                       //
            var dav = ((apiHost || {}).options || {}).dav || [];                                                       // 1112
            if (dav.length > 0) {                                                                                      // 1113
              res.setHeader("DAV", dav.join(", "));                                                                    // 1114
              res.setHeader("Access-Control-Expose-Headers", "DAV");                                                   // 1115
            }                                                                                                          // 1116
                                                                                                                       //
            res.writeHead(200, {});                                                                                    // 1118
            res.end();                                                                                                 // 1119
          } else {                                                                                                     // 1120
            var resources = (apiHost || {}).resources || {};                                                           // 1121
            var path = SandstormDb.escapeMongoKey(req.url.split("?")[0]);                                              // 1122
            if (path in resources) {                                                                                   // 1123
              // Serve a static resource.                                                                              //
              var resource = resources[path];                                                                          // 1125
              console.log(path, resources, resource);                                                                  // 1126
              if (resource.language) res.setHeader("Content-Language", resource.language);                             // 1127
              if (resource.encoding) res.setHeader("Content-Encoding", resource.encoding);                             // 1128
              res.writeHead(200, {                                                                                     // 1129
                "Content-Type": resource.type                                                                          // 1130
              });                                                                                                      // 1129
              res.end(resource.body);                                                                                  // 1132
            } else {                                                                                                   // 1133
              if (apiUseBasicAuth(req, hostId)) {                                                                      // 1134
                res.writeHead(401, {                                                                                   // 1135
                  "Content-Type": "text/plain",                                                                        // 1136
                  "WWW-Authenticate": "Basic realm='Sandstorm API'"                                                    // 1137
                });                                                                                                    // 1135
              } else {                                                                                                 // 1139
                // TODO(someday): Display some sort of nifty API browser.                                              //
                res.writeHead(403, { "Content-Type": "text/plain" });                                                  // 1141
              }                                                                                                        // 1142
                                                                                                                       //
              res.end("Missing or invalid authorization header.\n\n" + "This address serves APIs, which allow external apps (such as a phone app) to\n" + "access data on your Sandstorm server. This address is not meant to be opened\n" + "in a regular browser.");
            }                                                                                                          // 1148
          }                                                                                                            // 1149
        }).then(function () {}, errorHandler);                                                                         // 1150
      }                                                                                                                // 1151
                                                                                                                       //
      return {                                                                                                         // 1153
        v: Promise.resolve(true)                                                                                       // 1153
      };                                                                                                               // 1153
    }();                                                                                                               // 1033
                                                                                                                       //
    if ((typeof _ret2 === "undefined" ? "undefined" : _typeof(_ret2)) === "object") return _ret2.v;                    // 1033
  } else {                                                                                                             // 1154
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1155
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1156
      if (proxy) {                                                                                                     // 1157
        proxy.requestHandler(req, res);                                                                                // 1158
        return true;                                                                                                   // 1159
      } else {                                                                                                         // 1160
        return false;                                                                                                  // 1161
      }                                                                                                                // 1162
    });                                                                                                                // 1163
  }                                                                                                                    // 1164
};                                                                                                                     // 1165
                                                                                                                       //
// =======================================================================================                             //
// Proxy class                                                                                                         //
//                                                                                                                     //
// Connects to a grain and exports it on a wildcard host.                                                              //
//                                                                                                                     //
                                                                                                                       //
var Proxy = function () {                                                                                              //
  function Proxy(grainId, ownerId, sessionId, hostId, tabId, identityId, isApi, supervisor) {                          // 1174
    var _this4 = this;                                                                                                 // 1174
                                                                                                                       //
    _classCallCheck(this, Proxy);                                                                                      // 1174
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 1175
    this.ownerId = ownerId;                                                                                            // 1176
    this.identityId = identityId;                                                                                      // 1177
    this.supervisor = supervisor; // note: optional parameter; we can reconnect                                        // 1178
    this.sessionId = sessionId;                                                                                        // 1179
    this.tabId = tabId;                                                                                                // 1180
    this.isApi = isApi;                                                                                                // 1181
    this.hasLoaded = false;                                                                                            // 1182
    this.websockets = {};                                                                                              // 1183
    this.websocketCounter = 0; // Used for generating unique socket IDs.                                               // 1184
    if (sessionId) {                                                                                                   // 1185
      if (!hostId) throw new Error("sessionId must come with hostId");                                                 // 1186
      if (isApi) throw new Error("API proxy shouldn't have sessionId");                                                // 1187
      this.hostId = hostId;                                                                                            // 1188
    } else {                                                                                                           // 1189
      if (!isApi) throw new Error("non-API proxy requires sessionId");                                                 // 1190
      if (hostId) throw new Error("API proxy sholudn't have hostId");                                                  // 1191
    }                                                                                                                  // 1192
                                                                                                                       //
    if (this.identityId) {                                                                                             // 1194
      var identity = globalDb.getIdentity(this.identityId);                                                            // 1195
      if (!identity) {                                                                                                 // 1196
        throw new Error("identity not found: " + this.identityId);                                                     // 1197
      }                                                                                                                // 1198
                                                                                                                       //
      // The identity cap becomes invalid if the user no longer has access to the grain.                               //
      var idCapRequirement = {                                                                                         // 1201
        permissionsHeld: { identityId: identity._id, grainId: this.grainId }                                           // 1202
      };                                                                                                               // 1201
                                                                                                                       //
      this.userInfo = {                                                                                                // 1205
        displayName: { defaultText: identity.profile.name },                                                           // 1206
        preferredHandle: identity.profile.handle,                                                                      // 1207
        identityId: new Buffer(identity._id, "hex"),                                                                   // 1208
        identity: makeIdentity(identity._id, [idCapRequirement])                                                       // 1209
      };                                                                                                               // 1205
      if (identity.profile.pictureUrl) {                                                                               // 1211
        this.userInfo.pictureUrl = identity.profile.pictureUrl;                                                        // 1212
      } else {                                                                                                         // 1213
        this.userInfo.pictureUrl = PROTOCOL + "//" + makeWildcardHost("static") + "/identicon/" + this.identityId.slice(0, 32) + "?s=128";
      }                                                                                                                // 1217
                                                                                                                       //
      if (identity.profile.pronoun) this.userInfo.pronouns = identity.profile.pronoun;                                 // 1219
    } else {                                                                                                           // 1220
      this.userInfo = {                                                                                                // 1221
        displayName: { defaultText: "Anonymous User" },                                                                // 1222
        preferredHandle: "anonymous"                                                                                   // 1223
      };                                                                                                               // 1221
    }                                                                                                                  // 1225
                                                                                                                       //
    this.requestHandler = function (request, response) {                                                               // 1227
      if (_this4.sessionId) {                                                                                          // 1228
        // Implement /_sandstorm-init for setting the session cookie.                                                  //
        var url = Url.parse(request.url, true);                                                                        // 1230
        if (url.pathname === "/_sandstorm-init" && url.query.sessionid === _this4.sessionId) {                         // 1231
          _this4.doSessionInit(request, response, url.query.path);                                                     // 1232
          return;                                                                                                      // 1233
        }                                                                                                              // 1234
      }                                                                                                                // 1235
                                                                                                                       //
      Promise.resolve(undefined).then(function () {                                                                    // 1237
        var contentLength = request.headers["content-length"];                                                         // 1238
        if ((request.method === "POST" || request.method === "PUT") && (contentLength === undefined || contentLength > 1024 * 1024)) {
          // The input is either very long, or we don't know how long it is, so use streaming mode.                    //
          return _this4.handleRequestStreaming(request, response, contentLength, 0);                                   // 1242
        } else {                                                                                                       // 1243
          return readAll(request).then(function (data) {                                                               // 1244
            return _this4.handleRequest(request, data, response, 0);                                                   // 1245
          });                                                                                                          // 1246
        }                                                                                                              // 1247
      })["catch"](function (err) {                                                                                     // 1248
        _this4.setHasLoaded();                                                                                         // 1249
                                                                                                                       //
        var body = err.stack;                                                                                          // 1251
        if (err.cppFile) {                                                                                             // 1252
          body += "\nC++ location:" + err.cppFile + ":" + (err.line || "??");                                          // 1253
        }                                                                                                              // 1254
                                                                                                                       //
        if (err.kjType) {                                                                                              // 1256
          body += "\ntype: " + err.kjType;                                                                             // 1257
        }                                                                                                              // 1258
                                                                                                                       //
        if (response.headersSent) {                                                                                    // 1260
          // Unfortunately, it's too late to tell the client what happened.                                            //
          console.error("HTTP request failed after response already sent:", body);                                     // 1262
          response.end();                                                                                              // 1263
        } else {                                                                                                       // 1264
          if (err instanceof Meteor.Error) {                                                                           // 1265
            response.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                               // 1266
          } else {                                                                                                     // 1267
            response.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                        // 1268
          }                                                                                                            // 1269
                                                                                                                       //
          response.end(body);                                                                                          // 1271
        }                                                                                                              // 1272
      });                                                                                                              // 1273
    };                                                                                                                 // 1274
                                                                                                                       //
    this.upgradeHandler = function (request, socket, head) {                                                           // 1276
      _this4.handleWebSocket(request, socket, head, 0)["catch"](function (err) {                                       // 1277
        console.error("WebSocket setup failed:", err.stack);                                                           // 1278
        // TODO(cleanup):  Manually send back a 500 response?                                                          //
        socket.destroy();                                                                                              // 1280
      });                                                                                                              // 1281
    };                                                                                                                 // 1282
  }                                                                                                                    // 1283
                                                                                                                       //
  Proxy.prototype.close = function close() {                                                                           //
    for (var socketIdx in this.websockets) {                                                                           // 1286
      this.websockets[socketIdx].destroy();                                                                            // 1287
    };                                                                                                                 // 1288
                                                                                                                       //
    this.websockets = {};                                                                                              // 1290
                                                                                                                       //
    if (this.session) {                                                                                                // 1292
      this.session.close();                                                                                            // 1293
      delete this.session;                                                                                             // 1294
    }                                                                                                                  // 1295
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1297
      this.uiView.close();                                                                                             // 1298
      delete this.uiView;                                                                                              // 1299
    }                                                                                                                  // 1300
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1302
      this.supervisor.close();                                                                                         // 1303
      delete this.supervisor;                                                                                          // 1304
    }                                                                                                                  // 1305
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1307
      this.permissionsObserver.stop();                                                                                 // 1308
      delete this.permissionsObserver;                                                                                 // 1309
    }                                                                                                                  // 1310
  };                                                                                                                   // 1311
                                                                                                                       //
  Proxy.prototype.getConnection = function getConnection() {                                                           //
    if (!this.supervisor) {                                                                                            // 1314
      this.supervisor = globalBackend.cap().getGrain(this.ownerId, this.grainId).supervisor;                           // 1315
      this.uiView = null;                                                                                              // 1316
    }                                                                                                                  // 1317
                                                                                                                       //
    if (!this.uiView) {                                                                                                // 1319
      this.uiView = this.supervisor.getMainView().view;                                                                // 1320
    }                                                                                                                  // 1321
  };                                                                                                                   // 1322
                                                                                                                       //
  Proxy.prototype._callNewWebSession = function _callNewWebSession(request, userInfo) {                                //
    var params = Capnp.serialize(WebSession.Params, {                                                                  // 1325
      basePath: PROTOCOL + "//" + request.headers.host,                                                                // 1326
      userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",                 // 1327
      acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
        return s.trim();                                                                                               // 1331
      }) : ["en-US", "en"]                                                                                             // 1331
    });                                                                                                                // 1325
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, new Buffer(this.tabId, "hex")).session;
  };                                                                                                                   // 1337
                                                                                                                       //
  Proxy.prototype._callNewApiSession = function _callNewApiSession(request, userInfo) {                                //
    var _this5 = this;                                                                                                 // 1339
                                                                                                                       //
    var serializedParams = this.apiSessionParams;                                                                      // 1340
    if (!serializedParams) {                                                                                           // 1341
      throw new Meteor.Error(500, "Should have already computed apiSessionParams.");                                   // 1342
    }                                                                                                                  // 1343
                                                                                                                       //
    // TODO(someday): We are currently falling back to WebSession if we get any kind of error upon                     //
    // calling newSession with an ApiSession._id.                                                                      //
    // Eventually we'll remove this logic once we're sure apps have updated.                                           //
    return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), ApiSession.typeId, serializedParams, new Buffer(this.tabId, "hex")).then(function (session) {
      return session.session;                                                                                          // 1352
    }, function (err) {                                                                                                // 1353
      return _this5._callNewWebSession(request, userInfo);                                                             // 1354
    });                                                                                                                // 1355
  };                                                                                                                   // 1356
                                                                                                                       //
  Proxy.prototype._callNewSession = function _callNewSession(request, viewInfo) {                                      //
    var _this6 = this;                                                                                                 // 1358
                                                                                                                       //
    var userInfo = _.clone(this.userInfo);                                                                             // 1359
    var promise = inMeteor(function () {                                                                               // 1360
      var vertex = void 0;                                                                                             // 1361
      if (_this6.apiToken) {                                                                                           // 1362
        vertex = { token: _this6.apiToken };                                                                           // 1363
      } else {                                                                                                         // 1364
        // (this.identityId might be null; this is fine)                                                               //
        vertex = { grain: { _id: _this6.grainId, identityId: _this6.identityId } };                                    // 1366
      }                                                                                                                // 1367
                                                                                                                       //
      var onInvalidated = function onInvalidated() {                                                                   // 1369
        Sessions.remove({ _id: _this6.sessionId });                                                                    // 1370
      };                                                                                                               // 1371
                                                                                                                       //
      if (!_this6.sessionId) {                                                                                         // 1373
        onInvalidated = function onInvalidated() {                                                                     // 1374
          apiSessionProxies.removeProxiesOfToken(_this6.apiToken._id);                                                 // 1375
        };                                                                                                             // 1376
      }                                                                                                                // 1377
                                                                                                                       //
      var permissions = SandstormPermissions.grainPermissions(globalDb, vertex, viewInfo, onInvalidated);              // 1379
                                                                                                                       //
      if (_this6.permissionsObserver) _this6.permissionsObserver.stop();                                               // 1382
      _this6.permissionsObserver = permissions.observeHandle;                                                          // 1383
                                                                                                                       //
      if (!permissions.permissions) {                                                                                  // 1385
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 1386
      }                                                                                                                // 1387
                                                                                                                       //
      Sessions.update({                                                                                                // 1389
        _id: _this6.sessionId                                                                                          // 1390
      }, {                                                                                                             // 1389
        $set: {                                                                                                        // 1392
          viewInfo: viewInfo,                                                                                          // 1393
          permissions: permissions.permissions                                                                         // 1394
        }                                                                                                              // 1392
      });                                                                                                              // 1391
                                                                                                                       //
      return permissions.permissions;                                                                                  // 1398
    });                                                                                                                // 1399
                                                                                                                       //
    return promise.then(function (permissions) {                                                                       // 1401
      userInfo.permissions = permissions;                                                                              // 1402
                                                                                                                       //
      var numBytes = Math.ceil(permissions.length / 8);                                                                // 1404
      var buf = new Buffer(numBytes);                                                                                  // 1405
      for (var ii = 0; ii < numBytes; ++ii) {                                                                          // 1406
        buf[ii] = 0;                                                                                                   // 1407
      }                                                                                                                // 1408
                                                                                                                       //
      for (var _ii = 0; _ii < permissions.length; ++_ii) {                                                             // 1410
        var byteNum = Math.floor(_ii / 8);                                                                             // 1411
        var bitNum = _ii % 8;                                                                                          // 1412
        if (permissions[_ii]) {                                                                                        // 1413
          buf[byteNum] = buf[byteNum] | 1 << bitNum;                                                                   // 1414
        }                                                                                                              // 1415
      }                                                                                                                // 1416
                                                                                                                       //
      userInfo.deprecatedPermissionsBlob = buf;                                                                        // 1418
                                                                                                                       //
      if (_this6.isApi) {                                                                                              // 1420
        return _this6._callNewApiSession(request, userInfo);                                                           // 1421
      } else {                                                                                                         // 1422
        return _this6._callNewWebSession(request, userInfo);                                                           // 1423
      }                                                                                                                // 1424
    });                                                                                                                // 1425
  };                                                                                                                   // 1426
                                                                                                                       //
  Proxy.prototype.getSession = function getSession(request) {                                                          //
    var _this7 = this;                                                                                                 // 1428
                                                                                                                       //
    if (!this.session) {                                                                                               // 1429
      this.getConnection(); // make sure we're connected                                                               // 1430
      var promise = this.uiView.getViewInfo().then(function (viewInfo) {                                               // 1431
        return inMeteor(function () {                                                                                  // 1432
          // For now, we don't allow grains to set `appTitle` or `grainIcon`.                                          //
          var cachedViewInfo = _.omit(viewInfo, "appTitle", "grainIcon");                                              // 1434
          Grains.update(_this7.grainId, { $set: { cachedViewInfo: cachedViewInfo } });                                 // 1435
        }).then(function () {                                                                                          // 1436
          return _this7._callNewSession(request, viewInfo);                                                            // 1437
        });                                                                                                            // 1438
      }, function (error) {                                                                                            // 1439
        if (error.kjType === "failed" || error.kjType === "unimplemented") {                                           // 1440
          // Method not implemented.                                                                                   //
          // TODO(apibump): Don't treat 'failed' as 'unimplemented'. Unfortunately, old apps built                     //
          //   with old versions of Cap'n Proto don't throw 'unimplemented' exceptions, so we have                     //
          //   to accept 'failed' here at least until the next API bump.                                               //
          return _this7._callNewSession(request, {});                                                                  // 1445
        } else {                                                                                                       // 1446
          return Promise.reject(error);                                                                                // 1447
        }                                                                                                              // 1448
      });                                                                                                              // 1449
      this.session = new Capnp.Capability(promise, WebSession);                                                        // 1450
    }                                                                                                                  // 1451
                                                                                                                       //
    return this.session;                                                                                               // 1453
  };                                                                                                                   // 1454
                                                                                                                       //
  Proxy.prototype.keepAlive = function keepAlive() {                                                                   //
    this.getConnection();                                                                                              // 1457
    return this.supervisor.keepAlive();                                                                                // 1458
  };                                                                                                                   // 1459
                                                                                                                       //
  Proxy.prototype.resetConnection = function resetConnection() {                                                       //
    if (this.session) {                                                                                                // 1462
      this.session.close();                                                                                            // 1463
      delete this.session;                                                                                             // 1464
    }                                                                                                                  // 1465
                                                                                                                       //
    if (this.uiView) {                                                                                                 // 1467
      this.uiView.close();                                                                                             // 1468
      delete this.uiView;                                                                                              // 1469
    }                                                                                                                  // 1470
                                                                                                                       //
    if (this.supervisor) {                                                                                             // 1472
      this.supervisor.close();                                                                                         // 1473
      delete this.supervisor;                                                                                          // 1474
    }                                                                                                                  // 1475
                                                                                                                       //
    if (this.permissionsObserver) {                                                                                    // 1477
      this.permissionsObserver.stop();                                                                                 // 1478
      delete this.permissionsObserver;                                                                                 // 1479
    }                                                                                                                  // 1480
  };                                                                                                                   // 1481
                                                                                                                       //
  Proxy.prototype.maybeRetryAfterError = function maybeRetryAfterError(error, retryCount) {                            //
    var _this8 = this;                                                                                                 // 1483
                                                                                                                       //
    // If the error may be caused by the grain dying or a network failure, try to restart it,                          //
    // returning a promise that resolves once restarted. Otherwise, just rethrow the error.                            //
    // `retryCount` should be incremented for every successful retry as part of the same request;                      //
    // we only want to retry once.                                                                                     //
    if (SandstormBackend.shouldRestartGrain(error, retryCount)) {                                                      // 1488
      this.resetConnection();                                                                                          // 1489
      return inMeteor(function () {                                                                                    // 1490
        _this8.supervisor = globalBackend.continueGrain(_this8.grainId).supervisor;                                    // 1491
      });                                                                                                              // 1492
    } else {                                                                                                           // 1493
      throw error;                                                                                                     // 1494
    }                                                                                                                  // 1495
  };                                                                                                                   // 1496
                                                                                                                       //
  Proxy.prototype.doSessionInit = function doSessionInit(request, response, requestPath) {                             //
    // jscs:disable disallowQuotedKeysInObjects                                                                        //
    var path = requestPath || "/";                                                                                     // 1500
                                                                                                                       //
    // Check that the path is relative (ie. starts with a /).                                                          //
    // Also ensure that it doesn't start with 2 /, because that is interpreted as non-relative                         //
    if (path.lastIndexOf("/", 0) !== 0 || path.lastIndexOf("//", 0) === 0) {                                           // 1504
      response.writeHead(400, "Invalid path supplied", { "Content-Type": "text/plain" });                              // 1505
      response.end("Invalid path supplied.");                                                                          // 1506
      return;                                                                                                          // 1507
    }                                                                                                                  // 1508
                                                                                                                       //
    // Set the session ID.                                                                                             //
    response.setHeader("Set-Cookie", ["sandstorm-sid=", this.sessionId, "; Max-Age=31536000; HttpOnly"].join(""));     // 1511
                                                                                                                       //
    response.setHeader("Cache-Control", "no-cache, private");                                                          // 1513
                                                                                                                       //
    // Redirect to the app's root URL.                                                                                 //
    // Note:  All browsers support relative locations and the next update to HTTP/1.1 will officially                  //
    //   make them valid.  http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-26#page-67                       //
    response.writeHead(303, "See Other", { "Location": encodeURI(path) });                                             // 1518
    response.end();                                                                                                    // 1519
  };                                                                                                                   // 1520
                                                                                                                       //
  Proxy.prototype.makeContext = function makeContext(request, response, callback) {                                    //
    // Parses the cookies from the request, checks that the session ID is present and valid, then                      //
    // synchronously calls callback() passing it the request context object which contains the                         //
    // other cookies. Throws an exception if the session ID is missing or invalid. The callback                        //
    // must immediately use the context in an RPC. Once the callback returns, the context object                       //
    // will be torn down.                                                                                              //
    //                                                                                                                 //
    // `makeContext()` returns the result of `callback()`.                                                             //
                                                                                                                       //
    var context = {};                                                                                                  // 1531
                                                                                                                       //
    if (this.hostId) {                                                                                                 // 1533
      var parseResult = parseCookies(request);                                                                         // 1534
      if (!parseResult.sessionId || parseResult.sessionId !== this.sessionId) {                                        // 1535
        throw new Meteor.Error(403, "Unauthorized");                                                                   // 1536
      }                                                                                                                // 1537
                                                                                                                       //
      if (parseResult.cookies.length > 0) {                                                                            // 1539
        context.cookies = parseResult.cookies;                                                                         // 1540
      }                                                                                                                // 1541
    } else {                                                                                                           // 1542
      // jscs:disable disallowEmptyBlocks                                                                              //
      // This is an API request. Cookies are not supported.                                                            //
    }                                                                                                                  // 1545
                                                                                                                       //
    context.accept = parseAcceptHeader(request);                                                                       // 1547
                                                                                                                       //
    context.eTagPrecondition = parsePreconditionHeader(request);                                                       // 1549
                                                                                                                       //
    context.additionalHeaders = [];                                                                                    // 1551
    for (var headerName in request.headers) {                                                                          // 1552
      if (REQUEST_HEADER_WHITELIST.matches(headerName)) {                                                              // 1553
        context.additionalHeaders.push({                                                                               // 1554
          name: headerName,                                                                                            // 1555
          value: request.headers[headerName]                                                                           // 1556
        });                                                                                                            // 1554
      }                                                                                                                // 1558
    }                                                                                                                  // 1559
                                                                                                                       //
    if (response) {                                                                                                    // 1561
      var promise = new Promise(function (resolve, reject) {                                                           // 1562
        response.resolveResponseStream = resolve;                                                                      // 1563
        response.rejectResponseStream = reject;                                                                        // 1564
      });                                                                                                              // 1565
                                                                                                                       //
      context.responseStream = new Capnp.Capability(promise, ByteStream);                                              // 1567
                                                                                                                       //
      try {                                                                                                            // 1569
        return callback(context);                                                                                      // 1570
      } finally {                                                                                                      // 1571
        context.responseStream.close();                                                                                // 1572
      }                                                                                                                // 1573
    } else {                                                                                                           // 1574
      // WebSocket -- no response object.                                                                              //
      return callback(context);                                                                                        // 1576
    }                                                                                                                  // 1577
  };                                                                                                                   // 1578
                                                                                                                       //
  Proxy.prototype.translateResponse = function translateResponse(rpcResponse, response, request) {                     //
    if (this.hostId) {                                                                                                 // 1581
      if (rpcResponse.setCookies && rpcResponse.setCookies.length > 0) {                                               // 1582
        response.setHeader("Set-Cookie", rpcResponse.setCookies.map(makeSetCookieHeader));                             // 1583
      }                                                                                                                // 1584
                                                                                                                       //
      // TODO(security): Add a Content-Security-Policy header which:                                                   //
      // (1) Prevents the app from initiating HTTP requests to third parties.                                          //
      // (2) Prevents the app from navigating the parent frame.                                                        //
      // (3) Prevents the app from opening popups.                                                                     //
      // (4) Prohibits anyone other than the Sandstorm shell from framing the app (as a backup                         //
      //   defense vs. clickjacking, though unguessable hostnames already mostly prevent this).                        //
    } else {                                                                                                           // 1592
        // This is an API request. Cookies are not supported.                                                          //
                                                                                                                       //
        // We need to make sure caches know that different bearer tokens get totally different results.                //
        response.setHeader("Vary", "Authorization");                                                                   // 1596
                                                                                                                       //
        // APIs can be called from any origin. Because we ignore cookies, there is no security problem.                //
        response.setHeader("Access-Control-Allow-Origin", "*");                                                        // 1599
                                                                                                                       //
        // Add a Content-Security-Policy as a backup in case someone finds a way to load this resource                 //
        // in a browser context. This policy should thoroughly neuter it.                                              //
        response.setHeader("Content-Security-Policy", "default-src 'none'; sandbox");                                  // 1603
      }                                                                                                                // 1604
                                                                                                                       //
    if (rpcResponse.additionalHeaders && rpcResponse.additionalHeaders.length > 0) {                                   // 1606
      // Add any additional prefixed/whitelisted headers to the response.                                              //
      // We cannot trust that the headers in the RPC response are actually                                             //
      // allowed, so we check if they are prefixed or whitelisted.                                                     //
      rpcResponse.additionalHeaders.forEach(function (header) {                                                        // 1610
        if (RESPONSE_HEADER_WHITELIST.matches(header.name)) {                                                          // 1611
          // If header is prefixed with appHeaderPrefix,                                                               //
          // or if the header name is in whitelist, set it.                                                            //
          response.setHeader(header.name, header.value);                                                               // 1614
        }                                                                                                              // 1615
      });                                                                                                              // 1616
    }                                                                                                                  // 1617
                                                                                                                       //
    // On first response, update the session to have hasLoaded=true                                                    //
    this.setHasLoaded();                                                                                               // 1620
                                                                                                                       //
    // TODO(security): Set X-Content-Type-Options: nosniff?                                                            //
                                                                                                                       //
    if ("content" in rpcResponse) {                                                                                    // 1624
      var content = rpcResponse.content;                                                                               // 1625
      var code = successCodes[content.statusCode];                                                                     // 1626
      if (!code) {                                                                                                     // 1627
        throw new Error("Unknown status code: ", content.statusCode);                                                  // 1628
      }                                                                                                                // 1629
                                                                                                                       //
      if (content.mimeType) {                                                                                          // 1631
        response.setHeader("Content-Type", content.mimeType);                                                          // 1632
      }                                                                                                                // 1633
                                                                                                                       //
      if (content.encoding) {                                                                                          // 1635
        response.setHeader("Content-Encoding", content.encoding);                                                      // 1636
      }                                                                                                                // 1637
                                                                                                                       //
      if (content.language) {                                                                                          // 1639
        response.setHeader("Content-Language", content.language);                                                      // 1640
      }                                                                                                                // 1641
                                                                                                                       //
      if (content.eTag) {                                                                                              // 1643
        response.setHeader("ETag", composeETag(content.eTag));                                                         // 1644
      }                                                                                                                // 1645
                                                                                                                       //
      if ("disposition" in content && "download" in content.disposition) {                                             // 1647
        response.setHeader("Content-Disposition", 'attachment; filename="' + content.disposition.download.replace(/([\\"\n])/g, "\\$1") + '"');
      }                                                                                                                // 1650
                                                                                                                       //
      if ("stream" in content.body) {                                                                                  // 1652
        if (request.method === "HEAD") {                                                                               // 1653
          content.body.stream.close();                                                                                 // 1654
          response.rejectResponseStream(new Error("HEAD request; content doesn't matter."));                           // 1655
        } else {                                                                                                       // 1656
          var streamHandle = content.body.stream;                                                                      // 1657
          var responseStream = new Capnp.Capability(new ResponseStream(response, code.id, code.title, streamHandle), ByteStream);
          response.resolveResponseStream(responseStream);                                                              // 1661
          return { streamHandle: responseStream };                                                                     // 1662
        }                                                                                                              // 1663
      } else {                                                                                                         // 1664
        response.rejectResponseStream(new Error("Response content body was not a stream."));                           // 1665
                                                                                                                       //
        if ("bytes" in content.body) {                                                                                 // 1668
          response.setHeader("Content-Length", content.body.bytes.length);                                             // 1669
        } else {                                                                                                       // 1670
          throw new Error("Unknown content body type.");                                                               // 1671
        }                                                                                                              // 1672
      }                                                                                                                // 1673
                                                                                                                       //
      response.writeHead(code.id, code.title);                                                                         // 1675
                                                                                                                       //
      if ("bytes" in content.body && request.method !== "HEAD") {                                                      // 1677
        response.write(content.body.bytes);                                                                            // 1678
      }                                                                                                                // 1679
                                                                                                                       //
      response.end();                                                                                                  // 1681
    } else if ("noContent" in rpcResponse) {                                                                           // 1682
      var noContent = rpcResponse.noContent;                                                                           // 1683
      var noContentCode = noContentSuccessCodes[noContent.shouldResetForm * 1];                                        // 1684
      if (noContent.eTag) {                                                                                            // 1685
        response.setHeader("ETag", composeETag(noContent.eTag));                                                       // 1686
      }                                                                                                                // 1687
                                                                                                                       //
      response.writeHead(noContentCode.id, noContentCode.title);                                                       // 1689
      response.end();                                                                                                  // 1690
    } else if ("preconditionFailed" in rpcResponse) {                                                                  // 1691
      var preconditionFailed = rpcResponse.preconditionFailed;                                                         // 1692
      if (request.method === "GET" && "if-none-match" in request.headers) {                                            // 1693
        if (preconditionFailed.matchingETag) {                                                                         // 1694
          response.setHeader("ETag", composeETag(preconditionFailed.matchingETag));                                    // 1695
        }                                                                                                              // 1696
                                                                                                                       //
        response.writeHead(304, "Not Modified");                                                                       // 1698
      } else {                                                                                                         // 1699
        response.writeHead(412, "Precondition Failed");                                                                // 1700
      }                                                                                                                // 1701
                                                                                                                       //
      response.end();                                                                                                  // 1703
    } else if ("redirect" in rpcResponse) {                                                                            // 1704
      var redirect = rpcResponse.redirect;                                                                             // 1705
      var redirectCode = redirectCodes[redirect.switchToGet * 2 + redirect.isPermanent];                               // 1706
      response.writeHead(redirectCode.id, redirectCode.title, {                                                        // 1707
        "Location": redirect.location                                                                                  // 1708
      });                                                                                                              // 1707
      response.end();                                                                                                  // 1710
    } else if ("clientError" in rpcResponse) {                                                                         // 1711
      var clientError = rpcResponse.clientError;                                                                       // 1712
      var errorCode = errorCodes[clientError.statusCode];                                                              // 1713
      if (!errorCode) {                                                                                                // 1714
        throw new Error("Unknown status code: ", clientError.statusCode);                                              // 1715
      }                                                                                                                // 1716
                                                                                                                       //
      response.writeHead(errorCode.id, errorCode.title, {                                                              // 1718
        "Content-Type": "text/html"                                                                                    // 1719
      });                                                                                                              // 1718
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1722
        if (clientError.descriptionHtml) {                                                                             // 1723
          response.write(clientError.descriptionHtml);                                                                 // 1724
        } else {                                                                                                       // 1725
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>" + errorCode.id + ": " + errorCode.title + "</h1></body></html>");          // 1727
        }                                                                                                              // 1729
      }                                                                                                                // 1730
                                                                                                                       //
      response.end();                                                                                                  // 1732
    } else if ("serverError" in rpcResponse) {                                                                         // 1733
      response.writeHead(500, "Internal Server Error", {                                                               // 1734
        "Content-Type": "text/html"                                                                                    // 1735
      });                                                                                                              // 1734
                                                                                                                       //
      if (request.method !== "HEAD") {                                                                                 // 1738
        if (rpcResponse.serverError.descriptionHtml) {                                                                 // 1739
          response.write(rpcResponse.serverError.descriptionHtml);                                                     // 1740
        } else {                                                                                                       // 1741
          // TODO(someday):  Better default error page.                                                                //
          response.write("<html><body><h1>500: Internal Server Error</h1></body></html>");                             // 1743
        }                                                                                                              // 1744
      }                                                                                                                // 1745
                                                                                                                       //
      response.end();                                                                                                  // 1747
    } else {                                                                                                           // 1748
      throw new Error("Unknown HTTP response type:\n" + JSON.stringify(rpcResponse));                                  // 1749
    }                                                                                                                  // 1750
                                                                                                                       //
    return {};                                                                                                         // 1752
  };                                                                                                                   // 1753
                                                                                                                       //
  Proxy.prototype.handleRequest = function handleRequest(request, data, response, retryCount) {                        //
    var _this9 = this;                                                                                                 // 1755
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 1756
      return _this9.makeContext(request, response, function (context) {                                                // 1757
        // jscs:disable requireDotNotation                                                                             //
        // Send the RPC.                                                                                               //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1760
        var session = _this9.getSession(request);                                                                      // 1761
                                                                                                                       //
        var requestContent = function requestContent() {                                                               // 1763
          return {                                                                                                     // 1764
            content: data,                                                                                             // 1765
            encoding: request.headers["content-encoding"],                                                             // 1766
            mimeType: request.headers["content-type"]                                                                  // 1767
          };                                                                                                           // 1764
        };                                                                                                             // 1769
                                                                                                                       //
        var xmlContent = function xmlContent() {                                                                       // 1771
          var type = request.headers["content-type"] || "application/xml;charset=utf-8";                               // 1772
          var match = type.match(/[^/]*\/xml(; *charset *= *([^ ;]*))?/);                                              // 1773
          if (!match) {                                                                                                // 1774
            response.writeHead(415, "Unsupported media type.", {                                                       // 1775
              "Content-Type": "text/plain"                                                                             // 1776
            });                                                                                                        // 1775
            response.end("expected XML request body");                                                                 // 1778
            throw new Error("expected XML request body");                                                              // 1779
          }                                                                                                            // 1780
                                                                                                                       //
          var charset = match[2] || "ISO-8859-1";                                                                      // 1782
                                                                                                                       //
          var encoding = request.headers["content-encoding"];                                                          // 1784
          if (encoding && encoding !== "identity") {                                                                   // 1785
            if (encoding !== "gzip") throw new Error("unknown Content-Encoding: " + encoding);                         // 1786
            data = gunzipSync(data);                                                                                   // 1787
          }                                                                                                            // 1788
                                                                                                                       //
          return data.toString(charset.toLowerCase() === "utf-8" ? "utf8" : "binary");                                 // 1790
        };                                                                                                             // 1791
                                                                                                                       //
        var propfindDepth = function propfindDepth() {                                                                 // 1793
          var depth = request.headers["depth"];                                                                        // 1794
          return depth === "0" ? "zero" : depth === "1" ? "one" : "infinity";                                          // 1795
        };                                                                                                             // 1798
                                                                                                                       //
        var shallow = function shallow() {                                                                             // 1800
          return request.headers["depth"] === "0";                                                                     // 1801
        };                                                                                                             // 1802
                                                                                                                       //
        var noOverwrite = function noOverwrite() {                                                                     // 1804
          return (request.headers["overwrite"] || "").toLowerCase() === "f";                                           // 1805
        };                                                                                                             // 1806
                                                                                                                       //
        var destination = function destination() {                                                                     // 1808
          var result = request.headers["destination"];                                                                 // 1809
          if (!result) throw new Error("missing destination");                                                         // 1810
          return Url.parse(result).path.slice(1); // remove leading '/'                                                // 1811
        };                                                                                                             // 1812
                                                                                                                       //
        if (request.method === "GET" || request.method === "HEAD") {                                                   // 1814
          return session.get(path, context, request.method === "HEAD");                                                // 1815
        } else if (request.method === "POST") {                                                                        // 1816
          return session.post(path, requestContent(), context);                                                        // 1817
        } else if (request.method === "PUT") {                                                                         // 1818
          return session.put(path, requestContent(), context);                                                         // 1819
        } else if (request.method === "PATCH") {                                                                       // 1820
          return session.patch(path, requestContent(), context);                                                       // 1821
        } else if (request.method === "DELETE") {                                                                      // 1822
          return session["delete"](path, context);                                                                     // 1823
        } else if (request.method === "PROPFIND") {                                                                    // 1824
          return session.propfind(path, xmlContent(), propfindDepth(), context);                                       // 1825
        } else if (request.method === "PROPPATCH") {                                                                   // 1826
          return session.proppatch(path, xmlContent(), context);                                                       // 1827
        } else if (request.method === "MKCOL") {                                                                       // 1828
          return session.mkcol(path, requestContent(), context);                                                       // 1829
        } else if (request.method === "COPY") {                                                                        // 1830
          return session.copy(path, destination(), noOverwrite(), shallow(), context);                                 // 1831
        } else if (request.method === "MOVE") {                                                                        // 1832
          return session.move(path, destination(), noOverwrite(), context);                                            // 1833
        } else if (request.method === "LOCK") {                                                                        // 1834
          return session.lock(path, xmlContent(), shallow(), context);                                                 // 1835
        } else if (request.method === "UNLOCK") {                                                                      // 1836
          return session.unlock(path, request.headers["lock-token"], context);                                         // 1837
        } else if (request.method === "ACL") {                                                                         // 1838
          return session.acl(path, xmlContent(), context);                                                             // 1839
        } else if (request.method === "REPORT") {                                                                      // 1840
          return session.report(path, requestContent(), context);                                                      // 1841
        } else if (request.method === "OPTIONS") {                                                                     // 1842
          return session.options(path, context).then(function (options) {                                              // 1843
            var dav = [];                                                                                              // 1844
            if (options.davClass1) dav.push("1");                                                                      // 1845
            if (options.davClass2) dav.push("2");                                                                      // 1846
            if (options.davClass3) dav.push("3");                                                                      // 1847
            if (options.davExtensions) {                                                                               // 1848
              options.davExtensions.forEach(function (token) {                                                         // 1849
                if (token.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+|<[\x21-\x7E]*>)$/)) {                                   // 1850
                  dav.push(token);                                                                                     // 1851
                }                                                                                                      // 1852
              });                                                                                                      // 1853
            }                                                                                                          // 1854
                                                                                                                       //
            if (dav.length > 0) {                                                                                      // 1856
              response.setHeader("DAV", dav.join(", "));                                                               // 1857
              response.setHeader("Access-Control-Expose-Headers", "DAV");                                              // 1858
            }                                                                                                          // 1859
                                                                                                                       //
            response.end();                                                                                            // 1861
            // Return no response; we already handled everything.                                                      //
          }, function (err) {                                                                                          // 1863
            if (err.kjType !== "unimplemented") throw err;                                                             // 1864
            response.end();                                                                                            // 1865
            // Return no response; we already handled everything.                                                      //
          });                                                                                                          // 1867
        } else {                                                                                                       // 1868
            throw new Error("Sandstorm only supports the following methods: GET, POST, PUT, PATCH, DELETE, HEAD, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK, ACL, REPORT, and OPTIONS.");
          }                                                                                                            // 1870
      });                                                                                                              // 1871
    }).then(function (rpcResponse) {                                                                                   // 1872
      if (rpcResponse !== undefined) {                                                                                 // 1873
        // Will be undefined for OPTIONS request.                                                                      //
        return _this9.translateResponse(rpcResponse, response, request);                                               // 1874
      }                                                                                                                // 1875
    })["catch"](function (error) {                                                                                     // 1876
      return _this9.maybeRetryAfterError(error, retryCount).then(function () {                                         // 1877
        return _this9.handleRequest(request, data, response, retryCount + 1);                                          // 1878
      });                                                                                                              // 1879
    });                                                                                                                // 1880
  };                                                                                                                   // 1881
                                                                                                                       //
  Proxy.prototype.handleRequestStreaming = function handleRequestStreaming(request, response, contentLength, retryCount) {
    var _this10 = this;                                                                                                // 1883
                                                                                                                       //
    return this.makeContext(request, response, function (context) {                                                    // 1884
      var path = request.url.slice(1); // remove leading '/'                                                           // 1885
      var session = _this10.getSession(request);                                                                       // 1886
                                                                                                                       //
      var mimeType = request.headers["content-type"] || "application/octet-stream";                                    // 1888
      var encoding = request.headers["content-encoding"];                                                              // 1889
                                                                                                                       //
      var requestStreamPromise = void 0;                                                                               // 1891
      if (request.method === "POST") {                                                                                 // 1892
        requestStreamPromise = session.postStreaming(path, mimeType, context, encoding);                               // 1893
      } else if (request.method === "PUT") {                                                                           // 1894
        requestStreamPromise = session.putStreaming(path, mimeType, context, encoding);                                // 1895
      } else {                                                                                                         // 1896
        throw new Error("Sandstorm only supports streaming POST and PUT requests.");                                   // 1897
      }                                                                                                                // 1898
                                                                                                                       //
      // TODO(perf): We ought to be pipelining the body, but we can't currently, because we have to                    //
      //   handle the case where the app doesn't actually support streaming. We could pipeline while                   //
      //   also buffering the data on the side in case we need it again later, but that's kind of                      //
      //   complicated. We should fix the whole protocol to make streaming the standard.                               //
      return requestStreamPromise.then(function (requestStreamResult) {                                                // 1904
        var requestStream = requestStreamResult.stream;                                                                // 1905
                                                                                                                       //
        // Initialized when getResponse() returns, if the response is streaming.                                       //
        var downloadStreamHandle = void 0;                                                                             // 1908
                                                                                                                       //
        // Initialized if an upload-stream method throws.                                                              //
        var uploadStreamError = void 0;                                                                                // 1911
                                                                                                                       //
        // We call `getResponse()` immediately so that the app can start streaming data down even                      //
        // while data is still being streamed up. This theoretically allows apps to perform                            //
        // bidirectional streaming, though probably very few actually do that.                                         //
        //                                                                                                             //
        // Note that we need to be able to cancel `responsePromise` below, so it's important that                      //
        // it is the raw Cap'n Proto promise. Hence `translateResponsePromise` is a separate                           //
        // variable.                                                                                                   //
        var responsePromise = requestStream.getResponse();                                                             // 1920
                                                                                                                       //
        var reportUploadStreamError = function reportUploadStreamError(err) {                                          // 1922
          // Called when an upload-stream method throws.                                                               //
                                                                                                                       //
          if (!uploadStreamError) {                                                                                    // 1925
            uploadStreamError = err;                                                                                   // 1926
                                                                                                                       //
            // If we're still waiting on any response stuff, cancel it.                                                //
            responsePromise.cancel();                                                                                  // 1929
            requestStream.close();                                                                                     // 1930
            if (downloadStreamHandle) {                                                                                // 1931
              downloadStreamHandle.close();                                                                            // 1932
            }                                                                                                          // 1933
          }                                                                                                            // 1934
        };                                                                                                             // 1935
                                                                                                                       //
        // If we have a Content-Length, pass it along to the app by calling `expectSize()`.                            //
        if (contentLength !== undefined) {                                                                             // 1938
          requestStream.expectSize(contentLength)["catch"](function (err) {                                            // 1939
            // expectSize() is allowed to be unimplemented.                                                            //
            if (err.kjType !== "unimplemented") {                                                                      // 1941
              reportUploadStreamError(err);                                                                            // 1942
            }                                                                                                          // 1943
          });                                                                                                          // 1944
        }                                                                                                              // 1945
                                                                                                                       //
        // Pipe the input stream to the app.                                                                           //
        var writesInFlight = 0;                                                                                        // 1948
        var readingPaused = false;                                                                                     // 1949
        request.on("data", function (buf) {                                                                            // 1950
          // TODO(someday): Coalesce small writes.                                                                     //
          if (!uploadStreamError) {                                                                                    // 1952
            requestStream.write(buf).then(function () {                                                                // 1953
              writesInFlight--;                                                                                        // 1954
              if (readingPaused) {                                                                                     // 1955
                request.resume();                                                                                      // 1956
                readingPaused = false;                                                                                 // 1957
              }                                                                                                        // 1958
            })["catch"](reportUploadStreamError);                                                                      // 1959
                                                                                                                       //
            if (writesInFlight++ > 16) {                                                                               // 1961
              request.pause();                                                                                         // 1962
              readingPaused = true;                                                                                    // 1963
            }                                                                                                          // 1964
          }                                                                                                            // 1965
        });                                                                                                            // 1966
                                                                                                                       //
        request.on("end", function () {                                                                                // 1968
          if (!uploadStreamError) requestStream.done()["catch"](reportUploadStreamError);                              // 1969
                                                                                                                       //
          // We're all done making calls to requestStream.                                                             //
          requestStream.close();                                                                                       // 1972
        });                                                                                                            // 1973
                                                                                                                       //
        request.on("close", function () {                                                                              // 1975
          reportUploadStreamError(new Error("HTTP connection unexpectedly closed during request."));                   // 1976
        });                                                                                                            // 1977
                                                                                                                       //
        request.on("error", function (err) {                                                                           // 1979
          reportUploadStreamError(err);                                                                                // 1980
        });                                                                                                            // 1981
                                                                                                                       //
        return responsePromise.then(function (rpcResponse) {                                                           // 1983
          // Stop here if the upload stream has already failed.                                                        //
          if (uploadStreamError) throw uploadStreamError;                                                              // 1985
          downloadStreamHandle = _this10.translateResponse(rpcResponse, response, request).streamHandle;               // 1986
        });                                                                                                            // 1987
      }, function (err) {                                                                                              // 1988
        if (err.kjType === "failed" && err.message.indexOf("not implemented") !== -1) {                                // 1989
          // Hack to work around old apps using an old version of Cap'n Proto, before the                              //
          // 'unimplemented' exception type was introduced. :(                                                         //
          // TODO(cleanup): When we transition to API version 2, we can move this into the                             //
          //   compatibility layer.                                                                                    //
          err.kjType = "unimplemented";                                                                                // 1994
        }                                                                                                              // 1995
                                                                                                                       //
        if (SandstormBackend.shouldRestartGrain(err, 0)) {                                                             // 1997
          // This is the kind of error that indicates we should retry. Note that we passed 0 for                       //
          // the retry count above because we were just checking if this is a retriable error (vs.                     //
          // possibly a method-not-implemented error); maybeRetryAfterError() will check again with                    //
          // the proper retry count.                                                                                   //
          return _this10.maybeRetryAfterError(err, retryCount).then(function () {                                      // 2002
            return _this10.handleRequestStreaming(request, response, contentLength, retryCount + 1);                   // 2003
          });                                                                                                          // 2004
        } else if (err.kjType === "unimplemented") {                                                                   // 2005
          // Streaming is not implemented. Fall back to non-streaming version.                                         //
          return readAll(request).then(function (data) {                                                               // 2007
            return _this10.handleRequest(request, data, response, 0);                                                  // 2008
          });                                                                                                          // 2009
        } else {                                                                                                       // 2010
          throw err;                                                                                                   // 2011
        }                                                                                                              // 2012
      });                                                                                                              // 2013
    });                                                                                                                // 2014
  };                                                                                                                   // 2015
                                                                                                                       //
  Proxy.prototype.handleWebSocket = function handleWebSocket(request, socket, head, retryCount) {                      //
    var _this11 = this;                                                                                                // 2017
                                                                                                                       //
    return Promise.resolve(undefined).then(function () {                                                               // 2018
      return _this11.makeContext(request, undefined, function (context) {                                              // 2019
        var path = request.url.slice(1); // remove leading '/'                                                         // 2020
        var session = _this11.getSession(request);                                                                     // 2021
                                                                                                                       //
        if (!("sec-websocket-key" in request.headers)) {                                                               // 2023
          throw new Error("Missing Sec-WebSocket-Accept header.");                                                     // 2024
        }                                                                                                              // 2025
                                                                                                                       //
        var magic = request.headers["sec-websocket-key"] + "258EAFA5-E914-47DA-95CA-C5AB0DC85B11";                     // 2027
        var acceptKey = Crypto.createHash("sha1").update(magic).digest("base64");                                      // 2028
                                                                                                                       //
        var protocols = [];                                                                                            // 2030
        if ("sec-websocket-protocol" in request.headers) {                                                             // 2031
          protocols = request.headers["sec-websocket-protocol"].split(",").map(function (s) {                          // 2032
            return s.trim();                                                                                           // 2033
          });                                                                                                          // 2033
        }                                                                                                              // 2034
                                                                                                                       //
        var receiver = new WebSocketReceiver(socket);                                                                  // 2036
                                                                                                                       //
        var promise = session.openWebSocket(path, context, protocols, receiver);                                       // 2038
                                                                                                                       //
        if (head.length > 0) {                                                                                         // 2040
          promise.serverStream.sendBytes(head);                                                                        // 2041
        }                                                                                                              // 2042
                                                                                                                       //
        var socketIdx = _this11.websocketCounter.toString();                                                           // 2044
        _this11.websockets[socketIdx] = socket;                                                                        // 2045
        _this11.websocketCounter += 1;                                                                                 // 2046
        pumpWebSocket(socket, promise.serverStream, function () {                                                      // 2047
          delete _this11.websockets[socketIdx];                                                                        // 2047
        });                                                                                                            // 2047
                                                                                                                       //
        return promise.then(function (response) {                                                                      // 2049
          var headers = ["HTTP/1.1 101 Switching Protocols", "Upgrade: websocket", "Connection: Upgrade", "Sec-WebSocket-Accept: " + acceptKey];
          if (response.protocol && response.protocol.length > 0) {                                                     // 2056
            headers.push("Sec-WebSocket-Protocol: " + response.protocol.join(", "));                                   // 2057
          }                                                                                                            // 2058
                                                                                                                       //
          headers.push("");                                                                                            // 2060
          headers.push("");                                                                                            // 2061
                                                                                                                       //
          socket.write(headers.join("\r\n"));                                                                          // 2063
          receiver.go();                                                                                               // 2064
                                                                                                                       //
          // Note:  At this point errors are out of our hands.                                                         //
        });                                                                                                            // 2067
      });                                                                                                              // 2068
    })["catch"](function (error) {                                                                                     // 2069
      return _this11.maybeRetryAfterError(error, retryCount).then(function () {                                        // 2070
        return _this11.handleWebSocket(request, socket, head, retryCount + 1);                                         // 2071
      });                                                                                                              // 2072
    });                                                                                                                // 2073
  };                                                                                                                   // 2074
                                                                                                                       //
  Proxy.prototype.setHasLoaded = function setHasLoaded() {                                                             //
    var _this12 = this;                                                                                                // 2076
                                                                                                                       //
    if (!this.hasLoaded) {                                                                                             // 2077
      (function () {                                                                                                   // 2077
        _this12.hasLoaded = true;                                                                                      // 2078
        var sessionId = _this12.sessionId;                                                                             // 2079
        inMeteor(function () {                                                                                         // 2080
          Sessions.update({ _id: sessionId }, { $set: { hasLoaded: true } });                                          // 2081
        });                                                                                                            // 2082
      })();                                                                                                            // 2077
    }                                                                                                                  // 2083
  };                                                                                                                   // 2084
                                                                                                                       //
  return Proxy;                                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 2087
                                                                                                                       //
var isRfc1918OrLocal = function isRfc1918OrLocal(address) {                                                            // 2089
  if (Net.isIPv4(address)) {                                                                                           // 2090
    var quad = address.split(".").map(function (x) {                                                                   // 2091
      return parseInt(x, 10);                                                                                          // 2091
    });                                                                                                                // 2091
    return quad[0] === 127 || quad[0] === 10 || quad[0] === 192 && quad[1] === 168 || quad[0] === 172 && quad[1] >= 16 && quad[1] < 32;
  } else if (Net.isIPv6(address)) {                                                                                    // 2095
    // IPv6 specifies ::1 as localhost and fd:: as reserved for private networks                                       //
    return address === "::1" || address.lastIndexOf("fd", 0) === 0;                                                    // 2097
  } else {                                                                                                             // 2098
    // Ignore things that are neither IPv4 nor IPv6                                                                    //
    return false;                                                                                                      // 2100
  }                                                                                                                    // 2101
};                                                                                                                     // 2102
                                                                                                                       //
var quadToIntString = function quadToIntString(quad) {                                                                 // 2104
  var num = Bignum(quad[0]).shiftLeft(16).add(quad[1]).shiftLeft(16).add(quad[2]).shiftLeft(16).add(quad[3]);          // 2105
  return num.toString();                                                                                               // 2109
};                                                                                                                     // 2110
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Session cookie management                                                                                           //
                                                                                                                       //
var parseCookies = function parseCookies(request) {                                                                    // 2115
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["cookie"];                                                                              // 2117
                                                                                                                       //
  var result = { cookies: [] };                                                                                        // 2119
  if (header) {                                                                                                        // 2120
    var reqCookies = header.split(";");                                                                                // 2121
    for (var i in reqCookies) {                                                                                        // 2122
      var reqCookie = reqCookies[i];                                                                                   // 2123
      var equalsPos = reqCookie.indexOf("=");                                                                          // 2124
      var cookie = void 0;                                                                                             // 2125
      if (equalsPos === -1) {                                                                                          // 2126
        cookie = { key: reqCookie.trim(), value: "" };                                                                 // 2127
      } else {                                                                                                         // 2128
        cookie = { key: reqCookie.slice(0, equalsPos).trim(), value: reqCookie.slice(equalsPos + 1) };                 // 2129
      }                                                                                                                // 2130
                                                                                                                       //
      if (cookie.key === "sandstorm-sid") {                                                                            // 2132
        if (result.sessionId) {                                                                                        // 2133
          throw new Error("Multiple sandstorm session IDs?");                                                          // 2134
        }                                                                                                              // 2135
                                                                                                                       //
        result.sessionId = cookie.value;                                                                               // 2137
      } else {                                                                                                         // 2138
        result.cookies.push(cookie);                                                                                   // 2139
      }                                                                                                                // 2140
    }                                                                                                                  // 2141
  }                                                                                                                    // 2142
                                                                                                                       //
  return result;                                                                                                       // 2144
};                                                                                                                     // 2145
                                                                                                                       //
var parsePreconditionHeader = function parsePreconditionHeader(request) {                                              // 2147
  if (request.headers["if-match"]) {                                                                                   // 2148
    if (request.headers["if-match"].trim() === "*") {                                                                  // 2149
      return { exists: null };                                                                                         // 2150
    }                                                                                                                  // 2151
                                                                                                                       //
    var matches = parseETagList(request.headers["if-match"]);                                                          // 2153
    if (matches.length > 0) {                                                                                          // 2154
      return { matchesOneOf: matches };                                                                                // 2155
    }                                                                                                                  // 2156
  }                                                                                                                    // 2157
                                                                                                                       //
  if (request.headers["if-none-match"]) {                                                                              // 2159
    if (request.headers["if-none-match"].trim() === "*") {                                                             // 2160
      return { doesntExist: null };                                                                                    // 2161
    }                                                                                                                  // 2162
                                                                                                                       //
    var noneMatches = parseETagList(request.headers["if-none-match"]);                                                 // 2164
    if (noneMatches.length > 0) {                                                                                      // 2165
      return { matchesNoneOf: noneMatches };                                                                           // 2166
    }                                                                                                                  // 2167
  }                                                                                                                    // 2168
                                                                                                                       //
  return { none: null };                                                                                               // 2170
};                                                                                                                     // 2171
                                                                                                                       //
var parseETagList = function parseETagList(input) {                                                                    // 2173
  // An ETag is a quoted, \-escaped string, possibly prefixed with W/ (outside the quotes) to                          //
  // indicate that it is weak. We are parsing a list of comma-delimited etags.                                         //
                                                                                                                       //
  input = input.trim();                                                                                                // 2177
  var results = [];                                                                                                    // 2178
                                                                                                                       //
  while (input.length > 0) {                                                                                           // 2180
    var match = input.match(/^\s*(W\/)?"(([^"\\]|\\.)*)"\s*($|,)/);                                                    // 2181
    if (!match) throw new Meteor.Error(400, "invalid etag");                                                           // 2182
                                                                                                                       //
    input = input.slice(match[0].length).trim();                                                                       // 2184
    results.push({ weak: !!match[1], value: match[2].replace(/\\(.)/g, "$1") });                                       // 2185
  }                                                                                                                    // 2186
                                                                                                                       //
  return results;                                                                                                      // 2188
};                                                                                                                     // 2189
                                                                                                                       //
var composeETag = function composeETag(tag) {                                                                          // 2191
  var result = '"' + (tag.value || "").replace(/([\\"])/g, "\\$1") + '"';                                              // 2192
  if (tag.weak) result = "W/" + result;                                                                                // 2193
  return result;                                                                                                       // 2194
};                                                                                                                     // 2195
                                                                                                                       //
var parseAcceptHeader = function parseAcceptHeader(request) {                                                          // 2197
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers["accept"];                                                                              // 2199
                                                                                                                       //
  var result = [];                                                                                                     // 2201
  if (header) {                                                                                                        // 2202
    var acceptList = header.split(",");                                                                                // 2203
    for (var i in acceptList) {                                                                                        // 2204
      var acceptStr = acceptList[i];                                                                                   // 2205
      var tokensList = acceptStr.split(";");                                                                           // 2206
                                                                                                                       //
      var temp = { mimeType: tokensList[0].trim() };                                                                   // 2208
                                                                                                                       //
      var tokensListRest = tokensList.slice(1);                                                                        // 2210
      for (var j in tokensListRest) {                                                                                  // 2211
        var token = tokensListRest[j];                                                                                 // 2212
        var equalsPos = token.indexOf("=");                                                                            // 2213
        if (equalsPos) {                                                                                               // 2214
          var key = token.slice(0, equalsPos).trim();                                                                  // 2215
          var value = token.slice(equalsPos + 1).trim();                                                               // 2216
                                                                                                                       //
          if (key === "q") {                                                                                           // 2218
            temp.qValue = +value;                                                                                      // 2219
          }                                                                                                            // 2220
        }                                                                                                              // 2221
      }                                                                                                                // 2222
                                                                                                                       //
      result.push(temp);                                                                                               // 2224
    }                                                                                                                  // 2225
  }                                                                                                                    // 2226
                                                                                                                       //
  return result;                                                                                                       // 2228
};                                                                                                                     // 2229
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Regular HTTP request handling                                                                                       //
                                                                                                                       //
var readAll = function readAll(stream) {                                                                               // 2234
  return new Promise(function (resolve, reject) {                                                                      // 2235
    var buffers = [];                                                                                                  // 2236
    stream.on("data", function (buf) {                                                                                 // 2237
      buffers.push(buf);                                                                                               // 2238
    });                                                                                                                // 2239
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 2241
      resolve(Buffer.concat(buffers));                                                                                 // 2242
    });                                                                                                                // 2243
                                                                                                                       //
    stream.on("error", reject);                                                                                        // 2245
  });                                                                                                                  // 2246
};                                                                                                                     // 2247
                                                                                                                       //
var makeSetCookieHeader = function makeSetCookieHeader(cookie) {                                                       // 2249
  var result = [cookie.name, "=", cookie.value];                                                                       // 2250
                                                                                                                       //
  if ("absolute" in cookie.expires) {                                                                                  // 2252
    result.push("; Expires=");                                                                                         // 2253
    result.push(new Date(cookie.expires.absolute * 1000).toUTCString());                                               // 2254
  } else if ("relative" in cookie.expires) {                                                                           // 2255
    result.push("; Max-Age=" + cookie.expires.relative);                                                               // 2256
  }                                                                                                                    // 2257
                                                                                                                       //
  if (cookie.path) {                                                                                                   // 2259
    result.push("; Path=" + cookie.path);                                                                              // 2260
  }                                                                                                                    // 2261
                                                                                                                       //
  if (cookie.httpOnly) {                                                                                               // 2263
    result.push("; HttpOnly");                                                                                         // 2264
  }                                                                                                                    // 2265
                                                                                                                       //
  return result.join("");                                                                                              // 2267
};                                                                                                                     // 2268
                                                                                                                       //
// TODO(cleanup):  Auto-generate based on annotations in web-session.capnp.                                            //
var successCodes = {                                                                                                   // 2271
  ok: { id: 200, title: "OK" },                                                                                        // 2272
  created: { id: 201, title: "Created" },                                                                              // 2273
  accepted: { id: 202, title: "Accepted" },                                                                            // 2274
  multiStatus: { id: 207, title: "Multi-Status" }                                                                      // 2275
};                                                                                                                     // 2271
var noContentSuccessCodes = [                                                                                          // 2277
// Indexed by shouldResetForm * 1                                                                                      //
{ id: 204, title: "No Content" }, { id: 205, title: "Reset Content" }];                                                // 2279
var redirectCodes = [                                                                                                  // 2282
// Indexed by switchToGet * 2 + isPermanent                                                                            //
{ id: 307, title: "Temporary Redirect" }, { id: 308, title: "Permanent Redirect" }, { id: 303, title: "See Other" }, { id: 301, title: "Moved Permanently" }];
var errorCodes = {                                                                                                     // 2289
  badRequest: { id: 400, title: "Bad Request" },                                                                       // 2290
  forbidden: { id: 403, title: "Forbidden" },                                                                          // 2291
  notFound: { id: 404, title: "Not Found" },                                                                           // 2292
  methodNotAllowed: { id: 405, title: "Method Not Allowed" },                                                          // 2293
  notAcceptable: { id: 406, title: "Not Acceptable" },                                                                 // 2294
  conflict: { id: 409, title: "Conflict" },                                                                            // 2295
  gone: { id: 410, title: "Gone" },                                                                                    // 2296
  requestEntityTooLarge: { id: 413, title: "Request Entity Too Large" },                                               // 2297
  requestUriTooLong: { id: 414, title: "Request-URI Too Long" },                                                       // 2298
  unsupportedMediaType: { id: 415, title: "Unsupported Media Type" },                                                  // 2299
  imATeapot: { id: 418, title: "I'm a teapot" },                                                                       // 2300
  unprocessableEntity: { id: 422, title: "Unprocessable Entity" }                                                      // 2301
};                                                                                                                     // 2289
                                                                                                                       //
ResponseStream = function () {                                                                                         // 2304
  // Note: This class is used in pre-meteor.js as well as in this file.                                                //
                                                                                                                       //
  function ResponseStream(response, httpCode, httpStatus, upstreamHandle) {                                            // 2307
    var _this13 = this;                                                                                                // 2307
                                                                                                                       //
    _classCallCheck(this, ResponseStream);                                                                             // 2307
                                                                                                                       //
    // This is stupidly complicated, because:                                                                          //
    // - New versions of sandstorm-http-bridge (and other well-behaved apps) wait on write()                           //
    //   completion for flow control, so we want write() to complete only when there is space                          //
    //   available for more writes.                                                                                    //
    // - Old versions of sandstorm-http-bridge would make a zillion simultaneous calls to write()                      //
    //   with all of the data they wanted to send without waiting for previous calls to complete.                      //
    //   While in-flight, these writes can consume a lot of RAM at multiple points in the system.                      //
    // - Old versions of sandstorm-http-bridge would print any thrown error to stderr and then                         //
    //   keep going. So if canceling a download early on causes all future write()s to fail, this                      //
    //   can lead to very excessive log spam.                                                                          //
    // - If a write() fails to complete (it returns a promise that never resolves), then later                         //
    //   upon garbage collection the RPC will actually throw an exception about a PromiseFulfiller                     //
    //   never having been fulfilled. Hence, if we simply stop responding to write()s after some                       //
    //   point, we again get log spam.                                                                                 //
    // - If the connection closes during a write, Node never calls the completion callback at all.                     //
    //   We have to listen for the "close" event.                                                                      //
                                                                                                                       //
    this.response = response;                                                                                          // 2325
    this.httpCode = httpCode;                                                                                          // 2326
    this.httpStatus = httpStatus;                                                                                      // 2327
    this.upstreamHandle = upstreamHandle;                                                                              // 2328
                                                                                                                       //
    this.started = false;                                                                                              // 2330
    this.ended = false;                                                                                                // 2331
    this.waiting = [];                                                                                                 // 2332
                                                                                                                       //
    response.on("drain", function () {                                                                                 // 2334
      _this13.waiting.forEach(function (f) {                                                                           // 2335
        return f();                                                                                                    // 2335
      });                                                                                                              // 2335
      _this13.waiting = [];                                                                                            // 2336
    });                                                                                                                // 2337
                                                                                                                       //
    response.on("close", function () {                                                                                 // 2339
      _this13.aborted = true;                                                                                          // 2340
                                                                                                                       //
      // Resolve all outstanding writes. This is OK even if they didn't actually go through because                    //
      // an incomplete download is the client's problem, not the server's. The important thing is                      //
      // to cancel the stream if it is still being generated; to that end, the next new write()                        //
      // call after this point will throw.                                                                             //
      _this13.waiting.forEach(function (f) {                                                                           // 2346
        return f();                                                                                                    // 2346
      });                                                                                                              // 2346
      _this13.waiting = [];                                                                                            // 2347
                                                                                                                       //
      _this13.close();                                                                                                 // 2349
    });                                                                                                                // 2350
  }                                                                                                                    // 2351
                                                                                                                       //
  ResponseStream.prototype.expectSize = function expectSize(size) {                                                    // 2304
    if (!this.started) {                                                                                               // 2354
      this.started = true;                                                                                             // 2355
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": size });                             // 2356
    }                                                                                                                  // 2357
  };                                                                                                                   // 2358
                                                                                                                       //
  ResponseStream.prototype.write = function write(data) {                                                              // 2304
    var _this14 = this;                                                                                                // 2360
                                                                                                                       //
    if (!this.started) {                                                                                               // 2361
      this.started = true;                                                                                             // 2362
      this.response.writeHead(this.httpCode, this.httpStatus);                                                         // 2363
    }                                                                                                                  // 2364
                                                                                                                       //
    if (this.aborted) {                                                                                                // 2366
      // Connection has been aborted.                                                                                  //
      if (this.alreadyThrew) {                                                                                         // 2368
        // We already threw an error from a previous write(). Do not throw more errors, because                        //
        // older versions of sandstorm-http-bridge do not stop on the first error and will print                       //
        // every error to the log, wasting space. Newer versions stop on the first failure.                            //
        return;                                                                                                        // 2372
      } else {                                                                                                         // 2373
        this.alreadyThrew = true;                                                                                      // 2374
        throw new Error("client disconnected");                                                                        // 2375
      }                                                                                                                // 2376
    } else {                                                                                                           // 2377
      if (this.response.write(data)) {                                                                                 // 2378
        // All written.                                                                                                //
        return;                                                                                                        // 2380
      } else {                                                                                                         // 2381
        // Write buffer is full. Don't complete until it has more space.                                               //
        return new Promise(function (resolve, reject) {                                                                // 2383
          _this14.waiting.push(resolve);                                                                               // 2384
        });                                                                                                            // 2385
      }                                                                                                                // 2386
    }                                                                                                                  // 2387
  };                                                                                                                   // 2388
                                                                                                                       //
  ResponseStream.prototype.done = function done() {                                                                    // 2304
    if (!this.started) {                                                                                               // 2391
      this.started = true;                                                                                             // 2392
      this.response.writeHead(this.httpCode, this.httpStatus, { "Content-Length": 0 });                                // 2393
    }                                                                                                                  // 2394
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2396
      this.ended = true;                                                                                               // 2397
      this.response.end();                                                                                             // 2398
    }                                                                                                                  // 2399
                                                                                                                       //
    this.close();                                                                                                      // 2401
  };                                                                                                                   // 2402
                                                                                                                       //
  ResponseStream.prototype.close = function close() {                                                                  // 2304
    if (this.upstreamHandle) {                                                                                         // 2405
      this.upstreamHandle.close();                                                                                     // 2406
    }                                                                                                                  // 2407
                                                                                                                       //
    // If `this.done()` has not been called, we should report an error to the client. Unfortunately,                   //
    // the only case in which we can actually report the error is when we haven't done any writes                      //
    // yet. So we handle that case and ignore the error otherwise. Note that `!this.started`                           //
    // implies `!this.ended`.                                                                                          //
    if (!this.started) {                                                                                               // 2413
      this.started = true;                                                                                             // 2414
      this.response.writeHead(500, "done() never called on response stream", { "Content-Type": "text/plain" });        // 2415
    }                                                                                                                  // 2417
                                                                                                                       //
    if (!this.ended) {                                                                                                 // 2419
      this.ended = true;                                                                                               // 2420
      this.response.end();                                                                                             // 2421
    }                                                                                                                  // 2422
  };                                                                                                                   // 2423
                                                                                                                       //
  ResponseStream.prototype.sendingDirectResponse = function sendingDirectResponse() {                                  // 2304
    // For internal front-end use: Indicates that the caller is going to fill in the response                          //
    // instead. If a response has already been started, this throws an exception.                                      //
    //                                                                                                                 //
    // This is used in particular in pre-meteor.js, when dealing with static web publishing.                           //
                                                                                                                       //
    if (this.started) {                                                                                                // 2431
      throw new Error("can't sendDirectResponse() because response already started");                                  // 2432
      this.response.end();                                                                                             // 2433
    } else if (this.ended) {                                                                                           // 2434
      throw new Error("can't sendDirectResponse() because response already sent");                                     // 2435
    } else {                                                                                                           // 2436
      this.started = true;                                                                                             // 2437
      this.ended = true;                                                                                               // 2438
    }                                                                                                                  // 2439
  };                                                                                                                   // 2440
                                                                                                                       //
  return ResponseStream;                                                                                               // 2304
}();                                                                                                                   // 2304
                                                                                                                       //
// TODO(cleanup): Node 0.12 has a `gunzipSync` but 0.10 (which Meteor still uses) does not.                            //
var Zlib = Npm.require("zlib");                                                                                        // 2444
var gunzipSync = Meteor.wrapAsync(Zlib.gunzip, Zlib);                                                                  // 2445
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// WebSocket handling                                                                                                  //
                                                                                                                       //
WebSocketReceiver = function () {                                                                                      // 2450
  function WebSocketReceiver(socket) {                                                                                 // 2451
    _classCallCheck(this, WebSocketReceiver);                                                                          // 2451
                                                                                                                       //
    this.socket = socket;                                                                                              // 2452
    this.queue = [];                                                                                                   // 2453
  }                                                                                                                    // 2454
                                                                                                                       //
  WebSocketReceiver.prototype.go = function go() {                                                                     // 2450
    for (var i in this.queue) {                                                                                        // 2457
      this.socket.write(this.queue[i]);                                                                                // 2458
    }                                                                                                                  // 2459
                                                                                                                       //
    this.queue = null;                                                                                                 // 2461
  };                                                                                                                   // 2462
                                                                                                                       //
  WebSocketReceiver.prototype.sendBytes = function sendBytes(message) {                                                // 2450
    // TODO(someday):  Flow control of some sort?                                                                      //
    if (this.queue === null) {                                                                                         // 2466
      this.socket.write(message);                                                                                      // 2467
    } else {                                                                                                           // 2468
      this.queue.push(message);                                                                                        // 2469
    }                                                                                                                  // 2470
  };                                                                                                                   // 2471
                                                                                                                       //
  WebSocketReceiver.prototype.close = function close() {                                                               // 2450
    this.socket.end();                                                                                                 // 2474
  };                                                                                                                   // 2475
                                                                                                                       //
  return WebSocketReceiver;                                                                                            // 2450
}();                                                                                                                   // 2450
                                                                                                                       //
function pumpWebSocket(socket, rpcStream, destructor) {                                                                // 2478
  var writesInFlight = 0;                                                                                              // 2479
  var readingPaused = false;                                                                                           // 2480
  socket.on("data", function (chunk) {                                                                                 // 2481
    rpcStream.sendBytes(chunk).then(function () {                                                                      // 2482
      writesInFlight--;                                                                                                // 2483
      if (readingPaused) {                                                                                             // 2484
        socket.resume();                                                                                               // 2485
        readingPaused = false;                                                                                         // 2486
      }                                                                                                                // 2487
    })["catch"](function (err) {                                                                                       // 2488
      if (err.kjType !== "disconnected") {                                                                             // 2489
        console.error("WebSocket sendBytes failed: " + err.stack);                                                     // 2490
      }                                                                                                                // 2491
                                                                                                                       //
      socket.destroy();                                                                                                // 2493
    });                                                                                                                // 2494
                                                                                                                       //
    if (writesInFlight++ > 16) {                                                                                       // 2496
      socket.pause();                                                                                                  // 2497
      readingPaused = true;                                                                                            // 2498
    }                                                                                                                  // 2499
  });                                                                                                                  // 2500
                                                                                                                       //
  socket.on("end", function (chunk) {                                                                                  // 2502
    rpcStream.close();                                                                                                 // 2503
  });                                                                                                                  // 2504
                                                                                                                       //
  socket.on("close", function () {                                                                                     // 2506
    destructor();                                                                                                      // 2507
  });                                                                                                                  // 2508
};                                                                                                                     // 2509
                                                                                                                       //
// =======================================================================================                             //
// Debug log access                                                                                                    //
                                                                                                                       //
Meteor.publish("grainLog", function (grainId) {                                                                        // 2514
  var _this15 = this;                                                                                                  // 2514
                                                                                                                       //
  check(grainId, String);                                                                                              // 2515
  var id = 0;                                                                                                          // 2516
  var grain = Grains.findOne(grainId);                                                                                 // 2517
  if (!grain || !this.userId || grain.userId !== this.userId) {                                                        // 2518
    this.added("grainLog", id++, { text: "Only the grain owner can view the debug log." });                            // 2519
    this.ready();                                                                                                      // 2520
    return;                                                                                                            // 2521
  }                                                                                                                    // 2522
                                                                                                                       //
  var connected = false;                                                                                               // 2524
  var _this = this;                                                                                                    // 2525
                                                                                                                       //
  var receiver = {                                                                                                     // 2527
    write: function write(data) {                                                                                      // 2528
      connected = true;                                                                                                // 2529
      _this.added("grainLog", id++, { text: data.toString("utf8") });                                                  // 2530
    },                                                                                                                 // 2531
    close: function close() {                                                                                          // 2533
      if (connected) {                                                                                                 // 2534
        _this.added("grainLog", id++, {                                                                                // 2535
          text: "*** lost connection to grain (probably because it shut down) ***"                                     // 2536
        });                                                                                                            // 2535
      }                                                                                                                // 2538
    }                                                                                                                  // 2539
  };                                                                                                                   // 2527
                                                                                                                       //
  try {                                                                                                                // 2542
    (function () {                                                                                                     // 2542
      var handle = waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                 // 2543
        return supervisor.watchLog(8192, receiver);                                                                    // 2544
      })).handle;                                                                                                      // 2545
      connected = true;                                                                                                // 2546
      _this15.onStop(function () {                                                                                     // 2547
        handle.close();                                                                                                // 2548
      });                                                                                                              // 2549
    })();                                                                                                              // 2542
  } catch (err) {                                                                                                      // 2550
    if (!connected) {                                                                                                  // 2551
      this.added("grainLog", id++, {                                                                                   // 2552
        text: "*** couldn't connect to grain (" + err + ") ***"                                                        // 2553
      });                                                                                                              // 2552
    }                                                                                                                  // 2555
  }                                                                                                                    // 2556
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 2559
});                                                                                                                    // 2560
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"sandcats.js":["node-forge",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/sandcats.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var pki,asn1;module.import("node-forge",{"pki":function(v){pki=v},"asn1":function(v){asn1=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Sandcats = {};                                                                                                         // 17
                                                                                                                       //
                                                                                                                       // 19
var querystring = Npm.require("querystring");                                                                          // 20
var https = Npm.require("https");                                                                                      // 21
var fs = Npm.require("fs");                                                                                            // 22
var dgram = Npm.require("dgram");                                                                                      // 23
var Url = Npm.require("url");                                                                                          // 24
                                                                                                                       //
var SANDCATS_HOSTNAME = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].sandcatsHostname;    // 26
var SANDCATS_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandcats";                                                     // 28
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 30
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 31
var SANDCATS_NAME = void 0; // Look at `startup` below to see where this is set                                        // 32
                                                                                                                       //
var updateSandcatsIp = function updateSandcatsIp() {                                                                   // 34
  var responseCallback = function responseCallback(res) {                                                              // 35
    if (res.statusCode === 200) {                                                                                      // 36
      console.log("Successfully updated sandcats IP");                                                                 // 37
    } else {                                                                                                           // 38
      console.error("Failed to update sandcats IP:", res.headers);                                                     // 39
    }                                                                                                                  // 40
  };                                                                                                                   // 41
                                                                                                                       //
  var errorCallback = function errorCallback(err) {                                                                    // 43
    console.error("Couldn't send update sandcats hostname", err);                                                      // 44
  };                                                                                                                   // 45
                                                                                                                       //
  performSandcatsRequest("/update", SANDCATS_HOSTNAME, { rawHostname: SANDCATS_NAME }, errorCallback, responseCallback);
};                                                                                                                     // 49
                                                                                                                       //
var pingUdp = function pingUdp() {                                                                                     // 51
  var socket = dgram.createSocket("udp4");                                                                             // 52
  var secret = Random.secret(16);                                                                                      // 53
                                                                                                                       //
  message = new Buffer(SANDCATS_NAME + " " + secret);                                                                  // 55
  socket.on("message", function (buf) {                                                                                // 56
    if (buf.toString() === secret) {                                                                                   // 57
      updateSandcatsIp();                                                                                              // 58
    } else {                                                                                                           // 59
      console.error("Received unexpected response in UDP sandcats ping:", buf.toString());                             // 60
    }                                                                                                                  // 61
  });                                                                                                                  // 62
                                                                                                                       //
  socket.send(message, 0, message.length, 8080, SANDCATS_HOSTNAME, function (err) {                                    // 64
    if (err) {                                                                                                         // 65
      console.error("Couldn't send UDP sandcats ping", err);                                                           // 66
    }                                                                                                                  // 67
  });                                                                                                                  // 68
                                                                                                                       //
  Meteor.setTimeout(function () {                                                                                      // 70
    socket.close();                                                                                                    // 71
  }, 10 * 1000);                                                                                                       // 72
};                                                                                                                     // 73
                                                                                                                       //
var performSandcatsRequest = function performSandcatsRequest(path, hostname, postData, errorCallback, responseCallback) {
  var options = {                                                                                                      // 76
    hostname: hostname,                                                                                                // 77
    path: path,                                                                                                        // 78
    method: "POST",                                                                                                    // 79
    agent: false,                                                                                                      // 80
    key: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa"),                                                                 // 81
    cert: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa.pub"),                                                            // 82
    headers: {                                                                                                         // 83
      "X-Sand": "cats",                                                                                                // 84
      "Content-Type": "application/x-www-form-urlencoded"                                                              // 85
    }                                                                                                                  // 83
  };                                                                                                                   // 76
                                                                                                                       //
  if (postData.certificateSigningRequest) {                                                                            // 89
    console.log("Submitting certificate request for host", postData.rawHostname, "where the request has length", postData.certificateSigningRequest.length);
  }                                                                                                                    // 93
                                                                                                                       //
  var newPostData = querystring.stringify(postData);                                                                   // 95
  if (SANDCATS_HOSTNAME === "sandcats-dev.sandstorm.io" && !process.env.NODE_TLS_REJECT_UNAUTHORIZED) {                // 96
    console.log("You are using the Sandcats dev server but have full HTTPS " + "certificate checking enabled. Probably you will get an HTTPS " + "error. Proceeding anyway.");
  }                                                                                                                    // 101
                                                                                                                       //
  var req = https.request(options, responseCallback);                                                                  // 103
  req.write(newPostData);                                                                                              // 104
  req.end();                                                                                                           // 105
                                                                                                                       //
  if (errorCallback) {                                                                                                 // 107
    req.on("error", errorCallback);                                                                                    // 108
  }                                                                                                                    // 109
                                                                                                                       //
  return req;                                                                                                          // 111
};                                                                                                                     // 112
                                                                                                                       //
var generateKeyAndCsr = function generateKeyAndCsr(commonName) {                                                       // 114
  check(commonName, String);                                                                                           // 115
                                                                                                                       //
  // Generate key pair. Using Meteor.wrapAsync because forge supports                                                  //
  // a synchronous as well as an asynchronous API, and the synchronous                                                 //
  // one blocks for a while.                                                                                           //
  var wrappedGenerateKeyPair = Meteor.wrapAsync(pki.rsa.generateKeyPair);                                              // 120
                                                                                                                       //
  // I could pick an `e`[xponent] value for the resulting RSA key, but                                                 //
  // I will refrain.                                                                                                   //
  var keys = wrappedGenerateKeyPair({ bits: 2048 });                                                                   // 124
                                                                                                                       //
  // Create a certificate request (CSR).                                                                               //
  var csr = pki.createCertificationRequest();                                                                          // 127
  csr.publicKey = keys.publicKey;                                                                                      // 128
  csr.setSubject([{                                                                                                    // 129
    name: "commonName",                                                                                                // 131
    value: commonName,                                                                                                 // 132
    valueTagClass: asn1.Type.UTF8                                                                                      // 133
  }]);                                                                                                                 // 130
  // We specify UTF8 to encode a UTF8String (rather than the default of PRINTABLESTRING) in the                        //
  // commonName so that GlobalSign does not report a warning, and also because that happens to                         //
  // be what openssl(1) does when asked to create a CSR.                                                               //
  csr.sign(keys.privateKey);                                                                                           // 139
  console.log("generateKeyAndCsr created new key & certificate request for", commonName);                              // 140
  return {                                                                                                             // 141
    privateKeyAsPem: pki.privateKeyToPem(keys.privateKey),                                                             // 142
    csrAsPem: pki.certificationRequestToPem(csr)                                                                       // 143
  };                                                                                                                   // 141
};                                                                                                                     // 145
                                                                                                                       //
Sandcats.storeNewKeyAndCsr = function (hostname, basePath) {                                                           // 147
  // We use the current JS time (like UNIX timestamp but in                                                            //
  // milliseconds) as the key number. Note that the keyNumber is                                                       //
  // intended to be an opaque identifier; the only important thing is                                                  //
  // that it increases numerically over time. We use the current time                                                  //
  // just as a simplistic way to pick a filename that probably no one                                                  //
  // else has created yet.                                                                                             //
  var keyNumber = new Date().getTime();                                                                                // 154
  var keyFilename = basePath + "/" + keyNumber;                                                                        // 155
  var csrFilename = keyFilename + ".csr";                                                                              // 156
  var responseFilename = keyFilename + ".response-json";                                                               // 157
  var withWildcard = "*." + hostname;                                                                                  // 158
  var keyAndCsr = generateKeyAndCsr(withWildcard);                                                                     // 159
  fs.writeFileSync(keyFilename, keyAndCsr.privateKeyAsPem, { mode: 0400 });                                            // 160
  fs.writeFileSync(csrFilename, keyAndCsr.csrAsPem);                                                                   // 162
  console.log("storeNewKeyAndCsr successfully saved key and certificate request to", keyFilename, "and", csrFilename, "respectively of length", keyAndCsr.privateKeyAsPem.length, "and", keyAndCsr.csrAsPem.length);
  return {                                                                                                             // 167
    csrFilename: csrFilename,                                                                                          // 168
    keyFilename: keyFilename,                                                                                          // 169
    responseFilename: responseFilename                                                                                 // 170
  };                                                                                                                   // 167
};                                                                                                                     // 172
                                                                                                                       //
Sandcats.renewHttpsCertificateIfNeeded = function () {                                                                 // 174
  var renewHttpsCertificate = function renewHttpsCertificate() {                                                       // 175
    var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                           // 176
    var basePath = "/var/sandcats/https/" + hostname;                                                                  // 177
    var filenames = Sandcats.storeNewKeyAndCsr(hostname, basePath);                                                    // 178
                                                                                                                       //
    var errorCallback = function errorCallback(err) {                                                                  // 180
      console.error("Error while renewing HTTPS certificate (will continue to retry)", err);                           // 181
    };                                                                                                                 // 182
                                                                                                                       //
    var responseCallback = function responseCallback(res) {                                                            // 184
      if (res.statusCode == 200) {                                                                                     // 185
        (function () {                                                                                                 // 185
          // Save the response, chunk by chunk, then store it on disk                                                  //
          // for later use.                                                                                            //
          var responseBody = "";                                                                                       // 188
          res.on("data", function (chunk) {                                                                            // 189
            responseBody += chunk;                                                                                     // 190
          });                                                                                                          // 191
                                                                                                                       //
          res.on("end", function () {                                                                                  // 193
            // For sanity, make sure it parses as JSON, since we're                                                    //
            // going to need it to do that.                                                                            //
            try {                                                                                                      // 196
              JSON.parse(responseBody);                                                                                // 197
            } catch (e) {                                                                                              // 198
              console.error("JSON parse error receiving new HTTPS certificate. Discarding:", responseBody, "due to exception:", e);
              // Overwrite the responseBody with the empty JSON object                                                 //
              // and continue with the process of saving it to disk.                                                   //
              responseBody = "{}";                                                                                     // 205
            }                                                                                                          // 206
                                                                                                                       //
            try {                                                                                                      // 208
              fs.writeFileSync(filenames.responseFilename, responseBody, "utf-8");                                     // 209
            } catch (err) {                                                                                            // 210
              return console.error("Failure while saveing new HTTPS certificate to", filenames.responseFilename, "will continue to retry. Exception was:", err);
            }                                                                                                          // 215
                                                                                                                       //
            // Tell Sandcats that now is a good time to update its info                                                //
            // about which keys are available.                                                                         //
            if (!global.sandcats) {                                                                                    // 219
              console.error("When getting new certificate, could not find callback to request re-keying! Certs will probably become invalid soon.");
            } else {                                                                                                   // 221
              // Call the sandcats rekeying function.                                                                  //
              global.sandcats.rekey();                                                                                 // 223
              // That's that.                                                                                          //
              console.log("Successfully renewed HTTPS certificate into", filenames.responseFilename);                  // 225
            }                                                                                                          // 227
          });                                                                                                          // 228
        })();                                                                                                          // 185
      } else {                                                                                                         // 229
        console.log("Received HTTP error while renewing certificate (will keep retrying)", res.statusCode);            // 230
        res.on("data", function (chunk) {                                                                              // 232
          console.log("Error response contained information", chunk.toString("utf-8"));                                // 233
        });                                                                                                            // 234
      }                                                                                                                // 235
    };                                                                                                                 // 236
                                                                                                                       //
    var wrappedReadFile = Meteor.wrapAsync(fs.readFile);                                                               // 238
                                                                                                                       //
    performSandcatsRequest("/getcertificate", SANDCATS_HOSTNAME, {                                                     // 240
      rawHostname: SANDCATS_NAME,                                                                                      // 241
      certificateSigningRequest: wrappedReadFile(filenames.csrFilename, "utf-8")                                       // 242
    }, errorCallback, responseCallback);                                                                               // 240
  };                                                                                                                   // 244
                                                                                                                       //
  if (global.sandcats.shouldGetAnotherCertificate()) {                                                                 // 246
    console.log("renewHttpsCertificateIfNeeded: Happily choosing to renew certificate.");                              // 247
    return renewHttpsCertificate();                                                                                    // 248
  }                                                                                                                    // 249
};                                                                                                                     // 250
                                                                                                                       //
Sandcats.initializeSandcats = function () {                                                                            // 252
  var i = HOSTNAME.lastIndexOf(SANDCATS_HOSTNAME);                                                                     // 253
  if (i < 0) {                                                                                                         // 254
    console.error("SANDCATS_BASE_DOMAIN is configured but your HOSTNAME doesn't appear to contain it:", SANDCATS_HOSTNAME, HOSTNAME);
  } else {                                                                                                             // 257
    var oneMinute = 60 * 1000;                                                                                         // 258
    var oneHour = 60 * oneMinute;                                                                                      // 259
    var randomIntervalZeroToOneHour = Math.random() * oneHour;                                                         // 260
    // All Sandcats installs need dyndns updating.                                                                     //
    SANDCATS_NAME = HOSTNAME.slice(0, i - 1);                                                                          // 262
    Meteor.setInterval(pingUdp, oneMinute);                                                                            // 263
    // If process.env.HTTPS_PORT is set, we need to auto-refresh our HTTPS certificate.                                //
    if (process.env.HTTPS_PORT) {                                                                                      // 265
      // Always do a HTTPS certificate update check on Sandstorm start.                                                //
      Sandcats.renewHttpsCertificateIfNeeded();                                                                        // 267
                                                                                                                       //
      // After that's done, schedule it for every approx 1-2 hours in                                                  //
      // the future.                                                                                                   //
      Meteor.setInterval(Sandcats.renewHttpsCertificateIfNeeded, oneHour + randomIntervalZeroToOneHour);               // 271
    }                                                                                                                  // 273
  }                                                                                                                    // 274
};                                                                                                                     // 275
                                                                                                                       //
if (SANDCATS_HOSTNAME) {                                                                                               // 277
  Meteor.startup(Sandcats.initializeSandcats);                                                                         // 278
};                                                                                                                     // 279
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"shell-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/shell-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Set up browser policy.                                                                                              //
//                                                                                                                     //
// Note that by default (when the browser-policy package is added), Content-Security-Policy will                       //
// already be set to same-origin-only for everything except XHR and WebSocket. Eval is disabled,                       //
// but inline script are enabled.                                                                                      //
//                                                                                                                     //
// TODO(security): Consider disallowing inline scripts. Currently this forces Meteor to do an                          //
//   extra round trip on startup to fetch server settings. That seems like something that could                        //
//   be fixed in Meteor (e.g. embed the settings as JSON text rather than script). Startup time                        //
//   is incredibly important, and Meteor's templating system (which we use to render all our                           //
//   HTML) already does a good job of protecting us from script injection, so right now I think                        //
//   we should favor avoiding the round trip.                                                                          //
//                                                                                                                     //
// TODO(someday): Detect when an app tries to navigate off-site using CSP's violation reporting                        //
//   feature. Ask the user whether they want to open the link in a new tab. This is an annoying                        //
//   prompt, but if we just open the tab directly then apps can trivially leak by opening tabs                         //
//   with encoded URLs to an evil server. Although, this attack would be very detectable to the                        //
//   user, so maybe it's not a big deal...                                                                             //
                                                                                                                       //
BrowserPolicy.framing.disallow(); // Disallow framing of the UI.                                                       // 36
BrowserPolicy.content.allowFrameOrigin(getWildcardOrigin());                                                           // 37
                                                                                                                       //
// Allow anything to be loaded from the static asset host.                                                             //
var Url = Npm.require("url");                                                                                          // 40
var staticAssetHost = Url.parse(process.env.ROOT_URL).protocol + "//" + globalDb.makeWildcardHost("static");           // 41
BrowserPolicy.content.allowImageOrigin(staticAssetHost);                                                               // 43
BrowserPolicy.content.allowScriptOrigin(staticAssetHost);                                                              // 44
BrowserPolicy.content.allowFontOrigin(staticAssetHost);                                                                // 45
BrowserPolicy.content.allowConnectOrigin(staticAssetHost);                                                             // 46
                                                                                                                       //
Meteor.publish("grainsMenu", function () {                                                                             // 48
  var _this = this;                                                                                                    // 48
                                                                                                                       //
  if (this.userId) {                                                                                                   // 49
    if (Meteor.settings["public"].quotaEnabled) {                                                                      // 50
      (function () {                                                                                                   // 50
        // Hack: Fire off an asynchronous update to the user's storage usage whenever they open the                    //
        //   front page.                                                                                               //
        // TODO(someday): Implement the ability to reactively subscribe to storage usage from the                      //
        //   back-end?                                                                                                 //
        var userId = _this.userId;                                                                                     // 55
        globalBackend.cap().getUserStorageUsage(userId).then(function (results) {                                      // 56
          inMeteor(function () {                                                                                       // 57
            Meteor.users.update(userId, { $set: { storageUsage: parseInt(results.size) } });                           // 58
          });                                                                                                          // 59
        })["catch"](function (err) {                                                                                   // 60
          if (err.kjType !== "unimplemented") {                                                                        // 61
            console.error(err.stack);                                                                                  // 62
          }                                                                                                            // 63
        });                                                                                                            // 64
      })();                                                                                                            // 50
    }                                                                                                                  // 65
                                                                                                                       //
    var identityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                   // 67
    return [UserActions.find({ userId: this.userId }), Grains.find({ userId: this.userId }), ApiTokens.find({ "owner.user.identityId": { $in: identityIds } })];
  } else {                                                                                                             // 73
    return [];                                                                                                         // 74
  }                                                                                                                    // 75
});                                                                                                                    // 76
                                                                                                                       //
Meteor.publish("sessions", function (sessionId) {                                                                      // 78
  // sessionId itself should be secret enough, but they are also not meant to be shared, so as                         //
  // a backup we only publish the session to its owner. Note that `userId` can be null if the                          //
  // user is not logged in or is using incognito mode.                                                                 //
  check(sessionId, String);                                                                                            // 82
  return Sessions.find({ _id: sessionId, $or: [{ userId: this.userId }, { userId: null }] });                          // 83
});                                                                                                                    // 84
                                                                                                                       //
Meteor.publish("devPackages", function () {                                                                            // 86
  return DevPackages.find();                                                                                           // 87
});                                                                                                                    // 88
                                                                                                                       //
Meteor.publish("hasUsers", function () {                                                                               // 90
  var _this2 = this;                                                                                                   // 90
                                                                                                                       //
  // Publish pseudo-collection which tells the client if there are any users at all.                                   //
  //                                                                                                                   //
  // TODO(cleanup):  This seems overcomplicated.  Does Meteor have a better way?                                       //
  var cursor = Meteor.users.find();                                                                                    // 94
  if (cursor.count() > 0) {                                                                                            // 95
    this.added("hasUsers", "hasUsers", { hasUsers: true });                                                            // 96
  } else {                                                                                                             // 97
    (function () {                                                                                                     // 97
      var handle = cursor.observeChanges({                                                                             // 98
        added: function added(id) {                                                                                    // 99
          _this2.added("hasUsers", "hasUsers", { hasUsers: true });                                                    // 100
          handle.stop();                                                                                               // 101
          handle = null;                                                                                               // 102
        }                                                                                                              // 103
      });                                                                                                              // 98
      _this2.onStop(function () {                                                                                      // 105
        if (handle) handle.stop();                                                                                     // 106
      });                                                                                                              // 107
    })();                                                                                                              // 97
  }                                                                                                                    // 108
                                                                                                                       //
  this.ready();                                                                                                        // 110
});                                                                                                                    // 111
                                                                                                                       //
Meteor.publish("referralInfoPseudo", function () {                                                                     // 113
  var _this3 = this;                                                                                                   // 113
                                                                                                                       //
  // This publishes a pseudo-collection called referralInfo whose documents have the following                         //
  // form:                                                                                                             //
  //                                                                                                                   //
  // - id: (String) same as the User._id of an identity this user has referred                                         //
  // - name: (String) the profile.name from that identity                                                              //
  // - completed: (Boolean) if this referral is complete                                                               //
                                                                                                                       //
  //  If the user is not logged in, then we have no referralInfo.                                                      //
  if (!this.userId) {                                                                                                  // 122
    return [];                                                                                                         // 123
  }                                                                                                                    // 124
                                                                                                                       //
  // Implementation note:                                                                                              //
  //                                                                                                                   //
  // This pseudo-collection is populated very differently for (1) the completed: false case versus                     //
  // the (2) completed: true case.                                                                                     //
                                                                                                                       //
  // Case 1. Publish information about not-yet-complete referrals.                                                     //
  var notCompletedReferralIdentitiesCursor = Meteor.users.find({                                                       // 132
    referredBy: this.userId,                                                                                           // 133
    "profile.name": { $exists: true }                                                                                  // 134
  }, {                                                                                                                 // 132
    fields: {                                                                                                          // 136
      _id: 1,                                                                                                          // 137
      referredBy: 1,                                                                                                   // 138
      "profile.name": 1                                                                                                // 139
    }                                                                                                                  // 136
  });                                                                                                                  // 135
  var notCompletedReferralIdentitiesHandle = notCompletedReferralIdentitiesCursor.observeChanges({                     // 142
    // The added function gets called with the id of Bob when Alice refers Bob.                                        //
    added: function added(id, fields) {                                                                                // 144
      _this3.added("referralInfo", id, { name: fields.profile.name, completed: false });                               // 145
    },                                                                                                                 // 146
    // The removed function gets called when Bob is no longer an uncompleted referral.  Note that                      //
    // this will get more complicated once we support sending completed referrals to the client.                       //
    removed: function removed(id) {                                                                                    // 149
      _this3.removed("referralInfo", id);                                                                              // 150
    },                                                                                                                 // 151
    // The modified function gets called when Bob's profile.name changed.                                              //
    modified: function modified(id, fields) {                                                                          // 153
      _this3.modified("referralInfo", id, { name: fields.profile.name, completed: false });                            // 154
    }                                                                                                                  // 155
  });                                                                                                                  // 142
                                                                                                                       //
  // Case 2. Handle completed referrals.                                                                               //
  //                                                                                                                   //
  // - Do a query for the current list of completed identities.                                                        //
  //                                                                                                                   //
  // - Every time we see a new such identity, we create a query that watches that one identity in                      //
  //   case its profile.name changes.                                                                                  //
  //                                                                                                                   //
  // - Also watch the first query, since the list of completed identities might change.                                //
  var handleForProfileNameByIdentityId = {};                                                                           // 166
  var stopWatchingAllIdentities = function stopWatchingAllIdentities() {                                               // 167
    Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                      // 168
      stopWatchingIdentity(identityId);                                                                                // 169
    });                                                                                                                // 170
  };                                                                                                                   // 171
                                                                                                                       //
  var stopWatchingIdentity = function stopWatchingIdentity(identityId) {                                               // 173
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 174
    if (handleForProfileName) {                                                                                        // 175
      _this3.removed("referralInfo", identityId);                                                                      // 176
      handleForProfileName.stop();                                                                                     // 177
      // delete is safe because we iterate across `Object.keys()` which returns a copy.                                //
      delete handleForProfileNameByIdentityId[identityId];                                                             // 179
    }                                                                                                                  // 180
  };                                                                                                                   // 181
                                                                                                                       //
  var watchIdentityAndPublishReferralSuccess = function watchIdentityAndPublishReferralSuccess(identityId) {           // 183
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 184
    if (handleForProfileName) {                                                                                        // 185
      return;                                                                                                          // 186
    }                                                                                                                  // 187
                                                                                                                       //
    handleForProfileName = Meteor.users.find({                                                                         // 189
      _id: identityId                                                                                                  // 190
    }, {                                                                                                               // 189
      fields: {                                                                                                        // 192
        "profile.name": 1                                                                                              // 193
      }                                                                                                                // 192
    }).observeChanges({                                                                                                // 191
      added: function added(id, fields) {                                                                              // 196
        _this3.added("referralInfo", id, { name: fields.profile.name, completed: true });                              // 197
      },                                                                                                               // 198
                                                                                                                       //
      changed: function changed(id, fields) {                                                                          // 200
        _this3.changed("referralInfo", id, { name: fields.profile.name, completed: true });                            // 201
      },                                                                                                               // 202
                                                                                                                       //
      removed: function removed(id) {                                                                                  // 204
        stopWatchingIdentity(id);                                                                                      // 205
      }                                                                                                                // 206
    });                                                                                                                // 195
                                                                                                                       //
    handleForProfileNameByIdentityId[identityId] = handleForProfileName;                                               // 209
  };                                                                                                                   // 210
                                                                                                                       //
  var completedIdentityIdsHandle = Meteor.users.find({                                                                 // 212
    _id: this.userId,                                                                                                  // 213
    referredIdentityIds: { $exists: true }                                                                             // 214
  }, {                                                                                                                 // 212
    fields: {                                                                                                          // 216
      referredIdentityIds: true                                                                                        // 217
    }                                                                                                                  // 216
  }).observeChanges({                                                                                                  // 215
    // `added` gets called when a user gets their first completed referral.                                            //
    added: function added(id, fields) {                                                                                // 221
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 222
        // Unconditionally mark these as successful referrals and start watching.                                      //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 224
      }                                                                                                                // 226
    },                                                                                                                 // 227
    // `changed` gets called when a user adds/removes referredIdentityIds, usually when a                              //
    // referral becomes complete.                                                                                      //
    changed: function changed(id, fields) {                                                                            // 230
      // Two major tasks.                                                                                              //
      //                                                                                                               //
      // 1. Look for identityIds to unsubscribe from & send removed notices to the client.                             //
      //                                                                                                               //
      // 2. Look for identityIds to subscribe to.                                                                      //
                                                                                                                       //
      // Task 1. Unsubscribe where needed.                                                                             //
      var referredIdentityIdsAsObject = {};                                                                            // 238
      fields.referredIdentityIds.forEach(function (i) {                                                                // 239
        referredIdentityIdsAsObject[i] = true;                                                                         // 239
      });                                                                                                              // 239
                                                                                                                       //
      Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                    // 241
        // If the handle doesn't show up in the new list of referredIdentityIds, then remove                           //
        // info from the client & stop it on the server & make it null.                                                //
        var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                       // 244
        if (referredIdentityIdsAsObject.hasOwnProperty(identityId)) {                                                  // 245
          stopWatchingIdentity(identityId);                                                                            // 246
        }                                                                                                              // 247
      });                                                                                                              // 248
                                                                                                                       //
      // Task 2. Subscribe where needed.                                                                               //
      for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                    // 251
        // The watch... function will avoid double-creating subscriptions, so this is safe.                            //
        watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                         // 253
      }                                                                                                                // 254
    },                                                                                                                 // 255
    // `removed` gets called when a User suddenly has no referredIdentityIds.                                          //
    removed: function removed() {                                                                                      // 257
      // Remove all data from client; stop all handles.                                                                //
      stopWatchingAllIdentities();                                                                                     // 259
    }                                                                                                                  // 260
  });                                                                                                                  // 219
                                                                                                                       //
  // With cases 1 and 2 handled, register a cleanup function, then declare victory.                                    //
  this.onStop(function () {                                                                                            // 264
    stopWatchingAllIdentities();                                                                                       // 265
    notCompletedReferralIdentitiesHandle.stop();                                                                       // 266
    completedIdentityIdsHandle.stop();                                                                                 // 267
  });                                                                                                                  // 268
                                                                                                                       //
  this.ready();                                                                                                        // 270
});                                                                                                                    // 271
                                                                                                                       //
Meteor.publish("backers", function () {                                                                                // 273
  var _this4 = this;                                                                                                   // 273
                                                                                                                       //
  var backers = Assets.getText("backers.txt");                                                                         // 274
  var anonCount = 0;                                                                                                   // 275
  var counter = 0;                                                                                                     // 276
                                                                                                                       //
  backers.split("\n").forEach(function (name) {                                                                        // 278
    name = name.trim();                                                                                                // 279
    if (name === "") {                                                                                                 // 280
      ++anonCount;                                                                                                     // 281
    } else {                                                                                                           // 282
      _this4.added("backers", counter++, { name: name });                                                              // 283
    }                                                                                                                  // 284
  });                                                                                                                  // 285
                                                                                                                       //
  // Text file ends in \n but that shouldn't count.                                                                    //
  --anonCount;                                                                                                         // 288
                                                                                                                       //
  this.added("backers", "anonymous", { count: anonCount - 1 });                                                        // 290
                                                                                                                       //
  this.ready();                                                                                                        // 292
});                                                                                                                    // 293
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"signup-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/signup-server.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file covers creation and consumption of invite keys (i.e. to invite people to become                           //
// users of the Sandstorm server).                                                                                     //
                                                                                                                       //
Meteor.publish("signupKey", function (key) {                                                                           // 20
  check(key, String);                                                                                                  // 21
  return SignupKeys.find(key);                                                                                         // 22
});                                                                                                                    // 23
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  useSignupKey: function useSignupKey(key) {                                                                           // 26
    check(key, String);                                                                                                // 27
                                                                                                                       //
    if (!this.userId) {                                                                                                // 29
      throw new Meteor.Error(403, "Must be signed in.");                                                               // 30
    }                                                                                                                  // 31
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 33
    if (user.signupKey) {                                                                                              // 34
      // Don't waste it.                                                                                               //
      return;                                                                                                          // 36
    }                                                                                                                  // 37
                                                                                                                       //
    if (isDemoUser()) {                                                                                                // 39
      throw new Meteor.Error(403, "Demo users cannot accept invite keys. Please sign in as a real user.");             // 40
    }                                                                                                                  // 42
                                                                                                                       //
    if (!user.loginIdentities) {                                                                                       // 44
      // Don't consume signup key as identity user.                                                                    //
      return;                                                                                                          // 46
    }                                                                                                                  // 47
                                                                                                                       //
    var keyInfo = SignupKeys.findOne(key);                                                                             // 49
    if (!keyInfo || keyInfo.used) {                                                                                    // 50
      throw new Meteor.Error(403, "Invalid key or already used.");                                                     // 51
    }                                                                                                                  // 52
                                                                                                                       //
    if (isSignedUp() && user.payments && user.payments.id) {                                                           // 54
      // This user is already signed up with a payment account. Possibly, they signed up before                        //
      // using their invite, and then went back and clicked on the invite. As a result they                            //
      // probably now have two payment accounts. Mark this invite as used but also add a special                       //
      // flag so we can find it later and cancel the dupe payment account. Record who tried to                         //
      // use it so that we can transfer credits over if needed.                                                        //
      SignupKeys.update(key, { $set: { used: true, rejectedBy: this.userId } });                                       // 60
      return;                                                                                                          // 61
    }                                                                                                                  // 62
                                                                                                                       //
    var userFields = {                                                                                                 // 64
      signupKey: key,                                                                                                  // 65
      signupNote: keyInfo.note                                                                                         // 66
    };                                                                                                                 // 64
    if (keyInfo.email) {                                                                                               // 68
      userFields.signupEmail = keyInfo.email;                                                                          // 69
    }                                                                                                                  // 70
                                                                                                                       //
    if ("quota" in keyInfo) {                                                                                          // 72
      userFields.quota = keyInfo.quota;                                                                                // 73
    }                                                                                                                  // 74
                                                                                                                       //
    if (keyInfo.plan) {                                                                                                // 76
      userFields.plan = keyInfo.plan;                                                                                  // 77
    }                                                                                                                  // 78
                                                                                                                       //
    if (keyInfo.payments) {                                                                                            // 80
      userFields["payments.id"] = keyInfo.payments.id;                                                                 // 81
    }                                                                                                                  // 82
                                                                                                                       //
    Meteor.users.update(this.userId, { $set: userFields });                                                            // 84
    SignupKeys.update(key, { $set: { used: true } });                                                                  // 85
  }                                                                                                                    // 86
});                                                                                                                    // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"startup.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/startup.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file is for various startup code that doesn't fit neatly anywhere else                                         //
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 19
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 21
  var baseUrlRow = Misc.findOne({ _id: "BASE_URL" });                                                                  // 22
                                                                                                                       //
  if (!baseUrlRow) {                                                                                                   // 24
    // Fill data with current value in the case this is a first run                                                    //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 26
    Misc.insert(baseUrlRow);                                                                                           // 27
  } else if (baseUrlRow.value !== ROOT_URL) {                                                                          // 28
    console.log("resetting oauth");                                                                                    // 29
    Settings.find({ _id: { $in: ["google", "github"] } }).forEach(function (setting) {                                 // 30
      if (!!setting.value) {                                                                                           // 31
        Settings.update({ _id: setting._id }, { $set: { value: false,                                                  // 32
            automaticallyReset: { baseUrlChangedFrom: baseUrlRow.value } } });                                         // 34
      }                                                                                                                // 35
    });                                                                                                                // 36
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 37
    Misc.update({ _id: "BASE_URL" }, { $set: { value: ROOT_URL } });                                                   // 38
  }                                                                                                                    // 39
});                                                                                                                    // 40
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"stats-server.js":["/imports/demo.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/stats-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var allowDemo;module.import("/imports/demo.js",{"allowDemo":function(v){allowDemo=v}});// Sandstorm - Personal Cloud Sandbox
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var DAY_MS = 24 * 60 * 60 * 1000;                                                                                      // 19
                                                                                                                       //
if (Mongo.Collection.prototype.aggregate) {                                                                            // 21
  throw new Error("Looks like Meteor wrapped the Collection.aggregate() call. Make sure it " + "works then delete our own wrapper.");
}                                                                                                                      // 24
                                                                                                                       //
Mongo.Collection.prototype.aggregate = function () {                                                                   // 26
  // Meteor doesn't wrapp Mongo's aggregate() method.                                                                  //
  var raw = this.rawCollection();                                                                                      // 28
  return Meteor.wrapAsync(raw.aggregate, raw).apply(raw, arguments);                                                   // 29
};                                                                                                                     // 30
                                                                                                                       //
computeStats = function computeStats(since) {                                                                          // 32
  // We'll need this for a variety of queries.                                                                         //
  var timeConstraint = { $gt: since };                                                                                 // 34
                                                                                                                       //
  // This calculates the number of user accounts that have been used                                                   //
  // during the requested time period.                                                                                 //
  var currentlyActiveUsersCount = Meteor.users.find({                                                                  // 38
    expires: { $exists: false },                                                                                       // 39
    loginIdentities: { $exists: true },                                                                                // 40
    lastActive: timeConstraint                                                                                         // 41
  }).count();                                                                                                          // 38
                                                                                                                       //
  // This calculates the number of grains that have been used during                                                   //
  // the requested time period.                                                                                        //
  var activeGrainsCount = Grains.find({ lastUsed: timeConstraint }).count();                                           // 46
                                                                                                                       //
  // If Meteor.settings.allowDemoAccounts is true, DeleteStats                                                         //
  // contains records of type `user` and `appDemoUser`, indicating                                                     //
  // the number of those types of accounts that were created and                                                       //
  // then auto-expired through the demo mode's auto-account-expiry.                                                    //
  var deletedDemoUsersCount = DeleteStats.find({ type: "demoUser", lastActive: timeConstraint }).count();              // 52
  var deletedAppDemoUsersCount = DeleteStats.find({ type: "appDemoUser", lastActive: timeConstraint }).count();        // 54
                                                                                                                       //
  // Similarly, if the demo is enabled, we auto-delete grains; we store that                                           //
  // fact in DeleteStats with type: "grain".                                                                           //
  var deletedGrainsCount = DeleteStats.find({ type: "grain", lastActive: timeConstraint }).count();                    // 59
                                                                                                                       //
  var apps = Grains.aggregate([{ $match: { lastUsed: timeConstraint } }, {                                             // 62
    $group: {                                                                                                          // 65
      _id: "$appId",                                                                                                   // 66
      grains: { $sum: 1 },                                                                                             // 67
      userIds: { $addToSet: "$userId" }                                                                                // 68
    }                                                                                                                  // 65
  }, {                                                                                                                 // 64
    $project: {                                                                                                        // 72
      grains: 1,                                                                                                       // 73
      owners: { $size: "$userIds" }                                                                                    // 74
    }                                                                                                                  // 72
  }]);                                                                                                                 // 71
  apps = _.indexBy(apps, "_id");                                                                                       // 78
                                                                                                                       //
  for (var appId in apps) {                                                                                            // 80
    // We need to count ApiTokens, which don't have appId denormalized into them. We therefore                         //
    // have to fetch a list of grainIds first.                                                                         //
    // TODO(perf): If stats are getting slow, denormalize appId into ApiTokens. Note that it is                        //
    //   already denormalized for the specific case of apps that don't have icons, but the data                        //
    //   for that use case is NOT safe to use here because it's intended that we might allow an                        //
    //   app to mimic another app's icon by spoofing that app ID. In other words, the existing                         //
    //   denormalization of appId should be considered "app ID for identicon purposes only". We'll                     //
    //   need to add a new denormalization for stats purposes -- and make sure that it is not                          //
    //   revealed to the user.                                                                                         //
    var app = apps[appId];                                                                                             // 90
    delete app._id;                                                                                                    // 91
    var grains = Grains.find({                                                                                         // 92
      lastUsed: timeConstraint,                                                                                        // 93
      appId: appId                                                                                                     // 94
    }, {                                                                                                               // 92
      fields: { _id: 1 }                                                                                               // 96
    }).fetch();                                                                                                        // 95
    var grainIds = _.pluck(grains, "_id");                                                                             // 98
                                                                                                                       //
    var counts = ApiTokens.aggregate([{                                                                                // 100
      $match: {                                                                                                        // 102
        "owner.user": { $exists: true },                                                                               // 103
        lastUsed: timeConstraint,                                                                                      // 104
        grainId: { $in: grainIds }                                                                                     // 105
      }                                                                                                                // 102
    }, { $group: { _id: "$owner.user.identityId" } }, {                                                                // 101
      $group: {                                                                                                        // 110
        _id: "count",                                                                                                  // 111
        count: { $sum: 1 }                                                                                             // 112
      }                                                                                                                // 110
    }]);                                                                                                               // 109
                                                                                                                       //
    if (counts.length > 0) {                                                                                           // 117
      if (counts.length !== 1) {                                                                                       // 118
        console.error("error: sharedUsers aggregation returned multiple rows");                                        // 119
      }                                                                                                                // 120
                                                                                                                       //
      app.sharedUsers = counts[0].count;                                                                               // 122
    }                                                                                                                  // 123
  }                                                                                                                    // 124
                                                                                                                       //
  // Count per-app appdemo users and deleted grains.                                                                   //
  DeleteStats.aggregate([{                                                                                             // 127
    $match: {                                                                                                          // 129
      lastActive: timeConstraint,                                                                                      // 130
      appId: { $exists: true }                                                                                         // 131
    }                                                                                                                  // 129
  }, {                                                                                                                 // 128
    $group: {                                                                                                          // 135
      _id: {                                                                                                           // 136
        appId: "$appId",                                                                                               // 137
        type: "$type"                                                                                                  // 138
      },                                                                                                               // 136
      count: { $sum: 1 }                                                                                               // 140
    }                                                                                                                  // 135
  }]).forEach(function (deletion) {                                                                                    // 134
    var app = apps[deletion._id.appId];                                                                                // 144
    if (!app) {                                                                                                        // 145
      app = apps[deletion.appId] = {};                                                                                 // 146
    }                                                                                                                  // 147
                                                                                                                       //
    if (deletion._id.type === "appDemoUser") {                                                                         // 149
      app.appDemoUsers = deletion.count;                                                                               // 150
    } else if (deletion._id.type === "grain") {                                                                        // 151
      app.deleted = deletion.count;                                                                                    // 152
    } else if (deletion._id.type === "demoGrain") {                                                                    // 153
      app.demoed = deletion.count;                                                                                     // 154
    }                                                                                                                  // 155
  });                                                                                                                  // 156
                                                                                                                       //
  return {                                                                                                             // 158
    activeUsers: currentlyActiveUsersCount,                                                                            // 159
    demoUsers: deletedDemoUsersCount,                                                                                  // 160
    appDemoUsers: deletedAppDemoUsersCount,                                                                            // 161
    activeGrains: activeGrainsCount + deletedGrainsCount,                                                              // 162
    apps: apps                                                                                                         // 163
  };                                                                                                                   // 158
};                                                                                                                     // 165
                                                                                                                       //
function recordStats() {                                                                                               // 167
  var now = new Date();                                                                                                // 168
                                                                                                                       //
  var planStats = _.countBy(Meteor.users.find({ expires: { $exists: false }, "payments.id": { $exists: true } }, { fields: { plan: 1 } }).fetch(), "plan");
                                                                                                                       //
  var record = {                                                                                                       // 176
    timestamp: now,                                                                                                    // 177
    daily: computeStats(new Date(now.getTime() - DAY_MS)),                                                             // 178
    weekly: computeStats(new Date(now.getTime() - 7 * DAY_MS)),                                                        // 179
    monthly: computeStats(new Date(now.getTime() - 30 * DAY_MS)),                                                      // 180
    forever: computeStats(new Date(0)),                                                                                // 181
    plans: planStats                                                                                                   // 182
  };                                                                                                                   // 176
  record.computeTime = Date.now() - now;                                                                               // 184
                                                                                                                       //
  ActivityStats.insert(record);                                                                                        // 186
  var age = ActivityStats.find().count();                                                                              // 187
  if (age > 3) {                                                                                                       // 188
    var reportSetting = Settings.findOne({ _id: "reportStats" });                                                      // 189
    if (!reportSetting) {                                                                                              // 190
      // Setting not set yet, send out notifications and set it to false                                               //
      globalDb.sendAdminNotification("You can help Sandstorm by sending us some anonymous " + "usage stats. Click here for more info.", "/admin/stats");
      Settings.insert({ _id: "reportStats", value: "unset" });                                                         // 194
    } else if (reportSetting.value === true) {                                                                         // 195
      // The stats page which the user agreed we can send actually displays the whole history                          //
      // of the server, but we're only sending stats from the last day. Let's also throw in the                        //
      // length of said history. This is still strictly less information than what the user said                       //
      // we're allowed to send.                                                                                        //
      record.serverAge = age;                                                                                          // 200
                                                                                                                       //
      HTTP.post("https://alpha-api.sandstorm.io/data", {                                                               // 202
        data: record,                                                                                                  // 203
        headers: {                                                                                                     // 204
          Authorization: "Bearer aT-mGyNwsgwZBbZvd5FWr0Ma79O9IehI4NiEO94y_oR",                                         // 205
          "Content-Type": "application/json"                                                                           // 206
        }                                                                                                              // 204
      });                                                                                                              // 202
    }                                                                                                                  // 209
  }                                                                                                                    // 210
}                                                                                                                      // 211
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 213
  // Wait until 10:00 UTC (2:00 PST / 5:00 EST), then start recording stats every 24 hours.                            //
  // (Only on the first replica to avoid conflicts.)                                                                   //
  Meteor.setTimeout(function () {                                                                                      // 216
    Meteor.setInterval(function () {                                                                                   // 217
      recordStats();                                                                                                   // 218
    }, DAY_MS);                                                                                                        // 219
                                                                                                                       //
    recordStats();                                                                                                     // 221
  }, DAY_MS - (Date.now() - 10 * 60 * 60 * 1000) % DAY_MS);                                                            // 222
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 224
    if (StatsTokens.find().count() === 0) {                                                                            // 225
      StatsTokens.remove({});                                                                                          // 226
      StatsTokens.insert({ _id: Random.id(22) });                                                                      // 227
    }                                                                                                                  // 228
  });                                                                                                                  // 229
}                                                                                                                      // 230
                                                                                                                       //
Meteor.methods({                                                                                                       // 232
  regenerateStatsToken: function regenerateStatsToken() {                                                              // 233
    if (!isAdmin()) {                                                                                                  // 234
      throw new Meteor.Error(403, "Unauthorized", "User must be admin");                                               // 235
    }                                                                                                                  // 236
                                                                                                                       //
    StatsTokens.remove({});                                                                                            // 238
    var token = StatsTokens.insert({ _id: Random.id(22) });                                                            // 239
    return token._id;                                                                                                  // 240
  }                                                                                                                    // 241
});                                                                                                                    // 232
                                                                                                                       //
Router.map(function () {                                                                                               // 244
  this.route("fetchStats", {                                                                                           // 245
    where: "server",                                                                                                   // 246
    path: "/fetchStats/:tokenId",                                                                                      // 247
    action: function action() {                                                                                        // 248
      var token = StatsTokens.findOne({ _id: this.params.tokenId });                                                   // 249
                                                                                                                       //
      if (!token) {                                                                                                    // 251
        this.response.writeHead(404, {                                                                                 // 252
          "Content-Type": "text/plain"                                                                                 // 253
        });                                                                                                            // 252
        this.response.write("Token not found");                                                                        // 255
        return this.response.end();                                                                                    // 256
      }                                                                                                                // 257
                                                                                                                       //
      try {                                                                                                            // 259
        var stats = ActivityStats.find().fetch();                                                                      // 260
        var statsString = JSON.stringify(stats);                                                                       // 261
                                                                                                                       //
        this.response.writeHead(200, {                                                                                 // 263
          "Content-Type": "application/json"                                                                           // 264
        });                                                                                                            // 263
        this.response.write(statsString);                                                                              // 266
      } catch (error) {                                                                                                // 267
        console.error(error.stack);                                                                                    // 268
        this.response.writeHead(500, {                                                                                 // 269
          "Content-Type": "text/plain"                                                                                 // 270
        });                                                                                                            // 269
        this.response.write(error.stack);                                                                              // 272
      }                                                                                                                // 273
                                                                                                                       //
      return this.response.end();                                                                                      // 275
    }                                                                                                                  // 276
  });                                                                                                                  // 245
});                                                                                                                    // 278
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"imports":{"server":{"accounts":{"saml-utils.js":["crypto","querystring","url","xml2js","xmlbuilder","xml-crypto","xmldom","zlib",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/accounts/saml-utils.js                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({SAML:function(){return SAML}});var crypto;module.import("crypto",{"default":function(v){crypto=v}});var querystring;module.import("querystring",{"default":function(v){querystring=v}});var Url;module.import("url",{"default":function(v){Url=v}});var xml2js;module.import("xml2js",{"default":function(v){xml2js=v}});var xmlbuilder;module.import("xmlbuilder",{"default":function(v){xmlbuilder=v}});var xmlCrypto;module.import("xml-crypto",{"default":function(v){xmlCrypto=v}});var xmldom;module.import("xmldom",{"default":function(v){xmldom=v}});var zlib;module.import("zlib",{"default":function(v){zlib=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       // 5
                                                                                                                       // 6
                                                                                                                       // 7
                                                                                                                       // 8
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 10
                                                                                                                       //
var SAML = function SAML(options) {                                                                                    // 12
  this.options = this.initialize(options);                                                                             // 13
};                                                                                                                     // 14
                                                                                                                       //
SAML.prototype.initialize = function (options) {                                                                       // 16
  if (!options) {                                                                                                      // 17
    options = {};                                                                                                      // 18
  }                                                                                                                    // 19
                                                                                                                       //
  if (!options.protocol) {                                                                                             // 21
    options.protocol = "https://";                                                                                     // 22
  }                                                                                                                    // 23
                                                                                                                       //
  if (!options.path) {                                                                                                 // 25
    options.path = "/saml/consume";                                                                                    // 26
  }                                                                                                                    // 27
                                                                                                                       //
  if (!options.issuer) {                                                                                               // 29
    options.issuer = "onelogin_saml";                                                                                  // 30
  }                                                                                                                    // 31
                                                                                                                       //
  if (options.identifierFormat === undefined) {                                                                        // 33
    options.identifierFormat = "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent";                                 // 34
  }                                                                                                                    // 35
                                                                                                                       //
  return options;                                                                                                      // 37
};                                                                                                                     // 38
                                                                                                                       //
SAML.prototype.generateUniqueID = function () {                                                                        // 40
  var chars = "abcdef0123456789";                                                                                      // 41
  var uniqueID = "";                                                                                                   // 42
  for (var i = 0; i < 20; i++) {                                                                                       // 43
    uniqueID += chars.substr(Math.floor(Math.random() * 15), 1);                                                       // 44
  }                                                                                                                    // 45
                                                                                                                       //
  return uniqueID;                                                                                                     // 47
};                                                                                                                     // 48
                                                                                                                       //
SAML.prototype.generateInstant = function () {                                                                         // 50
  var date = new Date();                                                                                               // 51
  return date.getUTCFullYear() + "-" + ("0" + (date.getUTCMonth() + 1)).slice(-2) + "-" + ("0" + date.getUTCDate()).slice(-2) + "T" + ("0" + date.getUTCHours()).slice(-2) + ":" + ("0" + date.getUTCMinutes()).slice(-2) + ":" + ("0" + date.getUTCSeconds()).slice(-2) + "Z";
};                                                                                                                     // 53
                                                                                                                       //
SAML.prototype.signRequest = function (xml) {                                                                          // 55
  var signer = crypto.createSign("RSA-SHA1");                                                                          // 56
  signer.update(xml);                                                                                                  // 57
  return signer.sign(this.options.privateCert, "base64");                                                              // 58
};                                                                                                                     // 59
                                                                                                                       //
SAML.prototype.generateAuthorizeRequest = function (req) {                                                             // 61
  var id = "_" + this.generateUniqueID();                                                                              // 62
  var instant = this.generateInstant();                                                                                // 63
                                                                                                                       //
  var callbackUrl = void 0;                                                                                            // 65
  // Post-auth destination                                                                                             //
  if (this.options.callbackUrl) {                                                                                      // 67
    callbackUrl = this.options.callbackUrl;                                                                            // 68
  } else {                                                                                                             // 69
    callbackUrl = this.options.protocol + req.headers.host + this.options.path;                                        // 70
  }                                                                                                                    // 71
                                                                                                                       //
  if (this.options.id) id = this.options.id;                                                                           // 73
                                                                                                                       //
  var request = "<samlp:AuthnRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" ProtocolBinding=\"urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST\" AssertionConsumerServiceURL=\"" + callbackUrl + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>\n";
                                                                                                                       //
  if (this.options.identifierFormat) {                                                                                 // 82
    request += "<samlp:NameIDPolicy xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Format=\"" + this.options.identifierFormat + "\" AllowCreate=\"true\"></samlp:NameIDPolicy>\n";
  }                                                                                                                    // 85
                                                                                                                       //
  request += "<samlp:RequestedAuthnContext xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" Comparison=\"exact\">" + "<saml:AuthnContextClassRef xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" + "</saml:AuthnContextClassRef>" + "</samlp:RequestedAuthnContext>\n" + "</samlp:AuthnRequest>";
                                                                                                                       //
  return request;                                                                                                      // 95
};                                                                                                                     // 96
                                                                                                                       //
SAML.prototype.generateLogoutRequest = function (req) {                                                                // 98
  var id = "_" + this.generateUniqueID();                                                                              // 99
  var instant = this.generateInstant();                                                                                // 100
                                                                                                                       //
  //samlp:LogoutRequest xmlns:samlp="urn:oasis:names:tc:SAML:2.0:protocol" xmlns:saml="urn:oasis:names:tc:SAML:2.0:assertion"
  // ID="_135ad2fd-b275-4428-b5d6-3ac3361c3a7f" Version="2.0" Destination="https://idphost/adfs/ls/"                   //
  //IssueInstant="2008-06-03T12:59:57Z"><saml:Issuer>myhost</saml:Issuer><NameID Format="urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress"
  //NameQualifier="https://idphost/adfs/ls/">myemail@mydomain.com</NameID<samlp:SessionIndex>_0628125f-7f95-42cc-ad8e-fde86ae90bbe
  //</samlp:SessionIndex></samlp:LogoutRequest>                                                                        //
                                                                                                                       //
  var request = "<samlp:LogoutRequest xmlns:samlp=\"urn:oasis:names:tc:SAML:2.0:protocol\" " + "xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\" ID=\"" + id + "\" Version=\"2.0\" IssueInstant=\"" + instant + "\" Destination=\"" + this.options.entryPoint + "\">" + "<saml:Issuer xmlns:saml=\"urn:oasis:names:tc:SAML:2.0:assertion\">" + this.options.issuer + "</saml:Issuer>" + "<saml:NameID Format=\"" + req.user.nameIDFormat + "\">" + req.user.nameID + "</saml:NameID>" + "</samlp:LogoutRequest>";
  return request;                                                                                                      // 114
};                                                                                                                     // 115
                                                                                                                       //
SAML.prototype.requestToUrl = function (request, operation, callback) {                                                // 117
  var _this = this;                                                                                                    // 118
  zlib.deflateRaw(request, function (err, buffer) {                                                                    // 119
    if (err) {                                                                                                         // 120
      return callback(err);                                                                                            // 121
    }                                                                                                                  // 122
                                                                                                                       //
    var base64 = buffer.toString("base64");                                                                            // 124
    var target = _this.options.entryPoint;                                                                             // 125
                                                                                                                       //
    if (operation === "logout") {                                                                                      // 127
      if (_this.options.logoutUrl) {                                                                                   // 128
        target = _this.options.logoutUrl;                                                                              // 129
      }                                                                                                                // 130
    }                                                                                                                  // 131
                                                                                                                       //
    if (target.indexOf("?") > 0) target += "&";else target += "?";                                                     // 133
                                                                                                                       //
    var samlRequest = {                                                                                                // 138
      SAMLRequest: base64                                                                                              // 139
    };                                                                                                                 // 138
                                                                                                                       //
    if (_this.options.privateCert) {                                                                                   // 142
      samlRequest.SigAlg = "http://www.w3.org/2000/09/xmldsig#rsa-sha1";                                               // 143
      samlRequest.Signature = _this.signRequest(querystring.stringify(samlRequest));                                   // 144
    }                                                                                                                  // 145
                                                                                                                       //
    target += querystring.stringify(samlRequest);                                                                      // 147
                                                                                                                       //
    callback(null, target);                                                                                            // 149
  });                                                                                                                  // 150
};                                                                                                                     // 151
                                                                                                                       //
SAML.prototype.getAuthorizeUrl = function (req, callback) {                                                            // 153
  var request = this.generateAuthorizeRequest(req);                                                                    // 154
                                                                                                                       //
  this.requestToUrl(request, "authorize", callback);                                                                   // 156
};                                                                                                                     // 157
                                                                                                                       //
SAML.prototype.getLogoutUrl = function (req, callback) {                                                               // 159
  var request = this.generateLogoutRequest(req);                                                                       // 160
                                                                                                                       //
  this.requestToUrl(request, "logout", callback);                                                                      // 162
};                                                                                                                     // 163
                                                                                                                       //
SAML.prototype.certToPEM = function (cert) {                                                                           // 165
  cert = cert.match(/.{1,64}/g).join("\n");                                                                            // 166
  cert = "-----BEGIN CERTIFICATE-----\n" + cert;                                                                       // 167
  cert = cert + "\n-----END CERTIFICATE-----\n";                                                                       // 168
  return cert;                                                                                                         // 169
};                                                                                                                     // 170
                                                                                                                       //
SAML.prototype.validateSignature = function (xml, cert) {                                                              // 172
  var _this = this;                                                                                                    // 173
  var doc = new xmldom.DOMParser().parseFromString(xml);                                                               // 174
  var signature = xmlCrypto.xpath(doc, "//*[local-name(.)='Signature' and namespace-uri(.)='http://www.w3.org/2000/09/xmldsig#']")[0];
  var sig = new xmlCrypto.SignedXml();                                                                                 // 176
  sig.keyInfoProvider = {                                                                                              // 177
    getKeyInfo: function getKeyInfo(key) {                                                                             // 178
      return "<X509Data></X509Data>";                                                                                  // 179
    },                                                                                                                 // 180
                                                                                                                       //
    getKey: function getKey(keyInfo) {                                                                                 // 182
      return _this.certToPEM(cert);                                                                                    // 183
    }                                                                                                                  // 184
  };                                                                                                                   // 177
  sig.loadSignature(signature.toString());                                                                             // 186
  return sig.checkSignature(xml);                                                                                      // 187
};                                                                                                                     // 188
                                                                                                                       //
SAML.prototype.getElement = function (parentElement, elementName) {                                                    // 190
  if (parentElement["saml:" + elementName]) {                                                                          // 191
    return parentElement["saml:" + elementName];                                                                       // 192
  } else if (parentElement["samlp:" + elementName]) {                                                                  // 193
    return parentElement["samlp:" + elementName];                                                                      // 194
  } else if (parentElement["saml2p:" + elementName]) {                                                                 // 195
    return parentElement["saml2p:" + elementName];                                                                     // 196
  } else if (parentElement["saml2:" + elementName]) {                                                                  // 197
    return parentElement["saml2:" + elementName];                                                                      // 198
  }                                                                                                                    // 199
                                                                                                                       //
  return parentElement[elementName];                                                                                   // 201
};                                                                                                                     // 202
                                                                                                                       //
SAML.prototype.validateResponse = function (samlResponse, callback) {                                                  // 204
  var _this = this;                                                                                                    // 205
  var xml = new Buffer(samlResponse, "base64").toString("utf8");                                                       // 206
  var parser = new xml2js.Parser({ explicitRoot: true });                                                              // 207
  parser.parseString(xml, function (err, doc) {                                                                        // 208
    // Verify signature                                                                                                //
    if (_this.options.cert && !_this.validateSignature(xml, _this.options.cert)) {                                     // 210
      return callback(new Error("Invalid signature"), null, false);                                                    // 211
    }                                                                                                                  // 212
                                                                                                                       //
    var response = _this.getElement(doc, "Response");                                                                  // 214
    if (response) {                                                                                                    // 215
      var assertion = _this.getElement(response, "Assertion");                                                         // 216
      if (!assertion) {                                                                                                // 217
        return callback(new Error("Missing SAML assertion"), null, false);                                             // 218
      }                                                                                                                // 219
                                                                                                                       //
      profile = {};                                                                                                    // 221
                                                                                                                       //
      if (response.$ && response.$.InResponseTo) {                                                                     // 223
        profile.inResponseToId = response.$.InResponseTo;                                                              // 224
      }                                                                                                                // 225
                                                                                                                       //
      if (response.$ && response.$.Destination) {                                                                      // 227
        if (!response.$.Destination.startsWith(process.env.ROOT_URL)) {                                                // 228
          return callback(new Error("SAML Response received with invalid Destination: " + response.$.Destination));    // 229
        }                                                                                                              // 231
      }                                                                                                                // 232
                                                                                                                       //
      var issuer = _this.getElement(assertion[0], "Issuer");                                                           // 234
      if (issuer) {                                                                                                    // 235
        profile.issuer = issuer[0];                                                                                    // 236
      }                                                                                                                // 237
                                                                                                                       //
      var subject = _this.getElement(assertion[0], "Subject");                                                         // 239
      if (subject) {                                                                                                   // 240
        var nameID = _this.getElement(subject[0], "NameID");                                                           // 241
        if (nameID) {                                                                                                  // 242
          profile.nameID = nameID[0]._;                                                                                // 243
                                                                                                                       //
          if (nameID[0].$.Format) {                                                                                    // 245
            profile.nameIDFormat = nameID[0].$.Format;                                                                 // 246
            if (profile.nameIDFormat.toLowerCase().indexOf("transient") !== -1) {                                      // 247
              return callback(new Error("SAML returned a transient NameID. Sandstorm requires a persistent NameID. " + "Please check your IdP config."));
            }                                                                                                          // 251
          }                                                                                                            // 252
        }                                                                                                              // 253
                                                                                                                       //
        var subjectConfirmation = _this.getElement(subject[0], "SubjectConfirmation");                                 // 255
        if (subjectConfirmation) {                                                                                     // 256
          var subjectConfirmationData = _this.getElement(subjectConfirmation[0], "SubjectConfirmationData")[0];        // 257
          if (subjectConfirmationData) {                                                                               // 259
            var recipient = subjectConfirmationData.$.Recipient;                                                       // 260
            if (recipient && !recipient.startsWith(process.env.ROOT_URL)) {                                            // 261
              return callback(new Error("SAML sent to wrong recipient"));                                              // 262
            }                                                                                                          // 263
                                                                                                                       //
            var nowMs = Date.now();                                                                                    // 265
            var notBefore = subjectConfirmationData.$.NotBefore;                                                       // 266
            if (notBefore && nowMs < Date.parse(notBefore)) {                                                          // 267
              return callback(new Error("SAML assertion was signed for the future."));                                 // 268
            }                                                                                                          // 269
                                                                                                                       //
            var notOnOrAfter = subjectConfirmationData.$.NotOnOrAfter;                                                 // 271
            if (notOnOrAfter && nowMs >= Date.parse(notOnOrAfter)) {                                                   // 272
              return callback(new Error("SAML assertion was signed for the past."));                                   // 273
            }                                                                                                          // 274
          }                                                                                                            // 275
        }                                                                                                              // 276
      }                                                                                                                // 277
                                                                                                                       //
      var conditions = _this.getElement(assertion[0], "Conditions")[0];                                                // 279
      if (conditions) {                                                                                                // 280
        for (var key in conditions) {                                                                                  // 281
          if (conditions.hasOwnProperty(key)) {                                                                        // 282
            var value = conditions[key];                                                                               // 283
            if (key === "$") {                                                                                         // 284
              var _nowMs = Date.now();                                                                                 // 285
              var _notBefore = value.NotBefore;                                                                        // 286
              if (_notBefore && _nowMs < Date.parse(_notBefore)) {                                                     // 287
                return callback(new Error("SAML condition NotBefore is in the future."));                              // 288
              }                                                                                                        // 289
                                                                                                                       //
              var _notOnOrAfter = value.NotOnOrAfter;                                                                  // 291
              if (_notOnOrAfter && _nowMs >= Date.parse(_notOnOrAfter)) {                                              // 292
                return callback(new Error("SAML condition notOnOrAfter is in the past."));                             // 293
              }                                                                                                        // 294
            } else if (key.endsWith("AudienceRestriction") || key.endsWith("OneTimeUse") || key.endsWith("ProxyRestriction")) {
              continue;                                                                                                // 298
              // Do nothing.                                                                                           //
              // We already check both Destination and SubjectConfirmation.Recipient, so                               //
              // the Audience constraint isn't as important, and is tricky to handle                                   //
              // correctly.                                                                                            //
              // OneTimeUse is actually very tricky to get right, and requires a cache of                              //
              // previously seen assertions (or at least their hashes). In Sandstorm's case,                           //
              // we would probably need to stuff it in Mongo to make it robust across multiple                         //
              // front-ends. It is a very rarely used constraint anyways.                                              //
              // ProxyRestriction constraints only govern the future use of the assertion by the                       //
              // SP. We don't fall under this constraint so it's meaningless to us. As per the                         //
              // spec, it is always considered valid.                                                                  //
            } else {                                                                                                   // 310
                return callback(new Error("Unrecognized SAML constraint: " + key));                                    // 311
              }                                                                                                        // 312
          }                                                                                                            // 313
        }                                                                                                              // 314
      }                                                                                                                // 315
                                                                                                                       //
      var attributeStatement = _this.getElement(assertion[0], "AttributeStatement");                                   // 317
      if (attributeStatement) {                                                                                        // 318
        var attributes = _this.getElement(attributeStatement[0], "Attribute");                                         // 319
                                                                                                                       //
        if (attributes) {                                                                                              // 321
          attributes.forEach(function (attribute) {                                                                    // 322
            var value = _this.getElement(attribute, "AttributeValue");                                                 // 323
            if (typeof value[0] === "string") {                                                                        // 324
              profile[attribute.$.Name] = value[0];                                                                    // 325
            } else {                                                                                                   // 326
              profile[attribute.$.Name] = value[0]._;                                                                  // 327
            }                                                                                                          // 328
          });                                                                                                          // 329
        }                                                                                                              // 330
                                                                                                                       //
        if (!profile.mail && profile["urn:oid:0.9.2342.19200300.100.1.3"]) {                                           // 332
          // See http://www.incommonfederation.org/attributesummary.html for definition of attribute OIDs              //
          profile.mail = profile["urn:oid:0.9.2342.19200300.100.1.3"];                                                 // 334
        }                                                                                                              // 335
                                                                                                                       //
        if (!profile.email && profile.mail) {                                                                          // 337
          profile.email = profile.mail;                                                                                // 338
        }                                                                                                              // 339
                                                                                                                       //
        var microsoftEmail = profile["http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress"];            // 341
        if (!profile.email && microsoftEmail) {                                                                        // 342
          profile.email = microsoftEmail;                                                                              // 343
        }                                                                                                              // 344
                                                                                                                       //
        var microsoftDisplayName = profile["http://schemas.microsoft.com/identity/claims/displayname"];                // 346
        if (!profile.displayName && microsoftDisplayName) {                                                            // 347
          profile.displayName = microsoftDisplayName;                                                                  // 348
        }                                                                                                              // 349
      }                                                                                                                // 350
                                                                                                                       //
      if (!profile.email && profile.nameID && profile.nameIDFormat && profile.nameIDFormat.indexOf("emailAddress") >= 0) {
        profile.email = profile.nameID;                                                                                // 353
      }                                                                                                                // 354
                                                                                                                       //
      callback(null, profile, false);                                                                                  // 356
    } else {                                                                                                           // 357
      var logoutResponse = _this.getElement(doc, "LogoutResponse");                                                    // 358
                                                                                                                       //
      if (logoutResponse) {                                                                                            // 360
        callback(null, null, true);                                                                                    // 361
      } else {                                                                                                         // 362
        return callback(new Error("Unknown SAML response message"), null, false);                                      // 363
      }                                                                                                                // 364
    }                                                                                                                  // 366
  });                                                                                                                  // 368
};                                                                                                                     // 369
                                                                                                                       //
SAML.prototype.generateServiceProviderMetadata = function () {                                                         // 371
  var entityId = this.options.issuer;                                                                                  // 372
  var metadata = {                                                                                                     // 373
    "EntityDescriptor": {                                                                                              // 374
      "@xmlns": "urn:oasis:names:tc:SAML:2.0:metadata",                                                                // 375
      "@xmlns:ds": "http://www.w3.org/2000/09/xmldsig#",                                                               // 376
      "@entityID": entityId,                                                                                           // 377
      "@ID": entityId.replace(/\W/g, "_"),                                                                             // 378
      "SPSSODescriptor": {                                                                                             // 379
        "@protocolSupportEnumeration": "urn:oasis:names:tc:SAML:2.0:protocol"                                          // 380
      }                                                                                                                // 379
    }                                                                                                                  // 374
  };                                                                                                                   // 373
                                                                                                                       //
  var decryptionCert = this.options.localCertPublic; // TODO(someday); support local certs                             // 385
  if (decryptionCert) {                                                                                                // 386
    decryptionCert = decryptionCert.replace(/-+BEGIN CERTIFICATE-+\r?\n?/, "");                                        // 387
    decryptionCert = decryptionCert.replace(/-+END CERTIFICATE-+\r?\n?/, "");                                          // 388
    decryptionCert = decryptionCert.replace(/\r\n/g, "\n");                                                            // 389
                                                                                                                       //
    metadata.EntityDescriptor.SPSSODescriptor.KeyDescriptor = {                                                        // 391
      "ds:KeyInfo": {                                                                                                  // 392
        "ds:X509Data": {                                                                                               // 393
          "ds:X509Certificate": {                                                                                      // 394
            "#text": decryptionCert                                                                                    // 395
          }                                                                                                            // 394
        }                                                                                                              // 393
      },                                                                                                               // 392
      "EncryptionMethod": [                                                                                            // 399
      // this should be the set that the xmlenc library supports                                                       //
      { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes256-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#aes128-cbc" }, { "@Algorithm": "http://www.w3.org/2001/04/xmlenc#tripledes-cbc" }]
    };                                                                                                                 // 391
  }                                                                                                                    // 406
                                                                                                                       //
  if (this.options.logoutCallbackUrl) {                                                                                // 408
    metadata.EntityDescriptor.SPSSODescriptor.SingleLogoutService = {                                                  // 409
      "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                    // 410
      "@Location": this.options.logoutCallbackUrl                                                                      // 411
    };                                                                                                                 // 409
  }                                                                                                                    // 413
                                                                                                                       //
  metadata.EntityDescriptor.SPSSODescriptor.NameIDFormat = this.options.identifierFormat;                              // 415
  metadata.EntityDescriptor.SPSSODescriptor.AssertionConsumerService = {                                               // 416
    "@index": "1",                                                                                                     // 417
    "@isDefault": "true",                                                                                              // 418
    "@Binding": "urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST",                                                      // 419
    "@Location": Meteor.absoluteUrl("_saml/validate/default")                                                          // 420
  };                                                                                                                   // 416
                                                                                                                       //
  return xmlbuilder.create(metadata).end({ pretty: true, indent: "  ", newline: "\n" });                               // 423
};                                                                                                                     // 424
                                                                                                                       //
                                                                                                                       // 426
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"auth.js":["meteor/meteor","meteor/check","crypto","fs",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/auth.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({checkAuth:function(){return checkAuth},clearAdminToken:function(){return clearAdminToken},tokenIsValid:function(){return tokenIsValid},tokenIsSetupSession:function(){return tokenIsSetupSession}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var Match,check;module.import("meteor/check",{"Match":function(v){Match=v},"check":function(v){check=v}});var Crypto;module.import("crypto",{"default":function(v){Crypto=v}});var Fs;module.import("fs",{"default":function(v){Fs=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
// TODO(cleanup): globalDb is still an unbound global, but extracting it is Hard.                                      //
                                                                                                                       //
var ADMIN_TOKEN_EXPIRATION_TIME = 15 * 60 * 1000;                                                                      // 7
var SANDSTORM_ADMIN_TOKEN = SANDSTORM_VARDIR + "/adminToken";                                                          // 8
                                                                                                                       //
function clearAdminToken(token) {                                                                                      // 10
  if (tokenIsSetupSession(token)) {                                                                                    // 11
    var hash = Crypto.createHash("sha256").update(token).digest("base64");                                             // 12
    globalDb.collections.setupSession.remove({                                                                         // 13
      _id: "current-session",                                                                                          // 14
      hashedSessionId: hash                                                                                            // 15
    });                                                                                                                // 13
  }                                                                                                                    // 17
                                                                                                                       //
  if (tokenIsValid(token)) {                                                                                           // 19
    Fs.unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                              // 20
    console.log("Admin token deleted.");                                                                               // 21
  }                                                                                                                    // 22
}                                                                                                                      // 23
                                                                                                                       //
function tokenIsValid(token) {                                                                                         // 25
  if (token && Fs.existsSync(SANDSTORM_ADMIN_TOKEN)) {                                                                 // 26
    var stats = Fs.statSync(SANDSTORM_ADMIN_TOKEN);                                                                    // 27
    var expireTime = new Date(Date.now() - ADMIN_TOKEN_EXPIRATION_TIME);                                               // 28
    if (stats.mtime < expireTime) {                                                                                    // 29
      return false;                                                                                                    // 30
    } else {                                                                                                           // 31
      return Fs.readFileSync(SANDSTORM_ADMIN_TOKEN, { encoding: "utf8" }) === token;                                   // 32
    }                                                                                                                  // 33
  } else {                                                                                                             // 34
    return false;                                                                                                      // 35
  }                                                                                                                    // 36
}                                                                                                                      // 37
                                                                                                                       //
function tokenIsSetupSession(token) {                                                                                  // 39
  if (token) {                                                                                                         // 40
    var setupSession = globalDb.collections.setupSession.findOne({ _id: "current-session" });                          // 41
    if (setupSession) {                                                                                                // 42
      var hash = Crypto.createHash("sha256").update(token).digest("base64");                                           // 43
      var now = new Date();                                                                                            // 44
      var sessionLifetime = 24 * 60 * 60 * 1000; // length of setup session validity, in milliseconds: 1 day           // 45
      if (setupSession.hashedSessionId === hash && now - setupSession.creationDate < sessionLifetime) {                // 46
        return true;                                                                                                   // 47
      }                                                                                                                // 48
    }                                                                                                                  // 49
  }                                                                                                                    // 50
                                                                                                                       //
  return false;                                                                                                        // 52
}                                                                                                                      // 53
                                                                                                                       //
function checkAuth(token) {                                                                                            // 55
  check(token, Match.OneOf(undefined, null, String));                                                                  // 56
  if (!isAdmin() && !tokenIsValid(token) && !tokenIsSetupSession(token)) {                                             // 57
    throw new Meteor.Error(403, "User must be admin or provide a valid token");                                        // 58
  }                                                                                                                    // 59
}                                                                                                                      // 60
                                                                                                                       //
                                                                                                                       // 62
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"email.js":["meteor/meteor","url","simplesmtp","mailcomposer",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/email.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({send:function(){return send},rawSend:function(){return rawSend}});var Meteor;module.import("meteor/meteor",{"Meteor":function(v){Meteor=v}});var urlModule;module.import("url",{"default":function(v){urlModule=v}});var simplesmtp;module.import("simplesmtp",{"default":function(v){simplesmtp=v}});var MailComposer;module.import("mailcomposer",{"MailComposer":function(v){MailComposer=v}});
                                                                                                                       // 2
                                                                                                                       // 3
                                                                                                                       // 4
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 6
                                                                                                                       //
var getSmtpConfig = function getSmtpConfig() {                                                                         // 8
  var config = Settings.findOne({ _id: "smtpConfig" });                                                                // 9
  return config && config.value;                                                                                       // 10
};                                                                                                                     // 11
                                                                                                                       //
var makePool = function makePool(mailConfig) {                                                                         // 13
  var auth = false;                                                                                                    // 14
  if (mailConfig.auth && (mailConfig.auth.user || mailConfig.auth.pass)) {                                             // 15
    auth = mailConfig.auth;                                                                                            // 16
  }                                                                                                                    // 17
                                                                                                                       //
  var pool = simplesmtp.createClientPool(mailConfig.port, mailConfig.hostname, { secureConnection: mailConfig.port === 465,
    // XXX allow maxConnections to be configured?                                                                      //
    auth: auth });                                                                                                     // 24
                                                                                                                       //
  pool._futureWrappedSendMail = _.bind(Future.wrap(pool.sendMail), pool);                                              // 26
  return pool;                                                                                                         // 27
};                                                                                                                     // 28
                                                                                                                       //
// We construct the SMTP pool at the first call to Email.send, so that                                                 //
// other code like migrations can modify the SMTP configuration.                                                       //
var pool = void 0;                                                                                                     // 32
var configured = false;                                                                                                // 33
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 35
  Settings.find({ _id: "smtpConfig" }).observeChanges({                                                                // 36
    removed: function removed() {                                                                                      // 37
      configured = false;                                                                                              // 38
    },                                                                                                                 // 39
                                                                                                                       //
    changed: function changed() {                                                                                      // 41
      configured = false;                                                                                              // 42
    },                                                                                                                 // 43
                                                                                                                       //
    added: function added() {                                                                                          // 45
      configured = false;                                                                                              // 46
    }                                                                                                                  // 47
  });                                                                                                                  // 36
});                                                                                                                    // 49
                                                                                                                       //
var getPool = function getPool(smtpConfig) {                                                                           // 51
  if (smtpConfig) {                                                                                                    // 52
    return makePool(smtpConfig);                                                                                       // 53
  } else if (!configured) {                                                                                            // 54
    configured = true;                                                                                                 // 55
    var config = getSmtpConfig();                                                                                      // 56
    if (config) {                                                                                                      // 57
      pool = makePool(config);                                                                                         // 58
    }                                                                                                                  // 59
  }                                                                                                                    // 60
                                                                                                                       //
  return pool;                                                                                                         // 62
};                                                                                                                     // 63
                                                                                                                       //
var nextDevmodeMailId = 0;                                                                                             // 65
var outputStream = process.stdout;                                                                                     // 66
                                                                                                                       //
var devModeSend = function devModeSend(mc) {                                                                           // 68
  // This seems to be dead code.                                                                                       //
  var devmodeMailId = nextDevmodeMailId++;                                                                             // 70
                                                                                                                       //
  var stream = outputStream;                                                                                           // 72
                                                                                                                       //
  // This approach does not prevent other writers to stdout from interleaving.                                         //
  stream.write("====== BEGIN MAIL #" + devmodeMailId + " ======\n");                                                   // 75
  stream.write("(Mail not sent; to enable sending, set the MAIL_URL " + "environment variable.)\n");                   // 76
  mc.streamMessage();                                                                                                  // 78
  mc.pipe(stream, { end: false });                                                                                     // 79
  var future = new Future();                                                                                           // 80
  mc.on("end", function () {                                                                                           // 81
    stream.write("====== END MAIL #" + devmodeMailId + " ======\n");                                                   // 82
    future["return"]();                                                                                                // 83
  });                                                                                                                  // 84
                                                                                                                       //
  future.wait();                                                                                                       // 86
};                                                                                                                     // 87
                                                                                                                       //
var smtpSend = function smtpSend(pool, mc) {                                                                           // 89
  pool._futureWrappedSendMail(mc).wait();                                                                              // 90
};                                                                                                                     // 91
                                                                                                                       //
/**                                                                                                                    //
 * @summary Sends a raw email with a MailComposer object.                                                              //
 * Throws an `Error` on failure to contact mail server                                                                 //
 * or if mail server returns an error. All fields should match                                                         //
 * [RFC5322](http://tools.ietf.org/html/rfc5322) specification.                                                        //
 * @locus Server                                                                                                       //
 * @param {Object} mc A MailCompser object that you wish to send                                                       //
 * @param {String} smtpUrl SMTP server to use. If falsey, defaults to configured one.                                  //
*/                                                                                                                     //
var rawSend = function rawSend(mc, smtpConfig) {                                                                       // 102
  // SimpleSmtp does not add leading dots, so we need to.                                                              //
  // See http://tools.ietf.org/html/rfc5321#section-4.5.2                                                              //
  mc._message.body = mc._message.body.replace(/(^|\n)\./g, "$1..");                                                    // 105
                                                                                                                       //
  var pool = getPool(smtpConfig);                                                                                      // 107
  if (pool) {                                                                                                          // 108
    smtpSend(pool, mc);                                                                                                // 109
  } else {                                                                                                             // 110
    throw new Error("SMTP pool is misconfigured.");                                                                    // 111
  }                                                                                                                    // 112
};                                                                                                                     // 113
                                                                                                                       //
// Old comment below                                                                                                   //
/**                                                                                                                    //
 * Send an email.                                                                                                      //
 *                                                                                                                     //
 * Connects to the mail server configured via the MAIL_URL environment                                                 //
 * variable. If unset, prints formatted message to stdout. The "from" option                                           //
 * is required, and at least one of "to", "cc", and "bcc" must be provided;                                            //
 * all other options are optional.                                                                                     //
 *                                                                                                                     //
 * @param options                                                                                                      //
 * @param options.from {String} RFC5322 "From:" address                                                                //
 * @param options.to {String|String[]} RFC5322 "To:" address[es]                                                       //
 * @param options.cc {String|String[]} RFC5322 "Cc:" address[es]                                                       //
 * @param options.bcc {String|String[]} RFC5322 "Bcc:" address[es]                                                     //
 * @param options.replyTo {String|String[]} RFC5322 "Reply-To:" address[es]                                            //
 * @param options.subject {String} RFC5322 "Subject:" line                                                             //
 * @param options.text {String} RFC5322 mail body (plain text)                                                         //
 * @param options.html {String} RFC5322 mail body (HTML)                                                               //
 * @param options.headers {Object} custom RFC5322 headers (dictionary)                                                 //
 */                                                                                                                    //
                                                                                                                       //
// New API doc comment below                                                                                           //
/**                                                                                                                    //
 * @summary Send an email. Throws an `Error` on failure to contact mail server                                         //
 * or if mail server returns an error. All fields should match                                                         //
 * [RFC5322](http://tools.ietf.org/html/rfc5322) specification.                                                        //
 * @locus Server                                                                                                       //
 * @param {Object} options                                                                                             //
 * @param {String} options.from "From:" address (required)                                                             //
 * @param {String|String[]} options.to,cc,bcc,replyTo                                                                  //
 *   "To:", "Cc:", "Bcc:", and "Reply-To:" addresses                                                                   //
 * @param {String} [options.subject]  "Subject:" line                                                                  //
 * @param {String} [options.text|html] Mail body (in plain text or HTML)                                               //
 * @param {Object} [options.headers] Dictionary of custom headers                                                      //
 * @param {Object} [options.smtpConfig] SMTP server to use. Otherwise defaults to configured one.                      //
 * @param {String} [options.smtpConfig.hostname] SMTP server hostname.                                                 //
 * @param {Number} [options.smtpConfig.port] SMTP server port.                                                         //
 * @param {Object} [options.smtpConfig.auth] SMTP server authentication tokens.  Optional.                             //
 * @param {String} [options.smtpConfig.auth.user] Username of user to log in to SMTP server as.  Optional.             //
 * @param {String} [options.smtpConfig.auth.pass] Password of user to log in to SMTP server as.  Optional.             //
 * @param {Object} [options.attachments] Attachments. See:                                                             //
 *   https://github.com/nodemailer/mailcomposer/tree/v0.1.15#add-attachments                                           //
 * @param {String} [options.envelopeFrom] Envelope sender.                                                             //
 */                                                                                                                    //
var send = function send(options) {                                                                                    // 159
  var mc = new MailComposer();                                                                                         // 160
                                                                                                                       //
  // setup message data                                                                                                //
  mc.setMessageOption({                                                                                                // 163
    from: options.from,                                                                                                // 164
    to: options.to,                                                                                                    // 165
    cc: options.cc,                                                                                                    // 166
    bcc: options.bcc,                                                                                                  // 167
    replyTo: options.replyTo,                                                                                          // 168
    subject: options.subject,                                                                                          // 169
    text: options.text,                                                                                                // 170
    html: options.html                                                                                                 // 171
  });                                                                                                                  // 163
                                                                                                                       //
  if (options.envelopeFrom) {                                                                                          // 174
    var envelope = mc.getEnvelope();                                                                                   // 175
    envelope.from = options.envelopeFrom;                                                                              // 176
    mc.setMessageOption({                                                                                              // 177
      envelope: envelope                                                                                               // 178
    });                                                                                                                // 177
  }                                                                                                                    // 180
                                                                                                                       //
  _.each(options.headers, function (value, name) {                                                                     // 182
    mc.addHeader(name, value);                                                                                         // 183
  });                                                                                                                  // 184
                                                                                                                       //
  _.each(options.attachments, function (value) {                                                                       // 186
    mc.addAttachment(value);                                                                                           // 187
  });                                                                                                                  // 188
                                                                                                                       //
  rawSend(mc, options.smtpConfig);                                                                                     // 190
};                                                                                                                     // 191
                                                                                                                       //
                                                                                                                       // 193
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"frontend-ref.js":["babel-runtime/helpers/classCallCheck","./persistent.js",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/frontend-ref.js                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({FrontendRefRegistry:function(){return FrontendRefRegistry}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});var checkRequirements;module.import("./persistent.js",{"checkRequirements":function(v){checkRequirements=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
                                                                                                                       // 17
                                                                                                                       //
var FrontendRefRegistry = function () {                                                                                //
  function FrontendRefRegistry() {                                                                                     // 20
    _classCallCheck(this, FrontendRefRegistry);                                                                        // 20
                                                                                                                       //
    this._frontendRefHandlers = {};                                                                                    // 21
    this._typeIdHandlers = {};                                                                                         // 22
  }                                                                                                                    // 23
                                                                                                                       //
  FrontendRefRegistry.prototype.create = function create(db, frontendRef, requirements) {                              //
    // Construct a fresh capability based on a `frontendRef` value.                                                    //
                                                                                                                       //
    checkRequirements(requirements);                                                                                   // 28
                                                                                                                       //
    var saveTemplate = { frontendRef: frontendRef };                                                                   // 30
    if (requirements) {                                                                                                // 31
      saveTemplate.requirements = requirements;                                                                        // 32
    }                                                                                                                  // 33
                                                                                                                       //
    return this.restore(db, saveTemplate, frontendRef);                                                                // 35
  };                                                                                                                   // 36
                                                                                                                       //
  FrontendRefRegistry.prototype.restore = function restore(db, saveTemplate, frontendRef) {                            //
    // Restores a frontendRef capability using the appropriate registered handler.                                     //
                                                                                                                       //
    var keys = Object.keys(frontendRef);                                                                               // 41
    if (keys.length != 1) {                                                                                            // 42
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 43
    }                                                                                                                  // 44
                                                                                                                       //
    var key = keys[0];                                                                                                 // 46
    var handler = this._frontendRefHandlers[key];                                                                      // 47
    if (!handler) {                                                                                                    // 48
      throw new Error("invalid frontendRef: " + JSON.stringify(frontendRef));                                          // 49
    }                                                                                                                  // 50
                                                                                                                       //
    return handler.restore(db, saveTemplate, frontendRef[key]);                                                        // 52
  };                                                                                                                   // 53
                                                                                                                       //
  FrontendRefRegistry.prototype.query = function query(db, userAccountId, tag) {                                       //
    // Performs a powerbox query using the appropriate registered handler.                                             //
                                                                                                                       //
    var handler = this._typeIdHandlers[tag.id];                                                                        // 58
    if (handler) {                                                                                                     // 59
      return handler.query(db, userAccountId, tag.value);                                                              // 60
    } else {                                                                                                           // 61
      return []; // no matches                                                                                         // 62
    }                                                                                                                  // 63
  };                                                                                                                   // 64
                                                                                                                       //
  FrontendRefRegistry.prototype.validate = function validate(db, session, mutableFrontendRef) {                        //
    // Validates a powerbox request on the given `session` (a record from the Sessions table)                          //
    // requesting the creation of the given frontendRef type. `mutableFrontendRef` is expected to                      //
    // come directly from the client; calling validate() verifies that it has a valid type, and                        //
    // may modify the value to add bits that need to be generated server-side. `validate()` also                       //
    // returns an array of MembraneRequirements that shall apply to the capability. These                              //
    // requirements will not yet have been checked, so the caller should check them before                             //
    // proceeding.                                                                                                     //
                                                                                                                       //
    var keys = Object.keys(mutableFrontendRef);                                                                        // 75
    if (keys.length != 1) {                                                                                            // 76
      throw new Error("invalid frontendRef: " + JSON.stringify(mutableFrontendRef));                                   // 77
    }                                                                                                                  // 78
                                                                                                                       //
    var key = keys[0];                                                                                                 // 80
    var handler = this._frontendRefHandlers[key];                                                                      // 81
    if (!handler) {                                                                                                    // 82
      throw new Error("invalid frontendRef: " + JSON.stringify(mutableFrontendRef));                                   // 83
    }                                                                                                                  // 84
                                                                                                                       //
    if (!handler.validate) {                                                                                           // 86
      throw new Error("frontendRef type cannot be created via powerbox: " + JSON.stringify(mutableFrontendRef));       // 87
    }                                                                                                                  // 89
                                                                                                                       //
    return handler.validate(db, session, mutableFrontendRef[key]);                                                     // 91
  };                                                                                                                   // 92
                                                                                                                       //
  FrontendRefRegistry.prototype.register = function register(object) {                                                 //
    // Register callbacks related to a particular frontendRef type. The object has the fields:                         //
    //   `frontendRefField`: Name of the field of `ApiTokens.frontendRef` that is filled in for                        //
    //       this type. Only needed if `create` and/or `validate` handlers are defined.                                //
    //   `typeId`: Type ID of powerbox tags handled by the `query` callback. Stringified decimal                       //
    //       64-bit integer. Only needed if `query` is defined.                                                        //
    //   `restore`: Callback to construct a capability of this type when restoring a saved                             //
    //       capability. Has signature `(db, saveTemplate, value) -> capability`, where:                               //
    //     `value`: The value of the single field of `ApiTokens.frontendRef` for this capability.                      //
    //     `saveTemplate`: The token template to pass to the PersistentImpl constructor.                               //
    //     `capability` (returned): A Cap'n Proto capability implementing SystemPersistent along                       //
    //         with whatever other interfaces are appropriate for the ref type.                                        //
    //   `validate`: Callback to validate a powerbox request for a new capability of this type.                        //
    //       Has signature `(db, session, mutableValue) -> {descriptor, requirements}`, where:                         //
    //     `mutableValue` is the value of the single field of `frontendRef` for this capability.                       //
    //         If this is an object value, the callback may optionally modify it, e.g. adding                          //
    //         additional fields that need to be generated server-side. The callback *must*, at                        //
    //         the very least, type-check this value. It should throw an exception if the vaule is                     //
    //         not valid.                                                                                              //
    //     `session` is the record from the Sessions table of the UI session where the powerbox                        //
    //         request occurred.                                                                                       //
    //     `descriptor` (returned) is the JSON-encoded PowerboxDescriptor for the capability. Note                     //
    //         that if the descriptor contains any `tag.value`s, they of course need to be                             //
    //         presented as capnp-encoded Buffers.                                                                     //
    //     `requirements` (returned) is an array of MembraneRequirements which should apply to the                     //
    //         new capability. Note that these requirements will be checked immediately and the                        //
    //         powerbox request will fail if they aren't met.                                                          //
    //    `query`: Callback to populate options for a powerbox request for this type ID. Has                           //
    //        signature `(db, userAccountId, tagValue) -> options`, where:                                             //
    //      `tagValue`: A Buffer of the Cap'n-Proto-encoded `PowerboxDescriptor.Tag.value`.                            //
    //      `options` (returned): An array of objects representing the options that should be                          //
    //          offered to the user for this query. See the `powerboxOptions` Meteor publish in                        //
    //          powerbox-server.js for a full description of the fields of each option.                                //
                                                                                                                       //
    if (object.frontendRefField) {                                                                                     // 128
      if (object.frontendRefField in this._frontendRefHandlers) {                                                      // 129
        throw new Error("frontendRef handler already registered: " + object.frontendRefField);                         // 130
      }                                                                                                                // 131
                                                                                                                       //
      this._frontendRefHandlers[object.frontendRefField] = object;                                                     // 133
    }                                                                                                                  // 134
                                                                                                                       //
    if (object.typeId) {                                                                                               // 136
      if (object.typeId in this._typeIdHandlers) {                                                                     // 137
        throw new Error("typeId handler already registered: " + object.typeId);                                        // 138
      }                                                                                                                // 139
                                                                                                                       //
      this._typeIdHandlers[object.typeId] = object;                                                                    // 141
    }                                                                                                                  // 142
  };                                                                                                                   // 143
                                                                                                                       //
  return FrontendRefRegistry;                                                                                          //
}();                                                                                                                   //
                                                                                                                       //
                                                                                                                       // 146
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"persistent.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/server/persistent.js                                                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({PersistentImpl:function(){return PersistentImpl},hashSturdyRef:function(){return hashSturdyRef},generateSturdyRef:function(){return generateSturdyRef},checkRequirements:function(){return checkRequirements}});var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
var privateDb = Symbol("PersistentImpl.db");                                                                           // 19
var privateTemplate = Symbol("PersistentImpl.template");                                                               // 20
var privateIsSaved = Symbol("PersistentImpl.isSaved");                                                                 // 21
                                                                                                                       //
var PersistentImpl = function () {                                                                                     //
  function PersistentImpl(db, saveTemplate) {                                                                          // 24
    _classCallCheck(this, PersistentImpl);                                                                             // 24
                                                                                                                       //
    this[privateDb] = db;                                                                                              // 25
    this[privateTemplate] = saveTemplate;                                                                              // 26
                                                                                                                       //
    // TODO(someday): This may or may not be quite right in cases where we're saving a root token                      //
    //   by copy. Is the copy the "same" capability or not? Today, isSaved() is only used by                           //
    //   wakelock notification handles which are not issued through the powerbox, therefore do not                     //
    //   go through claimRequest(), therefore are not saved by copy, so the point is moot.                             //
    this[privateIsSaved] = !!saveTemplate.parentToken;                                                                 // 32
  }                                                                                                                    // 33
                                                                                                                       //
  PersistentImpl.prototype.isSaved = function isSaved() {                                                              //
    // Can be called by subclasses to ask whether or not a record currently exists in the ApiTokens                    //
    // table representing this capability.                                                                             //
                                                                                                                       //
    return this[privateIsSaved];                                                                                       // 39
  };                                                                                                                   // 40
                                                                                                                       //
  PersistentImpl.prototype.save = function save(params) {                                                              //
    var _this = this;                                                                                                  // 42
                                                                                                                       //
    return inMeteor(function () {                                                                                      // 43
      if (!params.sealFor) {                                                                                           // 44
        throw new Error("must specify 'sealFor'");                                                                     // 45
      }                                                                                                                // 46
                                                                                                                       //
      var db = _this[privateDb];                                                                                       // 48
                                                                                                                       //
      var newToken = _.clone(_this[privateTemplate]);                                                                  // 50
      newToken.owner = params.sealFor;                                                                                 // 51
      if (newToken.owner.user) {                                                                                       // 52
        if (!newToken.identityId) {                                                                                    // 53
          throw new Error("can't save non-UiView with user as owner");                                                 // 54
        }                                                                                                              // 55
                                                                                                                       //
        // Only "identityId" and "title" are allowed to be passed to save().                                           //
        var userOwner = _.pick(newToken.owner.user, "identityId", "title");                                            // 58
                                                                                                                       //
        // Fill in denormalizedGrainMetadata and upstreamTitle ourselves.                                              //
        userOwner.denormalizedGrainMetadata = db.getDenormalizedGrainInfo(newToken.grainId);                           // 61
                                                                                                                       //
        var grain = db.getGrain(newToken.grainId);                                                                     // 63
        if (grain && grain.title !== userOwner.title) {                                                                // 64
          userOwner.upstreamTitle = grain.title;                                                                       // 65
        }                                                                                                              // 66
                                                                                                                       //
        newToken.owner.user = userOwner;                                                                               // 68
      }                                                                                                                // 69
                                                                                                                       //
      var sturdyRef = generateSturdyRef();                                                                             // 71
      newToken._id = hashSturdyRef(sturdyRef);                                                                         // 72
                                                                                                                       //
      newToken.created = new Date();                                                                                   // 74
                                                                                                                       //
      db.collections.apiTokens.insert(newToken);                                                                       // 76
      _this[privateIsSaved] = true;                                                                                    // 77
      return { sturdyRef: new Buffer(sturdyRef) };                                                                     // 78
    });                                                                                                                // 79
  };                                                                                                                   // 80
                                                                                                                       //
  // TODO(someday): Implement SystemPersistent.addRequirements().                                                      //
                                                                                                                       //
                                                                                                                       //
  return PersistentImpl;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
function hashSturdyRef(sturdyRef) {                                                                                    // 85
  return Crypto.createHash("sha256").update(sturdyRef).digest("base64");                                               // 86
};                                                                                                                     // 87
                                                                                                                       //
function generateSturdyRef() {                                                                                         // 89
  return Random.secret();                                                                                              // 90
}                                                                                                                      // 91
                                                                                                                       //
function checkRequirements(db, requirements) {                                                                         // 93
  // Checks if the given list of MembraneRequirements are all satisfied, returning true if so and                      //
  // false otherwise.                                                                                                  //
                                                                                                                       //
  // TODO(cleanup): SandstormPermissions has a different way of checking the same requirements.                        //
  //   Reuse?                                                                                                          //
                                                                                                                       //
  // TODO(security): Eventually we want checkRequirements(), when it passes, to produce an observer                    //
  //   that can be used to receive a notification when the requirements may no longer be satisfied,                    //
  //   in order to revoke the live object. See RequirementObserver in supervisor.capnp.                                //
                                                                                                                       //
  if (!requirements) {                                                                                                 // 104
    return true;                                                                                                       // 105
  }                                                                                                                    // 106
                                                                                                                       //
  requirements.forEach(function (requirement) {                                                                        // 108
    if (requirement.tokenValid) {                                                                                      // 109
      var token = db.collections.apiTokens.findOne({ _id: requirement.tokenValid, revoked: { $ne: true } }, { fields: { requirements: 1 } });
      if (!token) {                                                                                                    // 113
        throw new Meteor.Error(403, "Capability revoked because the link through which it was introduced has been " + "revoked or deleted.");
      }                                                                                                                // 117
                                                                                                                       //
      checkRequirements(db, token.requirements);                                                                       // 119
                                                                                                                       //
      if (token.parentToken) {                                                                                         // 121
        checkRequirements(db, [{ tokenValid: token.parentToken }]);                                                    // 122
      }                                                                                                                // 123
    } else if (requirement.permissionsHeld) {                                                                          // 124
      var p = requirement.permissionsHeld;                                                                             // 125
      var viewInfo = db.collections.grains.findOne(p.grainId, { fields: { cachedViewInfo: 1 } }).cachedViewInfo;       // 126
      var vertex = void 0;                                                                                             // 128
      if (p.identityId) {                                                                                              // 129
        vertex = { grain: { _id: p.grainId, identityId: p.identityId } };                                              // 130
      } else {                                                                                                         // 131
        vertex = { token: { _id: p.tokenId, grainId: p.grainId } };                                                    // 132
      }                                                                                                                // 133
                                                                                                                       //
      var currentPermissions = SandstormPermissions.grainPermissions(db, vertex, viewInfo || {}).permissions;          // 135
      if (!currentPermissions) {                                                                                       // 137
        throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
      }                                                                                                                // 141
                                                                                                                       //
      var requiredPermissions = p.permissions || [];                                                                   // 143
      for (var ii = 0; ii < requiredPermissions.length; ++ii) {                                                        // 144
        if (requiredPermissions[ii] && !currentPermissions[ii]) {                                                      // 145
          throw new Meteor.Error(403, "Capability revoked because a user involved in introducing it no longer has " + "the necessary permissions.");
        }                                                                                                              // 149
      }                                                                                                                // 150
    } else if (requirement.userIsAdmin) {                                                                              // 151
      if (!db.isAdminById(requirement.userIsAdmin)) {                                                                  // 152
        throw new Meteor.Error(403, "Capability revoked because the user who created it has lost their admin " + "rights.");
      }                                                                                                                // 156
    } else {                                                                                                           // 157
      throw new Meteor.Error(403, "Unknown requirement type.");                                                        // 158
    }                                                                                                                  // 159
  });                                                                                                                  // 160
};                                                                                                                     // 161
                                                                                                                       //
                                                                                                                       // 163
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"db-deprecated.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/db-deprecated.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file imports symbols from the sandstorm-db package. New code should use SandstormDb                            //
// directly.                                                                                                           //
                                                                                                                       //
// TODO(cleanup): Over time, eliminate the use of each of these assignments by using `globalDb`                        //
//   directly. For collections, prefer to update SandstormDb to provide methods for querying the                       //
//   collection rather than use `globalDb.collections` directly. When code is moved into packages,                     //
//   the `globalDb` global should NOT go with it; the package should expect a SandstormDb to be                        //
//   passed in, thus allowing mocking the database for unit tests.                                                     //
                                                                                                                       //
globalDb = new SandstormDb();                                                                                          // 26
                                                                                                                       //
Packages = globalDb.collections.packages;                                                                              // 28
DevPackages = globalDb.collections.devPackages;                                                                        // 29
UserActions = globalDb.collections.userActions;                                                                        // 30
Grains = globalDb.collections.grains;                                                                                  // 31
Contacts = globalDb.collections.contacts;                                                                              // 32
Sessions = globalDb.collections.sessions;                                                                              // 33
SignupKeys = globalDb.collections.signupKeys;                                                                          // 34
ActivityStats = globalDb.collections.activityStats;                                                                    // 35
DeleteStats = globalDb.collections.deleteStats;                                                                        // 36
FileTokens = globalDb.collections.fileTokens;                                                                          // 37
ApiTokens = globalDb.collections.apiTokens;                                                                            // 38
Notifications = globalDb.collections.notifications;                                                                    // 39
StatsTokens = globalDb.collections.statsTokens;                                                                        // 40
Misc = globalDb.collections.misc;                                                                                      // 41
Settings = globalDb.collections.settings;                                                                              // 42
                                                                                                                       //
currentUserGrains = globalDb.currentUserGrains.bind(globalDb);                                                         // 44
isDemoUser = globalDb.isDemoUser.bind(globalDb);                                                                       // 45
isSignedUp = globalDb.isSignedUp.bind(globalDb);                                                                       // 46
isSignedUpOrDemo = globalDb.isSignedUpOrDemo.bind(globalDb);                                                           // 47
isUserOverQuota = globalDb.isUserOverQuota.bind(globalDb);                                                             // 48
isUserExcessivelyOverQuota = globalDb.isUserExcessivelyOverQuota.bind(globalDb);                                       // 49
isAdmin = globalDb.isAdmin.bind(globalDb);                                                                             // 50
isAdminById = globalDb.isAdminById.bind(globalDb);                                                                     // 51
findAdminUserForToken = globalDb.findAdminUserForToken.bind(globalDb);                                                 // 52
matchWildcardHost = globalDb.matchWildcardHost.bind(globalDb);                                                         // 53
makeWildcardHost = globalDb.makeWildcardHost.bind(globalDb);                                                           // 54
allowDevAccounts = globalDb.allowDevAccounts.bind(globalDb);                                                           // 55
roleAssignmentPattern = globalDb.roleAssignmentPattern;                                                                // 56
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"demo.js":function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// imports/demo.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
module.export({allowDemo:function(){return allowDemo}});// Sandstorm - Personal Cloud Sandbox                          //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var allowDemo = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDemoAccounts;           // 17
                                                                                                                       //
                                                                                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"shared":{"admin.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/admin.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// TODO(someday): split out fields by locus                                                                            //
// isEnabled is available on both client and server                                                                    //
// getLoginId is only used on server                                                                                   //
// initiateLogin and loginTemplate are only used on client                                                             //
                                                                                                                       //
function serviceEnabled(name) {                                                                                        // 22
  var setting = Settings.findOne({ _id: name });                                                                       // 23
  return setting && !!setting.value;                                                                                   // 24
}                                                                                                                      // 25
                                                                                                                       //
Accounts.identityServices.github = {                                                                                   // 27
  isEnabled: function isEnabled() {                                                                                    // 28
    return serviceEnabled("github");                                                                                   // 29
  },                                                                                                                   // 30
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 32
    return identity.services.github.username;                                                                          // 33
  },                                                                                                                   // 34
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 36
    Meteor.loginWithGithub();                                                                                          // 37
    return { oneClick: true };                                                                                         // 38
  },                                                                                                                   // 39
                                                                                                                       //
  loginTemplate: {                                                                                                     // 41
    name: "oauthLoginButton",                                                                                          // 42
    priority: 1,                                                                                                       // 43
    data: {                                                                                                            // 44
      method: "loginWithGithub",                                                                                       // 45
      name: "github",                                                                                                  // 46
      displayName: "GitHub",                                                                                           // 47
      linkingNewIdentity: false                                                                                        // 48
    }                                                                                                                  // 44
  }                                                                                                                    // 41
};                                                                                                                     // 27
                                                                                                                       //
Accounts.identityServices.google = {                                                                                   // 53
  isEnabled: function isEnabled() {                                                                                    // 54
    return serviceEnabled("google");                                                                                   // 55
  },                                                                                                                   // 56
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 58
    return identity.services.google.email;                                                                             // 59
  },                                                                                                                   // 60
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 62
    Meteor.loginWithGoogle({ loginHint: loginId });                                                                    // 63
    return { oneClick: true };                                                                                         // 64
  },                                                                                                                   // 65
                                                                                                                       //
  loginTemplate: {                                                                                                     // 67
    name: "oauthLoginButton",                                                                                          // 68
    priority: 2,                                                                                                       // 69
    data: {                                                                                                            // 70
      method: "loginWithGoogle",                                                                                       // 71
      name: "google",                                                                                                  // 72
      displayName: "Google",                                                                                           // 73
      linkingNewIdentity: false                                                                                        // 74
    }                                                                                                                  // 70
  }                                                                                                                    // 67
};                                                                                                                     // 53
                                                                                                                       //
Accounts.identityServices.email = {                                                                                    // 79
  isEnabled: function isEnabled() {                                                                                    // 80
    return serviceEnabled("emailToken");                                                                               // 81
  },                                                                                                                   // 82
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 84
    return identity.services.email.email;                                                                              // 85
  },                                                                                                                   // 86
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 88
    return { form: true };                                                                                             // 89
  },                                                                                                                   // 90
                                                                                                                       //
  loginTemplate: {                                                                                                     // 92
    name: "emailLoginForm",                                                                                            // 93
    priority: 10                                                                                                       // 94
  }                                                                                                                    // 92
};                                                                                                                     // 79
                                                                                                                       //
Accounts.identityServices.ldap = {                                                                                     // 98
  isEnabled: function isEnabled() {                                                                                    // 99
    return serviceEnabled("ldap") && globalDb.isFeatureKeyValid();                                                     // 100
  },                                                                                                                   // 101
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 103
    return identity.services.ldap.username;                                                                            // 104
  },                                                                                                                   // 105
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 107
    return { form: true };                                                                                             // 108
  },                                                                                                                   // 109
                                                                                                                       //
  loginTemplate: {                                                                                                     // 111
    name: "ldapLoginForm",                                                                                             // 112
    priority: 21 }                                                                                                     // 113
};                                                                                                                     // 98
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.saml = {                                                                                     // 117
  isEnabled: function isEnabled() {                                                                                    // 118
    return serviceEnabled("saml") && globalDb.isFeatureKeyValid();                                                     // 119
  },                                                                                                                   // 120
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 122
    return identity.services.saml.id;                                                                                  // 123
  },                                                                                                                   // 124
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 126
    Meteor.loginWithSaml();                                                                                            // 127
    return { oneClick: true };                                                                                         // 128
  },                                                                                                                   // 129
                                                                                                                       //
  loginTemplate: {                                                                                                     // 131
    name: "samlLoginForm",                                                                                             // 132
    priority: 20 }                                                                                                     // 133
};                                                                                                                     // 117
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.demo = {                                                                                     // 137
  isEnabled: function isEnabled() {                                                                                    // 138
    return false; // You can never authenticate as a demo user.                                                        // 139
  },                                                                                                                   // 140
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 142
    return identity._id;                                                                                               // 143
  },                                                                                                                   // 144
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 146
    return { demoCannotLogin: true };                                                                                  // 147
  },                                                                                                                   // 148
                                                                                                                       //
  loginTemplate: {}                                                                                                    // 150
};                                                                                                                     // 137
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/dev-accounts.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Accounts.identityServices.dev = {                                                                                      // 17
  isEnabled: function isEnabled() {                                                                                    // 18
    return globalDb.allowDevAccounts();                                                                                // 19
  },                                                                                                                   // 20
                                                                                                                       //
  getLoginId: function getLoginId(identity) {                                                                          // 22
    return identity.services.dev.name;                                                                                 // 23
  },                                                                                                                   // 24
                                                                                                                       //
  initiateLogin: function initiateLogin(loginId) {                                                                     // 26
    loginDevAccount(loginId);                                                                                          // 27
    return { oneClick: true };                                                                                         // 28
  },                                                                                                                   // 29
                                                                                                                       //
  loginTemplate: {                                                                                                     // 31
    name: "devLoginForm",                                                                                              // 32
    priority: -10 }                                                                                                    // 33
};                                                                                                                     // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"grain-shared.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/grain-shared.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Meteor.methods({                                                                                                       // 17
  // Methods defined in this file have meaningful latency compensation (client-side prediction)                        //
  // potential.                                                                                                        //
  //                                                                                                                   //
  // Methods for which latency compensation makes no sense are defined in grain-server.js.                             //
                                                                                                                       //
  markActivityReadByOwner: function markActivityReadByOwner(grainId) {                                                 // 23
    check(grainId, String);                                                                                            // 24
    check(this.userId, String);                                                                                        // 25
                                                                                                                       //
    Grains.update({ _id: grainId, userId: this.userId }, { $set: { "ownerSeenAllActivity": true } });                  // 27
  },                                                                                                                   // 29
                                                                                                                       //
  markActivityRead: function markActivityRead(grainId, identityId) {                                                   // 31
    check(grainId, String);                                                                                            // 32
    check(identityId, String);                                                                                         // 33
                                                                                                                       //
    if (!this.userId || !globalDb.userHasIdentity(this.userId, identityId)) {                                          // 35
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                               // 36
    }                                                                                                                  // 37
                                                                                                                       //
    ApiTokens.update({ "grainId": grainId, "owner.user.identityId": identityId }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
  }                                                                                                                    // 41
});                                                                                                                    // 17
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"install.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/install.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
isSafeDemoAppUrl = function isSafeDemoAppUrl(url) {                                                                    // 17
    // For demo accounts, we allow using a bare hash with no URL (which will never upload a new app)                   //
    // and we allow specifying a sandstorm.io URL.                                                                     //
    return !url || url.lastIndexOf("http://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://alpha-j7uny7u376jnimcsx34c.sandstorm.io/", 0) === 0 || url.lastIndexOf("https://app-index.sandstorm.io/", 0) === 0;
};                                                                                                                     // 25
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"testing.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/testing.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 17
                                                                                                                       //
// jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                                 //
if (isTesting) {                                                                                                       // 21
  if (Meteor.isServer) {                                                                                               // 22
    (function () {                                                                                                     // 22
      var clearUser = function clearUser(id) {                                                                         // 22
        UserActions.remove({ userId: id });                                                                            // 24
        globalDb.removeApiTokens({ userId: id });                                                                      // 25
        Grains.find({ userId: id }).forEach(function (grain) {                                                         // 26
          globalBackend.deleteGrain(grain._id);                                                                        // 27
        });                                                                                                            // 28
                                                                                                                       //
        Grains.remove({ userId: id });                                                                                 // 30
        Meteor.users.remove({ _id: id });                                                                              // 31
      };                                                                                                               // 32
                                                                                                                       //
      Meteor.methods({                                                                                                 // 34
        createMockGithubUser: function createMockGithubUser() {                                                        // 35
          Meteor.users.update({ _id: "Py8fwsaryQNGBuiXb" }, { $set: { createdAt: new Date("2014-08-11T21:44:04.147Z"), isAdmin: true, lastActive: new Date("2014-08-19T09:58:39.676Z"), profile: { name: "Github User" }, services: { github: { accessToken: "sometoken", id: 1595880, username: "testuser" }, resume: { loginTokens: [{ when: new Date("2099-08-13T05:16:02.356Z"), hashedToken: "GriUSDp+uN/K4HptwSl1wsdWfHEpS8c9KjjdqwKNo0k=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 39
                                                                                                                       //
        clearMockGithubUser: function clearMockGithubUser() {                                                          // 41
          clearUser("Py8fwsaryQNGBuiXb");                                                                              // 42
        },                                                                                                             // 43
                                                                                                                       //
        createMockGoogleUser: function createMockGoogleUser() {                                                        // 45
          Meteor.users.update({ _id: "6WJcRo2gg2Ysuxsok" }, { $set: { createdAt: new Date("2014-08-21T07:52:55.581Z"), profile: { name: "Google User" }, services: { google: { accessToken: "sometoken", expiresAt: 4562182723000, id: "116893057283177439912", verified_email: true, name: "Google User", given_name: "Google", family_name: "User", picture: "https://lh3.googleusercontent.com/-XdUIqdMkCWA/AAAAAAAAAAI/AAAAAAAAAAA/4252rscbv5M/photo.jpg", locale: "en", gender: "male" }, resume: { loginTokens: [{ when: new Date("2099-08-21T07:52:55.592Z"), hashedToken: "cbJGxLGKW3f0j7Ehit77hdK58W7xuPjzZhGHgKhyddo=" }] } }, signupKey: "admin" } }, { upsert: true });
        },                                                                                                             // 49
                                                                                                                       //
        clearMockGoogleUser: function clearMockGoogleUser() {                                                          // 51
          clearUser("6WJcRo2gg2Ysuxsok");                                                                              // 52
        },                                                                                                             // 53
                                                                                                                       //
        fetchAppIndexTest: function fetchAppIndexTest() {                                                              // 55
          globalDb.collections.appIndex.remove({});                                                                    // 56
          SandstormAutoupdateApps.updateAppIndex(this.connection.sandstormDb);                                         // 57
        }                                                                                                              // 58
      });                                                                                                              // 34
    })();                                                                                                              // 22
  }                                                                                                                    // 60
                                                                                                                       //
  mockLoginGithub = function mockLoginGithub() {                                                                       // 62
    Meteor.call("createMockGithubUser", function (err) {                                                               // 63
      if (err) {                                                                                                       // 64
        console.log(err);                                                                                              // 65
      }                                                                                                                // 66
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "F0S6luPxIJV--y_GAkBKOMuWMYnnqgG3UMv9M-DIs2f");                 // 68
      window.localStorage.setItem("Meteor.loginTokenExpires", "Mon Nov 10 2099 21:16:02 GMT-0800 (PST)");              // 69
      window.localStorage.setItem("Meteor.userId", "Py8fwsaryQNGBuiXb");                                               // 70
      window.location.reload();                                                                                        // 71
    });                                                                                                                // 72
  };                                                                                                                   // 73
                                                                                                                       //
  clearMockGithubUser = function clearMockGithubUser() {                                                               // 75
    Meteor.call("clearMockGithubUser", function (err) {                                                                // 76
      if (err) {                                                                                                       // 77
        console.log(err);                                                                                              // 78
      }                                                                                                                // 79
    });                                                                                                                // 80
  };                                                                                                                   // 81
                                                                                                                       //
  mockLoginGoogle = function mockLoginGoogle() {                                                                       // 83
    Meteor.call("createMockGoogleUser", function (err) {                                                               // 84
      if (err) {                                                                                                       // 85
        console.log(err);                                                                                              // 86
      }                                                                                                                // 87
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "P3ffUfVJtptyVX2IPUfNDZY0F3b-GIZ-WQf7w3GdL21");                 // 89
      window.localStorage.setItem("Meteor.loginTokenExpires", "Tue Nov 18 2099 23:52:55 GMT-0800 (PST)");              // 90
      window.localStorage.setItem("Meteor.userId", "6WJcRo2gg2Ysuxsok");                                               // 91
      window.location.reload();                                                                                        // 92
    });                                                                                                                // 93
  };                                                                                                                   // 94
                                                                                                                       //
  clearMockGoogleUser = function clearMockGoogleUser() {                                                               // 96
    Meteor.call("clearMockGoogleUser", function (err) {                                                                // 97
      if (err) {                                                                                                       // 98
        console.log(err);                                                                                              // 99
      }                                                                                                                // 100
    });                                                                                                                // 101
  };                                                                                                                   // 102
}                                                                                                                      // 103
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}},{"extensions":[".js",".json"]});
require("./server/lib/constants.js");
require("./server/accounts/email-token/token-server.js");
require("./server/accounts/identity/identity-server.js");
require("./server/accounts/ldap/ldap-server.js");
require("./server/accounts/saml/saml-server.js");
require("./server/accounts/accounts-ui-methods.js");
require("./server/accounts/accounts-ui-server.js");
require("./server/admin/admin-alert-server.js");
require("./server/admin/admin-user-invite.js");
require("./server/admin/network-capabilities-server.js");
require("./server/admin/personalization-server.js");
require("./server/admin/system-status-server.js");
require("./server/drivers/external-ui-view.js");
require("./server/drivers/ip.js");
require("./server/drivers/mail.js");
require("./server/00-startup.js");
require("./server/admin-server.js");
require("./server/backup.js");
require("./server/contacts-server.js");
require("./server/core.js");
require("./server/demo-server.js");
require("./server/desktop-notifications-server.js");
require("./server/dev-accounts-server.js");
require("./server/feature-key.js");
require("./server/grain-server.js");
require("./server/hack-session.js");
require("./server/identity.js");
require("./server/install-server.js");
require("./server/installer.js");
require("./server/notifications-server.js");
require("./server/pre-meteor.js");
require("./server/proxy.js");
require("./server/sandcats.js");
require("./server/shell-server.js");
require("./server/signup-server.js");
require("./server/startup.js");
require("./server/stats-server.js");
require("./shared/admin.js");
require("./shared/dev-accounts.js");
require("./shared/grain-shared.js");
require("./shared/install.js");
require("./shared/testing.js");
//# sourceMappingURL=app.js.map
