(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, getUserQuota, isUserOverQuota, isUserExcessivelyOverQuota, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, allowDevAccounts, sendReferralProgramNotification, roleAssignmentPattern, SandstormDb, appName, addStaticAsset, userPictureUrl, fetchPicture;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file defines the database schema.                                                                              //
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         //
// query it makes, so you can see if it's doing queries too often, etc.                                                //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            //
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              //
// The users collection is special and can be accessed through `Meteor.users`.                                         //
// See https://docs.meteor.com/#/full/meteor_users.                                                                    //
//                                                                                                                     //
// There are two distinct types of entries in the users collection: identities and accounts. An                        //
// identity contains personal profile information and typically includes some intrinsic method for                     //
// authenticating as the owner of that information.                                                                    //
//                                                                                                                     //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           //
// Each account can have multiple identities linked to it. To log in as an account you must first                      //
// authenticate as one of its linked identities.                                                                       //
//                                                                                                                     //
// Every user contains the following fields:                                                                           //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         //
//        stable SHA-256 ID of this identity, hex-encoded.                                                             //
//   createdAt: Date when this entry was added to the collection.                                                      //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                //
//   services: Object containing login data used by Meteor authentication services.                                    //
//   expires: Date when this user should be deleted. Only present for demo users.                                      //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   //
//                     rather than as a Date object. We should fix that.                                               //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     //
//              link. This field contains the app ID of the app that the user started out demoing.                     //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      //
//              being a demo user.                                                                                     //
//                                                                                                                     //
// Identity users additionally contain the following fields:                                                           //
//   profile: Object containing the data that will be shared with users and grains that come into                      //
//            contact with this identity. Includes the following fields:                                               //
//       service: String containing the name of this identity's authentication method.                                 //
//       name: String containing the chosen display name of the identity.                                              //
//       handle: String containing the identity's preferred handle.                                                    //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          //
//                an identicon will be used.                                                                           //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          //
//   referredBy: ID of the Account that referred this Identity.                                                        //
//                                                                                                                     //
// Account users additionally contain the following fields:                                                            //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      //
//                       a separate array here so that we can use a Mongo index to enforce the                         //
//                       invariant that an identity only be a login identity for a single account.                     //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        //
//                 to do this checking automatically.                                                                  //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  //
//   signupKey: If this is an invited user, then this field contains their signup key.                                 //
//   signupNote: If the user was invited through a link, then this field contains the note that the                    //
//               inviter admin attached to the key.                                                                    //
//   signupEmail: If the user was invited by email, then this field contains the email address that                    //
//                the invite was sent to.                                                                              //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    //
//                       terms of service.                                                                             //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       //
//              module writes data here; we merely read it. Missing fields should be treated as                        //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           //
//              TODO(cleanup): Use for referral bonus too.                                                             //
//   storageUsage: Number of bytes this user is currently storing.                                                     //
//   payments: Object defined by payments module, if loaded.                                                           //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 //
//   accessRequests: Object containing the following fields; used to limit spam.                                       //
//       count: Number of "request access" emails during sent during the current interval.                             //
//       resetOn: Date when the count should be reset.                                                                 //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              //
//                        stop writing new referredBy values onto Identities for this account.                         //
//   referredCompleteDate: The Date at which the completed referral occurred.                                          //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        //
//                        reliably determining which Identity's names are safe to display.                             //
//   experiments: Object where each field is an experiment that the user is in, and each value                         //
//           is the parameters for that experiment. Typically, the value simply names which                            //
//           experiment group which the user is in, where "control" is one group. If an experiment                     //
//           is not listed, then the user should not be considered at all for the purpose of that                      //
//           experiment. Each experiment may define a point in time where users not already in the                     //
//           experiment may be added to it and assigned to a group (for example, at user creation                      //
//           time). Current experiments:                                                                               //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       //
//               test group will see a plan selection dialog and asked to make an explitic choice                      //
//               (possibly "free") before they can create grains (but not when opening someone                         //
//               else's shared grain). The goal of the experiment is to determine whether this                         //
//               prompt scares users away -- and also whether it increases paid signups.                               //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              //
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 126
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 127
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 128
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 129
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 130
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 131
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 132
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 135
                                                                                                                       //
Packages = new Mongo.Collection("packages");                                                                           // 137
// Packages which are installed or downloading.                                                                        //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                //
//       >1 = download byte count.                                                                                     //
//   error:  If status is "failed", error message string.                                                              //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          //
//   appId:  If status is "ready", the application ID string.  Packages representing different                         //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         //
//       and can cryptographically verify that a package belongs to a particular app ID.                               //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        //
//       collector should at some point check whether there are any other references and, if not,                      //
//       delete the package.                                                                                           //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    //
//     even if it has no users.                                                                                        //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           //
//     packager.                                                                                                       //
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages");                                                                     // 159
// List of packages currently made available via the dev tools running on the local machine.                           //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     //
// on the local machine to publish an under-development app to this server. That should only ever                      //
// happen on developers' desktop machines.                                                                             //
//                                                                                                                     //
// While a dev package is published, it automatically appears as installed by every user of the                        //
// server, and it overrides all packages with the same application ID. If any instances of those                       //
// packages are currently open, they are killed and reset on publish.                                                  //
//                                                                                                                     //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     //
// are again killed and refreshed.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  The package ID string (as with Packages._id).                                                               //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  //
//   timestamp:  Time when the package was last updated. If this changes while the package is                          //
//     published, all running instances are reset. This is used e.g. to reset the app each time                        //
//     changes are made to the source code.                                                                            //
//   manifest:  The app's manifest, as with Packages.manifest.                                                         //
                                                                                                                       //
UserActions = new Mongo.Collection("userActions");                                                                     // 180
// List of actions that each user has installed which create new grains.  Each app may install                         //
// some number of actions (usually, one).                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   userId:  Account ID of the user who has installed this action.                                                    //
//   packageId:  Package used to run this action.                                                                      //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 //
//       that clients can access it without subscribing to the Packages collection.                                    //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     //
//       `{defaultText: "New Spreadsheet"}`.                                                                           //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        //
//   command:  Manifest.Command to run this action (see package.capnp).                                                //
                                                                                                                       //
Grains = new Mongo.Collection("grains");                                                                               // 199
// Grains belonging to users.                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   packageId:  _id of the package of which this grain is an instance.                                                //
//   packageSalt: If present, a random string that will used in session ID generation. This field                      //
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            //
//       clients with active sessions.                                                                                 //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   userId: The _id of the account that owns this grain.                                                              //
//   identityId: The identity with which the owning account prefers to open this grain.                                //
//   title:  Human-readable string title, as chosen by the user.                                                       //
//   lastUsed:  Date when the grain was last used by a user.                                                           //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    //
//                   time a session to this grain was opened.                                                          //
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       //
//            this date, the grain will be automatically deleted.                                                      //
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        //
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        //
//                                                                                                                     //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      //
// is implemented.                                                                                                     //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     //
//       web publishing. This field is initialized when first requested by the app.                                    //
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments");                                                             // 229
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             //
// collection.                                                                                                         //
                                                                                                                       //
Contacts = new Mongo.Collection("contacts");                                                                           // 234
// Edges in the social graph.                                                                                          //
//                                                                                                                     //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         //
// will show up in her user-picker UI for actions like share-by-identity.                                              //
//                                                                                                                     //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        //
// Bob's.                                                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: random                                                                                                       //
//   ownerId: The accountId of the user account who owns this contact.                                                 //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        //
//            the contact to the owner.                                                                                //
//   created: Date when this contact was created.                                                                      //
//   identityId: The `_id` of the user whose contact info this contains.                                               //
                                                                                                                       //
Sessions = new Mongo.Collection("sessions");                                                                           // 251
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     //
//       client, and the grain's `packageSalt`.                                                                        //
//   grainId:  _id of the grain to which this session is connected.                                                    //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     //
//       '*' in WILDCARD_HOST.                                                                                         //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      //
//       have the same `tabId` as the outer session.                                                                   //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        //
//       period.                                                                                                       //
//   userId:  Account ID of the user who owns this session.                                                            //
//   identityId:  Identity ID of the user who owns this session.                                                       //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     //
//       are present.                                                                                                  //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                           //
//       interaction.                                                                                                  //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                   //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     //
//       until newSession is called on the UiView.                                                                     //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        //
//       until newSession is called on the UiView.                                                                     //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   //
//       request                                                                                                       //
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys");                                                                       // 281
// Invite keys which may be used by users to get access to Sandstorm.                                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   used:  Boolean indicating whether this key has already been consumed.                                             //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          //
//   email: If this key was sent as an email invite, the email address to which it was sent.                           //
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats");                                                                 // 290
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   timestamp: Date when measurements were taken.                                                                     //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           //
//                                                                                                                     //
// Each of daily, weekly, and monthly contains:                                                                        //
//   activeUsers: The number of unique users who have used a grain on the server in the time                           //
//       interval. Only counts logged-in users.                                                                        //
//   demoUsers: Demo users.                                                                                            //
//   appDemoUsers: Users that came in through "app demo".                                                              //
//   activeGrains: The number of unique grains that have been used in the time interval.                               //
//   apps: An object indexed by app ID recording, for each app:                                                        //
//       owners: Number of unique owners of this app (counting only grains that still exist).                          //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    //
//         only grains that still exist).                                                                              //
//       grains: Number of active grains of this app (that still exist).                                               //
//       deleted: Number of non-demo grains of this app that were deleted.                                             //
//       demoed: Number of demo grains created and expired.                                                            //
//       appDemoUsers: Number of app demos initiated with this app.                                                    //
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats");                                                                     // 314
// Contains records of objects that were deleted, for stat-keeping purposes.                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             //
//   lastActive: Date of the user's or grain's last activity.                                                          //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     //
//     arrived to demo. For others, undefined.                                                                         //
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens");                                                                       // 323
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       //
// a token when they create a backup file (either by uploading it, or by backing up one of their                       //
// grains) and may use the token to read the file (either to download it, or to restore a new                          //
// grain from it).                                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The unguessable token string.                                                                          //
//   name:      Suggested filename.                                                                                    //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        //
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens");                                                                         // 334
// Access tokens for APIs exported by apps.                                                                            //
//                                                                                                                     //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         //
// `MainView`) -- the fields of type `Data` are API tokens.                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       //
//              That is, the UiView's newSession() method will intersect the requested permissions                     //
//              with this identity's permissions before forwarding on to the underlying app. If                        //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     //
//              this is NOT the identity against which the `requiredPermissions` parameter of                          //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    //
//              that created the token.                                                                                //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    //
//              permissions will be intersected with those held by `identityId` when the view is                       //
//              opened.                                                                                                //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    //
//              anonymous rather than as directly associated with `identityId`. This has no effect                     //
//              on the permissions granted.                                                                            //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      //
//              the app or its supervisor (whereas without this it strictly represents UiView).                        //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    //
//              containing exactly one of the following fields:                                                        //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           //
//                           `Notifications` collection.                                                               //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      //
//                  database when that happens. This field contains the boolean true to signify that                   //
//                  it has been set.                                                                                   //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           //
//                      value is an object containing the fields `id` and `services`. `id` is the                      //
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             //
//                      powerbox query for matching verified emails. `services` is a                                   //
//                      list of names of identity providers that are trusted to verify addresses.                      //
//                      If `services` is omitted or falsy, all configured identity providers are                       //
//                      trusted. Note that a malicious user could specify invalid names in the                         //
//                      list; they should be ignored.                                                                  //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               //
//                      An object containing `verifierId`, `tabId`, and `address`.                                     //
//       identity: An Identity capability. The field is the identity ID.                                               //
//   parentToken: If present, then this token represents exactly the capability represented by                         //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       //
//              is set to the identity that shared the view, and `accountId` is set to the account                     //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             //
//              `parentToken` is present.                                                                              //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          //
//              revocation. This should be displayed when visualizing incoming capabilities to                         //
//              the grain identified by `grainId`.                                                                     //
//   created:   Date when this token was created.                                                                      //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    //
//              become un-revoked in the future.                                                                       //
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     //
//              this date, the token will be automatically deleted.                                                    //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     //
//   lastUsed:  Optional Date when this token was last used.                                                           //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             //
//              as passed to the `save()` call that created this token. If not present, treat                          //
//              as `webkey` (the default for `ApiTokenOwner`).                                                         //
//   expiresIfUnused:                                                                                                  //
//              Optional Date after which the token, if it has not been used yet, expires.                             //
//              This field should be cleared on a token's first use.                                                   //
//   requirements: List of conditions which must hold for this token to be considered valid.                           //
//              Semantically, this list specifies the powers which were *used* to originally                           //
//              create the token. If any condition in the list becomes untrue, then the token must                     //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         //
//              through it must also become revoked. Each item is the JSON serialization of the                        //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          //
//              cleaned up when the token is.                                                                          //
//                                                                                                                     //
// It is important to note that a token's owner and provider are independent from each other. To                       //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    //
//                                                                                                                     //
// struct ApiToken {                                                                                                   //
//   owner :ApiTokenOwner;                                                                                             //
//   provider :union {                                                                                                 //
//     grain :group {                                                                                                  //
//       grainId :Text;                                                                                                //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment;                                                                           //
//           forSharing :Bool;                                                                                         //
//         }                                                                                                           //
//         objectId :SupervisorObjectId;                                                                               //
//       }                                                                                                             //
//     }                                                                                                               //
//     frontendRef :union {                                                                                            //
//       notificationHandle :Text;                                                                                     //
//       ipNetwork :Bool;                                                                                              //
//       ipInterface :Bool;                                                                                            //
//       emailVerifier :group {                                                                                        //
//         id :Text;                                                                                                   //
//         services :List(String);                                                                                     //
//       }                                                                                                             //
//       verifiedEmail :group {                                                                                        //
//         verifierId :Text;                                                                                           //
//         tabId :Text;                                                                                                //
//         address :Text;                                                                                              //
//       }                                                                                                             //
//       identity :Text;                                                                                               //
//     }                                                                                                               //
//     child :group {                                                                                                  //
//       parentToken :Text;                                                                                            //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           grainId :Text;                                                                                            //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        //
//         }                                                                                                           //
//         other :Void;                                                                                                //
//       }                                                                                                             //
//     }                                                                                                               //
//   }                                                                                                                 //
//   requirements: List(Supervisor.MembraneRequirement);                                                               //
//   ...                                                                                                               //
// }                                                                                                                   //
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 470
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 471
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 472
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts");                                                                           // 474
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      //
// to probe an API host without authentication to determine capabilities such as DAV protocols                         //
// supported, before authenticating to perform real requests. An app can specify these properties                      //
// when creating an offerTemplate.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     //
//                 up when ApiTokens are deleted.                                                                      //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          //
//                 This is an object containing fields:                                                                //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          //
//                 fields:                                                                                             //
//     type:       Content-Type.                                                                                       //
//     language:   Content-Language.                                                                                   //
//     encoding:   Content-Encoding.                                                                                   //
//     body:       Entity-body as a string or buffer.                                                                  //
                                                                                                                       //
Notifications = new Mongo.Collection("notifications");                                                                 // 499
// Notifications for a user.                                                                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   grainId:      The grain originating this notification, if any.                                                    //
//   userId:       Account ID of the user receiving the notification.                                                  //
//   text:         The JSON-ified LocalizedText to display in the notification.                                        //
//   isUnread:     Boolean indicating if this notification is unread.                                                  //
//   timestamp:    Date when this notification was last updated                                                        //
//   eventType:    If this notification is due to an activity event, this is the numeric index                         //
//                 of the event type on the grain's ViewInfo.                                                          //
//   count:        The number of times this exact event has repeated. Identical events are                             //
//                 aggregated by incrementing the count.                                                               //
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      //
//   path:         Path inside the grain to which the user should be directed if they click on                         //
//                 the notification.                                                                                   //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             //
//                 ApiToken referencing the `OngoingNotification` capability.                                          //
//   admin:        If present, this is a notification intended for an admin.                                           //
//     action:     If present, this is a (string) link that the notification should direct the                         //
//                 admin to.                                                                                           //
//     type:       The type of notification (currently only "reportStats").                                            //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     //
//                 as keys.                                                                                            //
//     $appId:     The appId that has an outstanding update.                                                           //
//       packageId: The packageId that it will update to.                                                              //
//       name: The name of the app. (appTitle from package.manifest)                                                   //
//       version: The app's version number. (appVersion from package.manifest)                                         //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           //
//   referral:     If this boolean field is true, then treat this notification as a referral                           //
//                 notification. This causes text to be ignored, since we need custom logic.                           //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      //
//                 a one-time notification only to Oasis users who existed when the bonus program                      //
//                 was implemented.                                                                                    //
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions");                                                 // 535
// Activity events to which a user is subscribed.                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   identityId:   Who is subscribed.                                                                                  //
//   grainId:      Grain to which subscription applies.                                                                //
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       //
//                 whole grain.                                                                                        //
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         //
//                 This allows is useful to express:                                                                   //
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  //
//                 - The owner of a grain does not want notifications (normally, they are                              //
//                   implicitly subscribed).                                                                           //
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      //
//                   which they comment, so they mute the grain.                                                       //
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 552
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 553
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens");                                                                     // 555
// Access tokens for the Stats collection                                                                              //
//                                                                                                                     //
// These tokens are used for accessing the ActivityStats collection remotely                                           //
// (ie. from a dashboard webapp)                                                                                       //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  //
                                                                                                                       //
Misc = new Mongo.Collection("misc");                                                                                   // 564
// Miscellaneous configuration and other settings                                                                      //
//                                                                                                                     //
// This table is currently only used for persisting BASE_URL from one session to the next,                             //
// but in general any miscellaneous settings should go in here                                                         //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "BASE_URL"                                                                //
//   value:     The value of the setting.                                                                              //
                                                                                                                       //
Settings = new Mongo.Collection("settings");                                                                           // 574
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         //
// route. This collection differs from misc in that any admin user can update it through the admin                     //
// interface.                                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "smtpConfig"                                                              //
//   value:     The value of the setting.                                                                              //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     //
//                       so, it will also write an object to this field indicating why the reset was                   //
//                       needed. That object can have the following variants:                                          //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      //
//                           with the old BASE_URL.                                                                    //
//   preinstalledApps: A list of objects:                                                                              //
//     appId: The Packages.appId of the app to install                                                                 //
//     status: packageId                                                                                               //
//     packageId: The Packages._id of the app to install                                                               //
//                                                                                                                     //
//   potentially other fields that are unique to the setting                                                           //
                                                                                                                       //
Migrations = new Mongo.Collection("migrations");                                                                       // 594
// This table tracks which migrations we have applied to this instance.                                                //
// It contains a single entry:                                                                                         //
//   _id:       "migrations_applied"                                                                                   //
//   value:     The number of migrations this instance has successfully completed.                                     //
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets");                                                                   // 600
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            //
// support relatively small assets: under 1MB each.                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID; will be used in the URL.                                                                    //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    //
//   content:   The asset content (byte buffer).                                                                       //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        //
//       to catch leaked assets, although it's probably not a big deal in practice.                                    //
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens");                                                         // 614
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         //
// profile picture.                                                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID.                                                                                             //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          //
//           userId: Account ID of user whose picture shall be replaced.                                               //
//           identityId: Which of the user's identities shall be updated.                                              //
//   expires:   Time when this token will go away if unused.                                                           //
                                                                                                                       //
Plans = new Mongo.Collection("plans");                                                                                 // 626
// Subscription plans, which determine quota.                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                //
//   storage: Number of bytes this user is allowed to store.                                                           //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          //
//   computeLabel: Label to display to the user describing this plan's compute units.                                  //
//   grains: Total number of grains this user can create (often `Infinity`).                                           //
//   price: Price per month in US cents.                                                                               //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           //
//       allowed to switch away.                                                                                       //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      //
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex");                                                                           // 640
// A mirror of the data from the App Market index                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: the appId of the app                                                                                         //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    //
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles");                                                             // 647
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     //
// by that user is installed, as well as if the keybase profile is requested and not already                           //
// present for some reason.                                                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    //
//   handle: Keybase handle.                                                                                           //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     //
//     server is currently actively checking this proof). Note that if a check fails due to network                    //
//     errors, the status goes back to "unverified".                                                                   //
//                                                                                                                     //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          //
//       for now and we just trust Keybase.                                                                            //
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey");                                                                       // 667
// Responsible for storing the current feature key that is active on the server.  Contains a single                    //
// document with two keys:                                                                                             //
//                                                                                                                     //
//   _id: "currentFeatureKey"                                                                                          //
//   value: the still-signed, binary-encoded feature key                                                               //
//          (a feature key with comments removed and base64 decoded)                                                   //
//                                                                                                                     //
// This is only intended to be visible on the server.                                                                  //
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession");                                                                   // 677
// Responsible for storing information about setup sessions.  Contains a single document with three                    //
// keys:                                                                                                               //
//                                                                                                                     //
//   _id: "current-session"                                                                                            //
//   creationDate: Date object indicating when this session was created.                                               //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              //
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications");                                               // 685
// Responsible for very short-lived queueing of desktop notification information.                                      //
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        //
// odd in that it is intended primarily for edge-triggered communications, but                                         //
// Meteor's collections aren't really designed to support that organization.                                           //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            //
//   creationDate: Date object. indicating when this notification was posted.                                          //
//   userId: String. Account id to which this notification was published.                                              //
//   title: String. Primary label of the notification.                                                                 //
//   body: String (optional).  Additional context information to place in the notification.  May be                    //
//                             elided by the browser or by Sandstorm.                                                  //
//   action: Object. What to do when this desktop notification is activated.  Currently, only one                      //
//                   shape is supported:                                                                               //
//           { grain: { grainId, path } }                                                                              //
//   iconUrl: Optional String.  Primary icon to display with the notifications.                                        //
//                              See https://notifications.spec.whatwg.org/#icon-url                                    //
//   badgeUrl: Optional String. Secondary icon to display with the notification, used to represent                     //
//                              the notification if there is insufficient space to display the whole                   //
//                              notification.  Can also be displayed (though with less visual                          //
//                              priority than the primary icon) in the notification.                                   //
//                              See https://notifications.spec.whatwg.org/#badge-url                                   //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 709
  Meteor.publish("credentials", function () {                                                                          // 710
    // Data needed for isSignedUp() and isAdmin() to work.                                                             //
                                                                                                                       //
    if (this.userId) {                                                                                                 // 713
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 717
          referredIdentityIds: 1 } }), Plans.find()];                                                                  // 718
    } else {                                                                                                           // 721
      return [];                                                                                                       // 722
    }                                                                                                                  // 723
  });                                                                                                                  // 724
}                                                                                                                      // 725
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 727
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 728
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 729
};                                                                                                                     // 730
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 732
  // This function returns an object of the form:                                                                      //
  //                                                                                                                   //
  // - {grains: 0, storage: 0}                                                                                         //
  //                                                                                                                   //
  // which are extra resources this account gets as part of participating in the referral                              //
  // program. (Storage is measured in bytes, as usual for plans.)                                                      //
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        //
  //   payments-specific) and aggregating into `planBonus`.                                                            //
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              //
  var isPaid = user.plan && user.plan !== "free";                                                                      // 744
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 746
  if (isPaid) {                                                                                                        // 747
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 748
    return { grains: 0,                                                                                                // 749
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 750
  } else {                                                                                                             // 753
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 754
    var bonus = {                                                                                                      // 755
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 756
    };                                                                                                                 // 755
    if (successfulReferralsCount > 0) {                                                                                // 760
      bonus.grains = Infinity;                                                                                         // 761
    } else {                                                                                                           // 762
      bonus.grains = 0;                                                                                                // 763
    }                                                                                                                  // 764
                                                                                                                       //
    return bonus;                                                                                                      // 766
  }                                                                                                                    // 767
};                                                                                                                     // 768
                                                                                                                       //
getUserQuota = function getUserQuota(user) {                                                                           // 770
  var plan = Plans.findOne(user.plan || "free");                                                                       // 771
  var referralBonus = calculateReferralBonus(user);                                                                    // 772
  var bonus = user.planBonus || {};                                                                                    // 773
  var userQuota = {                                                                                                    // 774
    storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                              // 775
    grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                                  // 776
    compute: plan.compute + (bonus.compute || 0)                                                                       // 777
  };                                                                                                                   // 774
  return userQuota;                                                                                                    // 779
};                                                                                                                     // 780
                                                                                                                       //
isUserOverQuota = function isUserOverQuota(user) {                                                                     // 782
  // Return false if user has quota space remaining, true if it is full. When this returns true,                       //
  // we will not allow the user to create new grains, though they may be able to open existing ones                    //
  // which may still increase their storage usage.                                                                     //
  //                                                                                                                   //
  // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                  //
                                                                                                                       //
  if (!Meteor.settings["public"].quotaEnabled || user.isAdmin) return false;                                           // 789
                                                                                                                       //
  var plan = getUserQuota(user);                                                                                       // 791
  if (plan.grains < Infinity) {                                                                                        // 792
    var count = Grains.find({ userId: user._id }, { fields: {}, limit: plan.grains }).count();                         // 793
    if (count >= plan.grains) return "outOfGrains";                                                                    // 794
  }                                                                                                                    // 795
                                                                                                                       //
  return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                             // 797
};                                                                                                                     // 798
                                                                                                                       //
isUserExcessivelyOverQuota = function isUserExcessivelyOverQuota(user) {                                               // 800
  // Return true if user is so far over quota that we should prevent their existing grains from                        //
  // running at all.                                                                                                   //
  //                                                                                                                   //
  // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                  //
                                                                                                                       //
  if (!Meteor.settings["public"].quotaEnabled || user.isAdmin) return false;                                           // 806
                                                                                                                       //
  var quota = getUserQuota(user);                                                                                      // 808
                                                                                                                       //
  // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                             //
  if (quota.grains < Infinity) {                                                                                       // 811
    var count = Grains.find({ userId: user._id }, { fields: {}, limit: quota.grains * 2 }).count();                    // 812
    if (count >= quota.grains * 2) return "outOfGrains";                                                               // 813
  }                                                                                                                    // 814
                                                                                                                       //
  return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                     // 816
};                                                                                                                     // 817
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 819
  // Returns true if the user is the administrator.                                                                    //
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 822
  if (user && user.isAdmin) {                                                                                          // 823
    return true;                                                                                                       // 824
  } else {                                                                                                             // 825
    return false;                                                                                                      // 826
  }                                                                                                                    // 827
};                                                                                                                     // 828
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 830
  // Returns true if the user's id is the administrator.                                                               //
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 833
  if (user && user.isAdmin) {                                                                                          // 834
    return true;                                                                                                       // 835
  } else {                                                                                                             // 836
    return false;                                                                                                      // 837
  }                                                                                                                    // 838
};                                                                                                                     // 839
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 841
  if (!token.requirements) {                                                                                           // 842
    return;                                                                                                            // 843
  }                                                                                                                    // 844
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 846
    return "userIsAdmin" in requirement;                                                                               // 847
  });                                                                                                                  // 848
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 850
    return;                                                                                                            // 851
  }                                                                                                                    // 852
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 854
    return;                                                                                                            // 855
  }                                                                                                                    // 856
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 858
};                                                                                                                     // 859
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 861
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 863
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 864
}                                                                                                                      // 865
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 867
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           //
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    //
  // comparison logic ignores port numbers.                                                                            //
  var prefix = wildcardHost[0];                                                                                        // 872
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 873
  var hostSansPort = host.split(":")[0];                                                                               // 874
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 879
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 880
      return id;                                                                                                       // 881
    }                                                                                                                  // 882
  }                                                                                                                    // 883
                                                                                                                       //
  return null;                                                                                                         // 885
};                                                                                                                     // 886
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 888
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 889
};                                                                                                                     // 890
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 892
  if (hostId) {                                                                                                        // 893
    var split = hostId.split("-");                                                                                     // 894
    if (split[0] === "api") return split[1] || "*";                                                                    // 895
  }                                                                                                                    // 896
                                                                                                                       //
  return false;                                                                                                        // 898
};                                                                                                                     // 899
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 901
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 902
};                                                                                                                     // 903
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 905
if (Meteor.isServer) {                                                                                                 // 906
  (function () {                                                                                                       // 906
    var Crypto = Npm.require("crypto");                                                                                // 907
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 908
      // Given an API token, compute the host ID that must be used when requesting this token.                         //
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     //
      // any bugs which would allow someone who knows only the hostname to access the app API.                         //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 915
    };                                                                                                                 // 916
  })();                                                                                                                // 906
} else {                                                                                                               // 917
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 918
    // Given an API token, compute the host ID that must be used when requesting this token.                           //
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       //
    // any bugs which would allow someone who knows only the hostname to access the app API.                           //
    return SHA256("x" + token).slice(0, 32);                                                                           // 925
  };                                                                                                                   // 926
}                                                                                                                      // 927
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 929
  return "api-" + apiHostIdHashForToken(token);                                                                        // 930
};                                                                                                                     // 931
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 933
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 934
};                                                                                                                     // 935
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 937
  (function () {                                                                                                       // 937
    var Url = Npm.require("url");                                                                                      // 938
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 939
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              //
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 947
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 949
      if (dotPos < 0) {                                                                                                // 950
        return protocol + "//*";                                                                                       // 951
      } else {                                                                                                         // 952
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 953
      }                                                                                                                // 954
    };                                                                                                                 // 955
  })();                                                                                                                // 937
}                                                                                                                      // 956
                                                                                                                       //
allowDevAccounts = function allowDevAccounts() {                                                                       // 958
  var setting = Settings.findOne({ _id: "devAccounts" });                                                              // 959
  if (setting) {                                                                                                       // 960
    return setting.value;                                                                                              // 961
  } else {                                                                                                             // 962
    return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;                 // 963
  }                                                                                                                    // 965
};                                                                                                                     // 966
                                                                                                                       //
sendReferralProgramNotification = function sendReferralProgramNotification(userId) {                                   // 968
  Notifications.upsert({                                                                                               // 969
    userId: userId,                                                                                                    // 970
    referral: true                                                                                                     // 971
  }, {                                                                                                                 // 969
    userId: userId,                                                                                                    // 973
    referral: true,                                                                                                    // 974
    timestamp: new Date(),                                                                                             // 975
    isUnread: true                                                                                                     // 976
  });                                                                                                                  // 972
};                                                                                                                     // 978
                                                                                                                       //
roleAssignmentPattern = {                                                                                              // 980
  none: Match.Optional(null),                                                                                          // 981
  allAccess: Match.Optional(null),                                                                                     // 982
  roleId: Match.Optional(Match.Integer),                                                                               // 983
  addPermissions: Match.Optional([Boolean]),                                                                           // 984
  removePermissions: Match.Optional([Boolean])                                                                         // 985
};                                                                                                                     // 980
                                                                                                                       //
SandstormDb = function SandstormDb() {                                                                                 // 988
  this.collections = {                                                                                                 // 989
    // Direct access to underlying collections. DEPRECATED.                                                            //
    //                                                                                                                 //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      //
    //   direct access to the collections.                                                                             //
                                                                                                                       //
    packages: Packages,                                                                                                // 995
    devPackages: DevPackages,                                                                                          // 996
    userActions: UserActions,                                                                                          // 997
    grains: Grains,                                                                                                    // 998
    contacts: Contacts,                                                                                                // 999
    sessions: Sessions,                                                                                                // 1000
    signupKeys: SignupKeys,                                                                                            // 1001
    activityStats: ActivityStats,                                                                                      // 1002
    deleteStats: DeleteStats,                                                                                          // 1003
    fileTokens: FileTokens,                                                                                            // 1004
    apiTokens: ApiTokens,                                                                                              // 1005
    apiHosts: ApiHosts,                                                                                                // 1006
    notifications: Notifications,                                                                                      // 1007
    statsTokens: StatsTokens,                                                                                          // 1008
    misc: Misc,                                                                                                        // 1009
    settings: Settings,                                                                                                // 1010
    appIndex: AppIndex,                                                                                                // 1011
    keybaseProfiles: KeybaseProfiles,                                                                                  // 1012
    featureKey: FeatureKey,                                                                                            // 1013
    setupSession: SetupSession,                                                                                        // 1014
    users: Meteor.users,                                                                                               // 1015
    desktopNotifications: DesktopNotifications                                                                         // 1016
                                                                                                                       //
  };                                                                                                                   // 989
};                                                                                                                     // 1022
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           //
//   objects created in SandstormDb's constructor rather than globals.                                                 //
                                                                                                                       //
// Intentionally omitted:                                                                                              //
// - Migrations, since it's used only within this package.                                                             //
// - RoleAssignments, since it is deprecated and only used by the migration that eliminated it.                        //
_.extend(SandstormDb.prototype, {                                                                                      // 1027
  getUserQuota: getUserQuota,                                                                                          // 1028
  isUserOverQuota: isUserOverQuota,                                                                                    // 1029
  isUserExcessivelyOverQuota: isUserExcessivelyOverQuota,                                                              // 1030
  isAdmin: isAdmin,                                                                                                    // 1031
  isAdminById: isAdminById,                                                                                            // 1032
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1033
  matchWildcardHost: matchWildcardHost,                                                                                // 1034
  makeWildcardHost: makeWildcardHost,                                                                                  // 1035
  isApiHostId: isApiHostId,                                                                                            // 1036
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1037
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1038
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1039
  makeApiHost: makeApiHost,                                                                                            // 1040
  allowDevAccounts: allowDevAccounts,                                                                                  // 1041
  roleAssignmentPattern: roleAssignmentPattern,                                                                        // 1042
                                                                                                                       //
  isDemoUser: function isDemoUser() {                                                                                  // 1044
    // Returns true if this is a demo user.                                                                            //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1047
    if (user && user.expires) {                                                                                        // 1048
      return true;                                                                                                     // 1049
    } else {                                                                                                           // 1050
      return false;                                                                                                    // 1051
    }                                                                                                                  // 1052
  },                                                                                                                   // 1053
                                                                                                                       //
  isSignedUp: function isSignedUp() {                                                                                  // 1055
    var user = Meteor.user();                                                                                          // 1056
    return this.isAccountSignedUp(user);                                                                               // 1057
  },                                                                                                                   // 1058
                                                                                                                       //
  isAccountSignedUp: function isAccountSignedUp(user) {                                                                // 1060
    // Returns true if the user has presented an invite key.                                                           //
                                                                                                                       //
    if (!user) return false; // not signed in                                                                          // 1063
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1065
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1067
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1069
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1071
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1073
                                                                                                                       //
    return false;                                                                                                      // 1075
  },                                                                                                                   // 1076
                                                                                                                       //
  isSignedUpOrDemo: function isSignedUpOrDemo() {                                                                      // 1078
    var user = Meteor.user();                                                                                          // 1079
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1080
  },                                                                                                                   // 1081
                                                                                                                       //
  isAccountSignedUpOrDemo: function isAccountSignedUpOrDemo(user) {                                                    // 1083
    if (!user) return false; // not signed in                                                                          // 1084
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1086
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1088
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1090
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1092
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1094
                                                                                                                       //
    return false;                                                                                                      // 1096
  },                                                                                                                   // 1097
                                                                                                                       //
  isIdentityInOrganization: function isIdentityInOrganization(identity) {                                              // 1099
    if (!identity || !identity.services) {                                                                             // 1100
      return false;                                                                                                    // 1101
    }                                                                                                                  // 1102
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1104
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1105
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1106
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1107
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1108
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1109
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1110
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1111
      if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                              // 1112
        return true;                                                                                                   // 1113
      }                                                                                                                // 1114
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1115
      return true;                                                                                                     // 1116
    } else if (samlEnabled && identity.services.saml) {                                                                // 1117
      return true;                                                                                                     // 1118
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1119
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1120
        return true;                                                                                                   // 1121
      }                                                                                                                // 1122
    }                                                                                                                  // 1123
                                                                                                                       //
    return false;                                                                                                      // 1125
  },                                                                                                                   // 1126
                                                                                                                       //
  isUserInOrganization: function isUserInOrganization(user) {                                                          // 1128
    if (!this.isFeatureKeyValid()) {                                                                                   // 1129
      return false;                                                                                                    // 1130
    }                                                                                                                  // 1131
                                                                                                                       //
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1133
      var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                        // 1134
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1135
        return true;                                                                                                   // 1136
      }                                                                                                                // 1137
    }                                                                                                                  // 1138
                                                                                                                       //
    return false;                                                                                                      // 1140
  }                                                                                                                    // 1141
});                                                                                                                    // 1027
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1144
  (function () {                                                                                                       // 1144
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1145
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1147
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1148
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           //
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1151
        // Clean up ApiHosts for webkey tokens.                                                                        //
        if (token.hasApiHost) {                                                                                        // 1153
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1154
          ApiHosts.remove({ hash2: hash2 });                                                                           // 1155
        }                                                                                                              // 1156
      });                                                                                                              // 1157
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1159
    };                                                                                                                 // 1160
  })();                                                                                                                // 1144
}                                                                                                                      // 1161
                                                                                                                       //
// =======================================================================================                             //
// Below this point are newly-written or refactored functions.                                                         //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1166
  getUser: function getUser(userId) {                                                                                  // 1167
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1168
    if (userId) {                                                                                                      // 1169
      return Meteor.users.findOne(userId);                                                                             // 1170
    }                                                                                                                  // 1171
  },                                                                                                                   // 1172
                                                                                                                       //
  getIdentity: function getIdentity(identityId) {                                                                      // 1174
    check(identityId, String);                                                                                         // 1175
    var identity = Meteor.users.findOne({ _id: identityId });                                                          // 1176
    if (identity) {                                                                                                    // 1177
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1178
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1179
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1180
      return identity;                                                                                                 // 1181
    }                                                                                                                  // 1182
  },                                                                                                                   // 1183
                                                                                                                       //
  userHasIdentity: function userHasIdentity(userId, identityId) {                                                      // 1185
    check(userId, String);                                                                                             // 1186
    check(identityId, String);                                                                                         // 1187
                                                                                                                       //
    if (userId === identityId) return true;                                                                            // 1189
                                                                                                                       //
    var user = Meteor.users.findOne(userId);                                                                           // 1191
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1192
  },                                                                                                                   // 1193
                                                                                                                       //
  userGrains: function userGrains(userId, trashed) {                                                                   // 1195
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1196
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1197
                                                                                                                       //
    return this.collections.grains.find({ userId: userId, trashed: { $exists: !!trashed } });                          // 1199
  },                                                                                                                   // 1200
                                                                                                                       //
  currentUserGrains: function currentUserGrains(trashed) {                                                             // 1202
    return this.userGrains(Meteor.userId(), trashed);                                                                  // 1203
  },                                                                                                                   // 1204
                                                                                                                       //
  getGrain: function getGrain(grainId) {                                                                               // 1206
    check(grainId, String);                                                                                            // 1207
    return this.collections.grains.findOne(grainId);                                                                   // 1208
  },                                                                                                                   // 1209
                                                                                                                       //
  userApiTokens: function userApiTokens(userId, trashed) {                                                             // 1211
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1212
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1213
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1214
    return this.collections.apiTokens.find({                                                                           // 1215
      "owner.user.identityId": { $in: identityIds },                                                                   // 1216
      trashed: { $exists: !!trashed }                                                                                  // 1217
    });                                                                                                                // 1215
  },                                                                                                                   // 1219
                                                                                                                       //
  currentUserApiTokens: function currentUserApiTokens(trashed) {                                                       // 1221
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1222
  },                                                                                                                   // 1223
                                                                                                                       //
  userActions: function userActions(user) {                                                                            // 1225
    return this.collections.userActions.find({ userId: user });                                                        // 1226
  },                                                                                                                   // 1227
                                                                                                                       //
  currentUserActions: function currentUserActions() {                                                                  // 1229
    return this.userActions(Meteor.userId());                                                                          // 1230
  },                                                                                                                   // 1231
                                                                                                                       //
  iconSrcForPackage: function iconSrcForPackage(pkg, usage) {                                                          // 1233
    return Identicon.iconSrcForPackage(pkg, usage, this.makeWildcardHost("static"));                                   // 1234
  },                                                                                                                   // 1235
                                                                                                                       //
  getDenormalizedGrainInfo: function getDenormalizedGrainInfo(grainId) {                                               // 1237
    var grain = this.getGrain(grainId);                                                                                // 1238
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1239
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1241
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1242
    }                                                                                                                  // 1243
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                                // 1245
    var grainInfo = { appTitle: appTitle };                                                                            // 1246
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1248
      var icons = pkg.manifest.metadata.icons;                                                                         // 1249
      grainInfo.icon = icons.grain || icons.appGrid;                                                                   // 1250
    }                                                                                                                  // 1251
                                                                                                                       //
    // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                      //
    if (!grainInfo.icon && pkg) {                                                                                      // 1254
      grainInfo.appId = pkg.appId;                                                                                     // 1255
    }                                                                                                                  // 1256
                                                                                                                       //
    return grainInfo;                                                                                                  // 1258
  },                                                                                                                   // 1259
                                                                                                                       //
  getPlan: function getPlan(id) {                                                                                      // 1261
    check(id, String);                                                                                                 // 1262
    var plan = Plans.findOne(id);                                                                                      // 1263
    if (!plan) {                                                                                                       // 1264
      throw new Error("no such plan: " + id);                                                                          // 1265
    }                                                                                                                  // 1266
                                                                                                                       //
    return plan;                                                                                                       // 1268
  },                                                                                                                   // 1269
                                                                                                                       //
  listPlans: function listPlans() {                                                                                    // 1271
    return Plans.find({}, { sort: { price: 1 } });                                                                     // 1272
  },                                                                                                                   // 1273
                                                                                                                       //
  getMyPlan: function getMyPlan() {                                                                                    // 1275
    var user = Meteor.user();                                                                                          // 1276
    return user && Plans.findOne(user.plan || "free");                                                                 // 1277
  },                                                                                                                   // 1278
                                                                                                                       //
  getMyReferralBonus: function getMyReferralBonus(user) {                                                              // 1280
    // This function is called from the server and from the client, similar to getMyPlan().                            //
    //                                                                                                                 //
    // The parameter may be omitted in which case the current user is assumed.                                         //
                                                                                                                       //
    return calculateReferralBonus(user || Meteor.user());                                                              // 1285
  },                                                                                                                   // 1286
                                                                                                                       //
  getMyUsage: function getMyUsage(user) {                                                                              // 1288
    user = user || Meteor.user();                                                                                      // 1289
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1290
      if (Meteor.isClient) {                                                                                           // 1291
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       //
        // not reactive.                                                                                               //
        return user.pseudoUsage;                                                                                       // 1294
      } else {                                                                                                         // 1295
        return {                                                                                                       // 1296
          grains: Grains.find({ userId: user._id }).count(),                                                           // 1297
          storage: user.storageUsage || 0,                                                                             // 1298
          compute: 0 };                                                                                                // 1299
      }                                                                                                                // 1301
    } else // not tracked yet                                                                                          // 1302
      {                                                                                                                // 1302
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1303
      }                                                                                                                // 1304
  },                                                                                                                   // 1305
                                                                                                                       //
  isUninvitedFreeUser: function isUninvitedFreeUser() {                                                                // 1307
    if (!Meteor.settings["public"].allowUninvited) return false;                                                       // 1308
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1310
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1311
  },                                                                                                                   // 1312
                                                                                                                       //
  getSetting: function getSetting(name) {                                                                              // 1314
    var setting = Settings.findOne(name);                                                                              // 1315
    return setting && setting.value;                                                                                   // 1316
  },                                                                                                                   // 1317
                                                                                                                       //
  getSettingWithFallback: function getSettingWithFallback(name, fallbackValue) {                                       // 1319
    var value = this.getSetting(name);                                                                                 // 1320
    if (value === undefined) {                                                                                         // 1321
      return fallbackValue;                                                                                            // 1322
    }                                                                                                                  // 1323
                                                                                                                       //
    return value;                                                                                                      // 1325
  },                                                                                                                   // 1326
                                                                                                                       //
  addUserActions: function addUserActions(userId, packageId, simulation) {                                             // 1328
    check(userId, String);                                                                                             // 1329
    check(packageId, String);                                                                                          // 1330
                                                                                                                       //
    var pack = Packages.findOne({ _id: packageId });                                                                   // 1332
    if (pack) {                                                                                                        // 1333
      // Remove old versions.                                                                                          //
      var numRemoved = UserActions.remove({ userId: userId, appId: pack.appId });                                      // 1335
                                                                                                                       //
      // Install new.                                                                                                  //
      var actions = pack.manifest.actions;                                                                             // 1338
      for (var i in actions) {                                                                                         // 1339
        var action = actions[i];                                                                                       // 1340
        if ("none" in action.input) {                                                                                  // 1341
          var userAction = {                                                                                           // 1342
            userId: userId,                                                                                            // 1343
            packageId: pack._id,                                                                                       // 1344
            appId: pack.appId,                                                                                         // 1345
            appTitle: pack.manifest.appTitle,                                                                          // 1346
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1347
            appVersion: pack.manifest.appVersion,                                                                      // 1348
            title: action.title,                                                                                       // 1349
            nounPhrase: action.nounPhrase,                                                                             // 1350
            command: action.command                                                                                    // 1351
          };                                                                                                           // 1342
          UserActions.insert(userAction);                                                                              // 1353
        } else {                                                                                                       // 1354
          // TODO(someday):  Implement actions with capability inputs.                                                 //
        }                                                                                                              // 1356
      }                                                                                                                // 1357
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1359
        this.deleteUnusedPackages(pack.appId);                                                                         // 1360
      }                                                                                                                // 1361
    }                                                                                                                  // 1362
  },                                                                                                                   // 1363
                                                                                                                       //
  sendAdminNotification: function sendAdminNotification(message, link) {                                               // 1365
    Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                             // 1366
      Notifications.insert({                                                                                           // 1367
        admin: {                                                                                                       // 1368
          action: link,                                                                                                // 1369
          type: "reportStats"                                                                                          // 1370
        },                                                                                                             // 1368
        userId: user._id,                                                                                              // 1372
        text: { defaultText: message },                                                                                // 1373
        timestamp: new Date(),                                                                                         // 1374
        isUnread: true                                                                                                 // 1375
      });                                                                                                              // 1367
    });                                                                                                                // 1377
  },                                                                                                                   // 1378
                                                                                                                       //
  getKeybaseProfile: function getKeybaseProfile(keyFingerprint) {                                                      // 1380
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1381
  },                                                                                                                   // 1382
                                                                                                                       //
  getServerTitle: function getServerTitle() {                                                                          // 1384
    var setting = Settings.findOne({ _id: "serverTitle" });                                                            // 1385
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1386
  },                                                                                                                   // 1387
                                                                                                                       //
  getSmtpConfig: function getSmtpConfig() {                                                                            // 1389
    var setting = Settings.findOne({ _id: "smtpConfig" });                                                             // 1390
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1391
  },                                                                                                                   // 1392
                                                                                                                       //
                                                                                                                       //
  getReturnAddress: function getReturnAddress() {                                                                      // 1394
    var config = this.getSmtpConfig();                                                                                 // 1395
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1396
  },                                                                                                                   // 1397
                                                                                                                       //
  getReturnAddressWithDisplayName: function getReturnAddressWithDisplayName(identityId) {                              // 1399
    check(identityId, String);                                                                                         // 1400
    var identity = this.getIdentity(identityId);                                                                       // 1401
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                  // 1402
                                                                                                                       //
    // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                            //
    // we could escape such characters with a backslash, but that does not seem to help here.                          //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1406
                                                                                                                       //
    return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                                  // 1408
  },                                                                                                                   // 1409
                                                                                                                       //
  getPrimaryEmail: function getPrimaryEmail(accountId, identityId) {                                                   // 1411
    check(accountId, String);                                                                                          // 1412
    check(identityId, String);                                                                                         // 1413
                                                                                                                       //
    var identity = this.getIdentity(identityId);                                                                       // 1415
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1416
    var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                             // 1417
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1418
    if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                            // 1419
      return accountPrimaryEmailAddress;                                                                               // 1420
    } else if (senderPrimaryEmail) {                                                                                   // 1421
      return senderPrimaryEmail.email;                                                                                 // 1422
    } else {                                                                                                           // 1423
      return null;                                                                                                     // 1424
    }                                                                                                                  // 1425
  },                                                                                                                   // 1426
                                                                                                                       //
  incrementDailySentMailCount: function incrementDailySentMailCount(accountId) {                                       // 1428
    check(accountId, String);                                                                                          // 1429
                                                                                                                       //
    var DAILY_LIMIT = 50;                                                                                              // 1431
    var user = Meteor.users.findAndModify({                                                                            // 1432
      query: { _id: accountId },                                                                                       // 1433
      update: {                                                                                                        // 1434
        $inc: {                                                                                                        // 1435
          dailySentMailCount: 1                                                                                        // 1436
        }                                                                                                              // 1435
      },                                                                                                               // 1434
      fields: { dailySentMailCount: 1 }                                                                                // 1439
    });                                                                                                                // 1432
                                                                                                                       //
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1442
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1447
  },                                                                                                                   // 1448
                                                                                                                       //
  isFeatureKeyValid: function isFeatureKeyValid() {                                                                    // 1450
    var featureKey = this.currentFeatureKey();                                                                         // 1451
    return !!featureKey;                                                                                               // 1452
  },                                                                                                                   // 1453
                                                                                                                       //
  isFeatureKeyValidAndNotExpired: function isFeatureKeyValidAndNotExpired() {                                          // 1455
    var featureKey = this.currentFeatureKey();                                                                         // 1456
    return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                             // 1457
  },                                                                                                                   // 1458
                                                                                                                       //
  getLdapUrl: function getLdapUrl() {                                                                                  // 1460
    var setting = Settings.findOne({ _id: "ldapUrl" });                                                                // 1461
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1462
  },                                                                                                                   // 1463
                                                                                                                       //
  getLdapBase: function getLdapBase() {                                                                                // 1465
    var setting = Settings.findOne({ _id: "ldapBase" });                                                               // 1466
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1467
  },                                                                                                                   // 1468
                                                                                                                       //
  getLdapDnPattern: function getLdapDnPattern() {                                                                      // 1470
    var setting = Settings.findOne({ _id: "ldapDnPattern" });                                                          // 1471
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1472
  },                                                                                                                   // 1473
                                                                                                                       //
  getLdapSearchUsername: function getLdapSearchUsername() {                                                            // 1475
    var setting = Settings.findOne({ _id: "ldapSearchUsername" });                                                     // 1476
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1477
  },                                                                                                                   // 1478
                                                                                                                       //
  getLdapNameField: function getLdapNameField() {                                                                      // 1480
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 1481
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1482
  },                                                                                                                   // 1483
                                                                                                                       //
  getLdapEmailField: function getLdapEmailField() {                                                                    // 1485
    var setting = Settings.findOne({ _id: "ldapEmailField" });                                                         // 1486
    return setting ? setting.value : "mail";                                                                           // 1487
    // default to "mail". This setting was added later, and so could potentially be unset.                             //
  },                                                                                                                   // 1489
                                                                                                                       //
  getLdapExplicitDnSelected: function getLdapExplicitDnSelected() {                                                    // 1491
    var setting = Settings.findOne({ _id: "ldapExplicitDnSelected" });                                                 // 1492
    return setting && setting.value;                                                                                   // 1493
  },                                                                                                                   // 1494
                                                                                                                       //
  getLdapFilter: function getLdapFilter() {                                                                            // 1496
    var setting = Settings.findOne({ _id: "ldapFilter" });                                                             // 1497
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1498
  },                                                                                                                   // 1499
                                                                                                                       //
  getLdapSearchBindDn: function getLdapSearchBindDn() {                                                                // 1501
    var setting = Settings.findOne({ _id: "ldapSearchBindDn" });                                                       // 1502
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1503
  },                                                                                                                   // 1504
                                                                                                                       //
  getLdapSearchBindPassword: function getLdapSearchBindPassword() {                                                    // 1506
    var setting = Settings.findOne({ _id: "ldapSearchBindPassword" });                                                 // 1507
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1508
  },                                                                                                                   // 1509
                                                                                                                       //
  getOrganizationMembership: function getOrganizationMembership() {                                                    // 1511
    var setting = Settings.findOne({ _id: "organizationMembership" });                                                 // 1512
    return setting && setting.value;                                                                                   // 1513
  },                                                                                                                   // 1514
                                                                                                                       //
  getOrganizationEmailEnabled: function getOrganizationEmailEnabled() {                                                // 1516
    var membership = this.getOrganizationMembership();                                                                 // 1517
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1518
  },                                                                                                                   // 1519
                                                                                                                       //
  getOrganizationEmailDomain: function getOrganizationEmailDomain() {                                                  // 1521
    var membership = this.getOrganizationMembership();                                                                 // 1522
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1523
  },                                                                                                                   // 1524
                                                                                                                       //
  getOrganizationGoogleEnabled: function getOrganizationGoogleEnabled() {                                              // 1526
    var membership = this.getOrganizationMembership();                                                                 // 1527
    return membership && membership.google && membership.google.enabled;                                               // 1528
  },                                                                                                                   // 1529
                                                                                                                       //
  getOrganizationGoogleDomain: function getOrganizationGoogleDomain() {                                                // 1531
    var membership = this.getOrganizationMembership();                                                                 // 1532
    return membership && membership.google && membership.google.domain;                                                // 1533
  },                                                                                                                   // 1534
                                                                                                                       //
  getOrganizationLdapEnabled: function getOrganizationLdapEnabled() {                                                  // 1536
    var membership = this.getOrganizationMembership();                                                                 // 1537
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1538
  },                                                                                                                   // 1539
                                                                                                                       //
  getOrganizationSamlEnabled: function getOrganizationSamlEnabled() {                                                  // 1541
    var membership = this.getOrganizationMembership();                                                                 // 1542
    return membership && membership.saml && membership.saml.enabled;                                                   // 1543
  },                                                                                                                   // 1544
                                                                                                                       //
  getOrganizationDisallowGuests: function getOrganizationDisallowGuests() {                                            // 1546
    return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                        // 1547
  },                                                                                                                   // 1548
                                                                                                                       //
  getOrganizationDisallowGuestsRaw: function getOrganizationDisallowGuestsRaw() {                                      // 1550
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1551
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1552
  },                                                                                                                   // 1553
                                                                                                                       //
  getOrganizationShareContacts: function getOrganizationShareContacts() {                                              // 1555
    return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                         // 1556
  },                                                                                                                   // 1557
                                                                                                                       //
  getOrganizationShareContactsRaw: function getOrganizationShareContactsRaw() {                                        // 1559
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1560
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1561
      // default to true if undefined                                                                                  //
      return true;                                                                                                     // 1563
    } else {                                                                                                           // 1564
      return setting.value.shareContacts;                                                                              // 1565
    }                                                                                                                  // 1566
  },                                                                                                                   // 1567
                                                                                                                       //
  getSamlEntryPoint: function getSamlEntryPoint() {                                                                    // 1569
    var setting = Settings.findOne({ _id: "samlEntryPoint" });                                                         // 1570
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1571
  },                                                                                                                   // 1572
                                                                                                                       //
  getSamlPublicCert: function getSamlPublicCert() {                                                                    // 1574
    var setting = Settings.findOne({ _id: "samlPublicCert" });                                                         // 1575
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1576
  },                                                                                                                   // 1577
                                                                                                                       //
  getSamlEntityId: function getSamlEntityId() {                                                                        // 1579
    var setting = Settings.findOne({ _id: "samlEntityId" });                                                           // 1580
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1581
  },                                                                                                                   // 1582
                                                                                                                       //
  getActivitySubscriptions: function getActivitySubscriptions(grainId, threadPath) {                                   // 1584
    return ActivitySubscriptions.find({                                                                                // 1585
      grainId: grainId,                                                                                                // 1586
      threadPath: threadPath || { $exists: false }                                                                     // 1587
    }, {                                                                                                               // 1585
      fields: { identityId: 1, mute: 1, _id: 0 }                                                                       // 1589
    }).fetch();                                                                                                        // 1588
  },                                                                                                                   // 1591
                                                                                                                       //
  subscribeToActivity: function subscribeToActivity(identityId, grainId, threadPath) {                                 // 1593
    // Subscribe the given identity to activity events with the given grainId and (optional)                           //
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        //
    // case do nothing.                                                                                                //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1598
    if (threadPath) {                                                                                                  // 1599
      record.threadPath = threadPath;                                                                                  // 1600
    }                                                                                                                  // 1601
                                                                                                                       //
    // The $set here is redundant since an upsert automatically initializes a new record to contain                    //
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      //
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    //
    // What a wonderful query language.                                                                                //
    ActivitySubscriptions.upsert(record, { $set: record });                                                            // 1607
  },                                                                                                                   // 1608
                                                                                                                       //
  muteActivity: function muteActivity(identityId, grainId, threadPath) {                                               // 1610
    // Mute notifications for the given identity originating from the given grainId and                                //
    // (optional) threadPath.                                                                                          //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1614
    if (threadPath) {                                                                                                  // 1615
      record.threadPath = threadPath;                                                                                  // 1616
    }                                                                                                                  // 1617
                                                                                                                       //
    ActivitySubscriptions.upsert(record, { $set: { mute: true } });                                                    // 1619
  },                                                                                                                   // 1620
                                                                                                                       //
  updateAppIndex: function updateAppIndex() {                                                                          // 1622
    var _this2 = this;                                                                                                 // 1622
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                    // 1623
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1624
    if (!appUpdatesEnabled) {                                                                                          // 1625
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       //
      // timer that triggers this call.                                                                                //
      return;                                                                                                          // 1628
    }                                                                                                                  // 1629
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1631
    var appIndex = this.collections.appIndex;                                                                          // 1632
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1633
    var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                          // 1634
    // We make sure to get all preinstalled appIds, even ones that are currently                                       //
    // downloading/failed.                                                                                             //
    data.apps.forEach(function (app) {                                                                                 // 1637
      app._id = app.appId;                                                                                             // 1638
                                                                                                                       //
      var oldApp = appIndex.findOne({ _id: app.appId });                                                               // 1640
      app.hasSentNotifications = false;                                                                                // 1641
      appIndex.upsert({ _id: app._id }, app);                                                                          // 1642
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1643
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this2.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
        var pack = _this2.collections.packages.findOne({ _id: app.packageId });                                        // 1647
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1648
        if (pack) {                                                                                                    // 1649
          if (pack.status === "ready") {                                                                               // 1650
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1651
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1652
            } else {                                                                                                   // 1654
              _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1655
            }                                                                                                          // 1657
          } else {                                                                                                     // 1658
            var newPack = Packages.findAndModify({                                                                     // 1659
              query: { _id: app.packageId },                                                                           // 1660
              update: { $set: { isAutoUpdated: true } }                                                                // 1661
            });                                                                                                        // 1659
            if (newPack.status === "ready") {                                                                          // 1663
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  //
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  //
              // fine, since it will de-dupe).                                                                         //
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1667
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1668
              } else {                                                                                                 // 1670
                _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
              }                                                                                                        // 1673
            } else if (newPack.status === "failed") {                                                                  // 1674
              // If the package has failed, retry it                                                                   //
              _this2.startInstall(app.packageId, url, true, true);                                                     // 1676
            }                                                                                                          // 1677
          }                                                                                                            // 1678
        } else {                                                                                                       // 1679
          _this2.startInstall(app.packageId, url, false, true);                                                        // 1680
        }                                                                                                              // 1681
      }                                                                                                                // 1682
    });                                                                                                                // 1683
  },                                                                                                                   // 1684
                                                                                                                       //
  isPackagePreinstalled: function isPackagePreinstalled(packageId) {                                                   // 1686
    return Settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;                     // 1687
  },                                                                                                                   // 1688
                                                                                                                       //
  getAppIdForPreinstalledPackage: function getAppIdForPreinstalledPackage(packageId) {                                 // 1690
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1695
  },                                                                                                                   // 1696
                                                                                                                       //
  getPackageIdForPreinstalledApp: function getPackageIdForPreinstalledApp(appId) {                                     // 1698
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });   // 1699
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1703
  },                                                                                                                   // 1704
                                                                                                                       //
  getReadyPreinstalledAppIds: function getReadyPreinstalledAppIds() {                                                  // 1706
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1707
    var ret = setting && setting.value || [];                                                                          // 1708
    return _.chain(ret).filter(function (app) {                                                                        // 1709
      return app.status === "ready";                                                                                   // 1710
    }).map(function (app) {                                                                                            // 1710
      return app.appId;                                                                                                // 1711
    }).value();                                                                                                        // 1711
  },                                                                                                                   // 1713
                                                                                                                       //
  getAllPreinstalledAppIds: function getAllPreinstalledAppIds() {                                                      // 1715
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1716
    var ret = setting && setting.value || [];                                                                          // 1717
    return _.map(ret, function (app) {                                                                                 // 1718
      return app.appId;                                                                                                // 1718
    });                                                                                                                // 1718
  },                                                                                                                   // 1719
                                                                                                                       //
  preinstallAppsForUser: function preinstallAppsForUser(userId) {                                                      // 1721
    var _this3 = this;                                                                                                 // 1721
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1722
    appIds.forEach(function (appId) {                                                                                  // 1723
      try {                                                                                                            // 1724
        _this3.addUserActions(userId, _this3.getPackageIdForPreinstalledApp(appId));                                   // 1725
      } catch (e) {                                                                                                    // 1726
        console.error("failed to install app for user:", e);                                                           // 1727
      }                                                                                                                // 1728
    });                                                                                                                // 1729
  },                                                                                                                   // 1730
                                                                                                                       //
  setPreinstallAppAsDownloading: function setPreinstallAppAsDownloading(appId, packageId) {                            // 1732
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
  },                                                                                                                   // 1736
                                                                                                                       //
  setPreinstallAppAsReady: function setPreinstallAppAsReady(appId, packageId) {                                        // 1738
    // This function both sets the appId as ready and updates the packageId for the given appId                        //
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            //
    // latest installed package will be set as ready.                                                                  //
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
  },                                                                                                                   // 1745
                                                                                                                       //
  ensureAppPreinstall: function ensureAppPreinstall(appId, packageId) {                                                // 1747
    check(appId, String);                                                                                              // 1748
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1749
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1750
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1751
    if (pack && pack.status === "ready") {                                                                             // 1752
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1753
    } else if (pack && pack.status === "failed") {                                                                     // 1754
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1755
      this.startInstall(packageId, url, true, false);                                                                  // 1756
    } else {                                                                                                           // 1757
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1758
      this.startInstall(packageId, url, false, false);                                                                 // 1759
    }                                                                                                                  // 1760
  },                                                                                                                   // 1761
                                                                                                                       //
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 1763
    var _this4 = this;                                                                                                 // 1763
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 //
    //     appId: The Packages.appId of the app to install                                                             //
    //     packageId: The Packages._id of the app to install                                                           //
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 1767
                                                                                                                       //
    // Start by clearing out the setting. We'll push appIds one by one to it                                           //
    this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                            // 1770
        value: appAndPackageIds.map(function (data) {                                                                  // 1771
          return {                                                                                                     // 1772
            appId: data.appId,                                                                                         // 1773
            status: "notReady",                                                                                        // 1774
            packageId: data.packageId                                                                                  // 1775
          };                                                                                                           // 1772
        })                                                                                                             // 1777
      } });                                                                                                            // 1770
    appAndPackageIds.forEach(function (data) {                                                                         // 1779
      _this4.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1780
    });                                                                                                                // 1781
  },                                                                                                                   // 1782
                                                                                                                       //
  getProductivitySuiteAppIds: function getProductivitySuiteAppIds() {                                                  // 1784
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1785
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1787
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1788
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1789
  },                                                                                                                   // 1791
                                                                                                                       //
  // Wekan                                                                                                             //
  getSystemSuiteAppIds: function getSystemSuiteAppIds() {                                                              // 1793
    return [];                                                                                                         // 1794
  },                                                                                                                   // 1795
                                                                                                                       //
  isPreinstalledAppsReady: function isPreinstalledAppsReady() {                                                        // 1797
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1798
    if (!setting || !setting.value) {                                                                                  // 1799
      return true;                                                                                                     // 1800
    }                                                                                                                  // 1801
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1803
    var readyApps = this.collections.packages.find({                                                                   // 1804
      _id: {                                                                                                           // 1805
        $in: packageIds                                                                                                // 1806
      },                                                                                                               // 1805
      status: "ready"                                                                                                  // 1808
    });                                                                                                                // 1804
    return readyApps.count() === packageIds.length;                                                                    // 1810
  }                                                                                                                    // 1811
});                                                                                                                    // 1166
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 1814
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   //
  // and seems to be a de facto standard, for example:                                                                 //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  //
  return key.replace(".", "．").replace("$", "＄");                                                                      // 1819
};                                                                                                                     // 1820
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 1822
  // This function takes a Package object from Mongo and returns an                                                    //
  // app title.                                                                                                        //
  var manifest = packageObj.manifest;                                                                                  // 1825
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 1826
  var action = manifest.actions[0];                                                                                    // 1827
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 1828
  return appName;                                                                                                      // 1830
};                                                                                                                     // 1831
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 1833
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  //
  //   derive the app title from the action title.                                                                     //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        //
  if (!name) {                                                                                                         // 1838
    return "(unnamed)";                                                                                                // 1839
  }                                                                                                                    // 1840
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 1842
    name = name.slice(4);                                                                                              // 1843
  }                                                                                                                    // 1844
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 1846
    name = "Hacker CMS";                                                                                               // 1847
  } else {                                                                                                             // 1848
    var space = name.indexOf(" ");                                                                                     // 1849
    if (space > 0) {                                                                                                   // 1850
      name = name.slice(0, space);                                                                                     // 1851
    }                                                                                                                  // 1852
  }                                                                                                                    // 1853
                                                                                                                       //
  return name;                                                                                                         // 1855
};                                                                                                                     // 1856
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 1858
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 1862
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 1864
  // A hack to deal with legacy apps not including fields in their manifests.                                          //
  // I look forward to the day I can remove most of this code.                                                         //
  // Attempt to figure out the appropriate noun that this action will create.                                          //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 1869
  // Otherwise, try to guess one from the structure of the action title field                                          //
  if (action.title && action.title.defaultText) {                                                                      // 1871
    var text = action.title.defaultText;                                                                               // 1872
    // Strip a leading "New "                                                                                          //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 1874
      var candidate = text.slice(4);                                                                                   // 1875
      // Strip a leading appname too, if provided                                                                      //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 1877
        var newCandidate = candidate.slice(appTitle.length);                                                           // 1878
        // Unless that leaves you with no noun, in which case, use "grain"                                             //
        if (newCandidate.length > 0) {                                                                                 // 1880
          return newCandidate.toLowerCase();                                                                           // 1881
        } else {                                                                                                       // 1882
          return "grain";                                                                                              // 1883
        }                                                                                                              // 1884
      }                                                                                                                // 1885
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 1887
    }                                                                                                                  // 1888
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        //
    // the package soon.                                                                                               //
    return text;                                                                                                       // 1891
  } else {                                                                                                             // 1892
    return "grain";                                                                                                    // 1893
  }                                                                                                                    // 1894
};                                                                                                                     // 1895
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          //
// Largely things that deal with backwards-compatibility.                                                              //
_.extend(SandstormDb, {                                                                                                // 1899
  appNameFromActionName: appNameFromActionName,                                                                        // 1900
  appNameFromPackage: appNameFromPackage,                                                                              // 1901
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 1902
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 1903
});                                                                                                                    // 1899
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1906
  (function () {                                                                                                       // 1906
    var cleanupExpiredAssetUploads = function cleanupExpiredAssetUploads() {                                           // 1906
      AssetUploadTokens.remove({ expires: { $lt: Date.now() } });                                                      // 2108
    };                                                                                                                 // 2109
                                                                                                                       //
    // Cleanup tokens every hour.                                                                                      //
                                                                                                                       //
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1907
    var ContentType = Npm.require("content-type");                                                                     // 1908
    var Zlib = Npm.require("zlib");                                                                                    // 1909
    var Url = Npm.require("url");                                                                                      // 1910
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 1912
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 1914
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         //
      // The sequence looks like:                                                                                      //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             //
      //                                                                                                               //
      // We use this to determine how we'll stagger periodic events performed by this replica.                         //
      // Notice that this allows us to compute a stagger which is independent of the number of                         //
      // front-end replicas present; we can add more replicas to the end without affecting how the                     //
      // earlier ones schedule their events.                                                                           //
      var denom = 1;                                                                                                   // 1924
      while (denom <= n) {                                                                                             // 1925
        denom <<= 1;                                                                                                   // 1925
      }var num = n * 2 - denom + 1;                                                                                    // 1925
      return num / denom;                                                                                              // 1927
    };                                                                                                                 // 1928
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 1930
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 1932
      // Register a database cleanup function than should run periodically, roughly once every                         //
      // interval of the given length.                                                                                 //
      //                                                                                                               //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      //
      // scaled appropriately on the assumption that more data is being generated demanding more                       //
      // frequent cleanups.                                                                                            //
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 1940
      check(callback, Function);                                                                                       // 1941
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 1943
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 1944
      }                                                                                                                // 1946
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      //
      // the schedule is independent of the exact startup time.                                                        //
      var first = intervalMs - Date.now() % intervalMs;                                                                // 1950
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       //
      // same data at the same time.                                                                                   //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 1954
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           //
      if (first > intervalMs) first -= intervalMs;                                                                     // 1957
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 1959
        callback();                                                                                                    // 1960
        Meteor.setInterval(callback, intervalMs);                                                                      // 1961
      }, first);                                                                                                       // 1962
    };                                                                                                                 // 1963
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 1966
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 1968
      return Match.Where(function (buf) {                                                                              // 1969
        check(buf, Buffer);                                                                                            // 1970
        return buf.length < limit;                                                                                     // 1971
      });                                                                                                              // 1972
    };                                                                                                                 // 1973
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 1975
      check(s, String);                                                                                                // 1976
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 1977
    });                                                                                                                // 1978
                                                                                                                       //
    addStaticAsset = function addStaticAsset(metadata, content) {                                                      // 1980
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  //
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 1984
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 1985
        metadata.encoding = "gzip";                                                                                    // 1986
      }                                                                                                                // 1987
                                                                                                                       //
      check(metadata, {                                                                                                // 1989
        mimeType: String,                                                                                              // 1990
        encoding: Match.Optional("gzip")                                                                               // 1991
      });                                                                                                              // 1989
      check(content, BufferSmallerThan(1 << 20));                                                                      // 1993
                                                                                                                       //
      // Validate content type.                                                                                        //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 1996
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 1998
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 1999
      hasher.update(content);                                                                                          // 2000
      var hash = hasher.digest("base64");                                                                              // 2001
                                                                                                                       //
      var existing = StaticAssets.findAndModify({                                                                      // 2003
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2004
        update: { $inc: { refcount: 1 } },                                                                             // 2005
        fields: { _id: 1, refcount: 1 }                                                                                // 2006
      });                                                                                                              // 2003
      if (existing) {                                                                                                  // 2008
        return existing._id;                                                                                           // 2009
      }                                                                                                                // 2010
                                                                                                                       //
      return StaticAssets.insert(_.extend({                                                                            // 2012
        hash: hash,                                                                                                    // 2013
        content: content,                                                                                              // 2014
        refcount: 1                                                                                                    // 2015
      }, metadata));                                                                                                   // 2012
    };                                                                                                                 // 2017
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = addStaticAsset;                                                             // 2019
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2021
      // Increment the refcount on an existing static asset. Returns the asset on success.                             //
      // If the asset does not exist, returns a falsey value.                                                          //
      //                                                                                                               //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2029
                                                                                                                       //
      var existing = StaticAssets.findAndModify({                                                                      // 2031
        query: { hash: hash },                                                                                         // 2032
        update: { $inc: { refcount: 1 } },                                                                             // 2033
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2034
      });                                                                                                              // 2031
                                                                                                                       //
      return existing;                                                                                                 // 2037
    };                                                                                                                 // 2038
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2040
      // Decrement refcount on a static asset and delete if it has reached zero.                                       //
      //                                                                                                               //
      // You must call this AFTER removing the reference from the DB, in case of failure between                       //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2047
                                                                                                                       //
      var existing = StaticAssets.findAndModify({                                                                      // 2049
        query: { _id: id },                                                                                            // 2050
        update: { $inc: { refcount: -1 } },                                                                            // 2051
        fields: { _id: 1, refcount: 1 },                                                                               // 2052
        "new": true                                                                                                    // 2053
      });                                                                                                              // 2049
      if (!existing) {                                                                                                 // 2055
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2056
      } else if (existing.refcount <= 0) {                                                                             // 2057
        StaticAssets.remove({ _id: existing._id });                                                                    // 2058
      }                                                                                                                // 2059
    };                                                                                                                 // 2060
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2062
      // Get a static asset's mimeType, encoding, and raw content.                                                     //
                                                                                                                       //
      check(id, String);                                                                                               // 2065
                                                                                                                       //
      var asset = StaticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });              // 2067
      if (asset) {                                                                                                     // 2068
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      //
        //   here.                                                                                                     //
        asset.content = new Buffer(asset.content);                                                                     // 2071
      }                                                                                                                // 2072
                                                                                                                       //
      return asset;                                                                                                    // 2074
    };                                                                                                                 // 2075
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2077
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return AssetUploadTokens.insert({                                                                                // 2083
        purpose: purpose,                                                                                              // 2084
        expires: new Date(Date.now() + 300000) });                                                                     // 2085
    };                                                                                                                 // 2087
                                                                                                                       //
    // in 5 minutes                                                                                                    //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2089
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       //
      // returned. If no matching upload exists, returns undefined.                                                    //
                                                                                                                       //
      check(id, String);                                                                                               // 2093
                                                                                                                       //
      var upload = AssetUploadTokens.findAndModify({                                                                   // 2095
        query: { _id: id },                                                                                            // 2096
        remove: true                                                                                                   // 2097
      });                                                                                                              // 2095
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2100
        return undefined; // already expired                                                                           // 2101
      } else {                                                                                                         // 2102
          return upload.purpose;                                                                                       // 2103
        }                                                                                                              // 2104
    };                                                                                                                 // 2105
                                                                                                                       //
    SandstormDb.periodicCleanup(3600000, cleanupExpiredAssetUploads);                                                  // 2112
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2114
      var _this5 = this;                                                                                               // 2114
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         //
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2117
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2119
      Grains.find(query).forEach(function (grain) {                                                                    // 2120
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2121
        numDeleted += Grains.remove({ _id: grain._id });                                                               // 2122
        _this5.removeApiTokens({                                                                                       // 2123
          grainId: grain._id,                                                                                          // 2124
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2125
        });                                                                                                            // 2123
                                                                                                                       //
        _this5.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2131
                                                                                                                       //
        ActivitySubscriptions.remove({ grainId: grain._id });                                                          // 2133
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2135
          DeleteStats.insert({                                                                                         // 2136
            type: "grain", // Demo grains can never get here!                                                          // 2137
            lastActive: grain.lastUsed,                                                                                // 2138
            appId: grain.appId                                                                                         // 2139
          });                                                                                                          // 2136
        }                                                                                                              // 2141
                                                                                                                       //
        _this5.deleteUnusedPackages(grain.appId);                                                                      // 2143
      });                                                                                                              // 2144
      return numDeleted;                                                                                               // 2145
    };                                                                                                                 // 2146
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2148
      check(grainId, String);                                                                                          // 2149
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2150
      check(identityId, String);                                                                                       // 2151
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2153
      if (!grain) {                                                                                                    // 2154
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2155
      }                                                                                                                // 2156
                                                                                                                       //
      var title = grain.title;                                                                                         // 2158
      if (grain.userId !== accountId) {                                                                                // 2159
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2160
          grainId: grainId,                                                                                            // 2161
          "owner.user.identityId": identityId                                                                          // 2162
        }, {                                                                                                           // 2160
          sort: {                                                                                                      // 2164
            lastUsed: -1                                                                                               // 2165
          }                                                                                                            // 2164
        });                                                                                                            // 2163
        if (sharerToken) {                                                                                             // 2168
          title = sharerToken.owner.user.title;                                                                        // 2169
        } else {                                                                                                       // 2170
          title = "shared grain";                                                                                      // 2171
        }                                                                                                              // 2172
      }                                                                                                                // 2173
                                                                                                                       //
      return title;                                                                                                    // 2175
    };                                                                                                                 // 2176
                                                                                                                       //
    var packageCache = {};                                                                                             // 2178
    // Package info is immutable. Let's cache to save on mongo queries.                                                //
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2181
      // Get the given package record. Since package info is immutable, cache the data in the server                   //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       //
      // lot.                                                                                                          //
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2186
        return packageCache[packageId];                                                                                // 2187
      }                                                                                                                // 2188
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 2190
      if (pkg && pkg.status === "ready") {                                                                             // 2191
        packageCache[packageId] = pkg;                                                                                 // 2192
      }                                                                                                                // 2193
                                                                                                                       //
      return pkg;                                                                                                      // 2195
    };                                                                                                                 // 2196
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2198
      check(appId, String);                                                                                            // 2199
      Packages.find({ appId: appId }).forEach(function (pkg) {                                                         // 2200
        // Mark package for possible deletion;                                                                         //
        Packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });                         // 2202
      });                                                                                                              // 2203
    };                                                                                                                 // 2204
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this = this;                                                                                                // 2208
      var actions = _this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2211
        var userId = action.userId;                                                                                    // 2212
        var updater = {                                                                                                // 2213
          timestamp: new Date(),                                                                                       // 2214
          isUnread: true                                                                                               // 2215
        };                                                                                                             // 2213
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2217
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    //
        // field inside of an object to update                                                                         //
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2221
          marketingVersion: marketingVersion,                                                                          // 2222
          packageId: packageId,                                                                                        // 2223
          name: name,                                                                                                  // 2224
          version: versionNumber                                                                                       // 2225
        };                                                                                                             // 2221
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   //
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       //
        if (_this.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     //
          _this.collections.notifications.insert(inserter);                                                            // 2234
        }                                                                                                              // 2235
      });                                                                                                              // 2236
                                                                                                                       //
      _this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                     // 2238
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  //
      // package, we need to clean it up                                                                               //
      this.deleteUnusedPackages(appId);                                                                                // 2242
    };                                                                                                                 // 2243
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = sendReferralProgramNotification;                           // 2245
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2247
      check(appId, String);                                                                                            // 2248
      check(version, Match.Integer);                                                                                   // 2249
      check(packageId, String);                                                                                        // 2250
                                                                                                                       //
      var selector = {                                                                                                 // 2252
        userId: Meteor.userId(),                                                                                       // 2253
        appId: appId,                                                                                                  // 2254
        appVersion: { $lte: version },                                                                                 // 2255
        packageId: { $ne: packageId }                                                                                  // 2256
      };                                                                                                               // 2252
                                                                                                                       //
      Grains.find(selector).forEach(function (grain) {                                                                 // 2259
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2260
      });                                                                                                              // 2261
                                                                                                                       //
      Grains.update(selector, {                                                                                        // 2263
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2264
      }, { multi: true });                                                                                             // 2263
    };                                                                                                                 // 2266
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2268
      // Mark package for possible installation.                                                                       //
                                                                                                                       //
      var fields = {                                                                                                   // 2271
        status: "download",                                                                                            // 2272
        progress: 0,                                                                                                   // 2273
        url: url,                                                                                                      // 2274
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2275
      };                                                                                                               // 2271
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2278
        Packages.update({ _id: packageId, status: "failed" }, { $set: fields });                                       // 2279
      } else {                                                                                                         // 2280
        try {                                                                                                          // 2281
          fields._id = packageId;                                                                                      // 2282
          Packages.insert(fields);                                                                                     // 2283
        } catch (err) {                                                                                                // 2284
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2285
        }                                                                                                              // 2286
      }                                                                                                                // 2287
    };                                                                                                                 // 2288
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2290
      check(keyFingerprint, String);                                                                                   // 2291
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2292
    });                                                                                                                // 2293
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2295
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   //
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2298
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2300
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2305
      }, function (err, keybaseResponse) {                                                                             // 2304
        if (err) {                                                                                                     // 2307
          console.log("keybase lookup error:", err.stack);                                                             // 2308
          return;                                                                                                      // 2309
        }                                                                                                              // 2310
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2312
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2313
          return;                                                                                                      // 2314
        }                                                                                                              // 2315
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2317
                                                                                                                       //
        if (profile) {                                                                                                 // 2319
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       //
          var record = {                                                                                               // 2321
            displayName: (profile.profile || {}).full_name,                                                            // 2322
            handle: (profile.basics || {}).username,                                                                   // 2323
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2324
          };                                                                                                           // 2321
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        //
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2328
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    //
            // this would filter.)                                                                                     //
            for (var field in proof) {                                                                                 // 2331
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        //
              // return any objects anyway).                                                                           //
              if (field.match(/[.$]/) || (0, _typeof3["default"])(proof[field]) === "object") {                        // 2335
                delete proof[field];                                                                                   // 2336
              }                                                                                                        // 2337
            }                                                                                                          // 2338
                                                                                                                       //
            // Indicate not verified.                                                                                  //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    //
            //   Keybase node-based CLI.                                                                               //
            proof.status = "unverified";                                                                               // 2343
          });                                                                                                          // 2344
                                                                                                                       //
          KeybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });                                  // 2346
        } else {                                                                                                       // 2347
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    //
          // from Keybase.                                                                                             //
          //                                                                                                           //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     //
          //   but at present we don't have the ability to verify proofs.                                              //
          KeybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2356
      });                                                                                                              // 2357
    };                                                                                                                 // 2358
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2360
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        //
                                                                                                                       //
      check(identityId, String);                                                                                       // 2363
      var account = Meteor.users.findOne({ "loginIdentities.id": identityId });                                        // 2364
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !Grains.findOne({ userId: account._id }) && !ApiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !Contacts.findOne({ ownerId: account._id })) {
        Meteor.users.remove({ _id: account._id });                                                                     // 2373
        backend.deleteUser(account._id);                                                                               // 2374
      }                                                                                                                // 2375
    };                                                                                                                 // 2376
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2378
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2379
      var db = this.connection.sandstormDb;                                                                            // 2380
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2382
      if (cursor.count() === 0) {                                                                                      // 2383
        // Fire off async update.                                                                                      //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2385
      }                                                                                                                // 2386
                                                                                                                       //
      return cursor;                                                                                                   // 2388
    });                                                                                                                // 2389
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2391
      check(appId, String);                                                                                            // 2392
      var db = this.connection.sandstormDb;                                                                            // 2393
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2394
      return cursor;                                                                                                   // 2395
    });                                                                                                                // 2396
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2398
      var _this6 = this;                                                                                               // 2398
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         //
      // 1. referenced by one of their userActions                                                                     //
      // 2. referenced by one of their grains                                                                          //
      var db = this.connection.sandstormDb;                                                                            // 2402
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    //
      // to reactively remove a package from the client side when it is removed on the server, or                      //
      // when the client stops using it, because the worst case is the client has a small amount                       //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    //
      // stuff, we push the package info to the client, and then we never update it.                                   //
      //                                                                                                               //
      // Alternatively, we could subscribe to each individual package query, but this would waste                      //
      // lots of server-side resources watching for events that will never happen or don't matter.                     //
      var hasPackage = {};                                                                                             // 2414
      var refPackage = function refPackage(packageId) {                                                                // 2415
        // Ignore dev apps.                                                                                            //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2417
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2419
          hasPackage[packageId] = true;                                                                                // 2420
          var pkg = db.getPackage(packageId);                                                                          // 2421
          if (pkg) {                                                                                                   // 2422
            _this6.added("packages", packageId, pkg);                                                                  // 2423
          } else {                                                                                                     // 2424
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2425
          }                                                                                                            // 2427
        }                                                                                                              // 2428
      };                                                                                                               // 2429
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             //
      var actions = db.userActions(this.userId);                                                                       // 2432
      var actionsHandle = actions.observe({                                                                            // 2433
        added: function added(newAction) {                                                                             // 2434
          refPackage(newAction.packageId);                                                                             // 2435
        },                                                                                                             // 2436
                                                                                                                       //
        changed: function changed(newAction, oldAction) {                                                              // 2438
          refPackage(newAction.packageId);                                                                             // 2439
        }                                                                                                              // 2440
      });                                                                                                              // 2433
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     //
      var grains = db.userGrains(this.userId);                                                                         // 2444
      var grainsHandle = grains.observe({                                                                              // 2445
        added: function added(newGrain) {                                                                              // 2446
          refPackage(newGrain.packageId);                                                                              // 2447
        },                                                                                                             // 2448
                                                                                                                       //
        changed: function changed(newGrain, oldGrain) {                                                                // 2450
          refPackage(newGrain.packageId);                                                                              // 2451
        }                                                                                                              // 2452
      });                                                                                                              // 2445
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2455
        actionsHandle.stop();                                                                                          // 2456
        grainsHandle.stop();                                                                                           // 2457
      });                                                                                                              // 2458
                                                                                                                       //
      this.ready();                                                                                                    // 2460
    });                                                                                                                // 2461
  })();                                                                                                                // 1906
}                                                                                                                      // 2462
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2464
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2465
    // Returns an object with all of the current signed feature key properties,                                        //
    // or undefined, if the feature key is missing or not correctly signed.                                            //
    var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                       // 2468
    if (!doc) return undefined;                                                                                        // 2469
    var buf = new Buffer(doc.value);                                                                                   // 2470
    // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                    //
    // once we can use ES6 modules.                                                                                    //
    return loadSignedFeatureKey(buf);                                                                                  // 2473
  };                                                                                                                   // 2474
} else {                                                                                                               // 2475
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2476
    var featureKey = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                // 2477
    if (featureKey && !featureKey.isFreeKey && featureKey.isTrial && parseInt(featureKey.expires) * 1000 < Date.now()) {
      // If feature key was a trial (but not explicitly a free key), and the trial is past its                         //
      // expiration date, mark as a free key instead, with a 15-user limit.                                            //
      featureKey.isFreeKey = true;                                                                                     // 2484
      featureKey.userLimit = 15;                                                                                       // 2485
    }                                                                                                                  // 2486
                                                                                                                       //
    return featureKey;                                                                                                 // 2488
  };                                                                                                                   // 2489
}                                                                                                                      // 2490
                                                                                                                       //
Meteor.methods({                                                                                                       // 2492
  addUserActions: function addUserActions(packageId) {                                                                 // 2493
    check(packageId, String);                                                                                          // 2494
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2495
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2496
    }                                                                                                                  // 2497
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2499
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      //
      //   a proper DB object to use.                                                                                  //
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2502
    } else {                                                                                                           // 2503
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2504
    }                                                                                                                  // 2505
  },                                                                                                                   // 2506
  removeUserAction: function removeUserAction(actionId) {                                                              // 2508
    check(actionId, String);                                                                                           // 2509
    if (this.isSimulation) {                                                                                           // 2510
      UserActions.remove({ _id: actionId });                                                                           // 2511
    } else {                                                                                                           // 2512
      if (this.userId) {                                                                                               // 2513
        var action = UserActions.findAndModify({                                                                       // 2514
          query: { _id: actionId, userId: this.userId },                                                               // 2515
          remove: true                                                                                                 // 2516
        });                                                                                                            // 2514
                                                                                                                       //
        if (action) {                                                                                                  // 2519
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2520
        }                                                                                                              // 2521
      }                                                                                                                // 2522
    }                                                                                                                  // 2523
  }                                                                                                                    // 2524
});                                                                                                                    // 2492
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       //
    // has a given identity linked. Automatically stops the subscription if the user loses the                         //
    // identity. Returns a boolean indicating whether the user initially has the identity.                             //
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function removed() {                                         // 47
            publishHandler.stop();                                                                                     // 47
          } });                                                                                                        // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret)) === "object") return _ret.v;    // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                //
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    // We only make identicons client-side.                                                                            //
    return undefined;                                                                                                  // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 //
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      //
      // anyway to be safe.                                                                                            //
      id = id.slice(0, 32);                                                                                            // 129
                                                                                                                       //
      if (id in identiconCache) {                                                                                      // 131
        return identiconCache[id];                                                                                     // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     //
      var data = new Identicon(id, 512).toString();                                                                    // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[id] = result;                                                                                     // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              //
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         //
  // on the same account.                                                                                              //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            //
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              //
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    var email = identity.services.ldap.rawAttrs[SandstormDb.prototype.getLdapEmailField()];                            // 266
    if (email) {                                                                                                       // 267
      return [{ email: email, primary: true }];                                                                        // 268
    }                                                                                                                  // 269
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 270
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 271
  }                                                                                                                    // 272
                                                                                                                       //
  return [];                                                                                                           // 274
};                                                                                                                     // 275
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 277
  // Returns an array of identities which have the given email address as one of their verified                        //
  // addresses.                                                                                                        //
                                                                                                                       //
  check(email, String);                                                                                                // 281
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 //
    return !!_findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                    // 290
  });                                                                                                                  // 291
};                                                                                                                     // 292
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 294
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 295
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 300
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 302
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 303
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 304
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 308
  // Given an account user object, returns an array containing the ID of each identity linked to the                   //
  // account. Always returns the most recently added login identity first.                                             //
  if (user && user.loginIdentities) {                                                                                  // 311
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 312
  } else {                                                                                                             // 313
    return [];                                                                                                         // 314
  }                                                                                                                    // 315
};                                                                                                                     // 316
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 318
  // Given a user object, returns an array containing all email addresses associated with that user.                   //
  // Each entry in the array is an object of the form:                                                                 //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    //
  //                                                                                                                   //
  // At most one entry in the result has `primary = true`.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         //
  //   on SandstormDb.                                                                                                 //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 329
  var verifiedEmails = {};                                                                                             // 330
  var unverifiedEmails = {};                                                                                           // 331
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 333
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 334
    if (identity && identity.services) {                                                                               // 335
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 336
        if (verifiedEmail) {                                                                                           // 337
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 338
        }                                                                                                              // 339
      });                                                                                                              // 340
    }                                                                                                                  // 341
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 343
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 344
    }                                                                                                                  // 345
  });                                                                                                                  // 346
                                                                                                                       //
  var result = [];                                                                                                     // 348
  _.keys(verifiedEmails).map(function (email) {                                                                        // 349
    result.push({ email: email,                                                                                        // 350
      verified: true,                                                                                                  // 351
      primary: email === user.primaryEmail });                                                                         // 352
  });                                                                                                                  // 353
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 355
    if (!(email in verifiedEmails)) {                                                                                  // 356
      result.push({ email: email, verified: false });                                                                  // 356
    }                                                                                                                  // 356
  });                                                                                                                  // 357
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 360
    result[0].primary = true;                                                                                          // 361
  }                                                                                                                    // 362
                                                                                                                       //
  return result;                                                                                                       // 364
};                                                                                                                     // 365
                                                                                                                       //
SandstormDb.prototype.addContact = function addContact(ownerId, identityId) {                                          // 367
  check(ownerId, String);                                                                                              // 368
  check(identityId, String);                                                                                           // 369
  var profile = this.getIdentity(identityId).profile;                                                                  // 370
  this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                     // 371
    ownerId: ownerId,                                                                                                  // 372
    petname: profile && profile.name,                                                                                  // 373
    created: new Date(),                                                                                               // 374
    identityId: identityId                                                                                             // 375
  });                                                                                                                  // 371
};                                                                                                                     // 377
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"user.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/user.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Future = Npm.require("fibers/future");                                                                             // 18
                                                                                                                       //
userPictureUrl = function userPictureUrl(user) {                                                                       // 20
  if (user.services && !(user.profile && user.profile.picture)) {                                                      // 21
    // Try to determine user's avatar URL from login service.                                                          //
                                                                                                                       //
    var google = user.services.google;                                                                                 // 24
    if (google && google.picture) {                                                                                    // 25
      return google.picture;                                                                                           // 26
    }                                                                                                                  // 27
                                                                                                                       //
    var github = user.services.github;                                                                                 // 29
    if (github && github.id) {                                                                                         // 30
      return "https://avatars.githubusercontent.com/u/" + github.id;                                                   // 31
    }                                                                                                                  // 32
                                                                                                                       //
    // Note that we do NOT support Gravatar for email addresses because pinging Gravatar would be                      //
    // a data leak, revealing that the user has logged into this Sandstorm server. Google and                          //
    // Github are different because they are actually the identity providers, so they already know                     //
    // the user logged in.                                                                                             //
  }                                                                                                                    // 38
};                                                                                                                     // 39
                                                                                                                       //
fetchPicture = function fetchPicture(url) {                                                                            // 41
  try {                                                                                                                // 42
    var result = HTTP.get(url, {                                                                                       // 43
      npmRequestOptions: { encoding: null },                                                                           // 44
      timeout: 5000                                                                                                    // 45
    });                                                                                                                // 43
                                                                                                                       //
    var metadata = {};                                                                                                 // 48
                                                                                                                       //
    metadata.mimeType = result.headers["content-type"];                                                                // 50
    if (metadata.mimeType.lastIndexOf("image/png", 0) === -1 && metadata.mimeType.lastIndexOf("image/jpeg", 0) === -1) {
      throw new Error("unexpected Content-Type:", metadata.mimeType);                                                  // 53
    }                                                                                                                  // 54
                                                                                                                       //
    var enc = result.headers["content-encoding"];                                                                      // 56
    if (enc && enc !== "identity") {                                                                                   // 57
      metadata.encoding = enc;                                                                                         // 58
    }                                                                                                                  // 59
                                                                                                                       //
    return addStaticAsset(metadata, result.content);                                                                   // 61
  } catch (err) {                                                                                                      // 62
    console.error("failed to fetch user profile picture:", url, err.stack);                                            // 63
  }                                                                                                                    // 64
};                                                                                                                     // 65
                                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                                      // 67
  check(handle, String);                                                                                               // 68
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                         // 69
});                                                                                                                    // 70
                                                                                                                       //
var localSandstormDb = new SandstormDb();                                                                              // 72
// TODO(someday): fix this when SandstormDb actually stores meaningful state on the object.                            //
// Unfortunately, onCreateUser doesn't pass along the connection object.                                               //
                                                                                                                       //
Accounts.onCreateUser(function (options, user) {                                                                       // 76
  if (user.loginIdentities) {                                                                                          // 77
    // it's an account                                                                                                 //
    check(user, { _id: String,                                                                                         // 79
      createdAt: Date,                                                                                                 // 80
      isAdmin: Match.Optional(Boolean),                                                                                // 81
      hasCompletedSignup: Match.Optional(Boolean),                                                                     // 82
      signupKey: Match.Optional(String),                                                                               // 83
      signupNote: Match.Optional(String),                                                                              // 84
      signupEmail: Match.Optional(String),                                                                             // 85
      expires: Match.Optional(Date),                                                                                   // 86
      appDemoId: Match.Optional(String),                                                                               // 87
      loginIdentities: [{ id: String }],                                                                               // 88
      nonloginIdentities: [{ id: String }] });                                                                         // 89
                                                                                                                       //
    if (Meteor.settings["public"].quotaEnabled) {                                                                      // 91
      user.experiments = user.experiments || {};                                                                       // 92
      user.experiments = {                                                                                             // 93
        firstTimeBillingPrompt: Math.random() < 0.5 ? "control" : "test"                                               // 94
      };                                                                                                               // 93
      if (!("expires" in user)) {                                                                                      // 96
        sendReferralProgramNotification(user._id);                                                                     // 97
      }                                                                                                                // 98
    }                                                                                                                  // 99
                                                                                                                       //
    localSandstormDb.preinstallAppsForUser(user._id);                                                                  // 101
                                                                                                                       //
    return user;                                                                                                       // 103
  }                                                                                                                    // 104
                                                                                                                       //
  if (localSandstormDb.getOrganizationDisallowGuests() && !localSandstormDb.isIdentityInOrganization(user)) {          // 106
    throw new Meteor.Error(400, "User not in organization.");                                                          // 108
  }                                                                                                                    // 109
                                                                                                                       //
  // Check profile.                                                                                                    //
  if (options.profile) {                                                                                               // 112
    // TODO(cleanup): This check also appears in accounts-ui-methods.js.                                               //
    check(options.profile, Match.ObjectIncluding({                                                                     // 114
      name: Match.OneOf(null, Match.Optional(String)),                                                                 // 115
      handle: Match.Optional(ValidHandle),                                                                             // 116
      pronoun: Match.Optional(Match.OneOf("male", "female", "neutral", "robot"))                                       // 117
    }));                                                                                                               // 114
  }                                                                                                                    // 119
                                                                                                                       //
  check(options.unverifiedEmail, Match.Optional(String));                                                              // 121
                                                                                                                       //
  if (options.unverifiedEmail) {                                                                                       // 123
    user.unverifiedEmail = options.unverifiedEmail;                                                                    // 124
  }                                                                                                                    // 125
                                                                                                                       //
  user.profile = _.pick(options.profile || {}, "name", "handle", "pronouns");                                          // 127
                                                                                                                       //
  // Try downloading avatar.                                                                                           //
  var url = userPictureUrl(user);                                                                                      // 130
  if (url) {                                                                                                           // 131
    var assetId = fetchPicture(url);                                                                                   // 132
    if (assetId) {                                                                                                     // 133
      user.profile.picture = assetId;                                                                                  // 134
    }                                                                                                                  // 135
  }                                                                                                                    // 136
                                                                                                                       //
  var serviceUserId = void 0;                                                                                          // 138
  if (user.services && user.services.dev) {                                                                            // 139
    check(user.services.dev, { name: String, isAdmin: Boolean, hasCompletedSignup: Boolean });                         // 140
    serviceUserId = user.services.dev.name;                                                                            // 141
    user.profile.service = "dev";                                                                                      // 142
  } else if ("expires" in user) {                                                                                      // 143
    serviceUserId = user._id;                                                                                          // 144
    user.profile.service = "demo";                                                                                     // 145
  } else if (user.services && user.services.email) {                                                                   // 146
    check(user.services.email, {                                                                                       // 147
      email: String,                                                                                                   // 148
      tokens: [{                                                                                                       // 149
        digest: String,                                                                                                // 151
        algorithm: String,                                                                                             // 152
        createdAt: Date,                                                                                               // 153
        secureBox: Match.Optional({                                                                                    // 154
          version: Number,                                                                                             // 155
          salt: String,                                                                                                // 156
          iv: String,                                                                                                  // 157
          boxedValue: String                                                                                           // 158
        })                                                                                                             // 154
      }]                                                                                                               // 150
    });                                                                                                                // 147
    serviceUserId = user.services.email.email;                                                                         // 163
    user.profile.service = "email";                                                                                    // 164
  } else if (user.services && "google" in user.services) {                                                             // 165
    serviceUserId = user.services.google.id;                                                                           // 166
    user.profile.service = "google";                                                                                   // 167
  } else if (user.services && "github" in user.services) {                                                             // 168
    serviceUserId = user.services.github.id;                                                                           // 169
    user.profile.service = "github";                                                                                   // 170
  } else if (user.services && "ldap" in user.services) {                                                               // 171
    serviceUserId = user.services.ldap.id;                                                                             // 172
    user.profile.service = "ldap";                                                                                     // 173
  } else if (user.services && "saml" in user.services) {                                                               // 174
    serviceUserId = user.services.saml.id;                                                                             // 175
    user.profile.service = "saml";                                                                                     // 176
  } else {                                                                                                             // 177
    throw new Meteor.Error(400, "user does not have a recognized identity provider: " + JSON.stringify(user));         // 178
  }                                                                                                                    // 180
                                                                                                                       //
  user._id = Crypto.createHash("sha256").update(user.profile.service + ":" + serviceUserId).digest("hex");             // 182
                                                                                                                       //
  return user;                                                                                                         // 185
});                                                                                                                    // 186
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 188
  if (!attempt.allowed) {                                                                                              // 189
    return false;                                                                                                      // 190
  }                                                                                                                    // 191
                                                                                                                       //
  var db = attempt.connection.sandstormDb;                                                                             // 193
  var user = attempt.user;                                                                                             // 194
  if (user.loginIdentities) {                                                                                          // 195
    // it's an account                                                                                                 //
    if (db.getOrganizationDisallowGuests() && !db.isUserInOrganization(user)) {                                        // 197
      throw new Meteor.Error(403, "User not in organization.");                                                        // 199
    }                                                                                                                  // 200
  } else {                                                                                                             // 201
    if (db.getOrganizationDisallowGuests() && !db.isIdentityInOrganization(user)) {                                    // 202
      throw new Meteor.Error(403, "User not in organization.");                                                        // 204
    }                                                                                                                  // 205
  }                                                                                                                    // 206
                                                                                                                       //
  return true;                                                                                                         // 208
});                                                                                                                    // 209
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"migrations.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/migrations.js                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Minimal tooling for doing run-at-least-once, ordered migrations.                                                    //
//                                                                                                                     //
// Because migrations can experience partial failure and likely have                                                   //
// side-effects, we should be careful to make sure all migrations are                                                  //
// idempotent and safe to accidentally run multiple times.                                                             //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 7
var Url = Npm.require("url");                                                                                          // 8
var Crypto = Npm.require("crypto");                                                                                    // 9
                                                                                                                       //
var localSandstormDb = new SandstormDb();                                                                              // 11
// TODO(someday): fix this when SandstormDb actually stores meaningful state on the object.                            //
                                                                                                                       //
var updateLoginStyleToRedirect = function updateLoginStyleToRedirect() {                                               // 14
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 15
  ["google", "github"].forEach(function (serviceName) {                                                                // 16
    var config = configurations.findOne({ service: serviceName });                                                     // 17
    if (config && config.loginStyle !== "redirect") {                                                                  // 18
      configurations.update({ service: serviceName }, { $set: { loginStyle: "redirect" } });                           // 19
    }                                                                                                                  // 20
  });                                                                                                                  // 21
};                                                                                                                     // 22
                                                                                                                       //
var enableLegacyOAuthProvidersIfNotInSettings = function enableLegacyOAuthProvidersIfNotInSettings() {                 // 24
  // In the before time, Google and Github login were enabled by default.                                              //
  //                                                                                                                   //
  // This actually didn't make much sense, required the first user to configure                                        //
  // OAuth, and had some trust-the-first-user properties that weren't totally                                          //
  // secure.                                                                                                           //
  //                                                                                                                   //
  // Now, we have admin-token, so we wish to disable all logins by default                                             //
  // (since they need to be configured anyway) but since users may have never                                          //
  // explicitly told Sandstorm that Google or Github login should be enabled,                                          //
  // we can't just use the value in the Settings collection, since it might                                            //
  // never have been set.                                                                                              //
  //                                                                                                                   //
  // Thus, if the service is configured but absent from Settings, we should                                            //
  // explicitly enable it in Settings, and then the rest of the logic can just                                         //
  // depend on what value is in Settings and default to false without breaking                                         //
  // user installations.                                                                                               //
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                           // 41
  ["google", "github"].forEach(function (serviceName) {                                                                // 42
    var config = configurations.findOne({ service: serviceName });                                                     // 43
    var serviceConfig = Settings.findOne({ _id: serviceName });                                                        // 44
    if (config && !serviceConfig) {                                                                                    // 45
      // Only explicitly enable the login service if:                                                                  //
      // 1) the service is already configured                                                                          //
      // 2) there is no sandstorm configuration already present (the user was                                          //
      //    using the previous default behavior).                                                                      //
      Settings.insert({ _id: serviceName, value: true });                                                              // 50
    }                                                                                                                  // 51
  });                                                                                                                  // 52
};                                                                                                                     // 53
                                                                                                                       //
var denormalizeInviteInfo = function denormalizeInviteInfo() {                                                         // 55
  // When a user is invited via a signup token, the `signupKey` field of their user table entry                        //
  // has always been populated to indicate the key they used. This points into the SignupKeys table                    //
  // which has more information about the key, namely a freeform note entered by the admin when                        //
  // they created the key. In the case that the email invite form was used, the note has the form                      //
  // "E-mail invite to <address>".                                                                                     //
  //                                                                                                                   //
  // Later, we decided it was useful to indicate in the users table visible to the admin                               //
  // information about the invite terms. Namely, for email invites we want to show the address                         //
  // and for others we want to show the note. To make this efficient, fields `signupNote` and                          //
  // `signupEmail` were added to the users table. We can backfill these values by denormalizing                        //
  // from the SignupKeys table.                                                                                        //
                                                                                                                       //
  Meteor.users.find().forEach(function (user) {                                                                        // 68
    if (user.signupKey && typeof user.signupKey === "string" && user.signupKey !== "admin") {                          // 69
      var signupInfo = SignupKeys.findOne(user.signupKey);                                                             // 70
      if (signupInfo && signupInfo.note) {                                                                             // 71
        var newFields = { signupNote: signupInfo.note };                                                               // 72
                                                                                                                       //
        var prefix = "E-mail invite to ";                                                                              // 74
        if (signupInfo.note.lastIndexOf(prefix) === 0) {                                                               // 75
          newFields.signupEmail = signupInfo.note.slice(prefix.length);                                                // 76
        }                                                                                                              // 77
                                                                                                                       //
        Meteor.users.update(user._id, { $set: newFields });                                                            // 79
      }                                                                                                                // 80
    }                                                                                                                  // 81
  });                                                                                                                  // 82
};                                                                                                                     // 83
                                                                                                                       //
function mergeRoleAssignmentsIntoApiTokens() {                                                                         // 85
  RoleAssignments.find().forEach(function (roleAssignment) {                                                           // 86
    ApiTokens.insert({                                                                                                 // 87
      grainId: roleAssignment.grainId,                                                                                 // 88
      userId: roleAssignment.sharer,                                                                                   // 89
      roleAssignment: roleAssignment.roleAssignment,                                                                   // 90
      petname: roleAssignment.petname,                                                                                 // 91
      created: roleAssignment.created,                                                                                 // 92
      owner: {                                                                                                         // 93
        user: {                                                                                                        // 94
          userId: roleAssignment.recipient,                                                                            // 95
          title: roleAssignment.title                                                                                  // 96
        }                                                                                                              // 94
      }                                                                                                                // 93
    });                                                                                                                // 87
  });                                                                                                                  // 100
}                                                                                                                      // 101
                                                                                                                       //
function fixOasisStorageUsageStats() {}                                                                                // 103
// This migration only pertained to Oasis and it was successfully applied there. Since it referred                     //
// to some global variables that we later wanted to remove and/or rename, we've since replaced it                      //
// with a no-op.                                                                                                       //
                                                                                                                       //
function fetchProfilePictures() {                                                                                      // 108
  Meteor.users.find({}).forEach(function (user) {                                                                      // 109
    var url = userPictureUrl(user);                                                                                    // 110
    if (url) {                                                                                                         // 111
      console.log("Fetching user picture:", url);                                                                      // 112
      var assetId = fetchPicture(url);                                                                                 // 113
      if (assetId) {                                                                                                   // 114
        Meteor.users.update(user._id, { $set: { "profile.picture": assetId } });                                       // 115
      }                                                                                                                // 116
    }                                                                                                                  // 117
  });                                                                                                                  // 118
}                                                                                                                      // 119
                                                                                                                       //
function assignPlans() {                                                                                               // 121
  if (Meteor.settings["public"].quotaEnabled && SandstormDb.paymentsMigrationHook) {                                   // 122
    SandstormDb.paymentsMigrationHook(SignupKeys, Plans.find().fetch());                                               // 123
  }                                                                                                                    // 124
}                                                                                                                      // 125
                                                                                                                       //
function removeKeyrings() {                                                                                            // 127
  // These blobs full of public keys were not intended to find their way into mongo and while                          //
  // harmless they slow things down because they're huge. Remove them.                                                 //
  Packages.update({ "manifest.metadata.pgpKeyring": { $exists: true } }, { $unset: { "manifest.metadata.pgpKeyring": "" } }, { multi: true });
}                                                                                                                      // 133
                                                                                                                       //
function useLocalizedTextInUserActions() {                                                                             // 135
  function toLocalizedText(newObj, oldObj, field) {                                                                    // 136
    if (field in oldObj) {                                                                                             // 137
      if (typeof oldObj[field] === "string") {                                                                         // 138
        newObj[field] = { defaultText: oldObj[field] };                                                                // 139
      } else {                                                                                                         // 140
        newObj[field] = oldObj[field];                                                                                 // 141
      }                                                                                                                // 142
    }                                                                                                                  // 143
  }                                                                                                                    // 144
                                                                                                                       //
  UserActions.find({}).forEach(function (userAction) {                                                                 // 146
    var fields = {};                                                                                                   // 147
    toLocalizedText(fields, userAction, "appTitle");                                                                   // 148
    toLocalizedText(fields, userAction, "title");                                                                      // 149
    toLocalizedText(fields, userAction, "nounPhrase");                                                                 // 150
    UserActions.update(userAction._id, { $set: fields });                                                              // 151
  });                                                                                                                  // 152
}                                                                                                                      // 153
                                                                                                                       //
function verifyAllPgpSignatures() {                                                                                    // 155
  Packages.find({}).forEach(function (pkg) {                                                                           // 156
    try {                                                                                                              // 157
      console.log("checking PGP signature for package:", pkg._id);                                                     // 158
      var info = waitPromise(globalBackend.cap().tryGetPackage(pkg._id));                                              // 159
      if (info.authorPgpKeyFingerprint) {                                                                              // 160
        console.log("  " + info.authorPgpKeyFingerprint);                                                              // 161
        Packages.update(pkg._id, { $set: { authorPgpKeyFingerprint: info.authorPgpKeyFingerprint } });                 // 162
      } else {                                                                                                         // 164
        console.log("  no signature");                                                                                 // 165
      }                                                                                                                // 166
    } catch (err) {                                                                                                    // 167
      console.error(err.stack);                                                                                        // 168
    }                                                                                                                  // 169
  });                                                                                                                  // 170
}                                                                                                                      // 171
                                                                                                                       //
function splitUserIdsIntoAccountIdsAndIdentityIds() {                                                                  // 173
  Meteor.users.find().forEach(function (user) {                                                                        // 174
    var identity = {};                                                                                                 // 175
    var serviceUserId = void 0;                                                                                        // 176
    if ("devName" in user) {                                                                                           // 177
      identity.service = "dev";                                                                                        // 178
      serviceUserId = user.devName;                                                                                    // 179
    } else if ("expires" in user) {                                                                                    // 180
      identity.service = "demo";                                                                                       // 181
      serviceUserId = user._id;                                                                                        // 182
    } else if (user.services && "google" in user.services) {                                                           // 183
      identity.service = "google";                                                                                     // 184
      if (user.services.google.email && user.services.google.verified_email) {                                         // 185
        // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                          //
        identity.verifiedEmail = user.services.google.email;                                                           // 186
      }                                                                                                                // 187
                                                                                                                       //
      serviceUserId = user.services.google.id;                                                                         // 189
    } else if (user.services && "github" in user.services) {                                                           // 190
      identity.service = "github";                                                                                     // 191
      identity.unverifiedEmail = user.services.github.email;                                                           // 192
      serviceUserId = user.services.github.id;                                                                         // 193
    } else if (user.services && "emailToken" in user.services) {                                                       // 194
      identity.service = "emailToken";                                                                                 // 195
      identity.verifiedEmail = user.services.emailToken.email;                                                         // 196
      serviceUserId = user.services.emailToken.email;                                                                  // 197
    }                                                                                                                  // 198
                                                                                                                       //
    identity.id = Crypto.createHash("sha256").update(identity.service + ":" + serviceUserId).digest("hex");            // 200
                                                                                                                       //
    if (user.profile) {                                                                                                // 203
      if (user.profile.name) {                                                                                         // 204
        identity.name = user.profile.name;                                                                             // 205
      }                                                                                                                // 206
                                                                                                                       //
      if (user.profile.handle) {                                                                                       // 208
        identity.handle = user.profile.handle;                                                                         // 209
      }                                                                                                                // 210
                                                                                                                       //
      if (user.profile.picture) {                                                                                      // 212
        identity.picture = user.profile.picture;                                                                       // 213
      }                                                                                                                // 214
                                                                                                                       //
      if (user.profile.pronoun) {                                                                                      // 216
        identity.pronoun = user.profile.pronoun;                                                                       // 217
      }                                                                                                                // 218
                                                                                                                       //
      if (user.profile.email) {                                                                                        // 220
        identity.unverifiedEmail = user.profile.email;                                                                 // 221
      }                                                                                                                // 222
    }                                                                                                                  // 223
                                                                                                                       //
    identity.main = true;                                                                                              // 225
                                                                                                                       //
    Meteor.users.update(user._id, { $set: { identities: [identity] } });                                               // 227
                                                                                                                       //
    Grains.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                       // 229
    Sessions.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                     // 230
    ApiTokens.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                    // 231
    ApiTokens.update({ "owner.user.userId": user._id }, { $set: { "owner.user.identityId": identity.id } }, { multi: true });
    ApiTokens.update({ "owner.grain.introducerUser": user._id }, { $set: { "owner.grain.introducerIdentity": identity.id } }, { multi: true });
                                                                                                                       //
    while (ApiTokens.update({ "requirements.permissionsHeld.userId": user._id }, { $set: { "requirements.$.permissionsHeld.identityId": identity.id },
      $unset: { "requirements.$.permissionsHeld.userId": 1 } }, { multi: true }) > 0) {}                               // 243
    // The `$` operatorer modifies the first element in the array that matches the query. Since                        //
    // there may be many matches, we need to repeat until no documents are modified.                                   //
  });                                                                                                                  // 248
                                                                                                                       //
  ApiTokens.remove({ userInfo: { $exists: true } });                                                                   // 250
  // We've renamed `Grain.UserInfo.userId` to `Grain.userInfo.identityId`. The only place                              //
  // that this field could show up in the database was in this deprecated, no-longer-functional                        //
  // form of API token.                                                                                                //
}                                                                                                                      // 254
                                                                                                                       //
function appUpdateSettings() {                                                                                         // 256
  Settings.insert({ _id: "appMarketUrl", value: "https://apps.sandstorm.io" });                                        // 257
  Settings.insert({ _id: "appIndexUrl", value: "https://app-index.sandstorm.io" });                                    // 258
  Settings.insert({ _id: "appUpdatesEnabled", value: true });                                                          // 259
}                                                                                                                      // 260
                                                                                                                       //
function moveDevAndEmailLoginDataIntoIdentities() {                                                                    // 262
  Meteor.users.find().forEach(function (user) {                                                                        // 263
    if (user.identities.length != 1) {                                                                                 // 264
      throw new Error("User does not have exactly one identity: ", user);                                              // 265
    }                                                                                                                  // 266
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 268
    if (Match.test(identity.service, Object)) {                                                                        // 269
      return;                                                                                                          // 269
    } // Already migrated.                                                                                             // 269
                                                                                                                       //
    var newIdentity = _.pick(identity, "id", "main", "noLogin", "verifiedEmail", "unverifiedEmail");                   // 271
    newIdentity.profile = _.pick(identity, "name", "handle", "picture", "pronoun");                                    // 272
                                                                                                                       //
    var serviceObject = {};                                                                                            // 274
    var fieldsToUnset = {};                                                                                            // 275
                                                                                                                       //
    if (identity.service === "dev") {                                                                                  // 277
      serviceObject.name = user.devName;                                                                               // 278
      fieldsToUnset.devName = 1;                                                                                       // 279
    } else if (identity.service === "emailToken") {                                                                    // 280
      serviceObject.tokens = user.services.emailToken.tokens;                                                          // 281
      serviceObject.email = user.services.emailToken.email;                                                            // 282
      fieldsToUnset["services.emailToken"] = 1;                                                                        // 283
    }                                                                                                                  // 284
                                                                                                                       //
    newIdentity.service = {};                                                                                          // 286
    newIdentity.service[identity.service] = serviceObject;                                                             // 287
                                                                                                                       //
    var modifier = { $set: { identities: [newIdentity] } };                                                            // 289
    if (Object.keys(fieldsToUnset).length > 0) {                                                                       // 290
      modifier.$unset = fieldsToUnset;                                                                                 // 291
    }                                                                                                                  // 292
                                                                                                                       //
    Meteor.users.update({ _id: user._id }, modifier);                                                                  // 294
  });                                                                                                                  // 295
}                                                                                                                      // 296
                                                                                                                       //
function repairEmailIdentityIds() {                                                                                    // 298
  Meteor.users.find({ "identities.service.emailToken": { $exists: 1 } }).forEach(function (user) {                     // 299
    if (user.identities.length != 1) {                                                                                 // 300
      throw new Error("User does not have exactly one identity: ", user);                                              // 301
    }                                                                                                                  // 302
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 304
    var newIdentity = _.pick(identity, "main", "noLogin", "verifiedEmail", "unverifiedMail", "profile");               // 305
    newIdentity.service = { email: identity.service.emailToken };                                                      // 307
    newIdentity.id = Crypto.createHash("sha256").update("email:" + identity.service.emailToken.email).digest("hex");   // 308
                                                                                                                       //
    Grains.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });             // 311
    Sessions.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });           // 312
    ApiTokens.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });          // 313
    ApiTokens.update({ "owner.user.identityId": identity.id }, { $set: { "owner.user.identityId": newIdentity.id } }, { multi: true });
    ApiTokens.update({ "owner.grain.introducerIdentity": identity.id }, { $set: { "owner.grain.introducerIdentity": newIdentity.id } }, { multi: true });
                                                                                                                       //
    while (ApiTokens.update({ "requirements.permissionsHeld.identityId": identity.id }, { $set: { "requirements.$.permissionsHeld.identityId": newIdentity.id } }, { multi: true }) > 0) {}
                                                                                                                       //
    Meteor.users.update({ _id: user._id }, { $set: { identities: [newIdentity] } });                                   // 327
  });                                                                                                                  // 328
}                                                                                                                      // 329
                                                                                                                       //
function splitAccountUsersAndIdentityUsers() {                                                                         // 331
  Meteor.users.find({ identities: { $exists: true } }).forEach(function (user) {                                       // 332
    if (user.identities.length != 1) {                                                                                 // 333
      throw new Error("User does not have exactly one identity: ", user);                                              // 334
    }                                                                                                                  // 335
                                                                                                                       //
    var identity = user.identities[0];                                                                                 // 337
    var identityUser = _.pick(user, "createdAt", "lastActive", "expires");                                             // 338
    identityUser._id = identity.id;                                                                                    // 339
    identityUser.profile = identity.profile;                                                                           // 340
    _.extend(identityUser, _.pick(identity, "unverifiedEmail"));                                                       // 341
    identityUser.profile.service = Object.keys(identity.service)[0];                                                   // 342
                                                                                                                       //
    // Updating this user needs to be a two step process because the `services` field typically                        //
    // contains subfields that are constrained to be unique by Mongo indices.                                          //
    identityUser.stagedServices = _.omit(user.services, "resume");                                                     // 346
    if (identity.service.dev) {                                                                                        // 347
      identityUser.stagedServices.dev = identity.service.dev;                                                          // 348
    } else if (identity.service.email) {                                                                               // 349
      identityUser.stagedServices.email = identity.service.email;                                                      // 350
    }                                                                                                                  // 351
                                                                                                                       //
    var accountUser = _.pick(user, "_id", "createdAt", "lastActive", "expires", "isAdmin", "signupKey", "signupNote", "signupEmail", "plan", "storageUsage", "isAppDemoUser", "appDemoId", "payments", "dailySentMailCount", "hasCompletedSignup");
    accountUser.loginIdentities = [_.pick(identity, "id")];                                                            // 357
    accountUser.nonloginIdentities = [];                                                                               // 358
    if (user.services && user.services.resume) {                                                                       // 359
      accountUser.services = { resume: user.services.resume };                                                         // 360
    }                                                                                                                  // 361
                                                                                                                       //
    accountUser.stashedOldUser = user;                                                                                 // 363
                                                                                                                       //
    ApiTokens.update({ identityId: identityUser._id }, { $set: { accountId: user._id } }, { multi: true });            // 365
                                                                                                                       //
    Meteor.users.upsert({ _id: identityUser._id }, identityUser);                                                      // 368
    Meteor.users.update({ _id: user._id }, accountUser);                                                               // 369
  });                                                                                                                  // 370
                                                                                                                       //
  Meteor.users.find({ stagedServices: { $exists: true } }).forEach(function (identity) {                               // 372
    Meteor.users.update({ _id: identity._id }, { $unset: { stagedServices: 1 },                                        // 373
      $set: { services: identity.stagedServices } });                                                                  // 374
  });                                                                                                                  // 375
}                                                                                                                      // 376
                                                                                                                       //
function populateContactsFromApiTokens() {                                                                             // 378
  ApiTokens.find({ "owner.user.identityId": { $exists: 1 },                                                            // 379
    accountId: { $exists: 1 } }).forEach(function (token) {                                                            // 380
    var identityId = token.owner.user.identityId;                                                                      // 381
    var identity = SandstormDb.prototype.getIdentity(identityId);                                                      // 382
    if (identity) {                                                                                                    // 383
      var profile = identity.profile;                                                                                  // 384
      Contacts.upsert({ ownerId: token.accountId, identityId: identityId }, {                                          // 385
        ownerId: token.accountId,                                                                                      // 386
        petname: profile && profile.name,                                                                              // 387
        created: new Date(),                                                                                           // 388
        identityId: identityId,                                                                                        // 389
        profile: profile                                                                                               // 390
      });                                                                                                              // 385
    }                                                                                                                  // 392
  });                                                                                                                  // 393
}                                                                                                                      // 394
                                                                                                                       //
function cleanUpApiTokens() {                                                                                          // 396
  // The `splitUserIdsIntoAccountIdsAndIdentityIds()` migration only added `identityId` in cases                       //
  // where the user still existed in the database.                                                                     //
  ApiTokens.remove({ userId: { $exists: true }, identityId: { $exists: false } });                                     // 399
  ApiTokens.remove({ "owner.user.userId": { $exists: true },                                                           // 400
    "owner.user.identityId": { $exists: false } });                                                                    // 401
                                                                                                                       //
  // For a while we were accidentally setting `appIcon` instead of `icon`.                                             //
  ApiTokens.find({ "owner.user.denormalizedGrainMetadata.appIcon": { $exists: true } }).forEach(function (apiToken) {  // 404
    var icon = apiToken.owner.user.denormalizedGrainMetadata.appIcon;                                                  // 406
    ApiTokens.update({ _id: apiToken._id }, { $set: { "owner.user.denormalizedGrainMetadata.icon": icon },             // 407
      $unset: { "owner.user.denormalizedGrainMetadata.appIcon": true } });                                             // 409
  });                                                                                                                  // 410
                                                                                                                       //
  // For a while the `identityId` field of child UiView tokens was not getting set.                                    //
  function repairChain(parentToken) {                                                                                  // 413
    ApiTokens.find({ parentToken: parentToken._id, grainId: { $exists: true },                                         // 414
      identityId: { $exists: false } }).forEach(function (childToken) {                                                // 415
      ApiTokens.update({ _id: childToken._id }, { $set: { identityId: parentToken.identityId } });                     // 416
      repairChain(childToken);                                                                                         // 417
    });                                                                                                                // 418
  }                                                                                                                    // 419
                                                                                                                       //
  ApiTokens.find({ grainId: { $exists: true }, identityId: { $exists: true },                                          // 421
    parentToken: { $exists: false } }).forEach(repairChain);                                                           // 422
}                                                                                                                      // 423
                                                                                                                       //
function initServerTitleAndReturnAddress() {                                                                           // 425
  var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                             // 426
  Settings.insert({ _id: "serverTitle", value: hostname });                                                            // 427
  Settings.insert({ _id: "returnAddress", value: "no-reply@" + hostname });                                            // 428
}                                                                                                                      // 429
                                                                                                                       //
function sendReferralNotifications() {                                                                                 // 431
  if (Meteor.settings["public"].quotaEnabled) {                                                                        // 432
    Meteor.users.find({                                                                                                // 433
      loginIdentities: { $exists: true },                                                                              // 434
      expires: { $exists: false }                                                                                      // 435
    }, { fields: { _id: 1 } }).forEach(function (user) {                                                               // 433
      sendReferralProgramNotification(user._id);                                                                       // 437
    });                                                                                                                // 438
  }                                                                                                                    // 439
}                                                                                                                      // 440
                                                                                                                       //
function assignBonuses() {                                                                                             // 442
  if (Meteor.settings["public"].quotaEnabled && SandstormDb.bonusesMigrationHook) {                                    // 443
    SandstormDb.bonusesMigrationHook();                                                                                // 444
  }                                                                                                                    // 445
}                                                                                                                      // 446
                                                                                                                       //
function splitSmtpUrl() {                                                                                              // 448
  var smtpUrlSetting = Settings.findOne({ _id: "smtpUrl" });                                                           // 449
  var smtpUrl = smtpUrlSetting ? smtpUrlSetting.value : process.env.MAIL_URL;                                          // 450
  var returnAddress = Settings.findOne({ _id: "returnAddress" });                                                      // 451
                                                                                                                       //
  // Default values.                                                                                                   //
  var smtpConfig = {                                                                                                   // 454
    hostname: "localhost",                                                                                             // 455
    port: "25",                                                                                                        // 456
    auth: undefined,                                                                                                   // 457
    returnAddress: returnAddress.value                                                                                 // 458
  };                                                                                                                   // 454
                                                                                                                       //
  var parsed = void 0;                                                                                                 // 461
  try {                                                                                                                // 462
    parsed = smtpUrl && Url.parse(smtpUrl);                                                                            // 463
  } catch (e) {}                                                                                                       // 464
                                                                                                                       //
  if (parsed) {                                                                                                        // 466
    // If there was a SMTP URL previously defined, import its data.                                                    //
    var auth = undefined;                                                                                              // 468
    if (parsed.auth) {                                                                                                 // 469
      var colonIndex = parsed.auth.indexOf(":");                                                                       // 470
      var user = undefined;                                                                                            // 471
      var pass = undefined;                                                                                            // 472
      if (colonIndex !== -1) {                                                                                         // 473
        user = parsed.auth.slice(0, colonIndex);                                                                       // 474
        pass = parsed.auth.slice(colonIndex + 1);                                                                      // 475
      }                                                                                                                // 476
                                                                                                                       //
      auth = {                                                                                                         // 478
        user: user,                                                                                                    // 479
        pass: pass                                                                                                     // 480
      };                                                                                                               // 478
    }                                                                                                                  // 482
                                                                                                                       //
    // Override defaults with previous config's values.                                                                //
    smtpConfig.hostname = parsed.hostname || "localhost";                                                              // 485
    smtpConfig.port = parsed.port || "25";                                                                             // 486
    smtpConfig.auth = auth;                                                                                            // 487
  }                                                                                                                    // 488
                                                                                                                       //
  Settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                                       // 490
  Settings.remove({ _id: "returnAddress" });                                                                           // 491
  Settings.remove({ _id: "smtpUrl" });                                                                                 // 492
}                                                                                                                      // 493
                                                                                                                       //
function smtpPortShouldBeNumber() {                                                                                    // 495
  var entry = Settings.findOne({ _id: "smtpConfig" });                                                                 // 496
  if (entry) {                                                                                                         // 497
    var setting = entry.value;                                                                                         // 498
    if (setting.port) {                                                                                                // 499
      setting.port = _.isNumber(setting.port) ? setting.port : parseInt(setting.port);                                 // 500
      Settings.upsert({ _id: "smtpConfig" }, { value: setting });                                                      // 501
    }                                                                                                                  // 502
  }                                                                                                                    // 503
}                                                                                                                      // 504
                                                                                                                       //
function consolidateOrgSettings() {                                                                                    // 506
  var orgGoogleDomain = Settings.findOne({ _id: "organizationGoogle" });                                               // 507
  var orgEmailDomain = Settings.findOne({ _id: "organizationEmail" });                                                 // 508
  var orgLdap = Settings.findOne({ _id: "organizationLdap" });                                                         // 509
  var orgSaml = Settings.findOne({ _id: "organizationSaml" });                                                         // 510
                                                                                                                       //
  var orgMembership = {                                                                                                // 512
    google: {                                                                                                          // 513
      enabled: orgGoogleDomain ? !!orgGoogleDomain.value : false,                                                      // 514
      domain: orgGoogleDomain ? orgGoogleDomain.value : ""                                                             // 515
    },                                                                                                                 // 513
    email: {                                                                                                           // 517
      enabled: orgEmailDomain ? !!orgEmailDomain.value : false,                                                        // 518
      domain: orgEmailDomain ? orgEmailDomain.value : ""                                                               // 519
    },                                                                                                                 // 517
    ldap: {                                                                                                            // 521
      enabled: orgLdap ? orgLdap.value : false                                                                         // 522
    },                                                                                                                 // 521
    saml: {                                                                                                            // 524
      enabled: orgSaml ? orgSaml.value : false                                                                         // 525
    }                                                                                                                  // 524
  };                                                                                                                   // 512
                                                                                                                       //
  Settings.upsert({ _id: "organizationMembership" }, { value: orgMembership });                                        // 529
  Settings.remove({ _id: "organizationGoogle" });                                                                      // 530
  Settings.remove({ _id: "organizationEmail" });                                                                       // 531
  Settings.remove({ _id: "organizationLdap" });                                                                        // 532
  Settings.remove({ _id: "organizationSaml" });                                                                        // 533
}                                                                                                                      // 534
                                                                                                                       //
function unsetSmtpDefaultHostnameIfNoUsersExist() {                                                                    // 536
  // We don't actually want to have the default hostname "localhost" set.                                              //
  // If the user has already finished configuring their server, then this migration should do                          //
  // nothing (since we might break their deployment), but for new installs (which will have no users                   //
  // at the time this migration runs) we'll unset the hostname if it's still the previously-filled                     //
  // default value.                                                                                                    //
  var hasUsers = Meteor.users.findOne();                                                                               // 542
  if (!hasUsers) {                                                                                                     // 543
    var entry = Settings.findOne({ _id: "smtpConfig" });                                                               // 544
    var smtpConfig = entry.value;                                                                                      // 545
    if (smtpConfig.hostname === "localhost") {                                                                         // 546
      smtpConfig.hostname = "";                                                                                        // 547
      Settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                                   // 548
    }                                                                                                                  // 549
  }                                                                                                                    // 550
}                                                                                                                      // 551
                                                                                                                       //
function extractLastUsedFromApiTokenOwner() {                                                                          // 553
  // We used to store lastUsed as a field on owner.user.  It makes more sense to store lastUsed on                     //
  // the apiToken as a whole.  This migration hoists such values from owner.user onto the apiToken                     //
  // itself.                                                                                                           //
  ApiTokens.find({ "owner.user": { $exists: true } }).forEach(function (token) {                                       // 557
    var lastUsed = token.owner.user.lastUsed;                                                                          // 558
    ApiTokens.update({ _id: token._id }, {                                                                             // 559
      $set: { lastUsed: lastUsed },                                                                                    // 560
      $unset: { "owner.user.lastUsed": true }                                                                          // 561
    });                                                                                                                // 559
  });                                                                                                                  // 563
}                                                                                                                      // 564
                                                                                                                       //
function setUpstreamTitles() {                                                                                         // 566
  // Initializes the `upstreamTitle` and `renamed` fields of `ApiToken.owner.user`.                                    //
                                                                                                                       //
  var apiTokensRaw = ApiTokens.rawCollection();                                                                        // 569
  var aggregateApiTokens = Meteor.wrapAsync(apiTokensRaw.aggregate, apiTokensRaw);                                     // 570
                                                                                                                       //
  // First, construct a list of all *shared* grains. We will need to do a separate update()                            //
  // for each of these, so we'd like to skip those which have nothing to update.                                       //
  var grainIds = aggregateApiTokens([{ $match: { "owner.user": { $exists: true }, grainId: { $exists: true } } }, { $group: { _id: "$grainId" } }]).map(function (grain) {
    return grain._id;                                                                                                  // 577
  });                                                                                                                  // 577
                                                                                                                       //
  var count = 0;                                                                                                       // 579
  Grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } }).forEach(function (grain) {                         // 580
    if (count % 100 == 0) {                                                                                            // 581
      console.log(count + " / " + grainIds.length);                                                                    // 582
    }                                                                                                                  // 583
                                                                                                                       //
    ++count;                                                                                                           // 585
                                                                                                                       //
    // For ApiTokens whose petname titles do not match the upstream title, we need to set                              //
    // `upstreamTitle` and `renamed`. We have no way of knowing which of the two names was the                         //
    // original name, so we don't know whether it was the owner or the receiver who renamed their                      //
    // copy post-sharaing. We assume it was the owner, because:                                                        //
    // 1. It's probably unusual for people to try to rename a grain they don't own.                                    //
    // 2. This results in UI that is reasonably non-confusing even if we guessed wrong. Namely,                        //
    //    the user sees "Owner's title (was: User's title)", which is reasonably OK even if it                         //
    //    was the user who had renamed their copy. They can rename it again if they like. On the                       //
    //    other hand, if we guessed wrongly in the other direction, the user would see                                 //
    //    "User's title (renamed from: Owners title)", which would be wrong if it was in fact the                      //
    //    owner who renamed post-sharing.                                                                              //
    ApiTokens.update({                                                                                                 // 598
      grainId: grain._id,                                                                                              // 599
      "owner.user.title": { $exists: true, $ne: grain.title }                                                          // 600
    }, { $set: { "owner.user.upstreamTitle": grain.title } }, { multi: true });                                        // 598
  });                                                                                                                  // 602
}                                                                                                                      // 603
                                                                                                                       //
function markAllRead() {                                                                                               // 605
  // Mark as "read" all grains and tokens that predate the creation of read/unread status.                             //
  // Otherwise it's pretty annoying to see all your old grains look like they have activity.                           //
                                                                                                                       //
  Grains.update({}, { $set: { ownerSeenAllActivity: true } }, { multi: true });                                        // 609
  ApiTokens.update({ "owner.user": { $exists: true } }, { $set: { "owner.user.seenAllActivity": true } }, { multi: true });
}                                                                                                                      // 613
                                                                                                                       //
function clearAppIndex() {                                                                                             // 615
  // Due to a bug in the app update code, some app update notifications that the user accepted                         //
  // around July 9-16, 2016 may not have applied. We have no way of knowing exactly which updates                      //
  // the user accepted but didn't receive. Instead, to recover, we are clearing the local cache of                     //
  // the app index one time. This way, the next time the app index is re-fetched, the server will                      //
  // interpret all of the apps in the index as updated and will re-deliver notifications to                            //
  // everyone. This may mean users get notifications that they previously dismissed, but they can                      //
  // click "dismiss" again easily enough.                                                                              //
                                                                                                                       //
  AppIndex.remove({});                                                                                                 // 624
}                                                                                                                      // 625
                                                                                                                       //
function assignEmailVerifierIds() {                                                                                    // 627
  // Originally, the ID of an EmailVerifier was actually the _id of the root token from which it                       //
  // was restored. This was broken, though: Conceptually, it meant that you couldn't have a working                    //
  // EmailVerifier that had not been restore()d from disk. In practice, that wasn't a problem due                      //
  // to the fact that powerbox selections always involve a restore(), but a different problem                          //
  // existed: the capability returned by claimRequest() would return one ID, but after save()ing                       //
  // and restore()ing that capability, the ID would be different, because the new capability would                     //
  // be a copy -- not a child -- of the original. Additionally, the whole thing made various code                      //
  // ugly because it was puncturing layers of abstraction. So, we switched to doing the right                          //
  // thing: assigning an ID to the EmailVerifier on first creation and storing it separately.                          //
                                                                                                                       //
  ApiTokens.find({ "frontendRef.emailVerifier": { $exists: true } }).forEach(function (token) {                        // 638
    ApiTokens.update(token._id, { $set: { "frontendRef.emailVerifier.id": token._id } });                              // 639
  });                                                                                                                  // 640
}                                                                                                                      // 641
                                                                                                                       //
function startPreinstallingApps() {                                                                                    // 643
  // This isn't really a normal migration. It will run only on brand new servers, and it has to                        //
  // run after the `clearAppIndex` migration because it relies on populating AppIndex.                                 //
                                                                                                                       //
  var startPreinstallingAppsHelper = function startPreinstallingAppsHelper() {                                         // 647
    localSandstormDb.updateAppIndex();                                                                                 // 648
                                                                                                                       //
    var preinstalledApps = globalDb.collections.appIndex.find({ _id: {                                                 // 650
        $in: globalDb.getProductivitySuiteAppIds() }                                                                   // 651
    }).fetch();                                                                                                        // 650
    var appAndPackageIds = _.map(preinstalledApps, function (app) {                                                    // 653
      return {                                                                                                         // 654
        appId: app.appId,                                                                                              // 655
        packageId: app.packageId                                                                                       // 656
      };                                                                                                               // 654
    });                                                                                                                // 658
                                                                                                                       //
    localSandstormDb.setPreinstalledApps(appAndPackageIds);                                                            // 660
  };                                                                                                                   // 661
                                                                                                                       //
  // We want preinstalling apps to run async and not block startup.                                                    //
  Meteor.setTimeout(startPreinstallingAppsHelper, 0);                                                                  // 664
}                                                                                                                      // 665
                                                                                                                       //
function setNewServer() {                                                                                              // 667
  // This migration only applies to "old" servers. New servers will set                                                //
  // new_server_migrations_applied to false before any migrations run.                                                 //
  if (!Migrations.findOne({ _id: "new_server_migrations_applied" })) {                                                 // 670
    Migrations.insert({ _id: "new_server_migrations_applied", value: true });                                          // 671
  }                                                                                                                    // 672
}                                                                                                                      // 673
                                                                                                                       //
// This must come after all the functions named within are defined.                                                    //
// Only append to this list!  Do not modify or remove list entries;                                                    //
// doing so is likely change the meaning and semantics of user databases.                                              //
var MIGRATIONS = [updateLoginStyleToRedirect, enableLegacyOAuthProvidersIfNotInSettings, denormalizeInviteInfo, mergeRoleAssignmentsIntoApiTokens, fixOasisStorageUsageStats, fetchProfilePictures, assignPlans, removeKeyrings, useLocalizedTextInUserActions, verifyAllPgpSignatures, splitUserIdsIntoAccountIdsAndIdentityIds, appUpdateSettings, moveDevAndEmailLoginDataIntoIdentities, repairEmailIdentityIds, splitAccountUsersAndIdentityUsers, populateContactsFromApiTokens, cleanUpApiTokens, initServerTitleAndReturnAddress, sendReferralNotifications, assignBonuses, splitSmtpUrl, smtpPortShouldBeNumber, consolidateOrgSettings, unsetSmtpDefaultHostnameIfNoUsersExist, extractLastUsedFromApiTokenOwner, setUpstreamTitles, markAllRead, clearAppIndex, assignEmailVerifierIds, setNewServer];
                                                                                                                       //
var NEW_SERVER_STARTUP = [startPreinstallingApps];                                                                     // 711
                                                                                                                       //
function migrateToLatest() {                                                                                           // 715
  if (Meteor.settings.replicaNumber) {                                                                                 // 716
    (function () {                                                                                                     // 716
      // This is a replica. Wait for the first replica to perform migrations.                                          //
                                                                                                                       //
      console.log("Waiting for migrations on replica zero...");                                                        // 719
                                                                                                                       //
      var done = new Future();                                                                                         // 721
      var change = function change(doc) {                                                                              // 722
        console.log("Migrations applied elsewhere: " + doc.value + "/" + MIGRATIONS.length);                           // 723
        if (doc.value >= MIGRATIONS.length) done["return"]();                                                          // 724
      };                                                                                                               // 725
                                                                                                                       //
      var observer = Migrations.find({ _id: "migrations_applied" }).observe({                                          // 727
        added: change,                                                                                                 // 728
        changed: change                                                                                                // 729
      });                                                                                                              // 727
                                                                                                                       //
      var newServerDone = new Future();                                                                                // 732
      var newServerChange = function newServerChange(doc) {                                                            // 733
        if (doc.value) {                                                                                               // 734
          console.log("New server migrations applied elsewhere");                                                      // 735
          newServerDone["return"]();                                                                                   // 736
        }                                                                                                              // 737
      };                                                                                                               // 738
                                                                                                                       //
      var newServerObserver = Migrations.find({ _id: "new_server_migrations_applied" }).observe({                      // 740
        added: newServerChange,                                                                                        // 741
        changed: newServerChange                                                                                       // 742
      });                                                                                                              // 740
                                                                                                                       //
      done.wait();                                                                                                     // 745
      observer.stop();                                                                                                 // 746
      newServerDone.wait();                                                                                            // 747
      newServerObserver.stop();                                                                                        // 748
      console.log("Migrations have completed on replica zero.");                                                       // 749
    })();                                                                                                              // 716
  } else {                                                                                                             // 751
    var applied = Migrations.findOne({ _id: "migrations_applied" });                                                   // 752
    var start = void 0;                                                                                                // 753
    if (!applied) {                                                                                                    // 754
      // Migrations table is not yet seeded with a value.  This means it has                                           //
      // applied 0 migrations.  Persist this.                                                                          //
      Migrations.insert({ _id: "migrations_applied", value: 0 });                                                      // 757
      start = 0;                                                                                                       // 758
                                                                                                                       //
      // This also means this is a brand new server                                                                    //
      Migrations.insert({ _id: "new_server_migrations_applied", value: false });                                       // 761
    } else {                                                                                                           // 762
      start = applied.value;                                                                                           // 763
    }                                                                                                                  // 764
                                                                                                                       //
    console.log("Migrations already applied: " + start + "/" + MIGRATIONS.length);                                     // 766
                                                                                                                       //
    for (var i = start; i < MIGRATIONS.length; i++) {                                                                  // 768
      // Apply migration i, then record that migration i was successfully run.                                         //
      console.log("Applying migration " + (i + 1));                                                                    // 770
      MIGRATIONS[i]();                                                                                                 // 771
      Migrations.update({ _id: "migrations_applied" }, { $set: { value: i + 1 } });                                    // 772
      console.log("Applied migration " + (i + 1));                                                                     // 773
    }                                                                                                                  // 774
                                                                                                                       //
    if (!Migrations.findOne({ _id: "new_server_migrations_applied" }).value) {                                         // 776
      // new_server_migrations_applied is guaranteed to exist since we have a migration that                           //
      // ensures it.                                                                                                   //
      for (var _i = 0; _i < NEW_SERVER_STARTUP.length; _i++) {                                                         // 779
        console.log("Running new server startup function " + (_i + 1));                                                // 780
        NEW_SERVER_STARTUP[_i]();                                                                                      // 781
        console.log("Running new server startup function " + (_i + 1));                                                // 782
      }                                                                                                                // 783
                                                                                                                       //
      Migrations.update({ _id: "new_server_migrations_applied" }, { $set: { value: true } });                          // 785
    }                                                                                                                  // 786
  }                                                                                                                    // 787
}                                                                                                                      // 788
                                                                                                                       //
SandstormDb.prototype.migrateToLatest = migrateToLatest;                                                               // 790
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");
require("./node_modules/meteor/sandstorm-db/user.js");
require("./node_modules/meteor/sandstorm-db/migrations.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
